// SKY
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

layout(set = 0, binding = 0, std140) uniform _211_213
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    uint _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    float _m64;
    uint _m65;
    uint _m66;
    float _m67;
    float _m68;
    float _m69[3];
} _213;

layout(set = 2, binding = 0, std140) uniform _335_337
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    float _m24[1];
} _337;

layout(set = 0, binding = 1, std140) uniform _1191_1193
{
    vec4 _m0[64];
} _1193;

layout(set = 1, binding = 0, std140) uniform _1195_1197
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    int _m5;
    uint _m6;
    float _m7[2];
} _1197;

layout(push_constant, std430) uniform _1186_1188
{
    int _m0;
} _1188;

layout(set = 2, binding = 1) uniform TEXTURE_2D _361;
layout(set = 0, binding = 6) uniform sampler _365;
layout(set = 0, binding = 7) uniform texture3D _813;
layout(set = 0, binding = 8) uniform sampler _815;
layout(set = 0, binding = 9) uniform texture3D _834;
layout(set = 0, binding = 10) uniform texture3D _934;
layout(set = 0, binding = 11) uniform sampler _936;
layout(set = 2, binding = 2) uniform TEXTURE_2D _1023;
layout(set = 0, binding = 12) uniform TEXTURE_2D _1155;
layout(set = 0, binding = 13) uniform sampler _1157;

layout(location = 2, component = 0) in vec4 _370;
layout(location = 7, component = 0) in vec4 _400;
layout(location = 8, component = 0) in vec4 _408;
layout(location = 3, component = 0) in vec4 _606;
layout(location = 4, component = 0) in vec4 _635;
layout(location = 5, component = 0) in vec4 _691;
layout(location = 6, component = 0) in vec4 _695;
layout(location = 0, component = 0) out vec4 _711;
layout(location = 1, component = 0) out vec4 _1125;
layout(location = 2, component = 0) out vec4 _1126;
uint _50;
uint _52;
uint _54;
uint _56;
uint _58;
uint _60;
uint _62;
uint _63;
uint _65;
uint _66;
uint _68;
uint _70;
uint _72;
uint _74;
uint _76;
uint _78;
uint _80;
uint _82;
uint _84;

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec2 _16(vec2 _15)
{
    return clamp(_15, vec2(0.0), vec2(1.0));
}

float _42(inout float _40, bool _41)
{
    if (_41)
    {
        _40 += (float(_40 < _213._m24) * _213._m25);
    }
    float _230 = _40;
    return _213._m0.w / (_10(_230) + _213._m0.z);
}

uint _21(float _20)
{
    return floatBitsToUint(_20);
}

vec3 _47(vec2 _46)
{
    return (vec3(_213._m26, _213._m27, _213._m28) + (vec3(_213._m29, _213._m30, _213._m31) * _46.x)) + (vec3(_213._m32, _213._m33, _213._m34) * _46.y);
}

float _24(float _23)
{
    float _102 = (((-0.15658299624919891357421875) * abs(_23)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_23));
    float _116;
    if (_23 >= 0.0)
    {
        _116 = _102;
    }
    else
    {
        _116 = 3.1415927410125732421875 - _102;
    }
    return _116;
}

float _27(float _26)
{
    float _130;
    if (_26 < 1.0)
    {
        _130 = _26;
    }
    else
    {
        _130 = 1.0 / _26;
    }
    float _127 = _130;
    float _138 = _127 * _127;
    float _142 = 0.087292902171611785888671875;
    _142 = (-0.3018949925899505615234375) + (_142 * _138);
    _142 = 1.0 + (_142 * _138);
    _142 *= _127;
    float _158;
    if (_26 < 1.0)
    {
        _158 = _142;
    }
    else
    {
        _158 = 1.57079637050628662109375 - _142;
    }
    return _158;
}

float _30(float _29)
{
    float _171 = abs(_29);
    float _168 = _27(_171);
    float _175;
    if (_29 < 0.0)
    {
        _175 = -_168;
    }
    else
    {
        _175 = _168;
    }
    return _175;
}

float _35(float _33, float _34)
{
    float _189 = _33 / _34;
    float _185 = _30(_189);
    if (_34 < 0.0)
    {
        _185 += ((_33 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _185;
}

void main()
{
    _50 = 2147483648u;
    _52 = 1073741824u;
    _54 = 0u;
    _56 = 268435456u;
    _58 = 536870912u;
    _60 = 805306368u;
    _62 = 1073741824u;
    _63 = 1342177280u;
    _65 = 0u;
    _66 = 16777216u;
    _68 = 33554432u;
    _70 = 50331648u;
    _72 = 67108864u;
    _74 = 83886080u;
    _76 = 100663296u;
    _78 = 117440512u;
    _80 = 134217728u;
    _82 = 150994944u;
    _84 = 167772160u;
    int _280 = 6;
    float _282 = 1.0 / float(_280);
    int _286 = 1;
    float _288 = 1.0 / float(_286);
    if (_213._m65 == 1u)
    {
        _280 = 6;
        _282 = 1.0 / float(_280);
        _286 = 6;
        _288 = 1.0 / float(_286);
    }
    else
    {
        if (_213._m65 == 2u)
        {
            _280 = 8;
            _282 = 1.0 / float(_280);
            _286 = 8;
            _288 = 1.0 / float(_286);
        }
        else
        {
            if (_213._m65 == 3u)
            {
                _280 = 16;
                _282 = 1.0 / float(_280);
                _286 = 8;
                _288 = 1.0 / float(_286);
            }
        }
    }
    float _331 = 100.0;
    float _333 = _337._m16 * _331;
    float _342 = 1.0;
    float _343 = 1.0;
    float _344 = 0.0;
    if (_213._m66 > 0u)
    {
    }
    float _351 = 0.100000001490116119384765625 * _337._m17;
    vec4 _358 = SAMPLE_TEXTURE(SAMPLER_2D(_361, _365), (_370.xy * _337._m2.xy) + ((_337._m2.zw * vec2(_213._m67)) * _343));
    if (_358.w < 0.0039215688593685626983642578125)
    {
        _358.w = 0.0;
    }
    else
    {
        vec2 _399 = normalize(_400.xyz).xy * _351;
        vec2 _407 = normalize(_408.xyz).xy * _351;
        vec2 _419;
        if (_408.z < 0.0)
        {
            _419 = -_407;
        }
        else
        {
            _419 = _407;
        }
        _407 = _419;
        float _436 = (_408.z * _337._m18) + 0.5;
        float _427 = _10(_436);
        float _438 = 1.0;
        for (int _439 = 0; _439 < _280; _439++)
        {
            float _448 = _282 * (float(_439) + _344);
            vec2 _455 = _370.xy + (_399 * (1.0 - _448));
            vec2 _467 = _455;
            float _463 = SAMPLE_TEXTURE(SAMPLER_2D(_361, _365), (_16(_467) * _337._m2.xy) + ((_337._m2.zw * vec2(_213._m67)) * _343)).x;
            float _486 = max(0.001000000047497451305389404296875, _463 - _448);
            _438 *= exp(((-_486) * _333) * _282);
            float _501 = 1.0;
            for (int _502 = 0; _502 < _286; _502++)
            {
                float _511 = _288 * float(_502);
                vec2 _526 = _455 - (_407 * (1.0 - _511));
                float _516 = SAMPLE_TEXTURE(SAMPLER_2D(_361, _365), (_16(_526) * _337._m2.xy) + ((_337._m2.zw * vec2(_213._m67)) * _343)).x;
                float _544 = max(0.001000000047497451305389404296875, (_516 - _511) - _448);
                _501 *= exp(((-_544) * _333) * _288);
            }
            _501 = mix(_501, 1.0 - _501, _427);
            _342 = mix(_342, _501, _486);
        }
        _358.w *= (1.0 - _438);
    }
    _358.w *= SAMPLE_TEXTURE(SAMPLER_2D(_361, _365), (_370.xy * _337._m3.xy) + _337._m3.zw).z;
    float _599 = 1.0;
    float _600 = 0.0;
    _342 *= _599;
    vec3 _605 = normalize(_606.xyz);
    vec3 _610 = vec3(_213._m53, _213._m54, _213._m55);
    float _621 = dot(_610, _605);
    float _625 = max((_621 * 0.5) + 0.5, (_621 * (-0.5)) + 0.5);
    vec3 _634 = normalize(_635.xyz);
    float _639 = 0.079577468335628509521484375;
    vec2 _641 = vec2(_337._m19, -_337._m20);
    float _650 = dot(_634, _610);
    vec2 _654 = _641 * _641;
    vec2 _658 = vec2(1.0) - _654;
    vec2 _662 = (vec2(1.0) + _654) - ((vec2(2.0) * _641) * _650);
    vec2 _672 = (_658 * _639) / (_662 * sqrt(_662));
    float _681 = mix(_672.y, _672.x, (_650 * 0.5) + 0.5);
    vec3 _690 = _691.xyz;
    vec3 _694 = _695.xyz * _342;
    float _700 = (1.0 - _358.y) * (_337._m21 * 10.0);
    vec3 _732 = (_690 * _337._m4.xyz) + (_694 * ((vec3(_625) + (_337._m5.xyz * _700)) + vec3(_681)));
    _711 = vec4(_732.x, _732.y, _732.z, _711.w);
    float _741 = (_358.w * _599) - _600;
    _711.w = _10(_741);
    vec2 _745 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _213._m19.xy;
    float _774 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).z;
    bool _776 = false;
    float _777 = _42(_774, _776);
    float _762 = _777;
    vec2 _778 = _745 + vec2(0.0);
    float _782 = 0.119999997317790985107421875;
    float _784 = _213._m20.y;
    float _787 = _213._m21.z + 1.0;
    float _791 = pow(max(0.0, _762 - _782) / (_784 - _782), 0.5);
    float _801 = (0.5 / _787) + (_791 * (1.0 - (1.0 / _787)));
    
    // FIX
    _778.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec3 _810 = textureLod(sampler3D(_813, _815), vec4(_778, _801, 0.0).xyz, vec4(_778, _801, 0.0).w).xyz;
    vec2 _833 = textureLod(sampler3D(_834, _815), vec4(_778, _801, 0.0).xyz, vec4(_778, _801, 0.0).w).xy;
    float _852 = _833.x;
    float _855 = _833.y;
    float _861 = _213._m68;
    uint _859 = _21(_861);
    bool _865 = (_859 & 2u) != 0u;
    _810 *= float(_865);
    _852 = _865 ? _852 : 1.0;
    vec3 _876 = vec3(0.0);
    if ((_859 & 1u) != 0u)
    {
        vec3 _883 = vec3(_213._m35, _213._m36, _213._m37);
        vec3 _894 = _47(_745);
        vec4 _897 = vec4(0.0);
        vec3 _899 = normalize(_894);
        float _902 = _899.z;
        _897.x = clamp(_24(_902) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _911 = _899.y;
        float _914 = _899.x;
        _897.y = _35(_911, _914) / 6.283185482025146484375;
        _897.z = sqrt(_762 * _213._m22.w);
        _897.z = clamp(_897.z, 0.015625, 0.984375);
        _876 = textureLod(sampler3D(_934, _936), _897.xyz, _897.w).xyz;
        _876 *= _855;
    }
    vec3 _955 = ((_711.xyz + _876) * _852) + _810;
    _711 = vec4(_955.x, _955.y, _955.z, _711.w);
    float _958 = _337._m22;
    float _961 = _337._m22 + 9.9999997473787516355514526367188e-05;
    float _977 = (fract((_213._m67 * 0.2199999988079071044921875) * _958) * 10.0) / _961;
    float _966 = _10(_977);
    float _990 = (fract((_213._m67 * 0.430000007152557373046875) * _958) * 10.0) / _961;
    float _979 = _10(_990);
    float _1003 = (fract((_213._m67 * 0.810000002384185791015625) * _958) * 10.0) / _961;
    float _992 = _10(_1003);
    float _1013 = ((3.0 - _966) - _979) - _992;
    float _1005 = _10(_1013);
    vec4 _1015 = SAMPLE_TEXTURE(SAMPLER_2D(_361, _365), _370.xy);
    vec4 _1022 = SAMPLE_TEXTURE(SAMPLER_2D(_1023, _365), (_370.xy * _337._m6.xy) + (_337._m6.zw * vec2(_213._m67)));
    vec4 _1042 = SAMPLE_TEXTURE(SAMPLER_2D(_1023, _365), (_370.xy * _337._m7.xy) + (_337._m7.zw * vec2(_213._m67)));
    float _1062 = 1.0 - _1015.x;
    _1062 *= ((_1062 * _1062) * _1015.y);
    vec3 _1074 = vec3((((((_337._m8.xyz * _1022.x) * (_1042.y + (_1042.z * _966))) * _337._m23) * _1062) * _1005) + vec3(1.0));
    _711 = vec4(_711.xyz * _1074, _711.w);
    float _1113 = _711.w;
    _711.w = _10(_1113);
    vec3 _1122 = _711.xyz * _711.w;
    _711 = vec4(_1122.x, _1122.y, _1122.z, _711.w);
    _1125 = vec4(0.0);
    _1126 = vec4(0.0);
    float _1127 = _213._m23.w;
    if (!(_1127 == 0.0))
    {
        vec2 _1134 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _213._m19.xy;
        bool _1150 = ((1.0 - gl_FragCoord.z) - 0.0) < (1.0 - TEXTURE_LOD(SAMPLER_2D(_1155, _1157), vec4(_1134, 0.0, 0.0).xy, vec4(_1134, 0.0, 0.0).w).x);
        _1125 = _711 * float(!_1150);
        _711 *= float(_1150);
        _1126 = vec4(_711.w);
    }
}


