#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 40, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

struct _114
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    float _m5;
};

struct _122
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _3479
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _4415
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _719_721
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    vec4 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    vec4 _m37;
    vec4 _m38;
    vec4 _m39;
    vec4 _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    uint _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    float _m64;
    float _m65;
    float _m66;
    float _m67;
    float _m68;
    float _m69;
    float _m70;
    float _m71;
    float _m72;
    float _m73;
    float _m74;
    float _m75;
    float _m76;
    uint _m77;
    float _m78[3];
} _721;

layout(set = 2, binding = 0, std140) uniform _1101_1103
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    uint _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    uint _m31;
} _1103;

layout(set = 1, binding = 0, std140) uniform _1113_1115
{
    vec4 _m0;
    int _m1;
    float _m2;
    float _m3;
    float _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    uint _m10;
    float _m11[2];
} _1115;

layout(set = 3, binding = 0, std140) uniform _1153_1155
{
    vec4 _m0[5];
    vec4 _m1[5];
    vec4 _m2[5];
    vec4 _m3[5];
} _1155;

layout(set = 0, binding = 26, std430) restrict readonly buffer _2845_2847
{
    uint _m0[];
} _2847;

layout(set = 0, binding = 30, std140) uniform _3484_3486
{
    vec4 _m0[4096];
} _3486;

layout(set = 0, binding = 31, std140) uniform _3560_3562
{
    vec4 _m0[4096];
} _3562;

layout(set = 0, binding = 33, std430) restrict readonly buffer _3841_3843
{
    uint _m0[];
} _3843;

layout(set = 0, binding = 34, std140) uniform _4420_4422
{
    vec4 _m0[4095];
} _4422;

layout(set = 0, binding = 35, std140) uniform _4480_4482
{
    vec4 _m0[4095];
} _4482;

layout(set = 0, binding = 1, std140) uniform _5498_5500
{
    vec4 _m0[64];
} _5500;

layout(push_constant, std430) uniform _5494_5496
{
    int _m0;
} _5496;

layout(set = 3, binding = 1) uniform TEXTURE_2D _1202[5];
layout(set = 0, binding = 10) uniform sampler _1210;
layout(set = 3, binding = 3) uniform TEXTURE_2D _1231[5];
layout(set = 0, binding = 11) uniform sampler _1236;
layout(set = 3, binding = 2) uniform TEXTURE_2D _1246[5];
layout(set = 0, binding = 12) uniform sampler _1251;
layout(set = 3, binding = 4) uniform TEXTURE_2D _1271[5];
layout(set = 0, binding = 13) uniform sampler _1276;
layout(set = 3, binding = 5) uniform TEXTURE_2D _1286[5];
layout(set = 0, binding = 14) uniform sampler _1291;
layout(set = 3, binding = 7) uniform TEXTURE_2D _1301[5];
layout(set = 0, binding = 15) uniform sampler _1306;
layout(set = 3, binding = 8) uniform TEXTURE_2D _1316[5];
layout(set = 0, binding = 16) uniform sampler _1321;
layout(set = 4, binding = 0) uniform TEXTURE_2D _1406[34816];
layout(set = 0, binding = 17) uniform sampler _1411;
layout(set = 3, binding = 6) uniform TEXTURE_2D _1968[5];
layout(set = 0, binding = 18) uniform sampler _1973;
layout(set = 0, binding = 19) uniform TEXTURE_2D _2027;
layout(set = 0, binding = 20) uniform sampler _2029;
layout(set = 0, binding = 21) uniform TEXTURE_2D _2042;
layout(set = 0, binding = 22) uniform TEXTURE_2D _2204;
layout(set = 0, binding = 23) uniform sampler _2206;
layout(set = 0, binding = 24) uniform TEXTURE_2D _2423;
layout(set = 0, binding = 25) uniform sampler _2425;
layout(set = 0, binding = 27) uniform TEXTURE_2D _3086;
layout(set = 0, binding = 28) uniform sampler _3088;
layout(set = 0, binding = 29) uniform TEXTURE_2D _3385;
layout(set = 0, binding = 32) uniform textureCubeArray _3814;
layout(set = 0, binding = 9) uniform sampler _3816;
layout(set = 0, binding = 36) uniform texture2D _4873;
layout(set = 0, binding = 37) uniform samplerShadow _4875;
layout(set = 0, binding = 38) uniform TEXTURE_2D _5439;
layout(set = 0, binding = 6) uniform texture3D _5503;
layout(set = 0, binding = 7) uniform sampler _5504;
layout(set = 0, binding = 8) uniform texture3D _5505;

layout(location = 17, component = 3) in float _980;
layout(location = 18, component = 0) in float _982;
layout(location = 18, component = 1) in float _987;
layout(location = 18, component = 2) in float _989;
layout(location = 18, component = 3) in float _991;
layout(location = 19, component = 0) in float _1022;
layout(location = 19, component = 1) in float _1024;
layout(location = 19, component = 2) in float _1026;
layout(location = 19, component = 3) in float _1030;
layout(location = 20, component = 0) in float _1032;
layout(location = 20, component = 1) in float _1034;
layout(location = 20, component = 2) in float _1046;
layout(location = 10, component = 0) in vec4 _1071;
layout(location = 11, component = 0) in vec4 _1074;
layout(location = 12, component = 0) in vec4 _1077;
layout(location = 0, component = 0) out vec4 _5352;
layout(location = 1, component = 0) out vec4 _5366;
layout(location = 2, component = 0) out vec4 _5393;
uint _183;
uint _185;
uint _187;
uint _189;
uint _191;
uint _193;
uint _195;
uint _196;
uint _198;
uint _199;
uint _201;
uint _203;
uint _205;
uint _207;
uint _209;
uint _211;
uint _213;
uint _215;
uint _217;

_122 _124()
{
    _122 _613;
    _613._m0 = vec3(0.0);
    _613._m2 = vec3(0.0);
    _613._m3 = 0.0;
    _613._m4 = 0u;
    _613._m5 = 0.0;
    _613._m6 = vec3(0.0);
    _613._m7 = vec3(0.0, 0.0, 1.0);
    _613._m8 = vec3(0.0, 0.0, 1.0);
    _613._m1 = vec3(0.0);
    _613._m9 = 1.0;
    _613._m10 = 1.0;
    _613._m14 = vec3(0.0);
    _613._m15 = vec3(0.0);
    _613._m16 = vec4(0.0);
    _613._m17 = vec4(0.0);
    _613._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _613._m19 = vec3(0.0);
    _613._m20 = vec3(0.0);
    _613._m21 = vec3(0.0);
    _613._m22 = vec3(0.0);
    _613._m23 = vec3(0.0);
    _613._m24 = vec3(0.0);
    _613._m25 = 1.0;
    _613._m26 = uvec4(0u);
    _613._m27 = uvec4(0u);
    _613._m28 = uvec4(0u);
    _613._m29 = vec4(0.0);
    _613._m30 = vec4(0.0);
    _613._m31 = vec4(0.0);
    _613._m32 = vec4(0.0);
    _613._m33 = uvec2(0u);
    _613._m34 = vec2(0.0);
    _613._m35 = 0.0;
    _613._m36 = -1;
    _613._m37 = 0;
    _613._m38 = vec2(0.0);
    _613._m39 = 1.0;
    _613._m41 = -1;
    _613._m45 = 1.0;
    _613._m11 = 1.0;
    _613._m12 = 0u;
    _613._m13 = uvec3(0u);
    _613._m40 = vec3(0.0);
    _613._m46 = 0.0;
    _613._m47 = 1.0;
    return _613;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

_114 _116()
{
    _114 _601;
    _601._m0 = vec4(0.0);
    _601._m1 = vec4(0.0);
    _601._m2 = vec4(0.0);
    _601._m3 = vec4(0.0);
    _601._m4 = vec4(0.0);
    _601._m5 = 0.0;
    return _601;
}

vec2 _136(vec2 _135)
{
    return ((_135 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _141(inout vec2 _139, bool _140)
{
    vec2 _754 = _139;
    _139 = _136(_754);
    float _774 = (1.0 - (_139.x * _139.x)) - (_139.y * _139.y);
    vec3 _757 = vec3(_139.x, _139.y, sqrt(_10(_774)));
    if (_140 == false)
    {
        _757.z = -_757.z;
    }
    return _757;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

uint _89(inout vec4 _88)
{
    vec4 _421 = _88;
    _88 = _22(_421);
    return packUnorm4x8(_88.wzyx);
}

vec3 _71(mat3 _69, vec3 _70)
{
    return _69 * _70;
}

vec3 _146(vec3 _144, mat3 _145)
{
    mat3 _790 = _145;
    vec3 _792 = _144;
    return normalize(_71(_790, _792));
}

vec3 _152(vec2 _149, mat3 _150, bool _151)
{
    vec2 _799 = _149;
    bool _801 = _151;
    vec3 _803 = _141(_799, _801);
    vec3 _798 = _803;
    vec3 _804 = _798;
    mat3 _806 = _150;
    return _146(_804, _806);
}

float _131(inout float _129, bool _130)
{
    if (_130)
    {
        _129 += (float(_129 < _721._m41) * _721._m42);
    }
    float _735 = _129;
    return _721._m0.w / (_10(_735) + _721._m0.z);
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

vec4 _93(uint _92)
{
    return unpackUnorm4x8(_92).wzyx;
}

float _74(float _73)
{
    return exp2(_73);
}

vec3 _112(float _109, float _110, vec3 _111)
{
    float _552 = 0.0949999988079071044921875 + (_110 * (0.60000002384185791015625 + (4.190000057220458984375 * _110)));
    float _562 = _109 + 0.02500000037252902984619140625;
    float _566 = (9.5 * _110) * _109;
    float _580 = 1.0 - (14.0 * _109);
    float _572 = (_552 * _562) * _74(_580);
    float _587 = -_566;
    float _583 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _74(_587)));
    return mix(vec3(_572), vec3(_583), _111);
}

float _169(uvec2 _167, uint _168)
{
    uvec2 _861 = _167 & uvec2(3u);
    return float(((((2068378560u * (1u - (_861.x >> uint(1)))) + (1500172770u * (_861.x >> uint(1)))) >> ((_861.y + ((_861.x & 1u) << uint(2))) << uint(2))) + _168) & 15u) / 16.0;
}

vec3 _163(vec3 _160, vec4 _161, vec4 _162)
{
    return vec3((_161.xy * _160.xy) + _161.zw, _162.z) / vec3((_162.x * _160.z) + _162.y);
}

vec3 _157(vec3 _155, vec4 _156)
{
    return vec3(vec2(0.5) + (_156.xy * (_155.xy / vec2(_155.z))), (_156.w / _155.z) + _156.z);
}

int _50(uint _49)
{
    return findLSB(_49);
}

vec4 _64(vec3 _59, vec4 _60, vec4 _61, vec4 _62, vec4 _63)
{
    return vec4((_59.x * _60.x) + ((_59.y * _60.y) + ((_59.z * _60.z) + _60.w)), (_59.x * _61.x) + ((_59.y * _61.y) + ((_59.z * _61.z) + _61.w)), (_59.x * _62.x) + ((_59.y * _62.y) + ((_59.z * _62.z) + _62.w)), (_59.x * _63.x) + ((_59.y * _63.y) + ((_59.z * _63.z) + _63.w)));
}

float _56(float _55)
{
    return _55 * _55;
}

float _38(float _35, float _36, float _37)
{
    return min(_35, min(_36, _37));
}

float _33(float _30, float _31, float _32)
{
    return max(_30, max(_31, _32));
}

vec3 _53(vec3 _52)
{
    return _52 * _52;
}

uint _44(float _41, float _42, float _43)
{
    bool _259 = abs(_43) >= abs(_41);
    bool _267;
    if (_259)
    {
        _267 = abs(_43) >= abs(_42);
    }
    else
    {
        _267 = _259;
    }
    if (_267)
    {
        return uint((_43 < 0.0) ? 5 : 4);
    }
    if (abs(_42) >= abs(_41))
    {
        return uint((_42 < 0.0) ? 3 : 2);
    }
    return uint(int(_41 < 0.0));
}

float _79(float _77, float _78)
{
    return pow(_77, _78);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _98(vec3 _96, float _97)
{
    float _439 = dot(_96, vec3(16.666500091552734375));
    float _434 = _10(_439);
    float _448 = 1.0 - _97;
    float _451 = _10(_448);
    float _452 = 5.0;
    vec3 _456 = _96 + ((vec3(_434) - _96) * _79(_451, _452));
    return _16(_456);
}

vec3 _106(vec3 _101, vec3 _102, vec3 _103, vec3 _104, float _105)
{
    float _464 = dot(_101, _102);
    float _460 = _10(_464);
    vec3 _466 = normalize(_102 + _103);
    float _475 = dot(_101, _466);
    float _471 = _10(_475);
    float _481 = dot(_103, _466);
    float _477 = _10(_481);
    vec3 _484 = _104;
    float _486 = _477;
    vec3 _483 = _98(_484, _486);
    float _493 = dot(_101, _103);
    float _489 = _10(_493);
    float _495 = 1.0 - (_105 * 0.800000011920928955078125);
    _495 *= _495;
    _495 *= _495;
    float _506 = _495 * _495;
    float _510 = ((_471 * _471) * (_506 - 1.0)) + 1.0;
    _510 = _506 / ((_510 * _510) + 9.9999999392252902907785028219223e-09);
    float _525 = (_460 * (1.0 - _495)) + _495;
    float _532 = (_489 * (1.0 - _495)) + _495;
    _510 /= (((4.0 * _525) * _532) + 9.9999999392252902907785028219223e-09);
    return _483 * _510;
}

vec2 _172(vec2 _171)
{
    return (vec2(1.0) - abs(_171.yx)) * vec2((_171.x >= 0.0) ? 1.0 : (-1.0), (_171.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _177(inout vec3 _175, bool _176)
{
    _175 /= vec3((abs(_175.x) + abs(_175.y)) + abs(_175.z));
    vec2 _930;
    if (_175.z >= 0.0)
    {
        _930 = _175.xy;
    }
    else
    {
        vec2 _936 = _175.xy;
        _930 = _172(_936);
    }
    _175 = vec3(_930.x, _930.y, _175.z);
    if (_176)
    {
        vec2 _950 = (_175.xy * 0.5) + vec2(0.5);
        _175 = vec3(_950.x, _950.y, _175.z);
    }
    return _175.xy;
}

float _82(float _81)
{
    return sqrt(_81);
}

float _85(float _84)
{
    return sqrt(_84);
}

float _180(float _179)
{
    float _960 = abs(_179);
    float _957 = _85(_960);
    float _964;
    if (_179 > 0.0)
    {
        _964 = _957;
    }
    else
    {
        _964 = -_957;
    }
    return (_964 * 0.5) + 0.5;
}

void main()
{
    _183 = 2147483648u;
    _185 = 1073741824u;
    _187 = 0u;
    _189 = 268435456u;
    _191 = 536870912u;
    _193 = 805306368u;
    _195 = 1073741824u;
    _196 = 1342177280u;
    _198 = 0u;
    _199 = 16777216u;
    _201 = 33554432u;
    _203 = 50331648u;
    _205 = 67108864u;
    _207 = 83886080u;
    _209 = 100663296u;
    _211 = 117440512u;
    _213 = 134217728u;
    _215 = 150994944u;
    _217 = 167772160u;
    float _976 = 0.0;
    _122 _977 = _124();
    _977._m16 = vec4(0.0, 0.0, _980, _982);
    vec3 _986 = vec3(_987, _989, _991);
    _977._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _977._m15 = vec3(_721._m52, _721._m53, _721._m54) + _986;
    vec3 _1020 = vec3(0.0);
    vec3 _1021 = vec3(0.0);
    _1020 = normalize(vec3(_1022, _1024, _1026));
    _1021 = normalize(vec3(_1030, _1032, _1034));
    vec3 _1038 = _1020;
    vec3 _1040 = _1021;
    vec3 _1042 = normalize(cross(_1038, _1040) * _1046);
    _977._m18 = mat3(vec3(_1040), vec3(_1042), vec3(_1038));
    _977._m14 = normalize(-_986);
    _977._m29 = _1071;
    _977._m30 = _1074;
    _977._m31 = _1077;
    uint _1080 = 0u;
    vec4 _1081 = vec4(0.0);
    vec4 _1082 = vec4(0.0);
    vec4 _1083 = vec4(0.0);
    vec4 _1084 = vec4(0.0);
    vec4 _1085 = vec4(0.0);
    float _1086 = 0.0;
    uvec2 _1087 = uvec2(0u, 65535u);
    vec2 _1090 = _977._m16.zw;
    vec2 _1094 = _1090;
    vec2 _1096 = _1090;
    float _1098 = 0.0009765625;
    vec3 _1109;
    if ((_1103._m31 & 1u) != 0u)
    {
        _1109 = vec3(_1115._m3, _1115._m4, _1115._m5);
    }
    else
    {
        _1109 = vec3(1.0);
    }
    vec3 _1100 = _1109;
    float _1126 = 1.0;
    float _1127 = _1115._m6;
    bool _1130 = _1127 > 0.0;
    float _1133 = 1.0;
    uint _1134 = _1087.x;
    uint _1137 = _1134 & 7u;
    uint _1141 = _1137;
    uint _1143 = _1141;
    float _1145 = 0.0;
    vec2 _1146 = _1094;
    _1146.x *= _1155._m1[_1143].w;
    _1146.y *= _1155._m2[_1143].x;
    _1146.x += (_721._m70 * _1155._m2[_1143].y);
    _1146.y += (_721._m70 * _1155._m2[_1143].z);
    float _1191 = -1.0;
    vec4 _1192 = vec4(_1146, 0.0, _1191);
    uint _1204 = _1143;
    vec3 _1198 = (SAMPLE_TEXTURE1(SAMPLER_2D(_1202[nonuniformEXT(_1204)], _1210), _1192.xy, _1192.w).xyz * vec3(_1155._m0[_1143].x)) + vec3(_1155._m0[_1143].y);
    uint _1233 = _1143;
    vec2 _1230 = SAMPLE_TEXTURE1(SAMPLER_2D(_1231[nonuniformEXT(_1233)], _1236), _1192.xy, _1192.w).xy;
    uint _1248 = _1143;
    vec3 _1245 = (SAMPLE_TEXTURE1(SAMPLER_2D(_1246[nonuniformEXT(_1248)], _1251), _1192.xy, _1192.w).xyz * vec3(_1155._m0[_1143].z)) + vec3(_1155._m0[_1143].w);
    uint _1273 = _1143;
    float _1270 = SAMPLE_TEXTURE1(SAMPLER_2D(_1271[nonuniformEXT(_1273)], _1276), _1192.xy, _1192.w).x;
    uint _1288 = _1143;
    float _1285 = SAMPLE_TEXTURE1(SAMPLER_2D(_1286[nonuniformEXT(_1288)], _1291), _1192.xy, _1192.w).x;
    uint _1303 = _1143;
    vec3 _1300 = SAMPLE_TEXTURE1(SAMPLER_2D(_1301[nonuniformEXT(_1303)], _1306), _1192.xy, _1192.w).xyz;
    uint _1318 = _1143;
    float _1315 = SAMPLE_TEXTURE1(SAMPLER_2D(_1316[nonuniformEXT(_1318)], _1321), _1192.xy, _1192.w).x;
    _1081 = vec4(_1198.x, _1198.y, _1198.z, _1081.w);
    _1081.w = 0.0;
    _1082 = vec4(_1245.x, _1245.y, _1245.z, _1082.w);
    _1082.w = _1285;
    _1083 = vec4(_1230.x, _1230.y, _1083.z, _1083.w);
    _1084.x = 0.0;
    _1084.y = _1145;
    _1084.z = _1285;
    _1084.w = _1270;
    _1086 = _1315;
    _1133 = _1155._m1[_1143].x;
    vec3 _1359 = _1300 * _1155._m3[_1143].xyz;
    _1085 = vec4(_1359.x, _1359.y, _1359.z, _1085.w);
    float _1362 = _1130 ? _1127 : _1133;
    vec3 _1371 = _1085.xyz * vec3(_1362);
    _1085 = vec4(_1371.x, _1371.y, _1371.z, _1085.w);
    vec2 _1374 = vec2(0.0);
    _114 _1375;
    _1375._m0 = _1081;
    _1375._m1 = _1082;
    _1375._m2 = _1084;
    _1375._m3 = _1083;
    _1375._m4 = _1085;
    _1375._m5 = _1086;
    _1374 = _1375._m3.xy;
    _1375._m3 = vec4(vec2(0.5).x, vec2(0.5).y, _1375._m3.z, _1375._m3.w);
    bool _1394 = (_1103._m31 & 2u) != 0u;
    if (_1394)
    {
        vec4 _1402 = vec4(0.0);
        _1402 = SAMPLE_TEXTURE(SAMPLER_2D(_1406[_1103._m19], _1411), _1094);
        _1402 *= _1103._m1;
        _1402 = min(_1402, vec4(1.0));
        float _1423 = (_1086 - 0.4980392158031463623046875) * _1103._m20;
        for (int _1430 = 0; _1430 < 4; _1430++)
        {
            float _1438 = _1402[_1430];
            if (!(_1438 == 0.0))
            {
                float _1446 = 0.0;
                vec2 _1447 = vec2(_1103._m2[_1430]);
                uint _1452 = uint(_1430 + 1);
                uint _1456 = _1452 & 7u;
                uint _1459 = _1456;
                uint _1461 = _1459;
                uint _1464 = _1461;
                _1446 = SAMPLE_TEXTURE(SAMPLER_2D(_1316[nonuniformEXT(_1464)], _1321), _1090 * _1447).x;
                _1446 -= 0.4980392158031463623046875;
                _1446 *= _1103._m3[_1430];
                float _1481 = (_1423 + 1.0) - _1438;
                float _1486 = (_1446 + 0.0) + _1438;
                float _1491 = _1486 - _1481;
                float _1495 = (clamp(_1491 / _1103._m4[_1430], -1.0, 1.0) / 2.0) + 0.5;
                float _1505 = 0.100000001490116119384765625;
                float _1507 = abs(0.5 - _1438);
                float _1518 = (_1507 - (0.5 - _1505)) / _1505;
                float _1511 = _10(_1518);
                float _1520 = 0.0;
                if ((_1438 < _1505) && (_1495 > _1438))
                {
                    _1520 = mix(_1495, _1438, _1511);
                }
                else
                {
                    if ((_1438 > (1.0 - _1505)) && (_1495 < _1438))
                    {
                        _1520 = mix(_1495, _1438, _1511);
                    }
                    else
                    {
                        _1520 = _1495;
                    }
                }
                float _1551 = _1103._m5[_1430];
                float _1555 = _1103._m6[_1430];
                float _1559 = _1103._m7[_1430];
                float _1563 = _1103._m8[_1430];
                float _1567 = _1103._m9[_1430];
                _114 _1571 = _116();
                float _1573 = _1115._m6;
                bool _1576 = _1573 > 0.0;
                float _1579 = 1.0;
                uint _1580 = uint(_1430 + 1);
                uint _1584 = _1580 & 7u;
                uint _1587 = _1584;
                uint _1589 = _1587;
                float _1591 = 0.0;
                vec2 _1592 = _1090 * _1447;
                _1592.x *= _1155._m1[_1589].w;
                _1592.y *= _1155._m2[_1589].x;
                _1592.x += (_721._m70 * _1155._m2[_1589].y);
                _1592.y += (_721._m70 * _1155._m2[_1589].z);
                float _1630 = -1.0;
                vec4 _1631 = vec4(_1592, 0.0, _1630);
                uint _1639 = _1589;
                vec3 _1637 = (SAMPLE_TEXTURE1(SAMPLER_2D(_1202[nonuniformEXT(_1639)], _1210), _1631.xy, _1631.w).xyz * vec3(_1155._m0[_1589].x)) + vec3(_1155._m0[_1589].y);
                uint _1662 = _1589;
                vec2 _1660 = SAMPLE_TEXTURE1(SAMPLER_2D(_1231[nonuniformEXT(_1662)], _1236), _1631.xy, _1631.w).xy;
                uint _1675 = _1589;
                vec3 _1673 = (SAMPLE_TEXTURE1(SAMPLER_2D(_1246[nonuniformEXT(_1675)], _1251), _1631.xy, _1631.w).xyz * vec3(_1155._m0[_1589].z)) + vec3(_1155._m0[_1589].w);
                uint _1698 = _1589;
                float _1696 = SAMPLE_TEXTURE1(SAMPLER_2D(_1271[nonuniformEXT(_1698)], _1276), _1631.xy, _1631.w).x;
                uint _1711 = _1589;
                float _1709 = SAMPLE_TEXTURE1(SAMPLER_2D(_1286[nonuniformEXT(_1711)], _1291), _1631.xy, _1631.w).x;
                uint _1724 = _1589;
                vec3 _1722 = SAMPLE_TEXTURE1(SAMPLER_2D(_1301[nonuniformEXT(_1724)], _1306), _1631.xy, _1631.w).xyz;
                uint _1737 = _1589;
                float _1735 = SAMPLE_TEXTURE1(SAMPLER_2D(_1316[nonuniformEXT(_1737)], _1321), _1631.xy, _1631.w).x;
                _1571._m0 = vec4(_1637.x, _1637.y, _1637.z, _1571._m0.w);
                _1571._m0.w = 0.0;
                _1571._m1 = vec4(_1673.x, _1673.y, _1673.z, _1571._m1.w);
                _1571._m1.w = _1709;
                _1571._m3 = vec4(_1660.x, _1660.y, _1571._m3.z, _1571._m3.w);
                _1571._m2.x = 0.0;
                _1571._m2.y = _1591;
                _1571._m2.z = _1709;
                _1571._m2.w = _1696;
                _1571._m5 = _1735;
                _1579 = _1155._m1[_1589].x;
                vec3 _1780 = _1722 * _1155._m3[_1589].xyz;
                _1571._m4 = vec4(_1780.x, _1780.y, _1780.z, _1571._m4.w);
                float _1784 = _1576 ? _1573 : _1579;
                vec3 _1794 = _1571._m4.xyz * vec3(_1784);
                _1571._m4 = vec4(_1794.x, _1794.y, _1794.z, _1571._m4.w);
                _1375._m0 = mix(_1375._m0, _1571._m0, vec4(_1520 * _1551));
                _1375._m1 = mix(_1375._m1, _1571._m1, vec4(_1520 * _1559));
                _1375._m2.w = mix(_1375._m2.w, _1571._m2.w, _1520 * _1563);
                vec3 _1835 = mix(_1375._m2.xyz, _1571._m2.xyz, vec3(_1520));
                _1375._m2 = vec4(_1835.x, _1835.y, _1835.z, _1375._m2.w);
                _1375._m3 = mix(_1375._m3, _1571._m3, vec4(_1520 * _1555));
                _1375._m4 = mix(_1375._m4, _1571._m4, vec4(_1520 * _1567));
                _1375._m5 = mix(_1375._m5, _1571._m5, _1520);
            }
        }
    }
    _1081 = _1375._m0;
    _1082 = _1375._m1;
    _1084.w = _1375._m2.w;
    _1083 = _1375._m3;
    _1085 = _1375._m4;
    _1086 = _1375._m5;
    vec2 _1883 = _1374;
    bool _1885 = true;
    vec3 _1886 = _141(_1883, _1885);
    vec3 _1881 = _1886;
    vec2 _1888 = _1083.xy;
    bool _1891 = true;
    vec3 _1892 = _141(_1888, _1891);
    vec3 _1887 = _1892;
    vec3 _1893 = _1881 + vec3(0.0, 0.0, 1.0);
    vec3 _1896 = vec3(-_1887.xy, _1887.z);
    vec3 _1905 = (_1893 * dot(_1893, _1896)) - (_1896 * _1893.z);
    vec3 _1917 = normalize(_1905);
    _1083 = vec4(_1917.x, _1917.y, _1917.z, _1083.w);
    vec3 _1922 = _1083.xyz + vec3(1.0);
    _1083 = vec4(_1922.x, _1922.y, _1922.z, _1083.w);
    vec3 _1927 = _1083.xyz * 0.5;
    _1083 = vec4(_1927.x, _1927.y, _1927.z, _1083.w);
    _977._m22 = _1085.xyz * _1100;
    vec3 _1935 = vec3(0.0);
    vec3 _1936 = vec3(0.0);
    float _1937 = 0.0;
    uint _1938 = 0u;
    uint _1939 = _1938 & 7u;
    uint _1942 = _1939;
    uint _1944 = _1942;
    vec4 _1946 = vec4(_1090, 0.0, _1103._m21);
    uint _1954 = _1944;
    vec2 _1964 = SAMPLE_TEXTURE1(SAMPLER_2D(_1231[nonuniformEXT(_1954)], _1236), _1946.xy, _1946.w).xy;
    _1935 = vec3(_1964.x, _1964.y, _1935.z);
    uint _1970 = _1944;
    vec4 _1967 = SAMPLE_TEXTURE1(SAMPLER_2D(_1968[nonuniformEXT(_1970)], _1973), _1946.xy, _1946.w);
    _1936 = _1967.xyz;
    _1937 = _1967.w;
    _977._m8 = _1935;
    float _1992 = _1937 * _1103._m22;
    float _1987 = _10(_1992);
    vec4 _2000 = vec4(_1936, _1987);
    uint _2001 = _89(_2000);
    _977._m4 = _2001;
    float _2008 = (1.0 - _1987) * _1103._m23;
    _977._m10 = _10(_2008);
    _977._m0 = _1081.xyz;
    _977._m2 = _1082.xyz;
    _977._m1 = _1085.xyz;
    _977._m3 = _1084.w;
    _977._m6 = _1083.xyz;
    float _2026 = TEXEL_FETCH(SAMPLER_2D(_2027, _2029), ivec2(0), 0).w;
    if (_2026 > 0.0)
    {
        vec4 _2041 = SAMPLE_TEXTURE(SAMPLER_2D(_2042, _1411), _977._m16.zw * _1103._m24);
        vec3 _2053 = _2041.xyz;
        _2026 *= _2041.w;
        _977._m6 = mix(_977._m6, _2053, vec3(_2026));
        _977._m3 = mix(_977._m3, _977._m3 * _1103._m25, _2026);
        _977._m3 = max(_1103._m26 * _2026, _977._m3);
        _977._m0 = mix(_977._m0, _977._m0 * _1103._m27, vec3(_2026));
    }
    uint _2096 = 0u;
    bool _2097 = true;
    vec2 _2098 = _977._m6.xy;
    bool _2102 = _2097;
    vec3 _2104 = _141(_2098, _2102);
    _977._m7 = _2104;
    vec2 _2106 = _977._m6.xy;
    mat3 _2110 = _977._m18;
    bool _2113 = _2097;
    _977._m6 = _152(_2106, _2110, _2113);
    vec2 _2117 = _977._m8.xy;
    mat3 _2121 = _977._m18;
    bool _2124 = _2097;
    _977._m8 = _152(_2117, _2121, _2124);
    uvec2 _2128 = uvec2(_977._m17.xy);
    uint _2133 = _2128.x / 256u;
    uint _2138 = _2128.y / 256u;
    float _2143 = _977._m17.z;
    bool _2146 = false;
    float _2147 = _131(_2143, _2146);
    float _2142 = _2147;
    float _2148 = log2(max(1.0, _2142 / _721._m18.z)) * _721._m18.w;
    uint _2158 = min(23u, uint(_2148));
    float _2165 = _721._m71;
    float _2171 = _721._m72;
    uint _2163 = (_27(_2165) + ((_2133 + (_27(_2171) * _2138)) * 24u)) + _2158;
    float _2184 = _1115._m7;
    uint _2183 = _27(_2184);
    float _2188 = _721._m19.x;
    if (_2188 > 0.0)
    {
        vec2 _2195 = _977._m17.xy * _721._m20.xy;
        vec3 _2203 = (TEXTURE_LOD(SAMPLER_2D(_2204, _2206), vec4(_2195, 0.0, 0.0).xy, vec4(_2195, 0.0, 0.0).w).xyz * 2.0) - vec3(1.0);
        float _2228 = dot(_2203, _977._m6);
        _977._m11 = _10(_2228);
        float _2236 = 1.0 - pow(_977._m11, 0.699999988079071044921875);
        _977._m11 = _10(_2236);
        _977._m11 *= _977._m11;
    }
    _977._m21 = _977._m22;
    _977._m25 = 1.0;
    float _2249 = _721._m21.w;
    bool _2252 = _2249 < 0.0;
    _2249 = abs(_2249);
    vec3 _2257 = _977._m15;
    float _2276 = (1.0 - (length(_2257 - vec3(_721._m52, _721._m53, _721._m54)) / _2249)) / 0.25;
    float _2260 = _10(_2276);
    if ((!_2252) && (_2260 > 0.0))
    {
        vec3 _2285 = _721._m21.xyz;
        vec3 _2289 = _721._m22.xyz;
        float _2293 = _2257.z - _2289.z;
        float _2299 = _721._m23.w;
        float _2302 = _721._m24.w;
        float _2305 = float(_2302 < 0.0);
        _2302 = abs(_2302) - 1.0;
        bool _2312 = _2293 <= 0.0;
        float _2315 = 3.5 * float(!(_2302 == 0.0));
        float _2324;
        if (!(_2299 == 0.0))
        {
            _2324 = _2285.z;
        }
        else
        {
            _2324 = _2289.z;
        }
        float _2321 = _2324;
        float _2333 = min(_2312 ? 2.0 : 1000.0, abs(_2293));
        float _2340 = max(_2285.x - _2257.x, _2257.x - _2289.x);
        float _2352 = max(_2285.y - _2257.y, _2257.y - _2289.y);
        float _2364 = max(_2340, _2352) - _2333;
        _2364 = max(_2364, _2321 - _2257.z);
        _2364 = max(_2364, _2293 - _2315);
        if (_2364 <= 0.0)
        {
            float _2385 = _2312 ? _2299 : _2302;
            vec3 _2390 = _721._m24.xyz;
            _2390.z *= (_2312 ? 1.0 : (-1.0));
            vec2 _2400 = _2257.xy - (_2390.xy * (_2293 / _2390.z));
            float _2411 = (_721._m73 / 100.0) * 16.0;
            vec2 _2418 = _2400 * _2411;
            float _2422 = TEXTURE_LOD(SAMPLER_2D(_2423, _2425), vec4(_2418, 0.0, 0.0).xy, vec4(_2418, 0.0, 0.0).w).x;
            float _2440 = min(8.0, _2289.z - _2285.z);
            float _2453 = (-_2293) / _2440;
            float _2448 = _10(_2453);
            float _2460 = dot(_977._m6, _2390);
            float _2455 = _10(_2460);
            float _2466 = _2340 / _2333;
            float _2462 = 1.0 - _10(_2466);
            float _2472 = _2352 / _2333;
            _2462 *= (1.0 - _10(_2472));
            _2462 *= _2462;
            float _2488 = min(_2293 / 1.0, 1.0 - (_2293 / _2315));
            float _2480 = _10(_2488);
            _2462 *= max(_2480, _2448);
            _2462 *= _2462;
            _2462 *= _2260;
            float _2501 = _2422 - 1.0;
            float _2504 = float(_2312) * _2305;
            float _2509 = max(0.0, _2422 - 0.85000002384185791015625);
            float _2514 = _2312 ? _2501 : _2509;
            float _2519 = (((1.0 - _2504) * _2455) * _2462) * _2385;
            vec3 _2528 = _977._m0 + (_977._m2 * (vec3(1.0) - _977._m0));
            _977._m21 += ((_2528 * (_2514 * _2519)) * _721._m23.xyz);
            float _2552 = _2504 * _2462;
            _977._m25 = 1.0 + (_2552 * (_2422 - 1.0));
        }
    }
    else
    {
        if (_2260 > 0.0)
        {
            _2260 *= _721._m74;
            float _2572 = float(_721._m24.w < 0.0);
            vec3 _2577 = _721._m24.xyz;
            float _2586 = dot(_977._m6, _2577);
            float _2581 = _10(_2586);
            vec2 _2588 = _2257.xy - (_2577.xy * (_2257.z / _2577.z));
            float _2600 = (_721._m73 / 100.0) * 16.0;
            vec2 _2605 = _2588 * _2600;
            float _2609 = TEXTURE_LOD(SAMPLER_2D(_2423, _2425), vec4(_2605, 0.0, 0.0).xy, vec4(_2605, 0.0, 0.0).w).x;
            vec4 _2625 = _721._m23;
            _977._m21 += (_2625.xyz * (((((1.0 - _2572) * (_2609 - 1.0)) * _2581) * _2260) * _2625.w));
            _977._m25 = 1.0 + ((_2572 * (_2609 - 1.0)) * _2260);
        }
    }
    _977._m14 = normalize(vec3(_721._m52, _721._m53, _721._m54) - _977._m15);
    vec3 _2667 = vec3(0.0);
    vec3 _2668 = vec3(0.0);
    vec3 _2669 = vec3(0.0);
    vec3 _2670 = vec3(0.0);
    vec3 _2671 = vec3(0.0);
    vec4 _2672 = _977._m29;
    vec4 _2675 = _977._m30;
    vec4 _2678 = _977._m31;
    _2668 = vec3(_2672.x, _2672.y, _2672.z);
    _2669 = vec3(_2672.w, _2675.x, _2675.y);
    _2670 = vec3(_2675.z, _2675.w, _2678.x);
    _2671 = vec3(_2678.y, _2678.z, _2678.w);
    vec3 _2709 = ((_2668 - (_2669 * _977._m6.y)) + (_2670 * _977._m6.z)) - (_2671 * _977._m6.x);
    float _2733 = _1115._m8 * _721._m75;
    _2667 += (max(vec3(0.0), _2709 * _10(_2733)) * _977._m0);
    vec3 _2742 = vec3(0.0);
    vec3 _2743 = vec3(0.0);
    vec3 _2744 = vec3(0.0);
    vec3 _2745 = vec3(0.0);
    vec3 _2746 = vec3(0.0);
    vec4 _2747 = _977._m29;
    vec4 _2750 = _977._m30;
    vec4 _2753 = _977._m31;
    _2743 = vec3(_2747.x, _2747.y, _2747.z);
    _2744 = vec3(_2747.w, _2750.x, _2750.y);
    _2745 = vec3(_2750.z, _2750.w, _2753.x);
    _2746 = vec3(_2753.y, _2753.z, _2753.w);
    vec3 _2784 = ((_2743 - (_2744 * _977._m8.y)) + (_2745 * _977._m8.z)) - (_2746 * _977._m8.x);
    float _2807 = _1115._m8 * _721._m75;
    _2742 += (max(vec3(0.0), _2784 * _10(_2807)) * _977._m0);
    uint _2818 = _977._m4;
    _2667 = mix(_2667, _2742, vec3(_93(_2818).w));
    _977._m21 += _2667;
    bool _2830 = true;
    _2830 = (((_721._m77 & 1u) != 0u) == true) ? false : true;
    if (true && (_2830 == true))
    {
        uint _2843 = _2847._m0[_2163 * 64u];
        uint _2854 = _2843 & 255u;
        uint _2858 = _2854;
        uint _2860 = _2843;
        uint _2862 = _2163;
        float _2864 = _977._m47;
        float _2873 = dot(_977._m14, _977._m6);
        float _2867 = _10(_2873);
        float _2875 = _2867;
        float _2877 = _977._m3;
        vec3 _2880 = _977._m2;
        _977._m24 = (_112(_2875, _2877, _2880) * _977._m11) * _977._m39;
        float _2891 = _721._m25.x;
        float _2894 = _721._m25.z;
        bool _2898 = _2891 > 0.0;
        bool _2905;
        if (_2898)
        {
            _2905 = _977._m3 > _2894;
        }
        else
        {
            _2905 = _2898;
        }
        if (_2905)
        {
            float _2908 = 0.0;
            vec3 _2909 = normalize(reflect(-_977._m14, _977._m6));
            if (dot(_977._m14, _2909) <= _2908)
            {
                vec2 _2925 = vec2(1.0);
                uvec2 _2939 = uvec2(_977._m17.xy * (vec2(1.0) / _2925));
                uint _2940 = uint(_721._m25.w);
                float _2927 = _169(_2939, _2940);
                _2927 -= 1.0;
                vec2 _2944 = _977._m17.xy * _721._m20.xy;
                vec3 _2959 = vec3(_2944, _977._m17.z);
                vec4 _2960 = _721._m26;
                vec4 _2963 = _721._m27;
                vec3 _2952 = _163(_2959, _2960, _2963);
                mat3 _2967 = mat3(vec3(_721._m28.xyz), vec3(_721._m29.xyz), vec3(_721._m30.xyz));
                mat3 _2991 = _2967;
                vec3 _2993 = _2909;
                vec3 _2990 = normalize(_71(_2991, _2993));
                float _2997 = 1.0;
                uint _2998 = uint((_2891 == 1.0) ? 8 : 12);
                _2998 = (_2891 == 3.0) ? 16u : _2998;
                vec3 _3009 = _2952;
                float _3014 = _977._m17.z;
                bool _3017 = true;
                float _3018 = _131(_3014, _3017);
                vec3 _3011 = _3009 + (_2990 * _3018);
                vec4 _3021 = vec4(0.0);
                vec3 _3023 = _3009;
                vec4 _3025 = _721._m31;
                vec3 _3022 = _157(_3023, _3025);
                vec3 _3030 = _3011;
                vec4 _3032 = _721._m31;
                vec3 _3029 = _157(_3030, _3032);
                vec3 _3036 = ((_3029 - _3022) * (_2997 / float(_2998))) / vec3(length(_3029.xy - _3022.xy));
                vec3 _3053 = _3022 + (_3036 * _2927);
                float _3059 = abs(_3036.z) * 1.0;
                uint _3064 = 0u;
                vec3 _3065 = _3053;
                float _3067 = _3022.z;
                float _3254;
                for (uint _3070 = 0u; _3070 < _2998; _3070 += 4u)
                {
                    vec4 _3079 = vec4(1.0, 2.0, 3.0, 4.0) + vec4(float(_3070));
                    vec4 _3085 = vec4(1.0) - vec4(TEXTURE_LOD(SAMPLER_2D(_3086, _3088), vec4(_3053.xy + (_3036.xy * _3079.x), 0.0, 0.0).xy, vec4(_3053.xy + (_3036.xy * _3079.x), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_3086, _3088), vec4(_3053.xy + (_3036.xy * _3079.y), 0.0, 0.0).xy, vec4(_3053.xy + (_3036.xy * _3079.y), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_3086, _3088), vec4(_3053.xy + (_3036.xy * _3079.z), 0.0, 0.0).xy, vec4(_3053.xy + (_3036.xy * _3079.z), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_3086, _3088), vec4(_3053.xy + (_3036.xy * _3079.w), 0.0, 0.0).xy, vec4(_3053.xy + (_3036.xy * _3079.w), 0.0, 0.0).w).x);
                    uvec4 _3207 = mix(uvec4(0u), uvec4(1u), lessThan(abs(((_3053.zzzz + (_3036.zzzz * _3079)) - _3085) - vec4(_3059)), vec4(_3059)));
                    uint _3227 = (((_3207.x << uint(0)) | (_3207.y << uint(1))) | (_3207.z << uint(2))) | (_3207.w << uint(3));
                    if (_3227 > 0u)
                    {
                        uint _3248 = _3227;
                        uint _3247 = uint(_50(_3248));
                        if (_3247 > 0u)
                        {
                            _3254 = _3085[_3247 - 1u];
                        }
                        else
                        {
                            _3254 = _3067;
                        }
                        _3067 = _3254;
                        _3065 = _3053 + (_3036 * float((_3070 + _3247) + 1u));
                        float _3273 = _3085[_3247] - _3065.z;
                        float _3280 = (_3067 - _3065.z) + _3036.z;
                        float _3294 = _3273 / (_3273 - _3280);
                        float _3288 = _10(_3294);
                        vec3 _3296 = _3065 - _3036;
                        _3065 = (_3296 * _3288) + (_3065 * (1.0 - _3288));
                        _3064 = _3070 + _3247;
                        break;
                    }
                    _3067 = _3085.w;
                }
                if (_3064 > 0u)
                {
                    vec3 _3322 = _3065;
                    vec4 _3324 = _721._m32;
                    vec4 _3327 = _721._m33;
                    vec4 _3330 = _721._m34;
                    vec4 _3333 = _721._m35;
                    vec3 _3321 = _64(_3322, _3324, _3327, _3330, _3333).xyw;
                    vec2 _3343 = _3321.xy / vec2(_3321.z);
                    _3321 = vec3(_3343.x, _3343.y, _3321.z);
                    vec2 _3346 = (_3321.xy * 2.0) - vec2(1.0);
                    float _3360 = (1.0 - (float(_3064) / float(_2998))) * 4.0;
                    float _3352 = _10(_3360);
                    if (false)
                    {
                        float _3364 = _3346.y;
                        float _3369 = 1.0 - _56(_3364);
                        _3352 *= smoothstep(0.0, 0.25, _10(_3369));
                    }
                    else
                    {
                        float _3379 = 1.0 - dot(_3346, _3346);
                        _3352 *= smoothstep(0.0, 0.5, _10(_3379));
                    }
                    vec3 _3384 = TEXTURE_LOD(SAMPLER_2D(_3385, _2206), vec4(_3321.xy, 0.0, 0.0).xy, vec4(_3321.xy, 0.0, 0.0).w).xyz;
                    _3021 = vec4(_3384, _3352);
                }
                float _3417 = 1.0 - ((1.0 - _977._m3) / (1.0 - _2894));
                float _3409 = _10(_3417);
                float _3419 = (_3021.w * _3409) * _721._m76;
                _977._m21 += ((_3021.xyz * _3419) * _977._m24);
                _2864 = 1.0 - _3419;
            }
        }
        uint _3441 = 1u;
        _3479 _3481;
        while (_3441 <= _2858)
        {
            uint _3450 = (_2862 * 64u) + _3441;
            uint _3455 = _2847._m0[_3450];
            uint _3459 = _3455;
            if (_3459 >= _3455)
            {
                _3441++;
            }
            float _3468 = 0.0039215688593685626983642578125;
            if (_2864 <= (_3468 * 4.0))
            {
                break;
            }
            int _3477 = 4;
            int _3478 = 4;
            _3481._m0 = _3486._m0[(uint(_3477) * _3459) + 0u].xyz;
            float _3501 = _3486._m0[(uint(_3477) * _3459) + 0u].w;
            _3481._m1 = _27(_3501);
            _3481._m2 = _3486._m0[(uint(_3477) * _3459) + 1u].xyz;
            _3481._m3 = _3486._m0[(uint(_3477) * _3459) + 1u].w;
            _3481._m4 = _3486._m0[(uint(_3477) * _3459) + 2u];
            float _3536 = _3486._m0[(uint(_3477) * _3459) + 3u].x;
            _3481._m8 = _27(_3536);
            float _3546 = _3486._m0[(uint(_3477) * _3459) + 3u].y;
            _3481._m9 = _27(_3546);
            _3481._m10 = _3486._m0[(uint(_3477) * _3459) + 3u].z;
            _3481._m5 = _3562._m0[(uint(_3478) * _3459) + 0u];
            _3481._m6 = _3562._m0[(uint(_3478) * _3459) + 1u];
            _3481._m7 = _3562._m0[(uint(_3478) * _3459) + 2u];
            _3481._m12 = _3562._m0[(uint(_3478) * _3459) + 3u].xyz;
            _3481._m13 = _3562._m0[(uint(_3478) * _3459) + 3u].w;
            vec3 _3604 = vec3(dot(_977._m15, _3481._m5.xyz) + _3481._m5.w, dot(_977._m15, _3481._m6.xyz) + _3481._m6.w, dot(_977._m15, _3481._m4.xyz) + _3481._m4.w);
            float _3633 = _3604.x;
            float _3636 = _3604.y;
            float _3639 = _3604.z;
            bool _3644 = _38(_3633, _3636, _3639) <= _3468;
            bool _3661;
            if (!_3644)
            {
                float _3648 = _3604.x;
                float _3651 = _3604.y;
                float _3654 = _3604.z;
                _3661 = _33(_3648, _3651, _3654) >= (1.0 - _3468);
            }
            else
            {
                _3661 = _3644;
            }
            if (_3661)
            {
                continue;
            }
            uint _3665 = _3481._m1;
            vec3 _3668 = _3481._m0;
            float _3671 = float(bitfieldExtract(_3481._m8, 20, 12));
            float _3676 = 0.800000011920928955078125;
            vec3 _3677 = (_3604 * 2.0) - vec3(1.0);
            vec3 _3682 = _3677;
            vec3 _3681 = _53(_3682);
            vec3 _3685 = _3677 * sqrt(((vec3(1.0) - (_3681.yzx * 0.5)) - (_3681.zxy * 0.5)) + ((_3681.yzx * _3681.zxy) / vec3(3.0)));
            float _3716 = 1.0 - ((length(_3685) - _3676) / ((1.0 - _3676) + 9.9999999747524270787835121154785e-07));
            float _3705 = _10(_3716);
            _3705 *= _3705;
            _3705 *= _2864;
            float _3724 = _3481._m7.w;
            _3705 *= _3724;
            _2864 *= (1.0 - _3705);
            vec3 _3734 = _3481._m12;
            float _3737 = _3481._m13;
            float _3742 = _3705;
            vec3 _3740 = _3734 * (_10(_3742) * _3737);
            vec3 _3748 = _3481._m2;
            vec3 _3751 = _3481._m7.xyz;
            vec3 _3755 = vec3(0.0);
            vec3 _3756 = reflect(-_977._m14, _977._m6);
            vec3 _3763 = (_3751 - _977._m15) / _3756;
            vec3 _3770 = (_3748 - _977._m15) / _3756;
            vec3 _3777 = max(_3763, _3770);
            float _3782 = _3777.x;
            float _3785 = _3777.y;
            float _3788 = _3777.z;
            float _3781 = _38(_3782, _3785, _3788);
            vec3 _3792 = _977._m15 + (_3756 * _3781);
            vec3 _3799 = _3792 - _3668;
            float _3803 = 6.0;
            float _3805 = _3803 - (_3803 * _977._m3);
            _3755 = textureLod(samplerCubeArray(_3814, _3816), vec4(_3799, _3671), _3805).xyz;
            _977._m21 += ((_3755 * _3740) * _977._m24);
        }
    }
    uint _3839 = _3843._m0[_2163 * 64u];
    uint _3848 = _3839 & 255u;
    uint _3851 = _3848;
    uint _3853 = _3839;
    uint _3855 = _2163;
    uint _3857 = 1u;
    _3479 _3886;
    vec3 _4013;
    float _4135;
    vec2 _4203;
    _4415 _4417;
    _4415 _4638;
    while (_3857 <= _3851)
    {
        uint _3866 = (_3855 * 64u) + _3857;
        uint _3871 = _3843._m0[_3866];
        uint _3875 = _3871;
        if (_3875 >= _3871)
        {
            _3857++;
        }
        int _3884 = 4;
        int _3885 = 4;
        _3886._m0 = _3486._m0[(uint(_3884) * _3875) + 0u].xyz;
        float _3901 = _3486._m0[(uint(_3884) * _3875) + 0u].w;
        _3886._m1 = _27(_3901);
        _3886._m2 = _3486._m0[(uint(_3884) * _3875) + 1u].xyz;
        _3886._m3 = _3486._m0[(uint(_3884) * _3875) + 1u].w;
        _3886._m4 = _3486._m0[(uint(_3884) * _3875) + 2u];
        float _3936 = _3486._m0[(uint(_3884) * _3875) + 3u].x;
        _3886._m8 = _27(_3936);
        float _3946 = _3486._m0[(uint(_3884) * _3875) + 3u].y;
        _3886._m9 = _27(_3946);
        _3886._m10 = _3486._m0[(uint(_3884) * _3875) + 3u].z;
        _3886._m5 = _3562._m0[(uint(_3885) * _3875) + 0u];
        _3886._m6 = _3562._m0[(uint(_3885) * _3875) + 1u];
        _3886._m7 = _3562._m0[(uint(_3885) * _3875) + 2u];
        _3886._m12 = _3562._m0[(uint(_3885) * _3875) + 3u].xyz;
        _3886._m13 = _3562._m0[(uint(_3885) * _3875) + 3u].w;
        float _4000 = 0.0;
        uint _4001 = _3886._m1;
        vec3 _4004 = _3886._m0;
        vec3 _4007 = _4004;
        if ((_4001 & 7u) == 2u)
        {
            _4013 = _4007;
        }
        else
        {
            _4013 = normalize(_4004 - _977._m15);
        }
        vec3 _4009 = _4013;
        uint _4024 = uint(((_2183 & 3u) != 0u) ? 16 : 0);
        _4024 |= 32u;
        if ((_4001 & _4024) != 0u)
        {
            continue;
        }
        vec3 _4040 = vec3(dot(_977._m15, _3886._m5.xyz) + _3886._m5.w, dot(_977._m15, _3886._m6.xyz) + _3886._m6.w, dot(_977._m15, _3886._m7.xyz) + _3886._m7.w);
        vec2 _4074 = _4040.xy / vec2(_4040.z);
        _4040 = vec3(_4074.x, _4074.y, _4040.z);
        _4040.z = dot(_977._m15, _3886._m4.xyz) + _3886._m4.w;
        float _4087 = _4040.x;
        float _4090 = _4040.y;
        float _4093 = _4040.z;
        bool _4098 = _38(_4087, _4090, _4093) <= _4000;
        bool _4115;
        if (!_4098)
        {
            float _4102 = _4040.x;
            float _4105 = _4040.y;
            float _4108 = _4040.z;
            _4115 = _33(_4102, _4105, _4108) >= (1.0 - _4000);
        }
        else
        {
            _4115 = _4098;
        }
        if (_4115)
        {
            continue;
        }
        vec3 _4119 = vec3(1.0);
        uint _4120 = _4001 & 7u;
        vec3 _4123 = _3886._m0 - _977._m15;
        float _4129 = dot(_4123, _4123);
        if (_4120 != 2u)
        {
            _4135 = 1.0 / (1.0 + _4129);
        }
        else
        {
            _4135 = _977._m25;
        }
        _4119 = vec3(_4135);
        if (_4120 == 0u)
        {
            float _4155 = _4129 * _3886._m3;
            float _4158 = 1.0 - _56(_4155);
            float _4160 = _10(_4158);
            float _4150 = _56(_4160);
            _4119 *= _4150;
        }
        else
        {
            if (_4120 == 4u)
            {
                float _4176 = length((_4040.xy - vec2(0.5)) * 2.0);
                float _4170 = _10(_4176);
                float _4178 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_4170 * 7.80000019073486328125))));
                _4119 *= _4178;
            }
            else
            {
                if ((_4120 == 1u) || (_4120 == 2u))
                {
                    if (_4120 == 2u)
                    {
                        _4203 = fract((_4040.xy * _721._m36.xy) + _721._m36.zw);
                    }
                    else
                    {
                        _4203 = _4040.xy;
                    }
                    vec2 _4200 = _4203;
                    vec3 _4221 = vec3(0.0);
                    uint _4222 = bitfieldExtract(_3886._m8, 0, 20);
                    uint _4226 = _4222;
                    uint _4230 = _4226 + 0u;
                    vec3 _4246 = TEXTURE_LOD(SAMPLER_2D(_1406[nonuniformEXT(_4230)], _1276), vec4(_4200, 0.0, 0.0).xy, vec4(_4200, 0.0, 0.0).w).xyz;
                    _4221 = _53(_4246);
                    _4119 *= _4221;
                }
            }
        }
        float _4252 = float((_4001 >> uint(8)) & 255u) / 255.0;
        if ((_4120 == 0u) || (_4120 == 2u))
        {
            vec3 _4265 = abs((_4040 * 2.0) - vec3(1.0));
            float _4271 = _4265.x;
            float _4274 = _4265.y;
            float _4277 = _4265.z;
            float _4282 = 1.0 - _33(_4271, _4274, _4277);
            float _4287 = _10(_4282) / (9.9999999392252902907785028219223e-09 + _4252);
            float _4270 = _10(_4287);
            _4119 *= ((_4270 * _4270) * (3.0 - (2.0 * _4270)));
        }
        else
        {
            if ((_4120 == 1u) || (_4120 == 4u))
            {
                float _4307 = _4040.z;
                float _4311 = _56(_4307);
                float _4314 = 1.0 - _56(_4311);
                float _4316 = _10(_4314);
                float _4321 = _56(_4316) / (9.9999999392252902907785028219223e-09 + _4252);
                float _4306 = _10(_4321);
                _4119 *= _4306;
            }
        }
        float _4326 = _4119.x;
        float _4329 = _4119.y;
        float _4332 = _4119.z;
        if (_33(_4326, _4329, _4332) <= _4000)
        {
            continue;
        }
        float _4341 = 1.0;
        if ((_4001 & 8u) != 0u)
        {
            float _4348 = 0.00200000009499490261077880859375;
            vec3 _4350 = _977._m15 + (_977._m6 * _4348);
            uint _4358 = 0u;
            if ((_4001 & 7u) == 0u)
            {
                vec3 _4364 = _4350 - _3886._m2;
                float _4369 = _4364.x;
                float _4372 = _4364.y;
                float _4375 = _4364.z;
                _4358 = _44(_4369, _4372, _4375);
            }
            else
            {
                if ((_4001 & 7u) == 2u)
                {
                    float _4385 = 0.0;
                    uint _4386 = uint((_721._m37.w > 0.0) ? 3 : 4);
                    for (; _4358 < _4386; _4358++)
                    {
                        int _4400 = 5;
                        bool _4404 = (_1115._m10 & 1u) != 0u;
                        bool _4412;
                        if (!_4404)
                        {
                            _4412 = (_1115._m10 & 2u) != 0u;
                        }
                        else
                        {
                            _4412 = _4404;
                        }
                        if (_4412)
                        {
                            _4417._m0 = _4422._m0[(uint(_4400) * ((_4001 >> uint(22)) + _4358)) + 0u];
                            _4417._m1 = _4422._m0[(uint(_4400) * ((_4001 >> uint(22)) + _4358)) + 1u];
                            _4417._m2 = _4422._m0[(uint(_4400) * ((_4001 >> uint(22)) + _4358)) + 2u];
                            _4417._m3 = _4422._m0[(uint(_4400) * ((_4001 >> uint(22)) + _4358)) + 3u];
                            _4417._m4 = _4422._m0[(uint(_4400) * ((_4001 >> uint(22)) + _4358)) + 4u];
                        }
                        else
                        {
                            _4417._m0 = _4482._m0[(uint(_4400) * ((_4001 >> uint(22)) + _4358)) + 0u];
                            _4417._m1 = _4482._m0[(uint(_4400) * ((_4001 >> uint(22)) + _4358)) + 1u];
                            _4417._m2 = _4482._m0[(uint(_4400) * ((_4001 >> uint(22)) + _4358)) + 2u];
                            _4417._m3 = _4482._m0[(uint(_4400) * ((_4001 >> uint(22)) + _4358)) + 3u];
                            _4417._m4 = _4482._m0[(uint(_4400) * ((_4001 >> uint(22)) + _4358)) + 4u];
                        }
                        vec2 _4538 = vec2(dot(_4350, _4417._m0.xyz) + _4417._m0.w, dot(_4350, _4417._m1.xyz) + _4417._m1.w);
                        _4538 = abs((_4538 * 2.0) - vec2(1.0));
                        bool _4564 = _4538.x < 0.9900000095367431640625;
                        bool _4570;
                        if (_4564)
                        {
                            _4570 = _4538.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _4570 = _4564;
                        }
                        if (_4570)
                        {
                            _4385 = (1.0 - max(_4538.x, _4538.y)) * _721._m38.w;
                            break;
                        }
                    }
                    _977._m36 = int(_4358);
                    _4358 = min((_4386 - 1u), _4358);
                    if (_721._m37.w > 0.0)
                    {
                        uint _4597 = uint(_977._m17.x) ^ (uint(_977._m17.y) << uint(1));
                        _4597 ^= uint(_721._m39.x);
                        _4358 += uint(int(((float(_4597 & 3u) * 0.25) + 0.125) > _4385));
                    }
                }
            }
            int _4623 = 5;
            bool _4627 = (_1115._m10 & 1u) != 0u;
            bool _4635;
            if (!_4627)
            {
                _4635 = (_1115._m10 & 2u) != 0u;
            }
            else
            {
                _4635 = _4627;
            }
            if (_4635)
            {
                _4638._m0 = _4422._m0[(uint(_4623) * ((_4001 >> uint(22)) + _4358)) + 0u];
                _4638._m1 = _4422._m0[(uint(_4623) * ((_4001 >> uint(22)) + _4358)) + 1u];
                _4638._m2 = _4422._m0[(uint(_4623) * ((_4001 >> uint(22)) + _4358)) + 2u];
                _4638._m3 = _4422._m0[(uint(_4623) * ((_4001 >> uint(22)) + _4358)) + 3u];
                _4638._m4 = _4422._m0[(uint(_4623) * ((_4001 >> uint(22)) + _4358)) + 4u];
            }
            else
            {
                _4638._m0 = _4482._m0[(uint(_4623) * ((_4001 >> uint(22)) + _4358)) + 0u];
                _4638._m1 = _4482._m0[(uint(_4623) * ((_4001 >> uint(22)) + _4358)) + 1u];
                _4638._m2 = _4482._m0[(uint(_4623) * ((_4001 >> uint(22)) + _4358)) + 2u];
                _4638._m3 = _4482._m0[(uint(_4623) * ((_4001 >> uint(22)) + _4358)) + 3u];
                _4638._m4 = _4482._m0[(uint(_4623) * ((_4001 >> uint(22)) + _4358)) + 4u];
            }
            vec4 _4750 = vec4((_4350.x * _4638._m0.x) + ((_4350.y * _4638._m0.y) + ((_4350.z * _4638._m0.z) + _4638._m0.w)), (_4350.x * _4638._m1.x) + ((_4350.y * _4638._m1.y) + ((_4350.z * _4638._m1.z) + _4638._m1.w)), (_4350.x * _4638._m2.x) + ((_4350.y * _4638._m2.y) + ((_4350.z * _4638._m2.z) + _4638._m2.w)), (_4350.x * _4638._m3.x) + ((_4350.y * _4638._m3.y) + ((_4350.z * _4638._m3.z) + _4638._m3.w)));
            vec3 _4837 = _4750.xyz / vec3(_4750.w);
            _4750 = vec4(_4837.x, _4837.y, _4837.z, _4750.w);
            bool _4845 = min(_4750.x, _4750.y) > 0.0;
            bool _4854;
            if (_4845)
            {
                _4854 = max(_4750.x, _4750.y) < 1.0;
            }
            else
            {
                _4854 = _4845;
            }
            if (_4854)
            {
                vec2 _4866 = (_4750.xy * _4638._m4.xy) + _4638._m4.zw;
                _4750 = vec4(_4866.x, _4866.y, _4750.z, _4750.w);
                if (false)
                {
                    _4341 = textureLod(sampler2DShadow(_4873, _4875), vec3(_4750.xyz.xy, _4750.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4884 = (_4750.xy * _721._m40.xy) + vec2(0.5);
                    vec2 _4893 = floor(_4884);
                    vec2 _4896 = _4884 - _4893;
                    _4893 -= vec2(0.5);
                    vec2 _4903 = vec2(4.0) - (_4896 * 3.0);
                    vec2 _4908 = vec2(7.0);
                    vec2 _4911 = vec2(1.0) + (_4896 * 3.0);
                    vec2 _4916 = (_4893 + (((vec2(3.0) - (_4896 * 2.0)) / _4903) - vec2(2.0))) * _721._m40.zw;
                    vec2 _4931 = (_4893 + ((vec2(3.0) + _4896) / _4908)) * _721._m40.zw;
                    vec2 _4943 = (_4893 + ((_4896 / _4911) + vec2(2.0))) * _721._m40.zw;
                    vec3 _4969 = vec3(_4916.x, _4916.y, _4750.z);
                    _4341 = (_4903.x * _4903.y) * textureLod(sampler2DShadow(_4873, _4875), vec3(_4969.xy, _4969.z), 0.0);
                    vec3 _4987 = vec3(_4931.x, _4916.y, _4750.z);
                    _4341 += ((_4908.x * _4903.y) * textureLod(sampler2DShadow(_4873, _4875), vec3(_4987.xy, _4987.z), 0.0));
                    vec3 _5007 = vec3(_4943.x, _4916.y, _4750.z);
                    _4341 += ((_4911.x * _4903.y) * textureLod(sampler2DShadow(_4873, _4875), vec3(_5007.xy, _5007.z), 0.0));
                    vec3 _5027 = vec3(_4916.x, _4931.y, _4750.z);
                    _4341 += ((_4903.x * _4908.y) * textureLod(sampler2DShadow(_4873, _4875), vec3(_5027.xy, _5027.z), 0.0));
                    vec3 _5047 = vec3(_4931.x, _4931.y, _4750.z);
                    _4341 += ((_4908.x * _4908.y) * textureLod(sampler2DShadow(_4873, _4875), vec3(_5047.xy, _5047.z), 0.0));
                    vec3 _5067 = vec3(_4943.x, _4931.y, _4750.z);
                    _4341 += ((_4911.x * _4908.y) * textureLod(sampler2DShadow(_4873, _4875), vec3(_5067.xy, _5067.z), 0.0));
                    vec3 _5087 = vec3(_4916.x, _4943.y, _4750.z);
                    _4341 += ((_4903.x * _4911.y) * textureLod(sampler2DShadow(_4873, _4875), vec3(_5087.xy, _5087.z), 0.0));
                    vec3 _5107 = vec3(_4931.x, _4943.y, _4750.z);
                    _4341 += ((_4908.x * _4911.y) * textureLod(sampler2DShadow(_4873, _4875), vec3(_5107.xy, _5107.z), 0.0));
                    vec3 _5127 = vec3(_4943.x, _4943.y, _4750.z);
                    _4341 += ((_4911.x * _4911.y) * textureLod(sampler2DShadow(_4873, _4875), vec3(_5127.xy, _5127.z), 0.0));
                    _4341 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _4341 = float((_4001 & 7u) == 2u);
                if ((_4001 & 7u) == 2u)
                {
                    _977._m36 = -1;
                }
            }
            float _5147 = float((_4001 >> uint(16)) & 63u) / 63.0;
            float _5161 = ((_4341 * _5147) + 1.0) - _5147;
            _4341 = _10(_5161);
        }
        if (_4341 <= _4000)
        {
            continue;
        }
        vec3 _5169 = (_3886._m12 * _4341) * _4119;
        float _5176 = _3886._m13;
        vec3 _5179 = _5169;
        float _5186 = dot(_977._m6, _4009);
        float _5181 = _10(_5186);
        float _5188 = 1.0;
        vec3 _5190 = _977._m6;
        vec3 _5193 = _977._m14;
        vec3 _5196 = _4009;
        vec3 _5198 = _977._m2;
        float _5201 = _977._m3;
        vec3 _5189 = _106(_5190, _5193, _5196, _5198, _5201);
        _977._m21 += ((((_5189 * _5176) * _5179) * _5181) * _5188);
        vec3 _5218 = _5179;
        uint _5221 = _977._m4;
        vec4 _5220 = _93(_5221);
        vec3 _5225 = _5220.xyz;
        float _5233 = dot(_977._m8, _4009);
        float _5228 = _10(_5233);
        vec3 _5235 = vec3(mix(_5181, _5228, _1103._m28), mix(_5181, _5228, _1103._m29), mix(_5181, _5228, _1103._m30));
        float _5264 = dot(_977._m14, -_4009);
        float _5266 = _10(_5264);
        float _5267 = _1103._m10.w;
        vec3 _5274 = ((_1103._m10.xyz + vec3(_977._m5)) * _79(_5266, _5267)) * _5225;
        _5235 += _16(_5274);
        float _5278 = _5220.w;
        _5235 = mix(vec3(_5181), _5235, vec3(_5278));
        _977._m21 += ((_5218 * _5235) * _977._m0);
    }
    _977._m21 *= _977._m11;
    if (_1115._m0.w > 0.0)
    {
        float _5308 = 1.0 - dot(_977._m6, _977._m14);
        _5308 = pow(_5308, 42.0);
        vec3 _5318 = mix(vec3(1.0), vec3(0.0), vec3(_977._m7.z));
        _5318 *= (_5318 * _5318);
        vec3 _5328 = vec3(_5308);
        _5328 = clamp(_5328, vec3(0.0), vec3(0.100000001490116119384765625));
        _977._m21 += ((_5318 + (_5328 * vec3(15.0))) * _1115._m0.xyz);
    }
    _976 = _977._m6.x;
    _5352 = vec4(_977._m21, 0.0);
    if (((_721._m77 & 1u) != 0u) == true)
    {
        vec3 _5367 = _977._m6;
        bool _5370 = false;
        vec2 _5371 = _177(_5367, _5370);
        _5366 = vec4(_5371, 0.0, 0.0);
        float _5381 = dot(_977._m14, _977._m6);
        float _5375 = _10(_5381);
        float _5384 = _5375;
        float _5386 = _977._m3;
        vec3 _5389 = _977._m2;
        vec3 _5383 = _112(_5384, _5386, _5389);
        float _5394 = _5383.x;
        float _5398 = _5383.y;
        float _5402 = _5383.z;
        float _5406 = _977._m3;
        _5393 = vec4(_82(_5394), _82(_5398), _82(_5402), _180(_5406));
    }
    float _5411 = _1115._m9;
    if (_5411 > 0.0)
    {
        vec2 _5418 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _721._m20.xy;
        vec2 _5434 = vec2(_980, _982);
        float _5438 = (SAMPLE_TEXTURE(SAMPLER_2D(_5439, _1411), _5434 * _1103._m11.xy).x * 0.5) - 0.100000001490116119384765625;
        if (_5411 > _5438)
        {
            vec3 _5479 = TEXTURE_LOD(SAMPLER_2D(_3385, _1411), vec4(_5418 + vec2(_976 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).xy, vec4(_5418 + vec2(_976 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).w).xyz;
            _5352 = vec4(_5479.x, _5479.y, _5479.z, _5352.w);
        }
        else
        {
            if (_5411 > (_5438 - 0.02500000037252902984619140625))
            {
                _5352 = vec4(vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).x, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).y, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).z, _5352.w);
            }
        }
    }
}

