#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 40, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

struct _121
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _2858
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _3816
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _748_750
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    vec4 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    vec4 _m37;
    vec4 _m38;
    vec4 _m39;
    vec4 _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    uint _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    float _m64;
    float _m65;
    float _m66;
    float _m67;
    float _m68;
    float _m69;
    float _m70;
    float _m71;
    float _m72;
    float _m73;
    float _m74;
    float _m75;
    float _m76;
    uint _m77;
    float _m78[3];
} _750;

layout(set = 2, binding = 0, std140) uniform _1131_1133
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    float _m3;
    float _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    uint _m14;
    uint _m15;
    uint _m16;
    float _m17[2];
} _1133;

layout(set = 1, binding = 0, std140) uniform _1142_1144
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    int _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    uint _m15;
} _1144;

layout(set = 3, binding = 0, std140) uniform _1182_1184
{
    vec4 _m0[5];
    vec4 _m1[5];
    vec4 _m2[5];
    vec4 _m3[5];
} _1184;

layout(set = 0, binding = 26, std430) restrict readonly buffer _2224_2226
{
    uint _m0[];
} _2226;

layout(set = 0, binding = 30, std140) uniform _2863_2865
{
    vec4 _m0[4096];
} _2865;

layout(set = 0, binding = 31, std140) uniform _2939_2941
{
    vec4 _m0[4096];
} _2941;

layout(set = 0, binding = 33, std430) restrict readonly buffer _3220_3222
{
    uint _m0[];
} _3222;

layout(set = 0, binding = 34, std140) uniform _3821_3823
{
    vec4 _m0[4095];
} _3823;

layout(set = 0, binding = 35, std140) uniform _3881_3883
{
    vec4 _m0[4095];
} _3883;

layout(set = 0, binding = 1, std140) uniform _5087_5089
{
    vec4 _m0[64];
} _5089;

layout(push_constant, std430) uniform _5083_5085
{
    int _m0;
} _5085;

layout(set = 3, binding = 1) uniform TEXTURE_2D _1231[5];
layout(set = 0, binding = 10) uniform sampler _1239;
layout(set = 3, binding = 3) uniform TEXTURE_2D _1260[5];
layout(set = 0, binding = 11) uniform sampler _1265;
layout(set = 3, binding = 2) uniform TEXTURE_2D _1275[5];
layout(set = 0, binding = 12) uniform sampler _1280;
layout(set = 3, binding = 4) uniform TEXTURE_2D _1300[5];
layout(set = 0, binding = 13) uniform sampler _1305;
layout(set = 3, binding = 5) uniform TEXTURE_2D _1315[5];
layout(set = 0, binding = 14) uniform sampler _1320;
layout(set = 3, binding = 7) uniform TEXTURE_2D _1330[5];
layout(set = 0, binding = 15) uniform sampler _1335;
layout(set = 3, binding = 8) uniform TEXTURE_2D _1345[5];
layout(set = 0, binding = 16) uniform sampler _1350;
layout(set = 0, binding = 17) uniform TEXTURE_2D _1425;
layout(set = 0, binding = 18) uniform sampler _1427;
layout(set = 0, binding = 19) uniform TEXTURE_2D _1443;
layout(set = 0, binding = 20) uniform sampler _1445;
layout(set = 0, binding = 21) uniform TEXTURE_2D _1484;
layout(set = 0, binding = 22) uniform TEXTURE_2D _1666;
layout(set = 0, binding = 23) uniform sampler _1668;
layout(set = 0, binding = 24) uniform TEXTURE_2D _1885;
layout(set = 0, binding = 25) uniform sampler _1887;
layout(set = 0, binding = 27) uniform TEXTURE_2D _2465;
layout(set = 0, binding = 28) uniform sampler _2467;
layout(set = 0, binding = 29) uniform TEXTURE_2D _2764;
layout(set = 0, binding = 32) uniform textureCubeArray _3193;
layout(set = 0, binding = 9) uniform sampler _3195;
layout(set = 4, binding = 0) uniform TEXTURE_2D _3627[34816];
layout(set = 0, binding = 36) uniform texture2D _4274;
layout(set = 0, binding = 37) uniform samplerShadow _4276;
layout(set = 0, binding = 38) uniform TEXTURE_2D _5027;
layout(set = 3, binding = 6) uniform TEXTURE_2D _5082[5];
layout(set = 0, binding = 6) uniform texture3D _5092;
layout(set = 0, binding = 7) uniform sampler _5093;
layout(set = 0, binding = 8) uniform texture3D _5094;

layout(location = 17, component = 3) in float _1009;
layout(location = 18, component = 0) in float _1011;
layout(location = 18, component = 1) in float _1016;
layout(location = 18, component = 2) in float _1018;
layout(location = 18, component = 3) in float _1020;
layout(location = 19, component = 0) in float _1051;
layout(location = 19, component = 1) in float _1053;
layout(location = 19, component = 2) in float _1055;
layout(location = 19, component = 3) in float _1059;
layout(location = 20, component = 0) in float _1061;
layout(location = 20, component = 1) in float _1063;
layout(location = 20, component = 2) in float _1075;
layout(location = 10, component = 0) in vec4 _1100;
layout(location = 11, component = 0) in vec4 _1103;
layout(location = 12, component = 0) in vec4 _1106;
layout(location = 20, component = 3) in float _1478;
layout(location = 21, component = 0) in float _1480;
layout(location = 21, component = 2) in float _1495;
layout(location = 0, component = 0) out vec4 _4940;
layout(location = 1, component = 0) out vec4 _4954;
layout(location = 2, component = 0) out vec4 _4981;
uint _184;
uint _186;
uint _188;
uint _190;
uint _192;
uint _194;
uint _196;
uint _197;
uint _199;
uint _200;
uint _202;
uint _204;
uint _206;
uint _208;
uint _210;
uint _212;
uint _214;
uint _216;
uint _218;

_121 _123()
{
    _121 _636;
    _636._m0 = vec3(0.0);
    _636._m2 = vec3(0.0);
    _636._m3 = 0.0;
    _636._m4 = 0u;
    _636._m5 = 0.0;
    _636._m6 = vec3(0.0);
    _636._m7 = vec3(0.0, 0.0, 1.0);
    _636._m8 = vec3(0.0, 0.0, 1.0);
    _636._m1 = vec3(0.0);
    _636._m9 = 1.0;
    _636._m10 = 1.0;
    _636._m14 = vec3(0.0);
    _636._m15 = vec3(0.0);
    _636._m16 = vec4(0.0);
    _636._m17 = vec4(0.0);
    _636._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _636._m19 = vec3(0.0);
    _636._m20 = vec3(0.0);
    _636._m21 = vec3(0.0);
    _636._m22 = vec3(0.0);
    _636._m23 = vec3(0.0);
    _636._m24 = vec3(0.0);
    _636._m25 = 1.0;
    _636._m26 = uvec4(0u);
    _636._m27 = uvec4(0u);
    _636._m28 = uvec4(0u);
    _636._m29 = vec4(0.0);
    _636._m30 = vec4(0.0);
    _636._m31 = vec4(0.0);
    _636._m32 = vec4(0.0);
    _636._m33 = uvec2(0u);
    _636._m34 = vec2(0.0);
    _636._m35 = 0.0;
    _636._m36 = -1;
    _636._m37 = 0;
    _636._m38 = vec2(0.0);
    _636._m39 = 1.0;
    _636._m41 = -1;
    _636._m45 = 1.0;
    _636._m11 = 1.0;
    _636._m12 = 0u;
    _636._m13 = uvec3(0u);
    _636._m40 = vec3(0.0);
    _636._m46 = 0.0;
    _636._m47 = 1.0;
    return _636;
}

vec2 _16(vec2 _15)
{
    return clamp(_15, vec2(0.0), vec2(1.0));
}

float _127(vec2 _126)
{
    return dot(_126, _126);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _22(vec3 _21)
{
    return clamp(_21, vec3(0.0), vec3(1.0));
}

vec2 _137(vec2 _136)
{
    return ((_136 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _142(inout vec2 _140, bool _141)
{
    vec2 _783 = _140;
    _140 = _137(_783);
    float _803 = (1.0 - (_140.x * _140.x)) - (_140.y * _140.y);
    vec3 _786 = vec3(_140.x, _140.y, sqrt(_10(_803)));
    if (_141 == false)
    {
        _786.z = -_786.z;
    }
    return _786;
}

vec3 _83(mat3 _81, vec3 _82)
{
    return _81 * _82;
}

vec3 _147(vec3 _145, mat3 _146)
{
    mat3 _819 = _146;
    vec3 _821 = _145;
    return normalize(_83(_819, _821));
}

vec3 _153(vec2 _150, mat3 _151, bool _152)
{
    vec2 _828 = _150;
    bool _830 = _152;
    vec3 _832 = _142(_828, _830);
    vec3 _827 = _832;
    vec3 _833 = _827;
    mat3 _835 = _151;
    return _147(_833, _835);
}

float _134(inout float _132, bool _133)
{
    if (_133)
    {
        _132 += (float(_132 < _750._m41) * _750._m42);
    }
    float _764 = _132;
    return _750._m0.w / (_10(_764) + _750._m0.z);
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _86(float _85)
{
    return exp2(_85);
}

vec3 _116(float _113, float _114, vec3 _115)
{
    float _587 = 0.0949999988079071044921875 + (_114 * (0.60000002384185791015625 + (4.190000057220458984375 * _114)));
    float _597 = _113 + 0.02500000037252902984619140625;
    float _601 = (9.5 * _114) * _113;
    float _615 = 1.0 - (14.0 * _113);
    float _607 = (_587 * _597) * _86(_615);
    float _622 = -_601;
    float _618 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _86(_622)));
    return mix(vec3(_607), vec3(_618), _115);
}

float _170(uvec2 _168, uint _169)
{
    uvec2 _890 = _168 & uvec2(3u);
    return float(((((2068378560u * (1u - (_890.x >> uint(1)))) + (1500172770u * (_890.x >> uint(1)))) >> ((_890.y + ((_890.x & 1u) << uint(2))) << uint(2))) + _169) & 15u) / 16.0;
}

vec3 _164(vec3 _161, vec4 _162, vec4 _163)
{
    return vec3((_162.xy * _161.xy) + _162.zw, _163.z) / vec3((_163.x * _161.z) + _163.y);
}

vec3 _158(vec3 _156, vec4 _157)
{
    return vec3(vec2(0.5) + (_157.xy * (_156.xy / vec2(_156.z))), (_157.w / _156.z) + _157.z);
}

int _50(uint _49)
{
    return findLSB(_49);
}

vec4 _76(vec3 _71, vec4 _72, vec4 _73, vec4 _74, vec4 _75)
{
    return vec4((_71.x * _72.x) + ((_71.y * _72.y) + ((_71.z * _72.z) + _72.w)), (_71.x * _73.x) + ((_71.y * _73.y) + ((_71.z * _73.z) + _73.w)), (_71.x * _74.x) + ((_71.y * _74.y) + ((_71.z * _74.z) + _74.w)), (_71.x * _75.x) + ((_71.y * _75.y) + ((_71.z * _75.z) + _75.w)));
}

float _68(float _67)
{
    return _67 * _67;
}

float _38(float _35, float _36, float _37)
{
    return min(_35, min(_36, _37));
}

float _33(float _30, float _31, float _32)
{
    return max(_30, max(_31, _32));
}

vec3 _65(vec3 _64)
{
    return _64 * _64;
}

uint _44(float _41, float _42, float _43)
{
    bool _260 = abs(_43) >= abs(_41);
    bool _268;
    if (_260)
    {
        _268 = abs(_43) >= abs(_42);
    }
    else
    {
        _268 = _260;
    }
    if (_268)
    {
        return uint((_43 < 0.0) ? 5 : 4);
    }
    if (abs(_42) >= abs(_41))
    {
        return uint((_42 < 0.0) ? 3 : 2);
    }
    return uint(int(_41 < 0.0));
}

float _91(float _89, float _90)
{
    return pow(_89, _90);
}

vec3 _102(vec3 _100, float _101)
{
    float _474 = dot(_100, vec3(16.666500091552734375));
    float _469 = _10(_474);
    float _483 = 1.0 - _101;
    float _486 = _10(_483);
    float _487 = 5.0;
    vec3 _491 = _100 + ((vec3(_469) - _100) * _91(_486, _487));
    return _22(_491);
}

vec3 _110(vec3 _105, vec3 _106, vec3 _107, vec3 _108, float _109)
{
    float _499 = dot(_105, _106);
    float _495 = _10(_499);
    vec3 _501 = normalize(_106 + _107);
    float _510 = dot(_105, _501);
    float _506 = _10(_510);
    float _516 = dot(_107, _501);
    float _512 = _10(_516);
    vec3 _519 = _108;
    float _521 = _512;
    vec3 _518 = _102(_519, _521);
    float _528 = dot(_105, _107);
    float _524 = _10(_528);
    float _530 = 1.0 - (_109 * 0.800000011920928955078125);
    _530 *= _530;
    _530 *= _530;
    float _541 = _530 * _530;
    float _545 = ((_506 * _506) * (_541 - 1.0)) + 1.0;
    _545 = _541 / ((_545 * _545) + 9.9999999392252902907785028219223e-09);
    float _560 = (_495 * (1.0 - _530)) + _530;
    float _567 = (_524 * (1.0 - _530)) + _530;
    _545 /= (((4.0 * _560) * _567) + 9.9999999392252902907785028219223e-09);
    return _518 * _545;
}

float _53(float _52)
{
    float _307;
    if (_52 <= 0.040449999272823333740234375)
    {
        _307 = _52 / 12.9200000762939453125;
    }
    else
    {
        _307 = pow((_52 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
    return _307;
}

vec3 _56(vec3 _55)
{
    float _324 = _55.x;
    float _328 = _55.y;
    float _333 = _55.z;
    return vec3(_53(_324), _53(_328), _53(_333));
}

vec4 _62(vec4 _61)
{
    vec3 _341 = _61.xyz;
    return vec4(_56(_341), _61.w);
}

vec2 _173(vec2 _172)
{
    return (vec2(1.0) - abs(_172.yx)) * vec2((_172.x >= 0.0) ? 1.0 : (-1.0), (_172.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _178(inout vec3 _176, bool _177)
{
    _176 /= vec3((abs(_176.x) + abs(_176.y)) + abs(_176.z));
    vec2 _959;
    if (_176.z >= 0.0)
    {
        _959 = _176.xy;
    }
    else
    {
        vec2 _965 = _176.xy;
        _959 = _173(_965);
    }
    _176 = vec3(_959.x, _959.y, _176.z);
    if (_177)
    {
        vec2 _979 = (_176.xy * 0.5) + vec2(0.5);
        _176 = vec3(_979.x, _979.y, _176.z);
    }
    return _176.xy;
}

float _94(float _93)
{
    return sqrt(_93);
}

float _97(float _96)
{
    return sqrt(_96);
}

float _181(float _180)
{
    float _989 = abs(_180);
    float _986 = _97(_989);
    float _993;
    if (_180 > 0.0)
    {
        _993 = _986;
    }
    else
    {
        _993 = -_986;
    }
    return (_993 * 0.5) + 0.5;
}

void main()
{
    _184 = 2147483648u;
    _186 = 1073741824u;
    _188 = 0u;
    _190 = 268435456u;
    _192 = 536870912u;
    _194 = 805306368u;
    _196 = 1073741824u;
    _197 = 1342177280u;
    _199 = 0u;
    _200 = 16777216u;
    _202 = 33554432u;
    _204 = 50331648u;
    _206 = 67108864u;
    _208 = 83886080u;
    _210 = 100663296u;
    _212 = 117440512u;
    _214 = 134217728u;
    _216 = 150994944u;
    _218 = 167772160u;
    float _1005 = 0.0;
    _121 _1006 = _123();
    _1006._m16 = vec4(0.0, 0.0, _1009, _1011);
    vec3 _1015 = vec3(_1016, _1018, _1020);
    _1006._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _1006._m15 = vec3(_750._m52, _750._m53, _750._m54) + _1015;
    vec3 _1049 = vec3(0.0);
    vec3 _1050 = vec3(0.0);
    _1049 = normalize(vec3(_1051, _1053, _1055));
    _1050 = normalize(vec3(_1059, _1061, _1063));
    vec3 _1067 = _1049;
    vec3 _1069 = _1050;
    vec3 _1071 = normalize(cross(_1067, _1069) * _1075);
    _1006._m18 = mat3(vec3(_1069), vec3(_1071), vec3(_1067));
    _1006._m14 = normalize(-_1015);
    _1006._m29 = _1100;
    _1006._m30 = _1103;
    _1006._m31 = _1106;
    uint _1109 = 0u;
    vec4 _1110 = vec4(0.0);
    vec4 _1111 = vec4(0.0);
    vec4 _1112 = vec4(0.0);
    vec4 _1113 = vec4(0.0);
    vec4 _1114 = vec4(0.0);
    float _1115 = 0.0;
    uvec2 _1116 = uvec2(0u, 65535u);
    vec2 _1119 = _1006._m16.zw;
    vec2 _1123 = _1119;
    vec2 _1125 = _1119;
    float _1127 = 0.0009765625;
    vec3 _1139;
    if ((_1133._m16 & 1u) != 0u)
    {
        _1139 = vec3(_1144._m6, _1144._m7, _1144._m8);
    }
    else
    {
        _1139 = vec3(1.0);
    }
    vec3 _1129 = _1139;
    float _1155 = 1.0;
    float _1156 = _1144._m9;
    bool _1159 = _1156 > 0.0;
    float _1162 = 1.0;
    uint _1163 = _1116.x;
    uint _1166 = _1163 & 7u;
    uint _1170 = _1166;
    uint _1172 = _1170;
    float _1174 = 0.0;
    vec2 _1175 = _1123;
    _1175.x *= _1184._m1[_1172].w;
    _1175.y *= _1184._m2[_1172].x;
    _1175.x += (_750._m70 * _1184._m2[_1172].y);
    _1175.y += (_750._m70 * _1184._m2[_1172].z);
    float _1220 = -1.0;
    vec4 _1221 = vec4(_1175, 0.0, _1220);
    uint _1233 = _1172;
    vec3 _1227 = (SAMPLE_TEXTURE1(SAMPLER_2D(_1231[nonuniformEXT(_1233)], _1239), _1221.xy, _1221.w).xyz * vec3(_1184._m0[_1172].x)) + vec3(_1184._m0[_1172].y);
    uint _1262 = _1172;
    vec2 _1259 = SAMPLE_TEXTURE1(SAMPLER_2D(_1260[nonuniformEXT(_1262)], _1265), _1221.xy, _1221.w).xy;
    uint _1277 = _1172;
    vec3 _1274 = (SAMPLE_TEXTURE1(SAMPLER_2D(_1275[nonuniformEXT(_1277)], _1280), _1221.xy, _1221.w).xyz * vec3(_1184._m0[_1172].z)) + vec3(_1184._m0[_1172].w);
    uint _1302 = _1172;
    float _1299 = SAMPLE_TEXTURE1(SAMPLER_2D(_1300[nonuniformEXT(_1302)], _1305), _1221.xy, _1221.w).x;
    uint _1317 = _1172;
    float _1314 = SAMPLE_TEXTURE1(SAMPLER_2D(_1315[nonuniformEXT(_1317)], _1320), _1221.xy, _1221.w).x;
    uint _1332 = _1172;
    vec3 _1329 = SAMPLE_TEXTURE1(SAMPLER_2D(_1330[nonuniformEXT(_1332)], _1335), _1221.xy, _1221.w).xyz;
    uint _1347 = _1172;
    float _1344 = SAMPLE_TEXTURE1(SAMPLER_2D(_1345[nonuniformEXT(_1347)], _1350), _1221.xy, _1221.w).x;
    _1110 = vec4(_1227.x, _1227.y, _1227.z, _1110.w);
    _1110.w = 0.0;
    _1111 = vec4(_1274.x, _1274.y, _1274.z, _1111.w);
    _1111.w = _1314;
    _1112 = vec4(_1259.x, _1259.y, _1112.z, _1112.w);
    _1113.x = 0.0;
    _1113.y = _1174;
    _1113.z = _1314;
    _1113.w = _1299;
    _1115 = _1344;
    _1162 = _1184._m1[_1172].x;
    vec3 _1388 = _1329 * _1184._m3[_1172].xyz;
    _1114 = vec4(_1388.x, _1388.y, _1388.z, _1114.w);
    float _1391 = _1159 ? _1156 : _1162;
    vec3 _1400 = _1114.xyz * vec3(_1391);
    _1114 = vec4(_1400.x, _1400.y, _1400.z, _1114.w);
    vec2 _1403 = vec2(0.0);
    _1006._m22 = _1114.xyz * _1129;
    _1006._m0 = _1110.xyz;
    _1006._m2 = _1111.xyz;
    _1006._m1 = _1114.xyz;
    _1006._m3 = _1113.w;
    _1006._m6 = _1112.xyz;
    vec4 _1424 = TEXEL_FETCH(SAMPLER_2D(_1425, _1427), ivec2(0), 0);
    float _1434 = _1424.w;
    if (_1434 > 0.0)
    {
        float _1441 = 1.0;
        vec4 _1442 = SAMPLE_TEXTURE(SAMPLER_2D(_1443, _1445), _1006._m16.zw * _1133._m10);
        vec2 _1455 = _1442.xy;
        vec2 _1458 = _1455;
        vec2 _1467 = _1006._m6.xy + (_16(_1458) - vec2(0.4980392158031463623046875));
        _1006._m6 = vec3(_1467.x, _1467.y, _1006._m6.z);
        _1434 *= (_1442.w * _1441);
        vec2 _1477 = vec2(_1478, _1480);
        vec2 _1483 = SAMPLE_TEXTURE(SAMPLER_2D(_1484, _1445), _1477).xy;
        vec2 _1491 = _1483;
        vec2 _1500 = ((_16(_1491) - vec2(0.4980392158031463623046875)) * _1495) * 10.0;
        _1483 = _16(_1500);
        _1434 += (length(_1483) * 2.0);
        vec2 _1508 = _1483;
        vec2 _1514 = _1006._m6.xy + _16(_1508);
        _1006._m6 = vec3(_1514.x, _1514.y, _1006._m6.z);
        vec2 _1522 = _1006._m6.xy - vec2(0.4980392158031463623046875);
        float _1525 = 1.0 - _127(_1522);
        _1006._m6.z = sqrt(_10(_1525));
        _1006._m3 = mix(_1006._m3, _1006._m3 * _1133._m11, _1434);
        _1006._m3 = max(_1133._m12 * _1434, _1006._m3);
        _1006._m0 = mix(_1006._m0, _1006._m0 * _1133._m13, vec3(_1434));
        vec3 _1565 = _1006._m0 + (_1442.zzz * _1441);
        _1006._m0 = _22(_1565);
    }
    uint _1568 = 0u;
    bool _1569 = true;
    vec2 _1571 = _1006._m6.xy;
    bool _1575 = _1569;
    vec3 _1577 = _142(_1571, _1575);
    _1006._m7 = _1577;
    vec2 _1579 = _1006._m6.xy;
    mat3 _1583 = _1006._m18;
    bool _1586 = _1569;
    _1006._m6 = _153(_1579, _1583, _1586);
    uvec2 _1590 = uvec2(_1006._m17.xy);
    uint _1595 = _1590.x / 256u;
    uint _1600 = _1590.y / 256u;
    float _1605 = _1006._m17.z;
    bool _1608 = false;
    float _1609 = _134(_1605, _1608);
    float _1604 = _1609;
    float _1610 = log2(max(1.0, _1604 / _750._m18.z)) * _750._m18.w;
    uint _1620 = min(23u, uint(_1610));
    float _1627 = _750._m71;
    float _1633 = _750._m72;
    uint _1625 = (_27(_1627) + ((_1595 + (_27(_1633) * _1600)) * 24u)) + _1620;
    float _1646 = _1144._m10;
    uint _1645 = _27(_1646);
    float _1650 = _750._m19.x;
    if (_1650 > 0.0)
    {
        vec2 _1657 = _1006._m17.xy * _750._m20.xy;
        vec3 _1665 = (TEXTURE_LOD(SAMPLER_2D(_1666, _1668), vec4(_1657, 0.0, 0.0).xy, vec4(_1657, 0.0, 0.0).w).xyz * 2.0) - vec3(1.0);
        float _1690 = dot(_1665, _1006._m6);
        _1006._m11 = _10(_1690);
        float _1698 = 1.0 - pow(_1006._m11, 0.699999988079071044921875);
        _1006._m11 = _10(_1698);
        _1006._m11 *= _1006._m11;
    }
    _1006._m21 = _1006._m22;
    _1006._m25 = 1.0;
    float _1711 = _750._m21.w;
    bool _1714 = _1711 < 0.0;
    _1711 = abs(_1711);
    vec3 _1719 = _1006._m15;
    float _1738 = (1.0 - (length(_1719 - vec3(_750._m52, _750._m53, _750._m54)) / _1711)) / 0.25;
    float _1722 = _10(_1738);
    if ((!_1714) && (_1722 > 0.0))
    {
        vec3 _1747 = _750._m21.xyz;
        vec3 _1751 = _750._m22.xyz;
        float _1755 = _1719.z - _1751.z;
        float _1761 = _750._m23.w;
        float _1764 = _750._m24.w;
        float _1767 = float(_1764 < 0.0);
        _1764 = abs(_1764) - 1.0;
        bool _1774 = _1755 <= 0.0;
        float _1777 = 3.5 * float(!(_1764 == 0.0));
        float _1786;
        if (!(_1761 == 0.0))
        {
            _1786 = _1747.z;
        }
        else
        {
            _1786 = _1751.z;
        }
        float _1783 = _1786;
        float _1795 = min(_1774 ? 2.0 : 1000.0, abs(_1755));
        float _1802 = max(_1747.x - _1719.x, _1719.x - _1751.x);
        float _1814 = max(_1747.y - _1719.y, _1719.y - _1751.y);
        float _1826 = max(_1802, _1814) - _1795;
        _1826 = max(_1826, _1783 - _1719.z);
        _1826 = max(_1826, _1755 - _1777);
        if (_1826 <= 0.0)
        {
            float _1847 = _1774 ? _1761 : _1764;
            vec3 _1852 = _750._m24.xyz;
            _1852.z *= (_1774 ? 1.0 : (-1.0));
            vec2 _1862 = _1719.xy - (_1852.xy * (_1755 / _1852.z));
            float _1873 = (_750._m73 / 100.0) * 16.0;
            vec2 _1880 = _1862 * _1873;
            float _1884 = TEXTURE_LOD(SAMPLER_2D(_1885, _1887), vec4(_1880, 0.0, 0.0).xy, vec4(_1880, 0.0, 0.0).w).x;
            float _1902 = min(8.0, _1751.z - _1747.z);
            float _1915 = (-_1755) / _1902;
            float _1910 = _10(_1915);
            float _1922 = dot(_1006._m6, _1852);
            float _1917 = _10(_1922);
            float _1928 = _1802 / _1795;
            float _1924 = 1.0 - _10(_1928);
            float _1934 = _1814 / _1795;
            _1924 *= (1.0 - _10(_1934));
            _1924 *= _1924;
            float _1950 = min(_1755 / 1.0, 1.0 - (_1755 / _1777));
            float _1942 = _10(_1950);
            _1924 *= max(_1942, _1910);
            _1924 *= _1924;
            _1924 *= _1722;
            float _1963 = _1884 - 1.0;
            float _1966 = float(_1774) * _1767;
            float _1971 = max(0.0, _1884 - 0.85000002384185791015625);
            float _1976 = _1774 ? _1963 : _1971;
            float _1981 = (((1.0 - _1966) * _1917) * _1924) * _1847;
            vec3 _1990 = _1006._m0 + (_1006._m2 * (vec3(1.0) - _1006._m0));
            _1006._m21 += ((_1990 * (_1976 * _1981)) * _750._m23.xyz);
            float _2014 = _1966 * _1924;
            _1006._m25 = 1.0 + (_2014 * (_1884 - 1.0));
        }
    }
    else
    {
        if (_1722 > 0.0)
        {
            _1722 *= _750._m74;
            float _2034 = float(_750._m24.w < 0.0);
            vec3 _2039 = _750._m24.xyz;
            float _2048 = dot(_1006._m6, _2039);
            float _2043 = _10(_2048);
            vec2 _2050 = _1719.xy - (_2039.xy * (_1719.z / _2039.z));
            float _2062 = (_750._m73 / 100.0) * 16.0;
            vec2 _2067 = _2050 * _2062;
            float _2071 = TEXTURE_LOD(SAMPLER_2D(_1885, _1887), vec4(_2067, 0.0, 0.0).xy, vec4(_2067, 0.0, 0.0).w).x;
            vec4 _2087 = _750._m23;
            _1006._m21 += (_2087.xyz * (((((1.0 - _2034) * (_2071 - 1.0)) * _2043) * _1722) * _2087.w));
            _1006._m25 = 1.0 + ((_2034 * (_2071 - 1.0)) * _1722);
        }
    }
    _1006._m14 = normalize(vec3(_750._m52, _750._m53, _750._m54) - _1006._m15);
    vec3 _2129 = vec3(0.0);
    vec3 _2130 = vec3(0.0);
    vec3 _2131 = vec3(0.0);
    vec3 _2132 = vec3(0.0);
    vec3 _2133 = vec3(0.0);
    vec4 _2134 = _1006._m29;
    vec4 _2137 = _1006._m30;
    vec4 _2140 = _1006._m31;
    _2130 = vec3(_2134.x, _2134.y, _2134.z);
    _2131 = vec3(_2134.w, _2137.x, _2137.y);
    _2132 = vec3(_2137.z, _2137.w, _2140.x);
    _2133 = vec3(_2140.y, _2140.z, _2140.w);
    vec3 _2171 = ((_2130 - (_2131 * _1006._m6.y)) + (_2132 * _1006._m6.z)) - (_2133 * _1006._m6.x);
    float _2195 = _1144._m11 * _750._m75;
    _2129 += (max(vec3(0.0), _2171 * _10(_2195)) * _1006._m0);
    _1006._m21 += _2129;
    bool _2209 = true;
    _2209 = (((_750._m77 & 1u) != 0u) == true) ? false : true;
    if (true && (_2209 == true))
    {
        uint _2222 = _2226._m0[_1625 * 64u];
        uint _2233 = _2222 & 255u;
        uint _2237 = _2233;
        uint _2239 = _2222;
        uint _2241 = _1625;
        float _2243 = _1006._m47;
        float _2252 = dot(_1006._m14, _1006._m6);
        float _2246 = _10(_2252);
        float _2254 = _2246;
        float _2256 = _1006._m3;
        vec3 _2259 = _1006._m2;
        _1006._m24 = (_116(_2254, _2256, _2259) * _1006._m11) * _1006._m39;
        float _2270 = _750._m25.x;
        float _2273 = _750._m25.z;
        bool _2277 = _2270 > 0.0;
        bool _2284;
        if (_2277)
        {
            _2284 = _1006._m3 > _2273;
        }
        else
        {
            _2284 = _2277;
        }
        if (_2284)
        {
            float _2287 = 0.0;
            vec3 _2288 = normalize(reflect(-_1006._m14, _1006._m6));
            if (dot(_1006._m14, _2288) <= _2287)
            {
                vec2 _2304 = vec2(1.0);
                uvec2 _2318 = uvec2(_1006._m17.xy * (vec2(1.0) / _2304));
                uint _2319 = uint(_750._m25.w);
                float _2306 = _170(_2318, _2319);
                _2306 -= 1.0;
                vec2 _2323 = _1006._m17.xy * _750._m20.xy;
                vec3 _2338 = vec3(_2323, _1006._m17.z);
                vec4 _2339 = _750._m26;
                vec4 _2342 = _750._m27;
                vec3 _2331 = _164(_2338, _2339, _2342);
                mat3 _2346 = mat3(vec3(_750._m28.xyz), vec3(_750._m29.xyz), vec3(_750._m30.xyz));
                mat3 _2370 = _2346;
                vec3 _2372 = _2288;
                vec3 _2369 = normalize(_83(_2370, _2372));
                float _2376 = 1.0;
                uint _2377 = uint((_2270 == 1.0) ? 8 : 12);
                _2377 = (_2270 == 3.0) ? 16u : _2377;
                vec3 _2388 = _2331;
                float _2393 = _1006._m17.z;
                bool _2396 = true;
                float _2397 = _134(_2393, _2396);
                vec3 _2390 = _2388 + (_2369 * _2397);
                vec4 _2400 = vec4(0.0);
                vec3 _2402 = _2388;
                vec4 _2404 = _750._m31;
                vec3 _2401 = _158(_2402, _2404);
                vec3 _2409 = _2390;
                vec4 _2411 = _750._m31;
                vec3 _2408 = _158(_2409, _2411);
                vec3 _2415 = ((_2408 - _2401) * (_2376 / float(_2377))) / vec3(length(_2408.xy - _2401.xy));
                vec3 _2432 = _2401 + (_2415 * _2306);
                float _2438 = abs(_2415.z) * 1.0;
                uint _2443 = 0u;
                vec3 _2444 = _2432;
                float _2446 = _2401.z;
                float _2633;
                for (uint _2449 = 0u; _2449 < _2377; _2449 += 4u)
                {
                    vec4 _2458 = vec4(1.0, 2.0, 3.0, 4.0) + vec4(float(_2449));
                    vec4 _2464 = vec4(1.0) - vec4(TEXTURE_LOD(SAMPLER_2D(_2465, _2467), vec4(_2432.xy + (_2415.xy * _2458.x), 0.0, 0.0).xy, vec4(_2432.xy + (_2415.xy * _2458.x), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_2465, _2467), vec4(_2432.xy + (_2415.xy * _2458.y), 0.0, 0.0).xy, vec4(_2432.xy + (_2415.xy * _2458.y), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_2465, _2467), vec4(_2432.xy + (_2415.xy * _2458.z), 0.0, 0.0).xy, vec4(_2432.xy + (_2415.xy * _2458.z), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_2465, _2467), vec4(_2432.xy + (_2415.xy * _2458.w), 0.0, 0.0).xy, vec4(_2432.xy + (_2415.xy * _2458.w), 0.0, 0.0).w).x);
                    uvec4 _2586 = mix(uvec4(0u), uvec4(1u), lessThan(abs(((_2432.zzzz + (_2415.zzzz * _2458)) - _2464) - vec4(_2438)), vec4(_2438)));
                    uint _2606 = (((_2586.x << uint(0)) | (_2586.y << uint(1))) | (_2586.z << uint(2))) | (_2586.w << uint(3));
                    if (_2606 > 0u)
                    {
                        uint _2627 = _2606;
                        uint _2626 = uint(_50(_2627));
                        if (_2626 > 0u)
                        {
                            _2633 = _2464[_2626 - 1u];
                        }
                        else
                        {
                            _2633 = _2446;
                        }
                        _2446 = _2633;
                        _2444 = _2432 + (_2415 * float((_2449 + _2626) + 1u));
                        float _2652 = _2464[_2626] - _2444.z;
                        float _2659 = (_2446 - _2444.z) + _2415.z;
                        float _2673 = _2652 / (_2652 - _2659);
                        float _2667 = _10(_2673);
                        vec3 _2675 = _2444 - _2415;
                        _2444 = (_2675 * _2667) + (_2444 * (1.0 - _2667));
                        _2443 = _2449 + _2626;
                        break;
                    }
                    _2446 = _2464.w;
                }
                if (_2443 > 0u)
                {
                    vec3 _2701 = _2444;
                    vec4 _2703 = _750._m32;
                    vec4 _2706 = _750._m33;
                    vec4 _2709 = _750._m34;
                    vec4 _2712 = _750._m35;
                    vec3 _2700 = _76(_2701, _2703, _2706, _2709, _2712).xyw;
                    vec2 _2722 = _2700.xy / vec2(_2700.z);
                    _2700 = vec3(_2722.x, _2722.y, _2700.z);
                    vec2 _2725 = (_2700.xy * 2.0) - vec2(1.0);
                    float _2739 = (1.0 - (float(_2443) / float(_2377))) * 4.0;
                    float _2731 = _10(_2739);
                    if (false)
                    {
                        float _2743 = _2725.y;
                        float _2748 = 1.0 - _68(_2743);
                        _2731 *= smoothstep(0.0, 0.25, _10(_2748));
                    }
                    else
                    {
                        float _2758 = 1.0 - dot(_2725, _2725);
                        _2731 *= smoothstep(0.0, 0.5, _10(_2758));
                    }
                    vec3 _2763 = TEXTURE_LOD(SAMPLER_2D(_2764, _1668), vec4(_2700.xy, 0.0, 0.0).xy, vec4(_2700.xy, 0.0, 0.0).w).xyz;
                    _2400 = vec4(_2763, _2731);
                }
                float _2796 = 1.0 - ((1.0 - _1006._m3) / (1.0 - _2273));
                float _2788 = _10(_2796);
                float _2798 = (_2400.w * _2788) * _750._m76;
                _1006._m21 += ((_2400.xyz * _2798) * _1006._m24);
                _2243 = 1.0 - _2798;
            }
        }
        uint _2820 = 1u;
        _2858 _2860;
        while (_2820 <= _2237)
        {
            uint _2829 = (_2241 * 64u) + _2820;
            uint _2834 = _2226._m0[_2829];
            uint _2838 = _2834;
            if (_2838 >= _2834)
            {
                _2820++;
            }
            float _2847 = 0.0039215688593685626983642578125;
            if (_2243 <= (_2847 * 4.0))
            {
                break;
            }
            int _2856 = 4;
            int _2857 = 4;
            _2860._m0 = _2865._m0[(uint(_2856) * _2838) + 0u].xyz;
            float _2880 = _2865._m0[(uint(_2856) * _2838) + 0u].w;
            _2860._m1 = _27(_2880);
            _2860._m2 = _2865._m0[(uint(_2856) * _2838) + 1u].xyz;
            _2860._m3 = _2865._m0[(uint(_2856) * _2838) + 1u].w;
            _2860._m4 = _2865._m0[(uint(_2856) * _2838) + 2u];
            float _2915 = _2865._m0[(uint(_2856) * _2838) + 3u].x;
            _2860._m8 = _27(_2915);
            float _2925 = _2865._m0[(uint(_2856) * _2838) + 3u].y;
            _2860._m9 = _27(_2925);
            _2860._m10 = _2865._m0[(uint(_2856) * _2838) + 3u].z;
            _2860._m5 = _2941._m0[(uint(_2857) * _2838) + 0u];
            _2860._m6 = _2941._m0[(uint(_2857) * _2838) + 1u];
            _2860._m7 = _2941._m0[(uint(_2857) * _2838) + 2u];
            _2860._m12 = _2941._m0[(uint(_2857) * _2838) + 3u].xyz;
            _2860._m13 = _2941._m0[(uint(_2857) * _2838) + 3u].w;
            vec3 _2983 = vec3(dot(_1006._m15, _2860._m5.xyz) + _2860._m5.w, dot(_1006._m15, _2860._m6.xyz) + _2860._m6.w, dot(_1006._m15, _2860._m4.xyz) + _2860._m4.w);
            float _3012 = _2983.x;
            float _3015 = _2983.y;
            float _3018 = _2983.z;
            bool _3023 = _38(_3012, _3015, _3018) <= _2847;
            bool _3040;
            if (!_3023)
            {
                float _3027 = _2983.x;
                float _3030 = _2983.y;
                float _3033 = _2983.z;
                _3040 = _33(_3027, _3030, _3033) >= (1.0 - _2847);
            }
            else
            {
                _3040 = _3023;
            }
            if (_3040)
            {
                continue;
            }
            uint _3044 = _2860._m1;
            vec3 _3047 = _2860._m0;
            float _3050 = float(bitfieldExtract(_2860._m8, 20, 12));
            float _3055 = 0.800000011920928955078125;
            vec3 _3056 = (_2983 * 2.0) - vec3(1.0);
            vec3 _3061 = _3056;
            vec3 _3060 = _65(_3061);
            vec3 _3064 = _3056 * sqrt(((vec3(1.0) - (_3060.yzx * 0.5)) - (_3060.zxy * 0.5)) + ((_3060.yzx * _3060.zxy) / vec3(3.0)));
            float _3095 = 1.0 - ((length(_3064) - _3055) / ((1.0 - _3055) + 9.9999999747524270787835121154785e-07));
            float _3084 = _10(_3095);
            _3084 *= _3084;
            _3084 *= _2243;
            float _3103 = _2860._m7.w;
            _3084 *= _3103;
            _2243 *= (1.0 - _3084);
            vec3 _3113 = _2860._m12;
            float _3116 = _2860._m13;
            float _3121 = _3084;
            vec3 _3119 = _3113 * (_10(_3121) * _3116);
            vec3 _3127 = _2860._m2;
            vec3 _3130 = _2860._m7.xyz;
            vec3 _3134 = vec3(0.0);
            vec3 _3135 = reflect(-_1006._m14, _1006._m6);
            vec3 _3142 = (_3130 - _1006._m15) / _3135;
            vec3 _3149 = (_3127 - _1006._m15) / _3135;
            vec3 _3156 = max(_3142, _3149);
            float _3161 = _3156.x;
            float _3164 = _3156.y;
            float _3167 = _3156.z;
            float _3160 = _38(_3161, _3164, _3167);
            vec3 _3171 = _1006._m15 + (_3135 * _3160);
            vec3 _3178 = _3171 - _3047;
            float _3182 = 6.0;
            float _3184 = _3182 - (_3182 * _1006._m3);
            _3134 = textureLod(samplerCubeArray(_3193, _3195), vec4(_3178, _3050), _3184).xyz;
            _1006._m21 += ((_3134 * _3119) * _1006._m24);
        }
    }
    uint _3218 = _3222._m0[_1625 * 64u];
    uint _3227 = _3218 & 255u;
    uint _3230 = _3227;
    uint _3232 = _3218;
    uint _3234 = _1625;
    uint _3236 = 1u;
    _2858 _3265;
    vec3 _3392;
    float _3531;
    vec2 _3599;
    _3816 _3818;
    _3816 _4039;
    while (_3236 <= _3230)
    {
        uint _3245 = (_3234 * 64u) + _3236;
        uint _3250 = _3222._m0[_3245];
        uint _3254 = _3250;
        if (_3254 >= _3250)
        {
            _3236++;
        }
        int _3263 = 4;
        int _3264 = 4;
        _3265._m0 = _2865._m0[(uint(_3263) * _3254) + 0u].xyz;
        float _3280 = _2865._m0[(uint(_3263) * _3254) + 0u].w;
        _3265._m1 = _27(_3280);
        _3265._m2 = _2865._m0[(uint(_3263) * _3254) + 1u].xyz;
        _3265._m3 = _2865._m0[(uint(_3263) * _3254) + 1u].w;
        _3265._m4 = _2865._m0[(uint(_3263) * _3254) + 2u];
        float _3315 = _2865._m0[(uint(_3263) * _3254) + 3u].x;
        _3265._m8 = _27(_3315);
        float _3325 = _2865._m0[(uint(_3263) * _3254) + 3u].y;
        _3265._m9 = _27(_3325);
        _3265._m10 = _2865._m0[(uint(_3263) * _3254) + 3u].z;
        _3265._m5 = _2941._m0[(uint(_3264) * _3254) + 0u];
        _3265._m6 = _2941._m0[(uint(_3264) * _3254) + 1u];
        _3265._m7 = _2941._m0[(uint(_3264) * _3254) + 2u];
        _3265._m12 = _2941._m0[(uint(_3264) * _3254) + 3u].xyz;
        _3265._m13 = _2941._m0[(uint(_3264) * _3254) + 3u].w;
        float _3379 = 0.0;
        uint _3380 = _3265._m1;
        vec3 _3383 = _3265._m0;
        vec3 _3386 = _3383;
        if ((_3380 & 7u) == 2u)
        {
            _3392 = _3386;
        }
        else
        {
            _3392 = normalize(_3383 - _1006._m15);
        }
        vec3 _3388 = _3392;
        uint _3403 = uint(((_1645 & 3u) != 0u) ? 16 : 0);
        _3403 |= 32u;
        float _3417 = dot(_1006._m6, _3388);
        float _3412 = _10(_3417);
        bool _3419 = _3412 <= _3379;
        bool _3424 = _3419 == true;
        bool _3432;
        if (!_3424)
        {
            _3432 = (_3380 & _3403) != 0u;
        }
        else
        {
            _3432 = _3424;
        }
        if (_3432)
        {
            continue;
        }
        vec3 _3436 = vec3(dot(_1006._m15, _3265._m5.xyz) + _3265._m5.w, dot(_1006._m15, _3265._m6.xyz) + _3265._m6.w, dot(_1006._m15, _3265._m7.xyz) + _3265._m7.w);
        vec2 _3470 = _3436.xy / vec2(_3436.z);
        _3436 = vec3(_3470.x, _3470.y, _3436.z);
        _3436.z = dot(_1006._m15, _3265._m4.xyz) + _3265._m4.w;
        float _3483 = _3436.x;
        float _3486 = _3436.y;
        float _3489 = _3436.z;
        bool _3494 = _38(_3483, _3486, _3489) <= _3379;
        bool _3511;
        if (!_3494)
        {
            float _3498 = _3436.x;
            float _3501 = _3436.y;
            float _3504 = _3436.z;
            _3511 = _33(_3498, _3501, _3504) >= (1.0 - _3379);
        }
        else
        {
            _3511 = _3494;
        }
        if (_3511)
        {
            continue;
        }
        vec3 _3515 = vec3(1.0);
        uint _3516 = _3380 & 7u;
        vec3 _3519 = _3265._m0 - _1006._m15;
        float _3525 = dot(_3519, _3519);
        if (_3516 != 2u)
        {
            _3531 = 1.0 / (1.0 + _3525);
        }
        else
        {
            _3531 = _1006._m25;
        }
        _3515 = vec3(_3531);
        if (_3516 == 0u)
        {
            float _3551 = _3525 * _3265._m3;
            float _3554 = 1.0 - _68(_3551);
            float _3556 = _10(_3554);
            float _3546 = _68(_3556);
            _3515 *= _3546;
        }
        else
        {
            if (_3516 == 4u)
            {
                float _3572 = length((_3436.xy - vec2(0.5)) * 2.0);
                float _3566 = _10(_3572);
                float _3574 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_3566 * 7.80000019073486328125))));
                _3515 *= _3574;
            }
            else
            {
                if ((_3516 == 1u) || (_3516 == 2u))
                {
                    if (_3516 == 2u)
                    {
                        _3599 = fract((_3436.xy * _750._m36.xy) + _750._m36.zw);
                    }
                    else
                    {
                        _3599 = _3436.xy;
                    }
                    vec2 _3596 = _3599;
                    vec3 _3617 = vec3(0.0);
                    uint _3618 = bitfieldExtract(_3265._m8, 0, 20);
                    uint _3622 = _3618;
                    uint _3630 = _3622 + 0u;
                    vec3 _3646 = TEXTURE_LOD(SAMPLER_2D(_3627[nonuniformEXT(_3630)], _1305), vec4(_3596, 0.0, 0.0).xy, vec4(_3596, 0.0, 0.0).w).xyz;
                    _3617 = _65(_3646);
                    _3515 *= _3617;
                }
            }
        }
        float _3652 = float((_3380 >> uint(8)) & 255u) / 255.0;
        if ((_3516 == 0u) || (_3516 == 2u))
        {
            vec3 _3665 = abs((_3436 * 2.0) - vec3(1.0));
            float _3671 = _3665.x;
            float _3674 = _3665.y;
            float _3677 = _3665.z;
            float _3682 = 1.0 - _33(_3671, _3674, _3677);
            float _3687 = _10(_3682) / (9.9999999392252902907785028219223e-09 + _3652);
            float _3670 = _10(_3687);
            _3515 *= ((_3670 * _3670) * (3.0 - (2.0 * _3670)));
        }
        else
        {
            if ((_3516 == 1u) || (_3516 == 4u))
            {
                float _3707 = _3436.z;
                float _3711 = _68(_3707);
                float _3714 = 1.0 - _68(_3711);
                float _3716 = _10(_3714);
                float _3721 = _68(_3716) / (9.9999999392252902907785028219223e-09 + _3652);
                float _3706 = _10(_3721);
                _3515 *= _3706;
            }
        }
        float _3726 = _3515.x;
        float _3729 = _3515.y;
        float _3732 = _3515.z;
        if (_33(_3726, _3729, _3732) <= _3379)
        {
            continue;
        }
        float _3741 = 1.0;
        if ((_3380 & 8u) != 0u)
        {
            float _3748 = _1144._m12;
            vec3 _3751 = _1006._m15 + (_1006._m6 * _3748);
            uint _3759 = 0u;
            if ((_3380 & 7u) == 0u)
            {
                vec3 _3765 = _3751 - _3265._m2;
                float _3770 = _3765.x;
                float _3773 = _3765.y;
                float _3776 = _3765.z;
                _3759 = _44(_3770, _3773, _3776);
            }
            else
            {
                if ((_3380 & 7u) == 2u)
                {
                    float _3786 = 0.0;
                    uint _3787 = uint((_750._m37.w > 0.0) ? 3 : 4);
                    for (; _3759 < _3787; _3759++)
                    {
                        int _3801 = 5;
                        bool _3805 = (_1144._m15 & 1u) != 0u;
                        bool _3813;
                        if (!_3805)
                        {
                            _3813 = (_1144._m15 & 2u) != 0u;
                        }
                        else
                        {
                            _3813 = _3805;
                        }
                        if (_3813)
                        {
                            _3818._m0 = _3823._m0[(uint(_3801) * ((_3380 >> uint(22)) + _3759)) + 0u];
                            _3818._m1 = _3823._m0[(uint(_3801) * ((_3380 >> uint(22)) + _3759)) + 1u];
                            _3818._m2 = _3823._m0[(uint(_3801) * ((_3380 >> uint(22)) + _3759)) + 2u];
                            _3818._m3 = _3823._m0[(uint(_3801) * ((_3380 >> uint(22)) + _3759)) + 3u];
                            _3818._m4 = _3823._m0[(uint(_3801) * ((_3380 >> uint(22)) + _3759)) + 4u];
                        }
                        else
                        {
                            _3818._m0 = _3883._m0[(uint(_3801) * ((_3380 >> uint(22)) + _3759)) + 0u];
                            _3818._m1 = _3883._m0[(uint(_3801) * ((_3380 >> uint(22)) + _3759)) + 1u];
                            _3818._m2 = _3883._m0[(uint(_3801) * ((_3380 >> uint(22)) + _3759)) + 2u];
                            _3818._m3 = _3883._m0[(uint(_3801) * ((_3380 >> uint(22)) + _3759)) + 3u];
                            _3818._m4 = _3883._m0[(uint(_3801) * ((_3380 >> uint(22)) + _3759)) + 4u];
                        }
                        vec2 _3939 = vec2(dot(_3751, _3818._m0.xyz) + _3818._m0.w, dot(_3751, _3818._m1.xyz) + _3818._m1.w);
                        _3939 = abs((_3939 * 2.0) - vec2(1.0));
                        bool _3965 = _3939.x < 0.9900000095367431640625;
                        bool _3971;
                        if (_3965)
                        {
                            _3971 = _3939.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _3971 = _3965;
                        }
                        if (_3971)
                        {
                            _3786 = (1.0 - max(_3939.x, _3939.y)) * _750._m38.w;
                            break;
                        }
                    }
                    _1006._m36 = int(_3759);
                    _3759 = min((_3787 - 1u), _3759);
                    if (_750._m37.w > 0.0)
                    {
                        uint _3998 = uint(_1006._m17.x) ^ (uint(_1006._m17.y) << uint(1));
                        _3998 ^= uint(_750._m39.x);
                        _3759 += uint(int(((float(_3998 & 3u) * 0.25) + 0.125) > _3786));
                    }
                }
            }
            int _4024 = 5;
            bool _4028 = (_1144._m15 & 1u) != 0u;
            bool _4036;
            if (!_4028)
            {
                _4036 = (_1144._m15 & 2u) != 0u;
            }
            else
            {
                _4036 = _4028;
            }
            if (_4036)
            {
                _4039._m0 = _3823._m0[(uint(_4024) * ((_3380 >> uint(22)) + _3759)) + 0u];
                _4039._m1 = _3823._m0[(uint(_4024) * ((_3380 >> uint(22)) + _3759)) + 1u];
                _4039._m2 = _3823._m0[(uint(_4024) * ((_3380 >> uint(22)) + _3759)) + 2u];
                _4039._m3 = _3823._m0[(uint(_4024) * ((_3380 >> uint(22)) + _3759)) + 3u];
                _4039._m4 = _3823._m0[(uint(_4024) * ((_3380 >> uint(22)) + _3759)) + 4u];
            }
            else
            {
                _4039._m0 = _3883._m0[(uint(_4024) * ((_3380 >> uint(22)) + _3759)) + 0u];
                _4039._m1 = _3883._m0[(uint(_4024) * ((_3380 >> uint(22)) + _3759)) + 1u];
                _4039._m2 = _3883._m0[(uint(_4024) * ((_3380 >> uint(22)) + _3759)) + 2u];
                _4039._m3 = _3883._m0[(uint(_4024) * ((_3380 >> uint(22)) + _3759)) + 3u];
                _4039._m4 = _3883._m0[(uint(_4024) * ((_3380 >> uint(22)) + _3759)) + 4u];
            }
            vec4 _4151 = vec4((_3751.x * _4039._m0.x) + ((_3751.y * _4039._m0.y) + ((_3751.z * _4039._m0.z) + _4039._m0.w)), (_3751.x * _4039._m1.x) + ((_3751.y * _4039._m1.y) + ((_3751.z * _4039._m1.z) + _4039._m1.w)), (_3751.x * _4039._m2.x) + ((_3751.y * _4039._m2.y) + ((_3751.z * _4039._m2.z) + _4039._m2.w)), (_3751.x * _4039._m3.x) + ((_3751.y * _4039._m3.y) + ((_3751.z * _4039._m3.z) + _4039._m3.w)));
            vec3 _4238 = _4151.xyz / vec3(_4151.w);
            _4151 = vec4(_4238.x, _4238.y, _4238.z, _4151.w);
            bool _4246 = min(_4151.x, _4151.y) > 0.0;
            bool _4255;
            if (_4246)
            {
                _4255 = max(_4151.x, _4151.y) < 1.0;
            }
            else
            {
                _4255 = _4246;
            }
            if (_4255)
            {
                vec2 _4267 = (_4151.xy * _4039._m4.xy) + _4039._m4.zw;
                _4151 = vec4(_4267.x, _4267.y, _4151.z, _4151.w);
                if (false)
                {
                    _3741 = textureLod(sampler2DShadow(_4274, _4276), vec3(_4151.xyz.xy, _4151.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4285 = (_4151.xy * _750._m40.xy) + vec2(0.5);
                    vec2 _4294 = floor(_4285);
                    vec2 _4297 = _4285 - _4294;
                    _4294 -= vec2(0.5);
                    vec2 _4304 = vec2(4.0) - (_4297 * 3.0);
                    vec2 _4309 = vec2(7.0);
                    vec2 _4312 = vec2(1.0) + (_4297 * 3.0);
                    vec2 _4317 = (_4294 + (((vec2(3.0) - (_4297 * 2.0)) / _4304) - vec2(2.0))) * _750._m40.zw;
                    vec2 _4332 = (_4294 + ((vec2(3.0) + _4297) / _4309)) * _750._m40.zw;
                    vec2 _4344 = (_4294 + ((_4297 / _4312) + vec2(2.0))) * _750._m40.zw;
                    vec3 _4370 = vec3(_4317.x, _4317.y, _4151.z);
                    _3741 = (_4304.x * _4304.y) * textureLod(sampler2DShadow(_4274, _4276), vec3(_4370.xy, _4370.z), 0.0);
                    vec3 _4388 = vec3(_4332.x, _4317.y, _4151.z);
                    _3741 += ((_4309.x * _4304.y) * textureLod(sampler2DShadow(_4274, _4276), vec3(_4388.xy, _4388.z), 0.0));
                    vec3 _4408 = vec3(_4344.x, _4317.y, _4151.z);
                    _3741 += ((_4312.x * _4304.y) * textureLod(sampler2DShadow(_4274, _4276), vec3(_4408.xy, _4408.z), 0.0));
                    vec3 _4428 = vec3(_4317.x, _4332.y, _4151.z);
                    _3741 += ((_4304.x * _4309.y) * textureLod(sampler2DShadow(_4274, _4276), vec3(_4428.xy, _4428.z), 0.0));
                    vec3 _4448 = vec3(_4332.x, _4332.y, _4151.z);
                    _3741 += ((_4309.x * _4309.y) * textureLod(sampler2DShadow(_4274, _4276), vec3(_4448.xy, _4448.z), 0.0));
                    vec3 _4468 = vec3(_4344.x, _4332.y, _4151.z);
                    _3741 += ((_4312.x * _4309.y) * textureLod(sampler2DShadow(_4274, _4276), vec3(_4468.xy, _4468.z), 0.0));
                    vec3 _4488 = vec3(_4317.x, _4344.y, _4151.z);
                    _3741 += ((_4304.x * _4312.y) * textureLod(sampler2DShadow(_4274, _4276), vec3(_4488.xy, _4488.z), 0.0));
                    vec3 _4508 = vec3(_4332.x, _4344.y, _4151.z);
                    _3741 += ((_4309.x * _4312.y) * textureLod(sampler2DShadow(_4274, _4276), vec3(_4508.xy, _4508.z), 0.0));
                    vec3 _4528 = vec3(_4344.x, _4344.y, _4151.z);
                    _3741 += ((_4312.x * _4312.y) * textureLod(sampler2DShadow(_4274, _4276), vec3(_4528.xy, _4528.z), 0.0));
                    _3741 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3741 = float((_3380 & 7u) == 2u);
                if ((_3380 & 7u) == 2u)
                {
                    _1006._m36 = -1;
                }
            }
            float _4548 = float((_3380 >> uint(16)) & 63u) / 63.0;
            float _4562 = ((_3741 * _4548) + 1.0) - _4548;
            _3741 = _10(_4562);
        }
        if (_3741 <= _3379)
        {
            continue;
        }
        vec3 _4570 = (_3265._m12 * _3741) * _3515;
        float _4577 = _3265._m13;
        vec3 _4580 = _4570;
        float _4587 = dot(_1006._m6, _3388);
        float _4582 = _10(_4587);
        float _4589 = 1.0;
        vec3 _4591 = _1006._m6;
        vec3 _4594 = _1006._m14;
        vec3 _4597 = _3388;
        vec3 _4599 = _1006._m2;
        float _4602 = _1006._m3;
        vec3 _4590 = _110(_4591, _4594, _4597, _4599, _4602);
        _1006._m21 += ((((_4590 * _4577) * _4580) * _4582) * _4589);
        vec3 _4619 = _4580;
        _1006._m21 += ((_4619 * _4582) * _1006._m0);
    }
    _1006._m21 *= _1006._m11;
    if (_1144._m0.w > 0.0)
    {
        float _4642 = 1.0 - dot(_1006._m6, _1006._m14);
        _4642 = pow(_4642, 42.0);
        vec3 _4652 = mix(vec3(1.0), vec3(0.0), vec3(_1006._m7.z));
        _4652 *= (_4652 * _4652);
        vec3 _4662 = vec3(_4642);
        _4662 = clamp(_4662, vec3(0.0), vec3(0.100000001490116119384765625));
        _1006._m21 += ((_4652 + (_4662 * vec3(15.0))) * _1144._m0.xyz);
    }
    if (_1144._m1.w > 0.0)
    {
        vec2 _4689 = abs(vec2(1.0) / _750._m20.xy);
        vec2 _4695 = (vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _750._m20.xy) * (_4689 / vec2(32.0));
        vec4 _4758 = TEXTURE_LOD(SAMPLER_2D(_3627[_1133._m14], _1445), vec4((_4695 * _1133._m1.xy) + (vec2(_750._m70) * _1133._m1.zw), 0.0, 0.0).xy, vec4((_4695 * _1133._m1.xy) + (vec2(_750._m70) * _1133._m1.zw), 0.0, 0.0).w);
        vec4 _4716 = _62(_4758);
        float _4771 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).w;
        float _4760 = _10(_4771);
        float _4778 = _4760 * 200.0;
        float _4774 = _10(_4778);
        _4774 = mix(0.0, 1.0, _4774);
        float _4784 = 1.0 - _4774;
        _4774 = _10(_4784);
        vec3 _4786 = vec3(1.0 - _1006._m7.z);
        float _4791 = 1.0 - dot(_1006._m6, _1006._m14);
        float _4798 = _4791 * _4791;
        _4791 *= (_4791 * _4791);
        vec3 _4807 = vec3(_4791);
        vec3 _4810 = (((_4786 * _4786) * vec3(180.0)) * _1144._m1.xyz) + (_4807 * _1144._m1.xyz);
        vec3 _4827 = (((_1144._m1.xyz * vec3(0.100000001490116119384765625)) * _4716.xyz) * vec3(_4798)) + ((vec3(_4798) * _1144._m1.xyz) * vec3(20.0));
        _1006._m21 = mix(_1006._m21, (_1006._m21 + (mix(_4810, _4827, vec3(_4774)) * _4716.xyz)) + ((_1144._m1.xyz * vec3(0.100000001490116119384765625)) * vec3(_4798)), vec3(_1144._m1.w));
        float _4875 = dot(_1006._m6, normalize(-_1006._m14));
        _4875 *= (_4875 * _4875);
        vec3 _4888 = vec3(_4875) * _1144._m1.xyz;
        _1006._m21 += _4888;
    }
    if (_1144._m13 > 0.0)
    {
        vec3 _4905 = SAMPLE_TEXTURE(SAMPLER_2D(_3627[_1133._m15], _1445), _1006._m16.zw).xyz;
        vec3 _4917 = mix(_1144._m2.xyz, _1144._m3.xyz, _4905);
        _1006._m21 += ((_4905 * _4917) * mix(0.0, 10.0, _1144._m13));
    }
    _1005 = _1006._m6.x;
    _4940 = vec4(_1006._m21, 0.0);
    if (((_750._m77 & 1u) != 0u) == true)
    {
        vec3 _4955 = _1006._m6;
        bool _4958 = false;
        vec2 _4959 = _178(_4955, _4958);
        _4954 = vec4(_4959, 0.0, 0.0);
        float _4969 = dot(_1006._m14, _1006._m6);
        float _4963 = _10(_4969);
        float _4972 = _4963;
        float _4974 = _1006._m3;
        vec3 _4977 = _1006._m2;
        vec3 _4971 = _116(_4972, _4974, _4977);
        float _4982 = _4971.x;
        float _4986 = _4971.y;
        float _4990 = _4971.z;
        float _4994 = _1006._m3;
        _4981 = vec4(_94(_4982), _94(_4986), _94(_4990), _181(_4994));
    }
    float _4999 = _1144._m14;
    if (_4999 > 0.0)
    {
        vec2 _5006 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _750._m20.xy;
        vec2 _5022 = vec2(_1009, _1011);
        float _5026 = (SAMPLE_TEXTURE(SAMPLER_2D(_5027, _1445), _5022 * _1133._m2.xy).x * 0.5) - 0.100000001490116119384765625;
        if (_4999 > _5026)
        {
            vec3 _5067 = TEXTURE_LOD(SAMPLER_2D(_2764, _1445), vec4(_5006 + vec2(_1005 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).xy, vec4(_5006 + vec2(_1005 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).w).xyz;
            _4940 = vec4(_5067.x, _5067.y, _5067.z, _4940.w);
        }
        else
        {
            if (_4999 > (_5026 - 0.02500000037252902984619140625))
            {
                _4940 = vec4(vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).x, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).y, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).z, _4940.w);
            }
        }
    }
}

