#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 50, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

struct _123
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    float _m5;
};

struct _131
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _2596
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
};

struct _4641
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _5578
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _800_802
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    vec4 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    vec4 _m37;
    vec4 _m38;
    vec4 _m39;
    vec4 _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    uint _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    float _m64;
    float _m65;
    float _m66;
    float _m67;
    float _m68;
    float _m69;
    float _m70;
    float _m71;
    float _m72;
    float _m73;
    float _m74;
    float _m75;
    float _m76;
    float _m77;
    uint _m78;
    float _m79[2];
} _802;

layout(set = 2, binding = 0, std140) uniform _1182_1184
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    float _m16;
    float _m17;
    float _m18;
    uint _m19;
    float _m20;
    float _m21;
    float _m22;
    uint _m23;
    int _m24;
    int _m25;
    uint _m26;
    uint _m27;
    uint _m28;
    uint _m29;
    uint _m30;
    uint _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    float _m64;
    float _m65;
    float _m66;
    float _m67;
    float _m68;
    float _m69;
    uint _m70;
    float _m71[1];
} _1184;

layout(set = 1, binding = 0, std140) uniform _1195_1197
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    uint _m15;
    uint _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    int _m31;
    uint _m32;
    float _m33[1];
} _1197;

layout(set = 3, binding = 0, std140) uniform _1235_1237
{
    vec4 _m0[5];
    vec4 _m1[5];
    vec4 _m2[5];
    vec4 _m3[5];
} _1237;

layout(set = 0, binding = 22, std430) restrict readonly buffer _2145_2147
{
    vec4 _m0[];
} _2147;

layout(set = 0, binding = 23, std430) restrict readonly buffer _2507_2509
{
    uint _m0[];
} _2509;

layout(set = 0, binding = 24, std140) uniform _2601_2603
{
    vec4 _m0[4096];
} _2603;

layout(set = 0, binding = 25, std140) uniform _2621_2623
{
    vec4 _m0[4096];
} _2623;

layout(set = 0, binding = 26, std140) uniform _2674_2676
{
    vec4 _m0[2048];
} _2676;

layout(set = 0, binding = 33, std430) restrict readonly buffer _3997_3999
{
    uint _m0[];
} _3999;

layout(set = 0, binding = 37, std140) uniform _4645_4647
{
    vec4 _m0[4096];
} _4647;

layout(set = 0, binding = 38, std140) uniform _4721_4723
{
    vec4 _m0[4096];
} _4723;

layout(set = 0, binding = 40, std430) restrict readonly buffer _5002_5004
{
    uint _m0[];
} _5004;

layout(set = 0, binding = 41, std140) uniform _5583_5585
{
    vec4 _m0[4095];
} _5585;

layout(set = 0, binding = 1, std140) uniform _6397_6399
{
    vec4 _m0[64];
} _6399;

layout(push_constant, std430) uniform _2131_2133
{
    int _m0;
    int _m1;
} _2133;

layout(set = 3, binding = 1) uniform TEXTURE_2D _1278[5];
layout(set = 0, binding = 11) uniform sampler _1286;
layout(set = 3, binding = 3) uniform TEXTURE_2D _1304[5];
layout(set = 0, binding = 12) uniform sampler _1309;
layout(set = 3, binding = 2) uniform TEXTURE_2D _1316[5];
layout(set = 0, binding = 13) uniform sampler _1321;
layout(set = 3, binding = 4) uniform TEXTURE_2D _1338[5];
layout(set = 0, binding = 14) uniform sampler _1343;
layout(set = 3, binding = 5) uniform TEXTURE_2D _1350[5];
layout(set = 0, binding = 15) uniform sampler _1355;
layout(set = 3, binding = 7) uniform TEXTURE_2D _1362[5];
layout(set = 0, binding = 16) uniform sampler _1367;
layout(set = 3, binding = 8) uniform TEXTURE_2D _1374[5];
layout(set = 0, binding = 17) uniform sampler _1379;
layout(set = 4, binding = 0) uniform TEXTURE_2D _1461[34816];
layout(set = 0, binding = 18) uniform sampler _1466;
layout(set = 3, binding = 6) uniform TEXTURE_2D _1996[5];
layout(set = 0, binding = 19) uniform sampler _2001;
layout(set = 0, binding = 20) uniform TEXTURE_2D _2103;
layout(set = 0, binding = 21) uniform sampler _2105;
layout(set = 0, binding = 27) uniform TEXTURE_2D _2871;
layout(set = 0, binding = 28) uniform TEXTURE_2D _2922;
layout(set = 0, binding = 29) uniform TEXTURE_2D _3335;
layout(set = 0, binding = 30) uniform sampler _3337;
layout(set = 0, binding = 31) uniform TEXTURE_2D _3575;
layout(set = 0, binding = 32) uniform sampler _3577;
layout(set = 0, binding = 34) uniform TEXTURE_2D _4250;
layout(set = 0, binding = 35) uniform sampler _4252;
layout(set = 0, binding = 36) uniform TEXTURE_2D _4548;
layout(set = 0, binding = 39) uniform textureCubeArray _4975;
layout(set = 0, binding = 10) uniform sampler _4977;
layout(set = 0, binding = 42) uniform texture2D _5906;
layout(set = 0, binding = 43) uniform samplerShadow _5908;
layout(set = 0, binding = 7) uniform texture3D _6402;
layout(set = 0, binding = 8) uniform sampler _6403;
layout(set = 0, binding = 9) uniform texture3D _6404;

layout(location = 17, component = 3) in float _1060;
layout(location = 18, component = 0) in float _1062;
layout(location = 18, component = 1) in float _1067;
layout(location = 18, component = 2) in float _1069;
layout(location = 18, component = 3) in float _1071;
layout(location = 19, component = 0) in float _1102;
layout(location = 19, component = 1) in float _1104;
layout(location = 19, component = 2) in float _1106;
layout(location = 19, component = 3) in float _1110;
layout(location = 20, component = 0) in float _1112;
layout(location = 20, component = 1) in float _1114;
layout(location = 20, component = 2) in float _1126;
layout(location = 10, component = 0) in vec4 _1151;
layout(location = 11, component = 0) in vec4 _1154;
layout(location = 12, component = 0) in vec4 _1157;
layout(location = 0, component = 0) out vec4 _6337;
layout(location = 1, component = 0) out vec4 _6351;
layout(location = 2, component = 0) out vec4 _6378;
uint _196;
uint _198;
uint _200;
uint _202;
uint _204;
uint _206;
uint _208;
uint _209;
uint _211;
uint _212;
uint _214;
uint _216;
uint _218;
uint _220;
uint _222;
uint _224;
uint _226;
uint _228;
uint _230;

_131 _133()
{
    _131 _692;
    _692._m0 = vec3(0.0);
    _692._m2 = vec3(0.0);
    _692._m3 = 0.0;
    _692._m4 = 0u;
    _692._m5 = 0.0;
    _692._m6 = vec3(0.0);
    _692._m7 = vec3(0.0, 0.0, 1.0);
    _692._m8 = vec3(0.0, 0.0, 1.0);
    _692._m1 = vec3(0.0);
    _692._m9 = 1.0;
    _692._m10 = 1.0;
    _692._m14 = vec3(0.0);
    _692._m15 = vec3(0.0);
    _692._m16 = vec4(0.0);
    _692._m17 = vec4(0.0);
    _692._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _692._m19 = vec3(0.0);
    _692._m20 = vec3(0.0);
    _692._m21 = vec3(0.0);
    _692._m22 = vec3(0.0);
    _692._m23 = vec3(0.0);
    _692._m24 = vec3(0.0);
    _692._m25 = 1.0;
    _692._m26 = uvec4(0u);
    _692._m27 = uvec4(0u);
    _692._m28 = uvec4(0u);
    _692._m29 = vec4(0.0);
    _692._m30 = vec4(0.0);
    _692._m31 = vec4(0.0);
    _692._m32 = vec4(0.0);
    _692._m33 = uvec2(0u);
    _692._m34 = vec2(0.0);
    _692._m35 = 0.0;
    _692._m36 = -1;
    _692._m37 = 0;
    _692._m38 = vec2(0.0);
    _692._m39 = 1.0;
    _692._m41 = -1;
    _692._m45 = 1.0;
    _692._m11 = 1.0;
    _692._m12 = 0u;
    _692._m13 = uvec3(0u);
    _692._m40 = vec3(0.0);
    _692._m46 = 0.0;
    _692._m47 = 1.0;
    return _692;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

_123 _125()
{
    _123 _680;
    _680._m0 = vec4(0.0);
    _680._m1 = vec4(0.0);
    _680._m2 = vec4(0.0);
    _680._m3 = vec4(0.0);
    _680._m4 = vec4(0.0);
    _680._m5 = 0.0;
    return _680;
}

vec2 _149(vec2 _148)
{
    return ((_148 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _154(inout vec2 _152, bool _153)
{
    vec2 _835 = _152;
    _152 = _149(_835);
    float _855 = (1.0 - (_152.x * _152.x)) - (_152.y * _152.y);
    vec3 _838 = vec3(_152.x, _152.y, sqrt(_10(_855)));
    if (_153 == false)
    {
        _838.z = -_838.z;
    }
    return _838;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

uint _89(inout vec4 _88)
{
    vec4 _434 = _88;
    _88 = _22(_434);
    return packUnorm4x8(_88.wzyx);
}

vec3 _71(mat3 _69, vec3 _70)
{
    return _69 * _70;
}

vec3 _159(vec3 _157, mat3 _158)
{
    mat3 _871 = _158;
    vec3 _873 = _157;
    return normalize(_71(_871, _873));
}

vec3 _165(vec2 _162, mat3 _163, bool _164)
{
    vec2 _880 = _162;
    bool _882 = _164;
    vec3 _884 = _154(_880, _882);
    vec3 _879 = _884;
    vec3 _885 = _879;
    mat3 _887 = _163;
    return _159(_885, _887);
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _82(float _81)
{
    return sqrt(_81);
}

float _121(vec3 _118, float _119, float _120)
{
    float _635 = length(_118) * _120;
    if (_635 < 1.0)
    {
        float _644 = 1.0 - _119;
        float _647 = _635 * _635;
        float _651 = ((3.0 * _635) - (_635 * _647)) / (1.0 - _647);
        float _662 = 1.0 / (2.0 * _651);
        float _672 = (_644 * _644) + _662;
        return 1.0 - _82(_672);
    }
    return _119;
}

float _145(inout float _143, bool _144)
{
    if (_144)
    {
        _143 += (float(_143 < _802._m41) * _802._m42);
    }
    float _816 = _143;
    return _802._m0.w / (_10(_816) + _802._m0.z);
}

float _38(float _35, float _36, float _37)
{
    return min(_35, min(_36, _37));
}

float _33(float _30, float _31, float _32)
{
    return max(_30, max(_31, _32));
}

float _138(vec2 _137)
{
    return dot(_137, _137);
}

vec4 _96(uint _95)
{
    return vec4(float((_95 >> uint(24)) & 255u), float((_95 >> uint(16)) & 255u), float((_95 >> uint(8)) & 255u), float(_95 & 255u));
}

vec4 _93(uint _92)
{
    return unpackUnorm4x8(_92).wzyx;
}

float _74(float _73)
{
    return exp2(_73);
}

vec3 _115(float _112, float _113, vec3 _114)
{
    float _587 = 0.0949999988079071044921875 + (_113 * (0.60000002384185791015625 + (4.190000057220458984375 * _113)));
    float _597 = _112 + 0.02500000037252902984619140625;
    float _601 = (9.5 * _113) * _112;
    float _615 = 1.0 - (14.0 * _112);
    float _607 = (_587 * _597) * _74(_615);
    float _622 = -_601;
    float _618 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _74(_622)));
    return mix(vec3(_607), vec3(_618), _114);
}

float _182(uvec2 _180, uint _181)
{
    uvec2 _942 = _180 & uvec2(3u);
    return float(((((2068378560u * (1u - (_942.x >> uint(1)))) + (1500172770u * (_942.x >> uint(1)))) >> ((_942.y + ((_942.x & 1u) << uint(2))) << uint(2))) + _181) & 15u) / 16.0;
}

vec3 _176(vec3 _173, vec4 _174, vec4 _175)
{
    return vec3((_174.xy * _173.xy) + _174.zw, _175.z) / vec3((_175.x * _173.z) + _175.y);
}

vec3 _170(vec3 _168, vec4 _169)
{
    return vec3(vec2(0.5) + (_169.xy * (_168.xy / vec2(_168.z))), (_169.w / _168.z) + _169.z);
}

int _50(uint _49)
{
    return findLSB(_49);
}

vec4 _64(vec3 _59, vec4 _60, vec4 _61, vec4 _62, vec4 _63)
{
    return vec4((_59.x * _60.x) + ((_59.y * _60.y) + ((_59.z * _60.z) + _60.w)), (_59.x * _61.x) + ((_59.y * _61.y) + ((_59.z * _61.z) + _61.w)), (_59.x * _62.x) + ((_59.y * _62.y) + ((_59.z * _62.z) + _62.w)), (_59.x * _63.x) + ((_59.y * _63.y) + ((_59.z * _63.z) + _63.w)));
}

float _56(float _55)
{
    return _55 * _55;
}

vec3 _53(vec3 _52)
{
    return _52 * _52;
}

uint _44(float _41, float _42, float _43)
{
    bool _272 = abs(_43) >= abs(_41);
    bool _280;
    if (_272)
    {
        _280 = abs(_43) >= abs(_42);
    }
    else
    {
        _280 = _272;
    }
    if (_280)
    {
        return uint((_43 < 0.0) ? 5 : 4);
    }
    if (abs(_42) >= abs(_41))
    {
        return uint((_42 < 0.0) ? 3 : 2);
    }
    return uint(int(_41 < 0.0));
}

float _79(float _77, float _78)
{
    return pow(_77, _78);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _101(vec3 _99, float _100)
{
    float _474 = dot(_99, vec3(16.666500091552734375));
    float _469 = _10(_474);
    float _483 = 1.0 - _100;
    float _486 = _10(_483);
    float _487 = 5.0;
    vec3 _491 = _99 + ((vec3(_469) - _99) * _79(_486, _487));
    return _16(_491);
}

vec3 _109(vec3 _104, vec3 _105, vec3 _106, vec3 _107, float _108)
{
    float _499 = dot(_104, _105);
    float _495 = _10(_499);
    vec3 _501 = normalize(_105 + _106);
    float _510 = dot(_104, _501);
    float _506 = _10(_510);
    float _516 = dot(_106, _501);
    float _512 = _10(_516);
    vec3 _519 = _107;
    float _521 = _512;
    vec3 _518 = _101(_519, _521);
    float _528 = dot(_104, _106);
    float _524 = _10(_528);
    float _530 = 1.0 - (_108 * 0.800000011920928955078125);
    _530 *= _530;
    _530 *= _530;
    float _541 = _530 * _530;
    float _545 = ((_506 * _506) * (_541 - 1.0)) + 1.0;
    _545 = _541 / ((_545 * _545) + 9.9999999392252902907785028219223e-09);
    float _560 = (_495 * (1.0 - _530)) + _530;
    float _567 = (_524 * (1.0 - _530)) + _530;
    _545 /= (((4.0 * _560) * _567) + 9.9999999392252902907785028219223e-09);
    return _518 * _545;
}

vec2 _185(vec2 _184)
{
    return (vec2(1.0) - abs(_184.yx)) * vec2((_184.x >= 0.0) ? 1.0 : (-1.0), (_184.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _190(inout vec3 _188, bool _189)
{
    _188 /= vec3((abs(_188.x) + abs(_188.y)) + abs(_188.z));
    vec2 _1011;
    if (_188.z >= 0.0)
    {
        _1011 = _188.xy;
    }
    else
    {
        vec2 _1017 = _188.xy;
        _1011 = _185(_1017);
    }
    _188 = vec3(_1011.x, _1011.y, _188.z);
    if (_189)
    {
        vec2 _1031 = (_188.xy * 0.5) + vec2(0.5);
        _188 = vec3(_1031.x, _1031.y, _188.z);
    }
    return _188.xy;
}

float _85(float _84)
{
    return sqrt(_84);
}

float _193(float _192)
{
    float _1041 = abs(_192);
    float _1038 = _85(_1041);
    float _1045;
    if (_192 > 0.0)
    {
        _1045 = _1038;
    }
    else
    {
        _1045 = -_1038;
    }
    return (_1045 * 0.5) + 0.5;
}

void main()
{
    _196 = 2147483648u;
    _198 = 1073741824u;
    _200 = 0u;
    _202 = 268435456u;
    _204 = 536870912u;
    _206 = 805306368u;
    _208 = 1073741824u;
    _209 = 1342177280u;
    _211 = 0u;
    _212 = 16777216u;
    _214 = 33554432u;
    _216 = 50331648u;
    _218 = 67108864u;
    _220 = 83886080u;
    _222 = 100663296u;
    _224 = 117440512u;
    _226 = 134217728u;
    _228 = 150994944u;
    _230 = 167772160u;
    _131 _1057 = _133();
    _1057._m16 = vec4(0.0, 0.0, _1060, _1062);
    vec3 _1066 = vec3(_1067, _1069, _1071);
    _1057._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _1057._m15 = vec3(_802._m52, _802._m53, _802._m54) + _1066;
    vec3 _1100 = vec3(0.0);
    vec3 _1101 = vec3(0.0);
    _1100 = normalize(vec3(_1102, _1104, _1106));
    _1101 = normalize(vec3(_1110, _1112, _1114));
    vec3 _1118 = _1100;
    vec3 _1120 = _1101;
    vec3 _1122 = normalize(cross(_1118, _1120) * _1126);
    _1057._m18 = mat3(vec3(_1120), vec3(_1122), vec3(_1118));
    _1057._m14 = normalize(-_1066);
    _1057._m29 = _1151;
    _1057._m30 = _1154;
    _1057._m31 = _1157;
    uint _1160 = 0u;
    vec4 _1161 = vec4(0.0);
    vec4 _1162 = vec4(0.0);
    vec4 _1163 = vec4(0.0);
    vec4 _1164 = vec4(0.0);
    vec4 _1165 = vec4(0.0);
    float _1166 = 0.0;
    uvec2 _1167 = uvec2(0u, 65535u);
    vec2 _1170 = _1057._m16.zw;
    vec2 _1174 = _1170;
    vec2 _1176 = _1170;
    float _1178 = 0.0009765625;
    vec3 _1191;
    if ((_1184._m70 & 1u) != 0u)
    {
        _1191 = vec3(_1197._m17, _1197._m18, _1197._m19);
    }
    else
    {
        _1191 = vec3(1.0);
    }
    vec3 _1180 = _1191;
    float _1208 = 1.0;
    float _1209 = _1197._m20;
    bool _1212 = _1209 > 0.0;
    float _1215 = 1.0;
    uint _1216 = _1167.x;
    uint _1219 = _1216 & 7u;
    uint _1223 = _1219;
    uint _1225 = _1223;
    float _1227 = 0.0;
    vec2 _1228 = _1174;
    _1228.x *= _1237._m1[_1225].w;
    _1228.y *= _1237._m2[_1225].x;
    _1228.x += (_802._m70 * _1237._m2[_1225].y);
    _1228.y += (_802._m70 * _1237._m2[_1225].z);
    vec2 _1272 = _1228;
    uint _1280 = _1225;
    vec3 _1274 = (SAMPLE_TEXTURE(SAMPLER_2D(_1278[nonuniformEXT(_1280)], _1286), _1272).xyz * vec3(_1237._m0[_1225].x)) + vec3(_1237._m0[_1225].y);
    uint _1306 = _1225;
    vec2 _1303 = SAMPLE_TEXTURE(SAMPLER_2D(_1304[nonuniformEXT(_1306)], _1309), _1272).xy;
    uint _1318 = _1225;
    vec3 _1315 = (SAMPLE_TEXTURE(SAMPLER_2D(_1316[nonuniformEXT(_1318)], _1321), _1272).xyz * vec3(_1237._m0[_1225].z)) + vec3(_1237._m0[_1225].w);
    uint _1340 = _1225;
    float _1337 = SAMPLE_TEXTURE(SAMPLER_2D(_1338[nonuniformEXT(_1340)], _1343), _1272).x;
    uint _1352 = _1225;
    float _1349 = SAMPLE_TEXTURE(SAMPLER_2D(_1350[nonuniformEXT(_1352)], _1355), _1272).x;
    uint _1364 = _1225;
    vec3 _1361 = SAMPLE_TEXTURE(SAMPLER_2D(_1362[nonuniformEXT(_1364)], _1367), _1272).xyz;
    uint _1376 = _1225;
    float _1373 = SAMPLE_TEXTURE(SAMPLER_2D(_1374[nonuniformEXT(_1376)], _1379), _1272).x;
    _1161 = vec4(_1274.x, _1274.y, _1274.z, _1161.w);
    _1161.w = 0.0;
    _1162 = vec4(_1315.x, _1315.y, _1315.z, _1162.w);
    _1162.w = _1349;
    _1163 = vec4(_1303.x, _1303.y, _1163.z, _1163.w);
    _1164.x = 0.0;
    _1164.y = _1227;
    _1164.z = _1349;
    _1164.w = _1337;
    _1166 = _1373;
    _1215 = _1237._m1[_1225].x;
    vec3 _1414 = _1361 * _1237._m3[_1225].xyz;
    _1165 = vec4(_1414.x, _1414.y, _1414.z, _1165.w);
    float _1417 = _1212 ? _1209 : _1215;
    vec3 _1426 = _1165.xyz * vec3(_1417);
    _1165 = vec4(_1426.x, _1426.y, _1426.z, _1165.w);
    vec2 _1429 = vec2(0.0);
    _123 _1430;
    _1430._m0 = _1161;
    _1430._m1 = _1162;
    _1430._m2 = _1164;
    _1430._m3 = _1163;
    _1430._m4 = _1165;
    _1430._m5 = _1166;
    _1429 = _1430._m3.xy;
    _1430._m3 = vec4(vec2(0.5).x, vec2(0.5).y, _1430._m3.z, _1430._m3.w);
    bool _1449 = (_1184._m70 & 2u) != 0u;
    if (_1449)
    {
        vec4 _1457 = vec4(0.0);
        _1457 = SAMPLE_TEXTURE(SAMPLER_2D(_1461[_1184._m28], _1466), _1174);
        _1457 *= _1184._m7;
        _1457 = min(_1457, vec4(1.0));
        float _1478 = (_1166 - 0.4980392158031463623046875) * _1184._m17;
        for (int _1485 = 0; _1485 < 4; _1485++)
        {
            float _1493 = _1457[_1485];
            if (!(_1493 == 0.0))
            {
                float _1501 = 0.0;
                vec2 _1502 = vec2(_1184._m2[_1485]);
                uint _1507 = uint(_1485 + 1);
                uint _1511 = _1507 & 7u;
                uint _1514 = _1511;
                uint _1516 = _1514;
                uint _1519 = _1516;
                _1501 = SAMPLE_TEXTURE(SAMPLER_2D(_1374[nonuniformEXT(_1519)], _1379), _1170 * _1502).x;
                _1501 -= 0.4980392158031463623046875;
                _1501 *= _1184._m6[_1485];
                float _1536 = (_1478 + 1.0) - _1493;
                float _1541 = (_1501 + 0.0) + _1493;
                float _1546 = _1541 - _1536;
                float _1550 = (clamp(_1546 / _1184._m10[_1485], -1.0, 1.0) / 2.0) + 0.5;
                float _1559 = 0.100000001490116119384765625;
                float _1561 = abs(0.5 - _1493);
                float _1572 = (_1561 - (0.5 - _1559)) / _1559;
                float _1565 = _10(_1572);
                float _1574 = 0.0;
                if ((_1493 < _1559) && (_1550 > _1493))
                {
                    _1574 = mix(_1550, _1493, _1565);
                }
                else
                {
                    if ((_1493 > (1.0 - _1559)) && (_1550 < _1493))
                    {
                        _1574 = mix(_1550, _1493, _1565);
                    }
                    else
                    {
                        _1574 = _1550;
                    }
                }
                float _1605 = _1184._m4[_1485];
                float _1609 = _1184._m8[_1485];
                float _1613 = _1184._m11[_1485];
                float _1617 = _1184._m9[_1485];
                float _1621 = _1184._m5[_1485];
                _123 _1625 = _125();
                float _1627 = _1197._m20;
                bool _1630 = _1627 > 0.0;
                float _1633 = 1.0;
                uint _1634 = uint(_1485 + 1);
                uint _1638 = _1634 & 7u;
                uint _1641 = _1638;
                uint _1643 = _1641;
                float _1645 = 0.0;
                vec2 _1646 = _1170 * _1502;
                _1646.x *= _1237._m1[_1643].w;
                _1646.y *= _1237._m2[_1643].x;
                _1646.x += (_802._m70 * _1237._m2[_1643].y);
                _1646.y += (_802._m70 * _1237._m2[_1643].z);
                vec2 _1684 = _1646;
                uint _1688 = _1643;
                vec3 _1686 = (SAMPLE_TEXTURE(SAMPLER_2D(_1278[nonuniformEXT(_1688)], _1286), _1684).xyz * vec3(_1237._m0[_1643].x)) + vec3(_1237._m0[_1643].y);
                uint _1708 = _1643;
                vec2 _1706 = SAMPLE_TEXTURE(SAMPLER_2D(_1304[nonuniformEXT(_1708)], _1309), _1684).xy;
                uint _1718 = _1643;
                vec3 _1716 = (SAMPLE_TEXTURE(SAMPLER_2D(_1316[nonuniformEXT(_1718)], _1321), _1684).xyz * vec3(_1237._m0[_1643].z)) + vec3(_1237._m0[_1643].w);
                uint _1738 = _1643;
                float _1736 = SAMPLE_TEXTURE(SAMPLER_2D(_1338[nonuniformEXT(_1738)], _1343), _1684).x;
                uint _1748 = _1643;
                float _1746 = SAMPLE_TEXTURE(SAMPLER_2D(_1350[nonuniformEXT(_1748)], _1355), _1684).x;
                uint _1758 = _1643;
                vec3 _1756 = SAMPLE_TEXTURE(SAMPLER_2D(_1362[nonuniformEXT(_1758)], _1367), _1684).xyz;
                uint _1768 = _1643;
                float _1766 = SAMPLE_TEXTURE(SAMPLER_2D(_1374[nonuniformEXT(_1768)], _1379), _1684).x;
                _1625._m0 = vec4(_1686.x, _1686.y, _1686.z, _1625._m0.w);
                _1625._m0.w = 0.0;
                _1625._m1 = vec4(_1716.x, _1716.y, _1716.z, _1625._m1.w);
                _1625._m1.w = _1746;
                _1625._m3 = vec4(_1706.x, _1706.y, _1625._m3.z, _1625._m3.w);
                _1625._m2.x = 0.0;
                _1625._m2.y = _1645;
                _1625._m2.z = _1746;
                _1625._m2.w = _1736;
                _1625._m5 = _1766;
                _1633 = _1237._m1[_1643].x;
                vec3 _1808 = _1756 * _1237._m3[_1643].xyz;
                _1625._m4 = vec4(_1808.x, _1808.y, _1808.z, _1625._m4.w);
                float _1812 = _1630 ? _1627 : _1633;
                vec3 _1822 = _1625._m4.xyz * vec3(_1812);
                _1625._m4 = vec4(_1822.x, _1822.y, _1822.z, _1625._m4.w);
                _1430._m0 = mix(_1430._m0, _1625._m0, vec4(_1574 * _1605));
                _1430._m1 = mix(_1430._m1, _1625._m1, vec4(_1574 * _1613));
                _1430._m2.w = mix(_1430._m2.w, _1625._m2.w, _1574 * _1617);
                vec3 _1863 = mix(_1430._m2.xyz, _1625._m2.xyz, vec3(_1574));
                _1430._m2 = vec4(_1863.x, _1863.y, _1863.z, _1430._m2.w);
                _1430._m3 = mix(_1430._m3, _1625._m3, vec4(_1574 * _1609));
                _1430._m4 = mix(_1430._m4, _1625._m4, vec4(_1574 * _1621));
                _1430._m5 = mix(_1430._m5, _1625._m5, _1574);
            }
        }
    }
    _1161 = _1430._m0;
    _1162 = _1430._m1;
    _1164.w = _1430._m2.w;
    _1163 = _1430._m3;
    _1165 = _1430._m4;
    _1166 = _1430._m5;
    vec2 _1911 = _1429;
    bool _1913 = true;
    vec3 _1914 = _154(_1911, _1913);
    vec3 _1909 = _1914;
    vec2 _1916 = _1163.xy;
    bool _1919 = true;
    vec3 _1920 = _154(_1916, _1919);
    vec3 _1915 = _1920;
    vec3 _1921 = _1909 + vec3(0.0, 0.0, 1.0);
    vec3 _1924 = vec3(-_1915.xy, _1915.z);
    vec3 _1933 = (_1921 * dot(_1921, _1924)) - (_1924 * _1921.z);
    vec3 _1945 = normalize(_1933);
    _1163 = vec4(_1945.x, _1945.y, _1945.z, _1163.w);
    vec3 _1950 = _1163.xyz + vec3(1.0);
    _1163 = vec4(_1950.x, _1950.y, _1950.z, _1163.w);
    vec3 _1955 = _1163.xyz * 0.5;
    _1163 = vec4(_1955.x, _1955.y, _1955.z, _1163.w);
    _1057._m22 = _1165.xyz * _1180;
    vec3 _1963 = vec3(0.0);
    vec3 _1964 = vec3(0.0);
    float _1965 = 0.0;
    uint _1966 = 0u;
    uint _1967 = _1966 & 7u;
    uint _1970 = _1967;
    uint _1972 = _1970;
    vec4 _1974 = vec4(_1170, 0.0, _1184._m33);
    uint _1982 = _1972;
    vec2 _1992 = SAMPLE_TEXTURE1(SAMPLER_2D(_1304[nonuniformEXT(_1982)], _1309), _1974.xy, _1974.w).xy;
    _1963 = vec3(_1992.x, _1992.y, _1963.z);
    uint _1998 = _1972;
    vec4 _1995 = SAMPLE_TEXTURE1(SAMPLER_2D(_1996[nonuniformEXT(_1998)], _2001), _1974.xy, _1974.w);
    _1964 = _1995.xyz;
    _1965 = _1995.w;
    _1057._m8 = _1963;
    float _2020 = _1965 * _1184._m37;
    float _2015 = _10(_2020);
    vec4 _2028 = vec4(_1964, _2015);
    uint _2029 = _89(_2028);
    _1057._m4 = _2029;
    float _2036 = (1.0 - _2015) * _1184._m32;
    _1057._m10 = _10(_2036);
    _1057._m0 = _1161.xyz;
    _1057._m2 = _1162.xyz;
    _1057._m1 = _1165.xyz;
    _1057._m3 = _1164.w;
    _1057._m6 = _1163.xyz;
    uint _2054 = 0u;
    bool _2055 = true;
    vec2 _2056 = _1057._m6.xy;
    bool _2060 = _2055;
    vec3 _2062 = _154(_2056, _2060);
    _1057._m7 = _2062;
    vec2 _2064 = _1057._m6.xy;
    mat3 _2068 = _1057._m18;
    bool _2071 = _2055;
    _1057._m6 = _165(_2064, _2068, _2071);
    vec2 _2075 = _1057._m8.xy;
    mat3 _2079 = _1057._m18;
    bool _2082 = _2055;
    _1057._m8 = _165(_2075, _2079, _2082);
    vec3 _2086 = dFdx(_1057._m15);
    vec3 _2090 = dFdy(_1057._m15);
    vec2 _2094 = _1057._m17.xy * _802._m18.xy;
    uint _2102 = uint(int(TEXTURE_LOD(SAMPLER_2D(_2103, _2105), vec4(_2094, 0.0, 0.0).xy, vec4(_2094, 0.0, 0.0).w).x * 255.0));
    if ((_2102 > 0u) && (_2102 < 255u))
    {
        int _2130 = _2133._m1;
        if (_2130 > 0)
        {
            _2130--;
            vec4 _2143 = _2147._m0[((uint(_2130) + _2102) - 1u) * 2u];
            vec4 _2157 = _2147._m0[(((uint(_2130) + _2102) - 1u) * 2u) + 1u];
            vec2 _2167 = vec2((_1057._m15.x * _2143.x) + ((_1057._m15.y * _2143.y) + ((_1057._m15.z * _2143.z) + _2143.w)), (_1057._m15.x * _2157.x) + ((_1057._m15.y * _2157.y) + ((_1057._m15.z * _2157.z) + _2157.w)));
            vec2 _2209 = vec2(dot(_2086, _2143.xyz), dot(_2086, _2157.xyz));
            vec2 _2219 = vec2(dot(_2090, _2143.xyz), dot(_2090, _2157.xyz));
            int _2229 = int(_1184._m45);
            vec4 _2233 = vec4(0.0);
            vec4 _2234 = vec4(0.0);
            vec4 _2235 = vec4(0.0);
            uint _2236 = uint(_2229);
            uint _2241 = _2236 + 0u;
            _2233 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_2241)], _1286), _2167, _2209, _2219);
            uint _2252 = _2236 + 1u;
            _2234 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_2252)], _1309), _2167, _2209, _2219);
            uint _2263 = _2236 + 2u;
            _2235 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_2263)], _1321), _2167, _2209, _2219);
            vec2 _2273 = _2234.xy;
            bool _2276 = true;
            vec3 _2277 = _154(_2273, _2276);
            vec3 _2272 = _2277;
            float _2278 = _2234.w;
            float _2281 = _2234.z;
            vec3 _2284 = _2233.xyz;
            float _2287 = _2233.w;
            vec4 _2290 = _2235;
            float _2293 = _1197._m14;
            if (_2102 > _27(_2293))
            {
                _2284 *= _1197._m3.xyz;
                _2281 *= _1197._m3.w;
            }
            _1057._m0 = mix(_1057._m0, _2284, vec3(_2278));
            _1057._m2 = mix(_1057._m2, _2290.xyz, vec3(_2278));
            _1057._m22 = mix(_1057._m22, _2284 * (_2287 * 16.0), vec3(_2287));
            vec3 _2334 = _1057._m18[2];
            float _2337 = sign(dot(cross(_2157.xyz, _2143.xyz), _2334));
            vec3 _2355 = normalize(_2143.xyz + (_2334 * dot(_2143.xyz, _2334)));
            _2143 = vec4(_2355.x, _2355.y, _2355.z, _2143.w);
            vec3 _2364 = normalize(cross(_2334, _2143.xyz)) * _2337;
            _2157 = vec4(_2364.x, _2364.y, _2364.z, _2157.w);
            _2272 = ((_2143.xyz * _2272.x) + (_2157.xyz * _2272.y)) + (_2334 * _2272.z);
            vec3 _2383 = _2272;
            float _2385 = dot(_2383, _2334);
            _2272 = (_1057._m6 * _2385) + ((_2383 - (_2334 * _2385)) * dot(_1057._m6, _2334));
            _1057._m6 = normalize(_2272);
            vec3 _2407 = _2272;
            float _2409 = _2290.w;
            float _2412 = 1.0;
            _1057._m3 = mix(_1057._m3, _2290.w, _2281);
        }
    }
    uvec2 _2421 = uvec2(_1057._m17.xy);
    uint _2426 = _2421.x / 256u;
    uint _2431 = _2421.y / 256u;
    float _2436 = _1057._m17.z;
    bool _2439 = false;
    float _2440 = _145(_2436, _2439);
    float _2435 = _2440;
    float _2441 = log2(max(1.0, _2435 / _802._m19.z)) * _802._m19.w;
    uint _2451 = min(23u, uint(_2441));
    float _2458 = _802._m71;
    float _2464 = _802._m72;
    uint _2456 = (_27(_2458) + ((_2426 + (_27(_2464) * _2431)) * 24u)) + _2451;
    uvec2 _2476 = uvec2(_1057._m17.xy);
    uint _2481 = _2476.x / 32u;
    uint _2486 = _2476.y / 32u;
    float _2494 = _802._m73;
    uint _2490 = _2481 + (_2486 * _27(_2494));
    float _2501 = _1197._m30;
    uint _2500 = _27(_2501);
    uint _2505 = _2509._m0[_2456 * 64u];
    uint _2516 = _2505 & 255u;
    uint _2519 = _2509._m0[_2490 * 64u];
    uint _2524 = _2519 & 255u;
    uint _2532;
    uint _2534;
    uint _2536;
    if (_2516 < _2524)
    {
        _2532 = _2516;
        _2534 = _2505;
        _2536 = _2456;
    }
    else
    {
        _2532 = _2524;
        _2534 = _2519;
        _2536 = _2490;
    }
    vec3 _2542 = dFdx(_1057._m15);
    vec3 _2546 = dFdy(_1057._m15);
    uint _2550 = _2500 & 3u;
    bool _2553 = (_2500 & 4u) != 0u;
    uint _2558 = ((_2550 == 0u) && (!_2553)) ? 0u : _2532;
    uint _2566 = 1u;
    _2596 _2598;
    vec3 _3018;
    while (_2566 <= _2558)
    {
        uint _2575 = (_2536 * 64u) + _2566;
        uint _2580 = _2509._m0[_2575];
        uint _2584 = _2580;
        if (_2584 >= _2580)
        {
            _2566++;
        }
        int _2593 = 2;
        int _2594 = 2;
        int _2595 = 1;
        _2598._m0 = _2603._m0[(uint(_2593) * _2584) + 0u];
        _2598._m1 = _2603._m0[(uint(_2593) * _2584) + 1u];
        _2598._m2 = _2623._m0[(uint(_2594) * _2584) + 0u];
        float _2637 = _2623._m0[(uint(_2594) * _2584) + 1u].x;
        _2598._m3 = _27(_2637);
        float _2647 = _2623._m0[(uint(_2594) * _2584) + 1u].y;
        _2598._m4 = _27(_2647);
        float _2657 = _2623._m0[(uint(_2594) * _2584) + 1u].z;
        _2598._m5 = _27(_2657);
        float _2667 = _2623._m0[(uint(_2594) * _2584) + 1u].w;
        _2598._m6 = _27(_2667);
        float _2682 = _2676._m0[(uint(_2595) * _2584) + 0u].x;
        _2598._m7 = _27(_2682);
        float _2692 = _2676._m0[(uint(_2595) * _2584) + 0u].y;
        _2598._m8 = _27(_2692);
        float _2702 = _2676._m0[(uint(_2595) * _2584) + 0u].z;
        _2598._m9 = _27(_2702);
        vec4 _2707 = _2598._m0;
        vec4 _2710 = _2598._m1;
        vec4 _2713 = _2598._m2;
        vec3 _2716 = vec3(dot(_1057._m15, _2707.xyz) + _2707.w, dot(_1057._m15, _2710.xyz) + _2710.w, dot(_1057._m15, _2713.xyz) + _2713.w);
        float _2742 = 0.0039215688593685626983642578125;
        float _2744 = _2716.x;
        float _2747 = _2716.y;
        float _2750 = _2716.z;
        bool _2755 = _38(_2744, _2747, _2750) <= _2742;
        bool _2772;
        if (!_2755)
        {
            float _2759 = _2716.x;
            float _2762 = _2716.y;
            float _2765 = _2716.z;
            _2772 = _33(_2759, _2762, _2765) >= (1.0 - _2742);
        }
        else
        {
            _2772 = _2755;
        }
        if (_2772)
        {
            continue;
        }
        uint _2776 = _2598._m5;
        uint _2779 = _2598._m9;
        uint _2782 = _2500 & 3u;
        bool _2791 = ((_2779 & 512u) != 0u) && (_2782 != 0u);
        bool _2802;
        if (!_2791)
        {
            _2802 = ((_2779 & 1024u) != 0u) && (_2782 != 1u);
        }
        else
        {
            _2802 = _2791;
        }
        bool _2810;
        if (!_2802)
        {
            _2810 = (_2779 & 16384u) != 0u;
        }
        else
        {
            _2810 = _2802;
        }
        if (_2810)
        {
            continue;
        }
        vec2 _2814 = vec2(dot(_2542, _2707.xyz), dot(_2542, _2710.xyz));
        vec2 _2824 = vec2(dot(_2546, _2707.xyz), dot(_2546, _2710.xyz));
        vec4 _2834 = vec4(0.0);
        vec4 _2835 = vec4(0.0);
        uint _2836 = _2598._m3;
        uint _2842 = _2836 + 1u;
        vec4 _2839 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_2842)], _1309), _2716.xy, _2814 * vec2(1.0), _2824 * vec2(1.0));
        if ((_2779 & 32768u) != 0u)
        {
            vec2 _2861 = vec2(1.0 / length(_2707.xyz), 1.0 / length(_2710.xyz));
            vec2 _2892 = TEXTURE_LOD(SAMPLER_2D(_2871, _1466), vec4(_2716.xy * _2861, 0.0, 0.0).xy, vec4(_2716.xy * _2861, 0.0, 0.0).w).xy;
            _2839 = vec4(_2892.x, _2892.y, _2839.z, _2839.w);
            vec2 _2899 = _2839.xy - vec2(0.4980392158031463623046875);
            float _2902 = 1.0 - _138(_2899);
            _2839.z = sqrt(_10(_2902));
        }
        else
        {
            if ((_2779 & 65536u) != 0u)
            {
                vec2 _2913 = vec2(1.0, (1.0 / length(_2710.xyz)) / 2.5);
                vec2 _2921 = TEXTURE_GRAD(SAMPLER_2D(_2922, _1466), _2716.xy * _2913, _2814 * _2913, _2824 * _2913).xy;
                vec2 _2942 = _2839.xy + (_2921 - vec2(0.4980392158031463623046875));
                _2839 = vec4(_2942.x, _2942.y, _2839.z, _2839.w);
                vec2 _2948 = _2839.xy - vec2(0.4980392158031463623046875);
                float _2951 = 1.0 - _138(_2948);
                _2839.z = sqrt(_10(_2951));
            }
        }
        if ((_2776 & 1u) != 0u)
        {
            uint _2962 = _2836 + 0u;
            _2834 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_2962)], _1286), _2716.xy, _2814 * vec2(1.0), _2824 * vec2(1.0));
        }
        if ((_2776 & 2u) != 0u)
        {
            uint _2981 = _2836 + 2u;
            _2835 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_2981)], _1321), _2716.xy, _2814 * vec2(1.0), _2824 * vec2(1.0));
        }
        float _2993 = 1.0;
        vec3 _2994 = vec3(0.5, 0.5, 1.0);
        vec3 _2996 = vec3(0.0, 0.0, 1.0);
        vec4 _2997 = _2839;
        _2994 = _2997.xyz;
        _2993 = _2997.w;
        _2996 = (_2994 * 2.0) - vec3(1.0);
        if (_2993 <= (4.0 * _2742))
        {
            continue;
        }
        _2994 = _2996;
        if ((_2779 & 128u) != 0u)
        {
            _3018 = vec3(-_2994.x, -_2994.y, _2994.z);
        }
        else
        {
            _3018 = _2994;
        }
        _2994 = _3018;
        uint _3033 = _2598._m6;
        uint _3037 = _3033;
        float _3036 = 1.0 + (_96(_3037).w * 0.062745101749897003173828125);
        uint _3045 = _2776;
        float _3044 = _93(_3045).z;
        uint _3050 = _3033;
        vec3 _3049 = _93(_3050).xyz;
        float _3063 = _3036 - (_3036 * abs((_2716.z * 2.0) - 1.0));
        _2993 *= _10(_3063);
        float _3067 = _2993;
        if ((_2776 & 1u) != 0u)
        {
            _3049 *= _2834.xyz;
            _3067 *= _2834.w;
        }
        vec3 _3082 = _1057._m18[2];
        float _3091 = dot(_3082, normalize(_2713.xyz));
        float _3085 = _10(_3091);
        uint _3093 = _2598._m7;
        uint _3097 = _3093;
        vec4 _3096 = _93(_3097);
        _1057._m22 = mix(_1057._m22, ((_3096.xyz * ((_3067 * _3096.w) * 16.0)) * _3044) * _3085, vec3(_3067));
        uint _3118 = _2598._m8;
        uint _3122 = _3118;
        vec4 _3121 = _93(_3122);
        if ((_2776 & 2u) != 0u)
        {
            _3121 = _2835;
        }
        if ((_2776 & 32u) != 0u)
        {
            uint _3137 = _2776;
            float _3136 = _93(_3137).x;
            uint _3142 = _2776;
            float _3141 = _96(_3142).y;
            float _3162 = dot((_2716.xy + _2996.xy) - vec2(0.5), (_2716.xy + _2996.xy) - vec2(0.5));
            float _3146 = _10(_3162);
            float _3170 = _3141 * (_3136 - _3146);
            float _3172 = _10(_3170);
            float _3164 = _82(_3172);
            _2993 = min(_2993, _3164);
        }
        float _3177 = _2993 * _3085;
        uint _3181 = _2598._m4;
        uint _3185 = _3181;
        vec4 _3184 = _93(_3185) * _3177;
        _1057._m9 = max(_1057._m9, _3184.x);
        _1057._m0 = mix(_1057._m0, _3049, _3184.xxx);
        _1057._m2 = mix(_1057._m2, _3121.xyz, _3184.yyy);
        if (!(_3177 == 0.0))
        {
            float _3215 = 1.0;
            vec3 _3225 = normalize(_2707.xyz + (_3082 * dot(_2707.xyz, _3082)));
            _2707 = vec4(_3225.x, _3225.y, _3225.z, _2707.w);
            vec3 _3234 = normalize(cross(_3082, _2707.xyz)) * _3215;
            _2710 = vec4(_3234.x, _3234.y, _3234.z, _2710.w);
            _2994 = ((_2707.xyz * _2994.x) + (_2710.xyz * _2994.y)) + (_3082 * _2994.z);
            if ((_2779 & 256u) != 0u)
            {
                vec3 _3258 = mix(_3082, _2994, _3184.www);
                float _3264 = dot(_3258, _3082);
                _2994 = (_1057._m6 * _3264) + ((_3258 - (_3082 * _3264)) * dot(_1057._m6, _3082));
            }
            else
            {
                if ((_2779 & 64u) != 0u)
                {
                    _2994 = mix(mix(_1057._m6, _3082, vec3(_3177)), _2994, _3184.www);
                }
                else
                {
                    _2994 = mix(_1057._m6, _2994, _3184.www);
                }
            }
            _1057._m6 = normalize(_2994);
        }
        float _3309 = _3121.w;
        _1057._m3 = mix(_1057._m3, _3309, _3184.z);
    }
    float _3319 = _802._m20.x;
    if (_3319 > 0.0)
    {
        vec2 _3326 = _1057._m17.xy * _802._m18.xy;
        vec3 _3334 = (TEXTURE_LOD(SAMPLER_2D(_3335, _3337), vec4(_3326, 0.0, 0.0).xy, vec4(_3326, 0.0, 0.0).w).xyz * 2.0) - vec3(1.0);
        float _3359 = dot(_3334, _1057._m6);
        _1057._m11 = _10(_3359);
        float _3367 = 1.0 - pow(_1057._m11, 0.699999988079071044921875);
        _1057._m11 = _10(_3367);
        _1057._m11 *= _1057._m11;
    }
    _1057._m21 = _1057._m22;
    _1057._m25 = 1.0;
    float _3380 = _802._m21.w;
    bool _3383 = _3380 < 0.0;
    _3380 = abs(_3380);
    vec3 _3388 = _1057._m15;
    float _3407 = (1.0 - (length(_3388 - vec3(_802._m52, _802._m53, _802._m54)) / _3380)) / 0.25;
    float _3391 = _10(_3407);
    if ((!_3383) && (_3391 > 0.0))
    {
        vec3 _3416 = _802._m21.xyz;
        vec3 _3420 = _802._m22.xyz;
        float _3424 = _3388.z - _3420.z;
        float _3430 = _802._m23.w;
        float _3433 = _802._m24.w;
        float _3436 = float(_3433 < 0.0);
        _3433 = abs(_3433) - 1.0;
        bool _3443 = _3424 <= 0.0;
        float _3446 = 3.5 * float(!(_3433 == 0.0));
        float _3455;
        if (!(_3430 == 0.0))
        {
            _3455 = _3416.z;
        }
        else
        {
            _3455 = _3420.z;
        }
        float _3452 = _3455;
        float _3464 = min(_3443 ? 2.0 : 1000.0, abs(_3424));
        float _3471 = max(_3416.x - _3388.x, _3388.x - _3420.x);
        float _3483 = max(_3416.y - _3388.y, _3388.y - _3420.y);
        float _3495 = max(_3471, _3483) - _3464;
        _3495 = max(_3495, _3452 - _3388.z);
        _3495 = max(_3495, _3424 - _3446);
        if (_3495 <= 0.0)
        {
            float _3516 = _3443 ? _3430 : _3433;
            vec2 _3521 = _1057._m18[2].xy;
            float _3525 = length(_3521);
            vec3 _3528 = vec3(_3521, (-1.73205077648162841796875) * _3525);
            _3528 /= vec3(2.0 * _3525);
            vec3 _3541 = _802._m24.xyz;
            vec3 _3545 = mix(_3528, _3541, bvec3(_3443));
            vec2 _3552 = _3388.xy - (_3545.xy * (_3424 / _3545.z));
            float _3563 = (_802._m74 / 100.0) * 16.0;
            vec2 _3570 = _3552 * _3563;
            float _3574 = TEXTURE_LOD(SAMPLER_2D(_3575, _3577), vec4(_3570, 0.0, 0.0).xy, vec4(_3570, 0.0, 0.0).w).x;
            float _3592 = min(8.0, _3420.z - _3416.z);
            float _3605 = (-_3424) / _3592;
            float _3600 = _10(_3605);
            float _3612 = dot(_1057._m6, _3545);
            float _3607 = _10(_3612);
            float _3618 = _3471 / _3464;
            float _3614 = 1.0 - _10(_3618);
            float _3624 = _3483 / _3464;
            _3614 *= (1.0 - _10(_3624));
            _3614 *= _3614;
            float _3640 = min(_3424 / 1.0, 1.0 - (_3424 / _3446));
            float _3632 = _10(_3640);
            _3614 *= max(_3632, _3600);
            _3614 *= _3614;
            _3614 *= _3391;
            float _3653 = _3574 - 1.0;
            float _3656 = float(_3443) * _3436;
            float _3661 = max(0.0, _3574 - 0.85000002384185791015625);
            float _3666 = _3443 ? _3653 : _3661;
            float _3671 = (((1.0 - _3656) * _3607) * _3614) * _3516;
            vec3 _3680 = _1057._m0 + (_1057._m2 * (vec3(1.0) - _1057._m0));
            _1057._m21 += ((_3680 * (_3666 * _3671)) * _802._m23.xyz);
            float _3704 = _3656 * _3614;
            _1057._m25 = 1.0 + (_3704 * (_3574 - 1.0));
        }
    }
    else
    {
        if (_3391 > 0.0)
        {
            _3391 *= _802._m75;
            float _3724 = float(_802._m24.w < 0.0);
            vec3 _3729 = _802._m24.xyz;
            float _3738 = dot(_1057._m6, _3729);
            float _3733 = _10(_3738);
            vec2 _3740 = _3388.xy - (_3729.xy * (_3388.z / _3729.z));
            float _3752 = (_802._m74 / 100.0) * 16.0;
            vec2 _3757 = _3740 * _3752;
            float _3761 = TEXTURE_LOD(SAMPLER_2D(_3575, _3577), vec4(_3757, 0.0, 0.0).xy, vec4(_3757, 0.0, 0.0).w).x;
            vec4 _3777 = _802._m23;
            _1057._m21 += (_3777.xyz * (((((1.0 - _3724) * (_3761 - 1.0)) * _3733) * _3391) * _3777.w));
            _1057._m25 = 1.0 + ((_3724 * (_3761 - 1.0)) * _3391);
        }
    }
    _1057._m14 = normalize(vec3(_802._m52, _802._m53, _802._m54) - _1057._m15);
    vec3 _3819 = vec3(0.0);
    vec3 _3820 = vec3(0.0);
    vec3 _3821 = vec3(0.0);
    vec3 _3822 = vec3(0.0);
    vec3 _3823 = vec3(0.0);
    vec4 _3824 = _1057._m29;
    vec4 _3827 = _1057._m30;
    vec4 _3830 = _1057._m31;
    _3820 = vec3(_3824.x, _3824.y, _3824.z);
    _3821 = vec3(_3824.w, _3827.x, _3827.y);
    _3822 = vec3(_3827.z, _3827.w, _3830.x);
    _3823 = vec3(_3830.y, _3830.z, _3830.w);
    vec3 _3861 = ((_3820 - (_3821 * _1057._m6.y)) + (_3822 * _1057._m6.z)) - (_3823 * _1057._m6.x);
    float _3885 = _1197._m21 * _802._m76;
    _3819 += (max(vec3(0.0), _3861 * _10(_3885)) * _1057._m0);
    vec3 _3894 = vec3(0.0);
    vec3 _3895 = vec3(0.0);
    vec3 _3896 = vec3(0.0);
    vec3 _3897 = vec3(0.0);
    vec3 _3898 = vec3(0.0);
    vec4 _3899 = _1057._m29;
    vec4 _3902 = _1057._m30;
    vec4 _3905 = _1057._m31;
    _3895 = vec3(_3899.x, _3899.y, _3899.z);
    _3896 = vec3(_3899.w, _3902.x, _3902.y);
    _3897 = vec3(_3902.z, _3902.w, _3905.x);
    _3898 = vec3(_3905.y, _3905.z, _3905.w);
    vec3 _3936 = ((_3895 - (_3896 * _1057._m8.y)) + (_3897 * _1057._m8.z)) - (_3898 * _1057._m8.x);
    float _3959 = _1197._m21 * _802._m76;
    _3894 += (max(vec3(0.0), _3936 * _10(_3959)) * _1057._m0);
    uint _3970 = _1057._m4;
    _3819 = mix(_3819, _3894, vec3(_93(_3970).w));
    _1057._m21 += _3819;
    bool _3982 = true;
    _3982 = (((_802._m78 & 1u) != 0u) == true) ? false : true;
    if (true && (_3982 == true))
    {
        uint _3995 = _3999._m0[_2456 * 64u];
        uint _4004 = _3995 & 255u;
        uint _4007 = _3999._m0[_2490 * 64u];
        uint _4012 = _4007 & 255u;
        uint _4020;
        uint _4022;
        uint _4024;
        if (_4004 < _4012)
        {
            _4020 = _4004;
            _4022 = _3995;
            _4024 = _2456;
        }
        else
        {
            _4020 = _4012;
            _4022 = _4007;
            _4024 = _2490;
        }
        float _4030 = _1057._m47;
        float _4039 = dot(_1057._m14, _1057._m6);
        float _4033 = _10(_4039);
        float _4041 = _4033;
        float _4043 = _1057._m3;
        vec3 _4046 = _1057._m2;
        _1057._m24 = (_115(_4041, _4043, _4046) * _1057._m11) * _1057._m39;
        float _4057 = _802._m25.x;
        float _4060 = _802._m25.z;
        bool _4064 = _4057 > 0.0;
        bool _4071;
        if (_4064)
        {
            _4071 = _1057._m3 > _4060;
        }
        else
        {
            _4071 = _4064;
        }
        if (_4071)
        {
            float _4074 = 0.0;
            vec3 _4075 = normalize(reflect(-_1057._m14, _1057._m6));
            if (dot(_1057._m14, _4075) <= _4074)
            {
                vec2 _4091 = vec2(1.0);
                uvec2 _4104 = uvec2(_1057._m17.xy * (vec2(1.0) / _4091));
                uint _4105 = uint(_802._m25.w);
                float _4092 = _182(_4104, _4105);
                _4092 -= 1.0;
                vec2 _4109 = _1057._m17.xy * _802._m18.xy;
                vec3 _4124 = vec3(_4109, _1057._m17.z);
                vec4 _4125 = _802._m26;
                vec4 _4128 = _802._m27;
                vec3 _4117 = _176(_4124, _4125, _4128);
                mat3 _4132 = mat3(vec3(_802._m28.xyz), vec3(_802._m29.xyz), vec3(_802._m30.xyz));
                mat3 _4156 = _4132;
                vec3 _4158 = _4075;
                vec3 _4155 = normalize(_71(_4156, _4158));
                float _4162 = 1.0;
                uint _4163 = uint((_4057 == 1.0) ? 8 : 12);
                _4163 = (_4057 == 3.0) ? 16u : _4163;
                vec3 _4173 = _4117;
                float _4178 = _1057._m17.z;
                bool _4181 = true;
                float _4182 = _145(_4178, _4181);
                vec3 _4175 = _4173 + (_4155 * _4182);
                vec4 _4185 = vec4(0.0);
                vec3 _4187 = _4173;
                vec4 _4189 = _802._m31;
                vec3 _4186 = _170(_4187, _4189);
                vec3 _4194 = _4175;
                vec4 _4196 = _802._m31;
                vec3 _4193 = _170(_4194, _4196);
                vec3 _4200 = ((_4193 - _4186) * (_4162 / float(_4163))) / vec3(length(_4193.xy - _4186.xy));
                vec3 _4217 = _4186 + (_4200 * _4092);
                float _4223 = abs(_4200.z) * 1.0;
                uint _4228 = 0u;
                vec3 _4229 = _4217;
                float _4231 = _4186.z;
                float _4418;
                for (uint _4234 = 0u; _4234 < _4163; _4234 += 4u)
                {
                    vec4 _4243 = vec4(1.0, 2.0, 3.0, 4.0) + vec4(float(_4234));
                    vec4 _4249 = vec4(1.0) - vec4(TEXTURE_LOD(SAMPLER_2D(_4250, _4252), vec4(_4217.xy + (_4200.xy * _4243.x), 0.0, 0.0).xy, vec4(_4217.xy + (_4200.xy * _4243.x), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4250, _4252), vec4(_4217.xy + (_4200.xy * _4243.y), 0.0, 0.0).xy, vec4(_4217.xy + (_4200.xy * _4243.y), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4250, _4252), vec4(_4217.xy + (_4200.xy * _4243.z), 0.0, 0.0).xy, vec4(_4217.xy + (_4200.xy * _4243.z), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4250, _4252), vec4(_4217.xy + (_4200.xy * _4243.w), 0.0, 0.0).xy, vec4(_4217.xy + (_4200.xy * _4243.w), 0.0, 0.0).w).x);
                    uvec4 _4371 = mix(uvec4(0u), uvec4(1u), lessThan(abs(((_4217.zzzz + (_4200.zzzz * _4243)) - _4249) - vec4(_4223)), vec4(_4223)));
                    uint _4391 = (((_4371.x << uint(0)) | (_4371.y << uint(1))) | (_4371.z << uint(2))) | (_4371.w << uint(3));
                    if (_4391 > 0u)
                    {
                        uint _4412 = _4391;
                        uint _4411 = uint(_50(_4412));
                        if (_4411 > 0u)
                        {
                            _4418 = _4249[_4411 - 1u];
                        }
                        else
                        {
                            _4418 = _4231;
                        }
                        _4231 = _4418;
                        _4229 = _4217 + (_4200 * float((_4234 + _4411) + 1u));
                        float _4437 = _4249[_4411] - _4229.z;
                        float _4444 = (_4231 - _4229.z) + _4200.z;
                        float _4458 = _4437 / (_4437 - _4444);
                        float _4452 = _10(_4458);
                        vec3 _4460 = _4229 - _4200;
                        _4229 = (_4460 * _4452) + (_4229 * (1.0 - _4452));
                        _4228 = _4234 + _4411;
                        break;
                    }
                    _4231 = _4249.w;
                }
                if (_4228 > 0u)
                {
                    vec3 _4485 = _4229;
                    vec4 _4487 = _802._m32;
                    vec4 _4490 = _802._m33;
                    vec4 _4493 = _802._m34;
                    vec4 _4496 = _802._m35;
                    vec3 _4484 = _64(_4485, _4487, _4490, _4493, _4496).xyw;
                    vec2 _4506 = _4484.xy / vec2(_4484.z);
                    _4484 = vec3(_4506.x, _4506.y, _4484.z);
                    vec2 _4509 = (_4484.xy * 2.0) - vec2(1.0);
                    float _4523 = (1.0 - (float(_4228) / float(_4163))) * 4.0;
                    float _4515 = _10(_4523);
                    if (false)
                    {
                        float _4527 = _4509.y;
                        float _4532 = 1.0 - _56(_4527);
                        _4515 *= smoothstep(0.0, 0.25, _10(_4532));
                    }
                    else
                    {
                        float _4542 = 1.0 - dot(_4509, _4509);
                        _4515 *= smoothstep(0.0, 0.5, _10(_4542));
                    }
                    vec3 _4547 = TEXTURE_LOD(SAMPLER_2D(_4548, _3337), vec4(_4484.xy, 0.0, 0.0).xy, vec4(_4484.xy, 0.0, 0.0).w).xyz;
                    _4185 = vec4(_4547, _4515);
                }
                float _4580 = 1.0 - ((1.0 - _1057._m3) / (1.0 - _4060));
                float _4572 = _10(_4580);
                float _4582 = (_4185.w * _4572) * _802._m77;
                _1057._m21 += ((_4185.xyz * _4582) * _1057._m24);
                _4030 = 1.0 - _4582;
            }
        }
        uint _4604 = 1u;
        _4641 _4643;
        while (_4604 <= _4020)
        {
            uint _4613 = (_4024 * 64u) + _4604;
            uint _4618 = _3999._m0[_4613];
            uint _4622 = _4618;
            if (_4622 >= _4618)
            {
                _4604++;
            }
            float _4631 = 0.0039215688593685626983642578125;
            if (_4030 <= (_4631 * 4.0))
            {
                break;
            }
            int _4639 = 4;
            int _4640 = 4;
            _4643._m0 = _4647._m0[(uint(_4639) * _4622) + 0u].xyz;
            float _4662 = _4647._m0[(uint(_4639) * _4622) + 0u].w;
            _4643._m1 = _27(_4662);
            _4643._m2 = _4647._m0[(uint(_4639) * _4622) + 1u].xyz;
            _4643._m3 = _4647._m0[(uint(_4639) * _4622) + 1u].w;
            _4643._m4 = _4647._m0[(uint(_4639) * _4622) + 2u];
            float _4697 = _4647._m0[(uint(_4639) * _4622) + 3u].x;
            _4643._m8 = _27(_4697);
            float _4707 = _4647._m0[(uint(_4639) * _4622) + 3u].y;
            _4643._m9 = _27(_4707);
            _4643._m10 = _4647._m0[(uint(_4639) * _4622) + 3u].z;
            _4643._m5 = _4723._m0[(uint(_4640) * _4622) + 0u];
            _4643._m6 = _4723._m0[(uint(_4640) * _4622) + 1u];
            _4643._m7 = _4723._m0[(uint(_4640) * _4622) + 2u];
            _4643._m12 = _4723._m0[(uint(_4640) * _4622) + 3u].xyz;
            _4643._m13 = _4723._m0[(uint(_4640) * _4622) + 3u].w;
            vec3 _4765 = vec3(dot(_1057._m15, _4643._m5.xyz) + _4643._m5.w, dot(_1057._m15, _4643._m6.xyz) + _4643._m6.w, dot(_1057._m15, _4643._m4.xyz) + _4643._m4.w);
            float _4794 = _4765.x;
            float _4797 = _4765.y;
            float _4800 = _4765.z;
            bool _4805 = _38(_4794, _4797, _4800) <= _4631;
            bool _4822;
            if (!_4805)
            {
                float _4809 = _4765.x;
                float _4812 = _4765.y;
                float _4815 = _4765.z;
                _4822 = _33(_4809, _4812, _4815) >= (1.0 - _4631);
            }
            else
            {
                _4822 = _4805;
            }
            if (_4822)
            {
                continue;
            }
            uint _4826 = _4643._m1;
            vec3 _4829 = _4643._m0;
            float _4832 = float(bitfieldExtract(_4643._m8, 20, 12));
            float _4837 = 0.800000011920928955078125;
            vec3 _4838 = (_4765 * 2.0) - vec3(1.0);
            vec3 _4843 = _4838;
            vec3 _4842 = _53(_4843);
            vec3 _4846 = _4838 * sqrt(((vec3(1.0) - (_4842.yzx * 0.5)) - (_4842.zxy * 0.5)) + ((_4842.yzx * _4842.zxy) / vec3(3.0)));
            float _4877 = 1.0 - ((length(_4846) - _4837) / ((1.0 - _4837) + 9.9999999747524270787835121154785e-07));
            float _4866 = _10(_4877);
            _4866 *= _4866;
            _4866 *= _4030;
            float _4885 = _4643._m7.w;
            _4866 *= _4885;
            _4030 *= (1.0 - _4866);
            vec3 _4895 = _4643._m12;
            float _4898 = _4643._m13;
            float _4903 = _4866;
            vec3 _4901 = _4895 * (_10(_4903) * _4898);
            vec3 _4909 = _4643._m2;
            vec3 _4912 = _4643._m7.xyz;
            vec3 _4916 = vec3(0.0);
            vec3 _4917 = reflect(-_1057._m14, _1057._m6);
            vec3 _4924 = (_4912 - _1057._m15) / _4917;
            vec3 _4931 = (_4909 - _1057._m15) / _4917;
            vec3 _4938 = max(_4924, _4931);
            float _4943 = _4938.x;
            float _4946 = _4938.y;
            float _4949 = _4938.z;
            float _4942 = _38(_4943, _4946, _4949);
            vec3 _4953 = _1057._m15 + (_4917 * _4942);
            vec3 _4960 = _4953 - _4829;
            float _4964 = 6.0;
            float _4966 = _4964 - (_4964 * _1057._m3);
            _4916 = textureLod(samplerCubeArray(_4975, _4977), vec4(_4960, _4832), _4966).xyz;
            _1057._m21 += ((_4916 * _4901) * _1057._m24);
        }
    }
    uint _5000 = _5004._m0[_2456 * 64u];
    uint _5009 = _5000 & 255u;
    uint _5012 = _5004._m0[_2490 * 64u];
    uint _5017 = _5012 & 255u;
    uint _5025;
    uint _5027;
    uint _5029;
    if (_5009 < _5017)
    {
        _5025 = _5009;
        _5027 = _5000;
        _5029 = _2456;
    }
    else
    {
        _5025 = _5017;
        _5027 = _5012;
        _5029 = _2490;
    }
    uint _5035 = 1u;
    _4641 _5064;
    vec3 _5191;
    float _5312;
    vec2 _5380;
    _5578 _5580;
    _5578 _5727;
    while (_5035 <= _5025)
    {
        uint _5044 = (_5029 * 64u) + _5035;
        uint _5049 = _5004._m0[_5044];
        uint _5053 = _5049;
        if (_5053 >= _5049)
        {
            _5035++;
        }
        int _5062 = 4;
        int _5063 = 4;
        _5064._m0 = _4647._m0[(uint(_5062) * _5053) + 0u].xyz;
        float _5079 = _4647._m0[(uint(_5062) * _5053) + 0u].w;
        _5064._m1 = _27(_5079);
        _5064._m2 = _4647._m0[(uint(_5062) * _5053) + 1u].xyz;
        _5064._m3 = _4647._m0[(uint(_5062) * _5053) + 1u].w;
        _5064._m4 = _4647._m0[(uint(_5062) * _5053) + 2u];
        float _5114 = _4647._m0[(uint(_5062) * _5053) + 3u].x;
        _5064._m8 = _27(_5114);
        float _5124 = _4647._m0[(uint(_5062) * _5053) + 3u].y;
        _5064._m9 = _27(_5124);
        _5064._m10 = _4647._m0[(uint(_5062) * _5053) + 3u].z;
        _5064._m5 = _4723._m0[(uint(_5063) * _5053) + 0u];
        _5064._m6 = _4723._m0[(uint(_5063) * _5053) + 1u];
        _5064._m7 = _4723._m0[(uint(_5063) * _5053) + 2u];
        _5064._m12 = _4723._m0[(uint(_5063) * _5053) + 3u].xyz;
        _5064._m13 = _4723._m0[(uint(_5063) * _5053) + 3u].w;
        float _5178 = 0.0;
        uint _5179 = _5064._m1;
        vec3 _5182 = _5064._m0;
        vec3 _5185 = _5182;
        if ((_5179 & 7u) == 2u)
        {
            _5191 = _5185;
        }
        else
        {
            _5191 = normalize(_5182 - _1057._m15);
        }
        vec3 _5187 = _5191;
        uint _5202 = uint(((_2500 & 3u) != 0u) ? 16 : 0);
        _5202 |= 32u;
        if ((_5179 & _5202) != 0u)
        {
            continue;
        }
        vec3 _5217 = vec3(dot(_1057._m15, _5064._m5.xyz) + _5064._m5.w, dot(_1057._m15, _5064._m6.xyz) + _5064._m6.w, dot(_1057._m15, _5064._m7.xyz) + _5064._m7.w);
        vec2 _5251 = _5217.xy / vec2(_5217.z);
        _5217 = vec3(_5251.x, _5251.y, _5217.z);
        _5217.z = dot(_1057._m15, _5064._m4.xyz) + _5064._m4.w;
        float _5264 = _5217.x;
        float _5267 = _5217.y;
        float _5270 = _5217.z;
        bool _5275 = _38(_5264, _5267, _5270) <= _5178;
        bool _5292;
        if (!_5275)
        {
            float _5279 = _5217.x;
            float _5282 = _5217.y;
            float _5285 = _5217.z;
            _5292 = _33(_5279, _5282, _5285) >= (1.0 - _5178);
        }
        else
        {
            _5292 = _5275;
        }
        if (_5292)
        {
            continue;
        }
        vec3 _5296 = vec3(1.0);
        uint _5297 = _5179 & 7u;
        vec3 _5300 = _5064._m0 - _1057._m15;
        float _5306 = dot(_5300, _5300);
        if (_5297 != 2u)
        {
            _5312 = 1.0 / (1.0 + _5306);
        }
        else
        {
            _5312 = _1057._m25;
        }
        _5296 = vec3(_5312);
        if (_5297 == 0u)
        {
            float _5332 = _5306 * _5064._m3;
            float _5335 = 1.0 - _56(_5332);
            float _5337 = _10(_5335);
            float _5327 = _56(_5337);
            _5296 *= _5327;
        }
        else
        {
            if (_5297 == 4u)
            {
                float _5353 = length((_5217.xy - vec2(0.5)) * 2.0);
                float _5347 = _10(_5353);
                float _5355 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_5347 * 7.80000019073486328125))));
                _5296 *= _5355;
            }
            else
            {
                if ((_5297 == 1u) || (_5297 == 2u))
                {
                    if (_5297 == 2u)
                    {
                        _5380 = fract((_5217.xy * _802._m36.xy) + _802._m36.zw);
                    }
                    else
                    {
                        _5380 = _5217.xy;
                    }
                    vec2 _5377 = _5380;
                    vec3 _5398 = vec3(0.0);
                    uint _5399 = bitfieldExtract(_5064._m8, 0, 20);
                    uint _5403 = _5399;
                    uint _5407 = _5403 + 0u;
                    vec3 _5423 = TEXTURE_LOD(SAMPLER_2D(_1461[nonuniformEXT(_5407)], _1343), vec4(_5377, 0.0, 0.0).xy, vec4(_5377, 0.0, 0.0).w).xyz;
                    _5398 = _53(_5423);
                    _5296 *= _5398;
                }
            }
        }
        float _5429 = float((_5179 >> uint(8)) & 255u) / 255.0;
        if ((_5297 == 0u) || (_5297 == 2u))
        {
            vec3 _5442 = abs((_5217 * 2.0) - vec3(1.0));
            float _5448 = _5442.x;
            float _5451 = _5442.y;
            float _5454 = _5442.z;
            float _5459 = 1.0 - _33(_5448, _5451, _5454);
            float _5464 = _10(_5459) / (9.9999999392252902907785028219223e-09 + _5429);
            float _5447 = _10(_5464);
            _5296 *= ((_5447 * _5447) * (3.0 - (2.0 * _5447)));
        }
        else
        {
            if ((_5297 == 1u) || (_5297 == 4u))
            {
                float _5484 = _5217.z;
                float _5488 = _56(_5484);
                float _5491 = 1.0 - _56(_5488);
                float _5493 = _10(_5491);
                float _5498 = _56(_5493) / (9.9999999392252902907785028219223e-09 + _5429);
                float _5483 = _10(_5498);
                _5296 *= _5483;
            }
        }
        float _5503 = _5296.x;
        float _5506 = _5296.y;
        float _5509 = _5296.z;
        if (_33(_5503, _5506, _5509) <= _5178)
        {
            continue;
        }
        float _5518 = 1.0;
        if ((_5179 & 8u) != 0u)
        {
            float _5525 = 0.00200000009499490261077880859375;
            vec3 _5527 = _1057._m15 + (_1057._m6 * _5525);
            uint _5535 = 0u;
            if ((_5179 & 7u) == 0u)
            {
                vec3 _5541 = _5527 - _5064._m2;
                float _5546 = _5541.x;
                float _5549 = _5541.y;
                float _5552 = _5541.z;
                _5535 = _44(_5546, _5549, _5552);
            }
            else
            {
                if ((_5179 & 7u) == 2u)
                {
                    float _5562 = 0.0;
                    uint _5563 = uint((_802._m37.w > 0.0) ? 3 : 4);
                    for (; _5535 < _5563; _5535++)
                    {
                        int _5577 = 5;
                        _5580._m0 = _5585._m0[(uint(_5577) * ((_5179 >> uint(22)) + _5535)) + 0u];
                        _5580._m1 = _5585._m0[(uint(_5577) * ((_5179 >> uint(22)) + _5535)) + 1u];
                        _5580._m2 = _5585._m0[(uint(_5577) * ((_5179 >> uint(22)) + _5535)) + 2u];
                        _5580._m3 = _5585._m0[(uint(_5577) * ((_5179 >> uint(22)) + _5535)) + 3u];
                        _5580._m4 = _5585._m0[(uint(_5577) * ((_5179 >> uint(22)) + _5535)) + 4u];
                        vec2 _5641 = vec2(dot(_5527, _5580._m0.xyz) + _5580._m0.w, dot(_5527, _5580._m1.xyz) + _5580._m1.w);
                        _5641 = abs((_5641 * 2.0) - vec2(1.0));
                        bool _5667 = _5641.x < 0.9900000095367431640625;
                        bool _5673;
                        if (_5667)
                        {
                            _5673 = _5641.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _5673 = _5667;
                        }
                        if (_5673)
                        {
                            _5562 = (1.0 - max(_5641.x, _5641.y)) * _802._m38.w;
                            break;
                        }
                    }
                    _1057._m36 = int(_5535);
                    _5535 = min((_5563 - 1u), _5535);
                    if (_802._m37.w > 0.0)
                    {
                        uint _5700 = uint(_1057._m17.x) ^ (uint(_1057._m17.y) << uint(1));
                        _5700 ^= uint(_802._m39.x);
                        _5535 += uint(int(((float(_5700 & 3u) * 0.25) + 0.125) > _5562));
                    }
                }
            }
            int _5726 = 5;
            _5727._m0 = _5585._m0[(uint(_5726) * ((_5179 >> uint(22)) + _5535)) + 0u];
            _5727._m1 = _5585._m0[(uint(_5726) * ((_5179 >> uint(22)) + _5535)) + 1u];
            _5727._m2 = _5585._m0[(uint(_5726) * ((_5179 >> uint(22)) + _5535)) + 2u];
            _5727._m3 = _5585._m0[(uint(_5726) * ((_5179 >> uint(22)) + _5535)) + 3u];
            _5727._m4 = _5585._m0[(uint(_5726) * ((_5179 >> uint(22)) + _5535)) + 4u];
            vec4 _5783 = vec4((_5527.x * _5727._m0.x) + ((_5527.y * _5727._m0.y) + ((_5527.z * _5727._m0.z) + _5727._m0.w)), (_5527.x * _5727._m1.x) + ((_5527.y * _5727._m1.y) + ((_5527.z * _5727._m1.z) + _5727._m1.w)), (_5527.x * _5727._m2.x) + ((_5527.y * _5727._m2.y) + ((_5527.z * _5727._m2.z) + _5727._m2.w)), (_5527.x * _5727._m3.x) + ((_5527.y * _5727._m3.y) + ((_5527.z * _5727._m3.z) + _5727._m3.w)));
            vec3 _5870 = _5783.xyz / vec3(_5783.w);
            _5783 = vec4(_5870.x, _5870.y, _5870.z, _5783.w);
            bool _5878 = min(_5783.x, _5783.y) > 0.0;
            bool _5887;
            if (_5878)
            {
                _5887 = max(_5783.x, _5783.y) < 1.0;
            }
            else
            {
                _5887 = _5878;
            }
            if (_5887)
            {
                vec2 _5899 = (_5783.xy * _5727._m4.xy) + _5727._m4.zw;
                _5783 = vec4(_5899.x, _5899.y, _5783.z, _5783.w);
                if (false)
                {
                    _5518 = textureLod(sampler2DShadow(_5906, _5908), vec3(_5783.xyz.xy, _5783.xyz.z), 0.0);
                }
                else
                {
                    vec2 _5917 = (_5783.xy * _802._m40.xy) + vec2(0.5);
                    vec2 _5926 = floor(_5917);
                    vec2 _5929 = _5917 - _5926;
                    _5926 -= vec2(0.5);
                    vec2 _5936 = vec2(4.0) - (_5929 * 3.0);
                    vec2 _5941 = vec2(7.0);
                    vec2 _5944 = vec2(1.0) + (_5929 * 3.0);
                    vec2 _5949 = (_5926 + (((vec2(3.0) - (_5929 * 2.0)) / _5936) - vec2(2.0))) * _802._m40.zw;
                    vec2 _5964 = (_5926 + ((vec2(3.0) + _5929) / _5941)) * _802._m40.zw;
                    vec2 _5976 = (_5926 + ((_5929 / _5944) + vec2(2.0))) * _802._m40.zw;
                    vec3 _6002 = vec3(_5949.x, _5949.y, _5783.z);
                    _5518 = (_5936.x * _5936.y) * textureLod(sampler2DShadow(_5906, _5908), vec3(_6002.xy, _6002.z), 0.0);
                    vec3 _6020 = vec3(_5964.x, _5949.y, _5783.z);
                    _5518 += ((_5941.x * _5936.y) * textureLod(sampler2DShadow(_5906, _5908), vec3(_6020.xy, _6020.z), 0.0));
                    vec3 _6040 = vec3(_5976.x, _5949.y, _5783.z);
                    _5518 += ((_5944.x * _5936.y) * textureLod(sampler2DShadow(_5906, _5908), vec3(_6040.xy, _6040.z), 0.0));
                    vec3 _6060 = vec3(_5949.x, _5964.y, _5783.z);
                    _5518 += ((_5936.x * _5941.y) * textureLod(sampler2DShadow(_5906, _5908), vec3(_6060.xy, _6060.z), 0.0));
                    vec3 _6080 = vec3(_5964.x, _5964.y, _5783.z);
                    _5518 += ((_5941.x * _5941.y) * textureLod(sampler2DShadow(_5906, _5908), vec3(_6080.xy, _6080.z), 0.0));
                    vec3 _6100 = vec3(_5976.x, _5964.y, _5783.z);
                    _5518 += ((_5944.x * _5941.y) * textureLod(sampler2DShadow(_5906, _5908), vec3(_6100.xy, _6100.z), 0.0));
                    vec3 _6120 = vec3(_5949.x, _5976.y, _5783.z);
                    _5518 += ((_5936.x * _5944.y) * textureLod(sampler2DShadow(_5906, _5908), vec3(_6120.xy, _6120.z), 0.0));
                    vec3 _6140 = vec3(_5964.x, _5976.y, _5783.z);
                    _5518 += ((_5941.x * _5944.y) * textureLod(sampler2DShadow(_5906, _5908), vec3(_6140.xy, _6140.z), 0.0));
                    vec3 _6160 = vec3(_5976.x, _5976.y, _5783.z);
                    _5518 += ((_5944.x * _5944.y) * textureLod(sampler2DShadow(_5906, _5908), vec3(_6160.xy, _6160.z), 0.0));
                    _5518 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _5518 = float((_5179 & 7u) == 2u);
                if ((_5179 & 7u) == 2u)
                {
                    _1057._m36 = -1;
                }
            }
            float _6180 = float((_5179 >> uint(16)) & 63u) / 63.0;
            float _6194 = ((_5518 * _6180) + 1.0) - _6180;
            _5518 = _10(_6194);
        }
        if (_5518 <= _5178)
        {
            continue;
        }
        vec3 _6202 = (_5064._m12 * _5518) * _5296;
        float _6209 = _5064._m13;
        vec3 _6212 = _6202;
        float _6219 = dot(_1057._m6, _5187);
        float _6214 = _10(_6219);
        float _6221 = 1.0;
        vec3 _6223 = _1057._m6;
        vec3 _6226 = _1057._m14;
        vec3 _6229 = _5187;
        vec3 _6231 = _1057._m2;
        float _6234 = _1057._m3;
        vec3 _6222 = _109(_6223, _6226, _6229, _6231, _6234);
        _1057._m21 += ((((_6222 * _6209) * _6212) * _6214) * _6221);
        vec3 _6251 = _6212;
        uint _6254 = _1057._m4;
        vec4 _6253 = _93(_6254);
        vec3 _6258 = _6253.xyz;
        float _6266 = dot(_1057._m8, _5187);
        float _6261 = _10(_6266);
        vec3 _6268 = vec3(mix(_6214, _6261, _1184._m36), mix(_6214, _6261, _1184._m35), mix(_6214, _6261, _1184._m34));
        float _6297 = dot(_1057._m14, -_5187);
        float _6299 = _10(_6297);
        float _6300 = _1184._m12.w;
        vec3 _6307 = ((_1184._m12.xyz + vec3(_1057._m5)) * _79(_6299, _6300)) * _6258;
        _6268 += _16(_6307);
        float _6311 = _6253.w;
        _6268 = mix(vec3(_6214), _6268, vec3(_6311));
        _1057._m21 += ((_6251 * _6268) * _1057._m0);
    }
    _1057._m21 *= _1057._m11;
    _6337 = vec4(_1057._m21, 0.0);
    if (((_802._m78 & 1u) != 0u) == true)
    {
        vec3 _6352 = _1057._m6;
        bool _6355 = false;
        vec2 _6356 = _190(_6352, _6355);
        _6351 = vec4(_6356, 0.0, 0.0);
        float _6366 = dot(_1057._m14, _1057._m6);
        float _6360 = _10(_6366);
        float _6369 = _6360;
        float _6371 = _1057._m3;
        vec3 _6374 = _1057._m2;
        vec3 _6368 = _115(_6369, _6371, _6374);
        float _6379 = _6368.x;
        float _6383 = _6368.y;
        float _6387 = _6368.z;
        float _6391 = _1057._m3;
        _6378 = vec4(_82(_6379), _82(_6383), _82(_6387), _193(_6391));
    }
}

