// Shadow Template 3
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

struct _91
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _1748
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _2280
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _553_555
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    uint _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    uint _m59;
    float _m60[3];
} _555;

layout(set = 2, binding = 0, std140) uniform _891_893
{
    vec4 _m0;
    vec4 _m1;
    float _m2;
    float _m3;
    float _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    uint _m9;
    float _m10;
    uint _m11;
    uint _m12;
    uint _m13;
    uint _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20[2];
} _893;

layout(set = 1, binding = 0, std140) uniform _1093_1095
{
    int _m0;
    float _m1;
    float _m2;
    float _m3;
} _1095;

layout(set = 0, binding = 17, std430) restrict readonly buffer _1683_1685
{
    uint _m0[];
} _1685;

layout(set = 0, binding = 18, std140) uniform _1753_1755
{
    vec4 _m0[4096];
} _1755;

layout(set = 0, binding = 19, std140) uniform _1829_1831
{
    vec4 _m0[4096];
} _1831;

layout(set = 0, binding = 21, std140) uniform _2285_2287
{
    vec4 _m0[4095];
} _2287;

layout(set = 0, binding = 1, std140) uniform _3445_3447
{
    vec4 _m0[64];
} _3447;

layout(push_constant, std430) uniform _3441_3443
{
    int _m0;
    int _m1;
} _3443;

layout(set = 3, binding = 0) uniform texture2D _903[34816];
layout(set = 0, binding = 11) uniform sampler _912;
layout(set = 0, binding = 12) uniform sampler _929;
layout(set = 0, binding = 13) uniform texture2D _1116;
layout(set = 0, binding = 14) uniform sampler _1118;
layout(set = 0, binding = 15) uniform texture2D _1357;
layout(set = 0, binding = 16) uniform sampler _1359;
layout(set = 0, binding = 20) uniform sampler _2109;
layout(set = 0, binding = 22) uniform texture2D _2608;
layout(set = 0, binding = 23) uniform samplerShadow _2610;
layout(set = 0, binding = 24) uniform texture2D _3034;
layout(set = 0, binding = 25) uniform sampler _3036;
layout(set = 0, binding = 7) uniform texture3D _3450;
layout(set = 0, binding = 8) uniform sampler _3451;
layout(set = 0, binding = 9) uniform texture3D _3452;
layout(set = 0, binding = 10) uniform sampler _3453;

layout(location = 17, component = 3) in float _764;
layout(location = 18, component = 0) in float _766;
layout(location = 18, component = 1) in float _771;
layout(location = 18, component = 2) in float _773;
layout(location = 18, component = 3) in float _775;
layout(location = 19, component = 0) in float _803;
layout(location = 19, component = 1) in float _805;
layout(location = 19, component = 2) in float _807;
layout(location = 19, component = 3) in float _811;
layout(location = 20, component = 0) in float _813;
layout(location = 20, component = 1) in float _815;
layout(location = 20, component = 2) in float _827;
layout(location = 10, component = 0) in vec4 _852;
layout(location = 11, component = 0) in vec4 _855;
layout(location = 12, component = 0) in vec4 _858;
layout(location = 0, component = 0) out vec4 _3381;
layout(location = 1, component = 0) out vec4 _3396;
layout(location = 2, component = 0) out vec4 _3423;
uint _142;
uint _144;
uint _146;
uint _148;
uint _150;
uint _152;
uint _154;
uint _155;
uint _157;
uint _158;
uint _160;
uint _162;
uint _164;
uint _166;
uint _168;
uint _170;
uint _172;
uint _174;
uint _176;

_91 _93()
{
    _91 _445;
    _445._m0 = vec3(0.0);
    _445._m2 = vec3(0.0);
    _445._m3 = 0.0;
    _445._m4 = 0u;
    _445._m5 = 0.0;
    _445._m6 = vec3(0.0);
    _445._m7 = vec3(0.0, 0.0, 1.0);
    _445._m8 = vec3(0.0, 0.0, 1.0);
    _445._m1 = vec3(0.0);
    _445._m9 = 1.0;
    _445._m10 = 1.0;
    _445._m14 = vec3(0.0);
    _445._m15 = vec3(0.0);
    _445._m16 = vec4(0.0);
    _445._m17 = vec4(0.0);
    _445._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _445._m19 = vec3(0.0);
    _445._m20 = vec3(0.0);
    _445._m21 = vec3(0.0);
    _445._m22 = vec3(0.0);
    _445._m23 = vec3(0.0);
    _445._m24 = vec3(0.0);
    _445._m25 = 1.0;
    _445._m26 = uvec4(0u);
    _445._m27 = uvec4(0u);
    _445._m28 = uvec4(0u);
    _445._m29 = vec4(0.0);
    _445._m30 = vec4(0.0);
    _445._m31 = vec4(0.0);
    _445._m32 = vec4(0.0);
    _445._m33 = uvec2(0u);
    _445._m34 = vec2(0.0);
    _445._m35 = 0.0;
    _445._m36 = -1;
    _445._m37 = 0;
    _445._m38 = vec2(0.0);
    _445._m39 = 1.0;
    _445._m41 = -1;
    _445._m45 = 1.0;
    _445._m11 = 1.0;
    _445._m12 = 0u;
    _445._m13 = uvec3(0u);
    _445._m40 = vec3(0.0);
    _445._m46 = 0.0;
    _445._m47 = 1.0;
    return _445;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec2 _105(vec2 _104)
{
    return ((_104 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _110(inout vec2 _108, bool _109)
{
    vec2 _587 = _108;
    _108 = _105(_587);
    float _607 = (1.0 - (_108.x * _108.x)) - (_108.y * _108.y);
    vec3 _590 = vec3(_108.x, _108.y, sqrt(_10(_607)));
    if (_109 == false)
    {
        _590.z = -_590.z;
    }
    return _590;
}

vec3 _59(mat3 _57, vec3 _58)
{
    return _57 * _58;
}

vec3 _115(vec3 _113, mat3 _114)
{
    mat3 _623 = _114;
    vec3 _625 = _113;
    return normalize(_59(_623, _625));
}

vec3 _121(vec2 _118, mat3 _119, bool _120)
{
    vec2 _632 = _118;
    bool _634 = _120;
    vec3 _636 = _110(_632, _634);
    vec3 _631 = _636;
    vec3 _637 = _631;
    mat3 _639 = _119;
    return _115(_637, _639);
}

float _100(inout float _98, bool _99)
{
    if (_99)
    {
        _98 += (float(_98 < _555._m23) * _555._m24);
    }
    float _568 = _98;
    return _555._m0.w / (_10(_568) + _555._m0.z);
}

uint _21(float _20)
{
    return floatBitsToUint(_20);
}

float _32(float _29, float _30, float _31)
{
    return min(_29, min(_30, _31));
}

float _27(float _24, float _25, float _26)
{
    return max(_24, max(_25, _26));
}

float _44(float _43)
{
    return _43 * _43;
}

vec3 _41(vec3 _40)
{
    return _40 * _40;
}

uint _38(float _35, float _36, float _37)
{
    bool _212 = abs(_37) >= abs(_35);
    bool _220;
    if (_212)
    {
        _220 = abs(_37) >= abs(_36);
    }
    else
    {
        _220 = _212;
    }
    if (_220)
    {
        return uint((_37 < 0.0) ? 5 : 4);
    }
    if (abs(_36) >= abs(_35))
    {
        return uint((_36 < 0.0) ? 3 : 2);
    }
    return uint(int(_35 < 0.0));
}

vec4 _52(vec3 _50, mat4 _51)
{
    return vec4((_50.x * _51[0].x) + ((_50.y * _51[0].y) + ((_50.z * _51[0].z) + _51[0].w)), (_50.x * _51[1].x) + ((_50.y * _51[1].y) + ((_50.z * _51[1].z) + _51[1].w)), (_50.x * _51[2].x) + ((_50.y * _51[2].y) + ((_50.z * _51[2].z) + _51[2].w)), (_50.x * _51[3].x) + ((_50.y * _51[3].y) + ((_50.z * _51[3].z) + _51[3].w)));
}

float _128(uvec2 _126, uint _127)
{
    uvec2 _644 = _126 & uvec2(3u);
    return float(((((2068378560u * (1u - (_644.x >> uint(1)))) + (1500172770u * (_644.x >> uint(1)))) >> ((_644.y + ((_644.x & 1u) << uint(2))) << uint(2))) + _127) & 15u) / 16.0;
}

float _67(float _65, float _66)
{
    return pow(_65, _66);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _78(vec3 _76, float _77)
{
    float _375 = dot(_76, vec3(16.666500091552734375));
    float _370 = _10(_375);
    float _384 = 1.0 - _77;
    float _387 = _10(_384);
    float _388 = 5.0;
    vec3 _392 = _76 + ((vec3(_370) - _76) * _67(_387, _388));
    return _16(_392);
}

vec2 _131(vec2 _130)
{
    return (vec2(1.0) - abs(_130.yx)) * vec2((_130.x >= 0.0) ? 1.0 : (-1.0), (_130.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _136(inout vec3 _134, bool _135)
{
    _134 /= vec3((abs(_134.x) + abs(_134.y)) + abs(_134.z));
    vec2 _713;
    if (_134.z >= 0.0)
    {
        _713 = _134.xy;
    }
    else
    {
        vec2 _719 = _134.xy;
        _713 = _131(_719);
    }
    _134 = vec3(_713.x, _713.y, _134.z);
    if (_135)
    {
        vec2 _734 = (_134.xy * 0.5) + vec2(0.5);
        _134 = vec3(_734.x, _734.y, _134.z);
    }
    return _134.xy;
}

float _62(float _61)
{
    return exp2(_61);
}

vec3 _84(float _81, float _82, vec3 _83)
{
    float _396 = 0.0949999988079071044921875 + (_82 * (0.60000002384185791015625 + (4.190000057220458984375 * _82)));
    float _406 = _81 + 0.02500000037252902984619140625;
    float _410 = (9.5 * _82) * _81;
    float _424 = 1.0 - (14.0 * _81);
    float _416 = (_396 * _406) * _62(_424);
    float _431 = -_410;
    float _427 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _62(_431)));
    return mix(vec3(_416), vec3(_427), _83);
}

float _70(float _69)
{
    return sqrt(_69);
}

float _73(float _72)
{
    return sqrt(_72);
}

float _139(float _138)
{
    float _744 = abs(_138);
    float _741 = _73(_744);
    float _748;
    if (_138 > 0.0)
    {
        _748 = _741;
    }
    else
    {
        _748 = -_741;
    }
    return (_748 * 0.5) + 0.5;
}

void main()
{
    _142 = 2147483648u;
    _144 = 1073741824u;
    _146 = 0u;
    _148 = 268435456u;
    _150 = 536870912u;
    _152 = 805306368u;
    _154 = 1073741824u;
    _155 = 1342177280u;
    _157 = 0u;
    _158 = 16777216u;
    _160 = 33554432u;
    _162 = 50331648u;
    _164 = 67108864u;
    _166 = 83886080u;
    _168 = 100663296u;
    _170 = 117440512u;
    _172 = 134217728u;
    _174 = 150994944u;
    _176 = 167772160u;
    float _760 = 0.0;
    _91 _761 = _93();
    _761._m16 = vec4(0.0, 0.0, _764, _766);
    vec3 _770 = vec3(_771, _773, _775);
    _761._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _761._m15 = vec3(_555._m34, _555._m35, _555._m36) + _770;
    vec3 _801 = vec3(0.0);
    vec3 _802 = vec3(0.0);
    _801 = normalize(vec3(_803, _805, _807));
    _802 = normalize(vec3(_811, _813, _815));
    vec3 _819 = _801;
    vec3 _821 = _802;
    vec3 _823 = normalize(cross(_819, _821) * _827);
    _761._m18 = mat3(vec3(_821), vec3(_823), vec3(_819));
    _761._m14 = normalize(-_770);
    _761._m29 = _852;
    _761._m30 = _855;
    _761._m31 = _858;
    uint _861 = 0u;
    vec4 _862 = vec4(0.0);
    vec4 _863 = vec4(0.0);
    vec4 _864 = vec4(0.0);
    vec4 _865 = vec4(0.0);
    vec4 _866 = vec4(0.0);
    float _867 = 0.0;
    uvec2 _868 = uvec2(0u, 65535u);
    _761._m0 = _862.xyz;
    _761._m2 = _863.xyz;
    _761._m1 = _866.xyz;
    _761._m3 = _865.w;
    _761._m6 = _864.xyz;
    vec2 _886 = vec2(_764, _766) * _893._m1.xy;
    float _922 = texture(sampler2D(_903[_893._m9], _912), _886).x * _893._m10;
    _760 = _10(_922);
    vec4 _924 = texture(sampler2D(_903[_893._m11], _929), _886);
    _761._m0 = _924.xyz;
    _761._m9 = _924.w;
    vec3 _940 = texture(sampler2D(_903[_893._m12], _929), _886).xyz;
    vec2 _950 = texture(sampler2D(_903[_893._m13], _929), _886).xy;
    float _960 = texture(sampler2D(_903[_893._m14], _929), _886).x;
    _761._m2 = _940;
    _761._m6 = vec3(_950, 0.0);
    _761._m3 = _960;
    _761._m18[0] = normalize(_761._m18[0]);
    _761._m18[1] = normalize(_761._m18[1]);
    _761._m18[2] = normalize(_761._m18[2]);
    uint _991 = 0u;
    bool _992 = true;
    vec2 _994 = _761._m6.xy;
    bool _998 = _992;
    vec3 _1000 = _110(_994, _998);
    _761._m7 = _1000;
    vec2 _1002 = _761._m6.xy;
    mat3 _1006 = _761._m18;
    bool _1009 = _992;
    _761._m6 = _121(_1002, _1006, _1009);
    uvec2 _1013 = uvec2(_761._m17.xy);
    uint _1018 = _1013.x / 256u;
    uint _1023 = _1013.y / 256u;
    float _1028 = _761._m17.z;
    bool _1031 = false;
    float _1032 = _100(_1028, _1031);
    float _1027 = _1032;
    float _1033 = log2(max(1.0, _1027 / _555._m6.z)) * _555._m6.w;
    uint _1043 = min(23u, uint(_1033));
    float _1050 = _555._m52;
    float _1056 = _555._m53;
    uint _1048 = (_21(_1050) + ((_1018 + (_21(_1056) * _1023)) * 24u)) + _1043;
    uvec2 _1068 = uvec2(_761._m17.xy);
    uint _1073 = _1068.x / 32u;
    uint _1078 = _1068.y / 32u;
    float _1086 = _555._m54;
    uint _1082 = _1073 + (_1078 * _21(_1086));
    float _1096 = _1095._m2;
    uint _1092 = _21(_1096);
    float _1100 = _555._m7.x;
    if (_1100 > 0.0)
    {
        vec2 _1107 = _761._m17.xy * _555._m8.xy;
        vec3 _1115 = (textureLod(sampler2D(_1116, _1118), vec4(_1107, 0.0, 0.0).xy, vec4(_1107, 0.0, 0.0).w).xyz * 2.0) - vec3(1.0);
        float _1141 = dot(_1115, _761._m6);
        _761._m11 = _10(_1141);
        float _1149 = 1.0 - pow(_761._m11, 0.699999988079071044921875);
        _761._m11 = _10(_1149);
        _761._m11 *= _761._m11;
    }
    _761._m21 = _761._m22;
    _761._m25 = 1.0;
    float _1162 = _555._m9.w;
    bool _1165 = _1162 < 0.0;
    _1162 = abs(_1162);
    vec3 _1170 = _761._m15;
    float _1189 = (1.0 - (length(_1170 - vec3(_555._m34, _555._m35, _555._m36)) / _1162)) / 0.25;
    float _1173 = _10(_1189);
    if ((!_1165) && (_1173 > 0.0))
    {
        vec3 _1198 = _555._m9.xyz;
        vec3 _1202 = _555._m10.xyz;
        float _1206 = _1170.z - _1202.z;
        float _1212 = _555._m11.w;
        float _1215 = _555._m12.w;
        float _1218 = float(_1215 < 0.0);
        _1215 = abs(_1215) - 1.0;
        bool _1225 = _1206 <= 0.0;
        float _1228 = 3.5 * float(!(_1215 == 0.0));
        float _1237;
        if (!(_1212 == 0.0))
        {
            _1237 = _1198.z;
        }
        else
        {
            _1237 = _1202.z;
        }
        float _1234 = _1237;
        float _1246 = min(_1225 ? 2.0 : 1000.0, abs(_1206));
        float _1253 = max(_1198.x - _1170.x, _1170.x - _1202.x);
        float _1265 = max(_1198.y - _1170.y, _1170.y - _1202.y);
        float _1277 = max(_1253, _1265) - _1246;
        _1277 = max(_1277, _1234 - _1170.z);
        _1277 = max(_1277, _1206 - _1228);
        if (_1277 <= 0.0)
        {
            float _1298 = _1225 ? _1212 : _1215;
            vec2 _1303 = _761._m18[2].xy;
            float _1307 = length(_1303);
            vec3 _1310 = vec3(_1303, (-1.73205077648162841796875) * _1307);
            _1310 /= vec3(2.0 * _1307);
            vec3 _1323 = _555._m12.xyz;
            vec3 _1327 = mix(_1310, _1323, bvec3(_1225));
            vec2 _1334 = _1170.xy - (_1327.xy * (_1206 / _1327.z));
            float _1345 = (_555._m55 / 100.0) * 16.0;
            vec2 _1352 = _1334 * _1345;
            float _1356 = textureLod(sampler2D(_1357, _1359), vec4(_1352, 0.0, 0.0).xy, vec4(_1352, 0.0, 0.0).w).x;
            float _1374 = min(8.0, _1202.z - _1198.z);
            float _1387 = (-_1206) / _1374;
            float _1382 = _10(_1387);
            float _1394 = dot(_761._m6, _1327);
            float _1389 = _10(_1394);
            float _1400 = _1253 / _1246;
            float _1396 = 1.0 - _10(_1400);
            float _1406 = _1265 / _1246;
            _1396 *= (1.0 - _10(_1406));
            _1396 *= _1396;
            float _1422 = min(_1206 / 1.0, 1.0 - (_1206 / _1228));
            float _1414 = _10(_1422);
            _1396 *= max(_1414, _1382);
            _1396 *= _1396;
            _1396 *= _1173;
            float _1435 = _1356 - 1.0;
            float _1438 = float(_1225) * _1218;
            float _1443 = max(0.0, _1356 - 0.85000002384185791015625);
            float _1448 = _1225 ? _1435 : _1443;
            float _1453 = (((1.0 - _1438) * _1389) * _1396) * _1298;
            vec3 _1462 = _761._m0 + (_761._m2 * (vec3(1.0) - _761._m0));
            _761._m21 += ((_1462 * (_1448 * _1453)) * _555._m11.xyz);
            float _1486 = _1438 * _1396;
            _761._m25 = 1.0 + (_1486 * (_1356 - 1.0));
        }
    }
    else
    {
        if (_1173 > 0.0)
        {
            _1173 *= _555._m56;
            float _1506 = float(_555._m12.w < 0.0);
            vec3 _1511 = _555._m12.xyz;
            float _1520 = dot(_761._m6, _1511);
            float _1515 = _10(_1520);
            vec2 _1522 = _1170.xy - (_1511.xy * (_1170.z / _1511.z));
            float _1534 = (_555._m55 / 100.0) * 16.0;
            vec2 _1539 = _1522 * _1534;
            float _1543 = textureLod(sampler2D(_1357, _1359), vec4(_1539, 0.0, 0.0).xy, vec4(_1539, 0.0, 0.0).w).x;
            vec4 _1559 = _555._m11;
            _761._m21 += (_1559.xyz * (((((1.0 - _1506) * (_1543 - 1.0)) * _1515) * _1173) * _1559.w));
            _761._m25 = 1.0 + ((_1506 * (_1543 - 1.0)) * _1173);
        }
    }
    _761._m14 = normalize(vec3(_555._m34, _555._m35, _555._m36) - _761._m15);
    vec3 _1601 = vec3(0.0);
    vec3 _1602 = vec3(0.0);
    vec3 _1603 = vec3(0.0);
    vec3 _1604 = vec3(0.0);
    vec3 _1605 = vec3(0.0);
    vec4 _1606 = _761._m29;
    vec4 _1609 = _761._m30;
    vec4 _1612 = _761._m31;
    _1602 = vec3(_1606.x, _1606.y, _1606.z);
    _1603 = vec3(_1606.w, _1609.x, _1609.y);
    _1604 = vec3(_1609.z, _1609.w, _1612.x);
    _1605 = vec3(_1612.y, _1612.z, _1612.w);
    vec3 _1643 = ((_1602 - (_1603 * _761._m6.y)) + (_1604 * _761._m6.z)) - (_1605 * _761._m6.x);
    float _1667 = _1095._m3 * _555._m57;
    _1601 += (max(vec3(0.0), _1643 * _10(_1667)) * _761._m0);
    _761._m21 += _1601;
    uint _1681 = _1685._m0[_1048 * 64u];
    uint _1692 = _1681 & 255u;
    uint _1696 = _1685._m0[_1082 * 64u];
    uint _1701 = _1696 & 255u;
    uint _1709;
    uint _1711;
    uint _1713;
    if (_1692 < _1701)
    {
        _1709 = _1692;
        _1711 = _1681;
        _1713 = _1048;
    }
    else
    {
        _1709 = _1701;
        _1711 = _1696;
        _1713 = _1082;
    }
    uint _1719 = 1u;
    _1748 _1750;
    vec3 _1887;
    float _2009;
    vec2 _2079;
    _2280 _2282;
    _2280 _2429;
    while (_1719 <= _1709)
    {
        uint _1728 = (_1713 * 64u) + _1719;
        uint _1733 = _1685._m0[_1728];
        uint _1737 = _1733;
        if (_1737 >= _1733)
        {
            _1719++;
        }
        int _1746 = 4;
        int _1747 = 4;
        _1750._m0 = _1755._m0[(uint(_1746) * _1737) + 0u].xyz;
        float _1770 = _1755._m0[(uint(_1746) * _1737) + 0u].w;
        _1750._m1 = _21(_1770);
        _1750._m2 = _1755._m0[(uint(_1746) * _1737) + 1u].xyz;
        _1750._m3 = _1755._m0[(uint(_1746) * _1737) + 1u].w;
        _1750._m4 = _1755._m0[(uint(_1746) * _1737) + 2u];
        float _1805 = _1755._m0[(uint(_1746) * _1737) + 3u].x;
        _1750._m8 = _21(_1805);
        float _1815 = _1755._m0[(uint(_1746) * _1737) + 3u].y;
        _1750._m9 = _21(_1815);
        _1750._m10 = _1755._m0[(uint(_1746) * _1737) + 3u].z;
        _1750._m5 = _1831._m0[(uint(_1747) * _1737) + 0u];
        _1750._m6 = _1831._m0[(uint(_1747) * _1737) + 1u];
        _1750._m7 = _1831._m0[(uint(_1747) * _1737) + 2u];
        _1750._m12 = _1831._m0[(uint(_1747) * _1737) + 3u].xyz;
        _1750._m13 = _1831._m0[(uint(_1747) * _1737) + 3u].w;
        float _1873 = 0.0;
        uint _1874 = _1750._m1;
        vec3 _1877 = _1750._m0;
        vec3 _1880 = _1877;
        if ((_1874 & 7u) == 2u)
        {
            _1887 = _1880;
        }
        else
        {
            _1887 = normalize(_1877 - _761._m15);
        }
        vec3 _1882 = _1887;
        uint _1898 = uint(((_1092 & 3u) != 0u) ? 16 : 0);
        _1898 |= 32u;
        if ((_1874 & _1898) != 0u)
        {
            continue;
        }
        vec3 _1913 = vec3(dot(_761._m15, _1750._m5.xyz) + _1750._m5.w, dot(_761._m15, _1750._m6.xyz) + _1750._m6.w, dot(_761._m15, _1750._m7.xyz) + _1750._m7.w);
        vec2 _1947 = _1913.xy / vec2(_1913.z);
        _1913 = vec3(_1947.x, _1947.y, _1913.z);
        _1913.z = dot(_761._m15, _1750._m4.xyz) + _1750._m4.w;
        float _1960 = _1913.x;
        float _1963 = _1913.y;
        float _1966 = _1913.z;
        bool _1971 = _32(_1960, _1963, _1966) <= _1873;
        bool _1988;
        if (!_1971)
        {
            float _1975 = _1913.x;
            float _1978 = _1913.y;
            float _1981 = _1913.z;
            _1988 = _27(_1975, _1978, _1981) >= (1.0 - _1873);
        }
        else
        {
            _1988 = _1971;
        }
        if (_1988)
        {
            continue;
        }
        vec3 _1992 = vec3(1.0);
        uint _1994 = _1874 & 7u;
        vec3 _1997 = _1750._m0 - _761._m15;
        float _2003 = dot(_1997, _1997);
        if (_1994 != 2u)
        {
            _2009 = 1.0 / (1.0 + _2003);
        }
        else
        {
            _2009 = _761._m25;
        }
        _1992 = vec3(_2009);
        if (_1994 == 0u)
        {
            float _2029 = _2003 * _1750._m3;
            float _2032 = 1.0 - _44(_2029);
            float _2034 = _10(_2032);
            float _2024 = _44(_2034);
            _1992 *= _2024;
        }
        else
        {
            if (_1994 == 4u)
            {
                float _2052 = length((_1913.xy - vec2(0.5)) * 2.0);
                float _2045 = _10(_2052);
                float _2054 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_2045 * 7.80000019073486328125))));
                _1992 *= _2054;
            }
            else
            {
                if ((_1994 == 1u) || (_1994 == 2u))
                {
                    if (_1994 == 2u)
                    {
                        _2079 = fract((_1913.xy * _555._m13.xy) + _555._m13.zw);
                    }
                    else
                    {
                        _2079 = _1913.xy;
                    }
                    vec2 _2076 = _2079;
                    vec3 _2097 = vec3(0.0);
                    uint _2098 = bitfieldExtract(_1750._m8, 0, 20);
                    uint _2102 = _2098;
                    uint _2106 = _2102 + 0u;
                    vec3 _2123 = textureLod(sampler2D(_903[nonuniformEXT(_2106)], _2109), vec4(_2076, 0.0, 0.0).xy, vec4(_2076, 0.0, 0.0).w).xyz;
                    _2097 = _41(_2123);
                    _1992 *= _2097;
                }
            }
        }
        float _2129 = float((_1874 >> uint(8)) & 255u) / 255.0;
        if ((_1994 == 0u) || (_1994 == 2u))
        {
            vec3 _2142 = abs((_1913 * 2.0) - vec3(1.0));
            float _2148 = _2142.x;
            float _2151 = _2142.y;
            float _2154 = _2142.z;
            float _2159 = 1.0 - _27(_2148, _2151, _2154);
            float _2165 = _10(_2159) / (9.9999999392252902907785028219223e-09 + _2129);
            float _2147 = _10(_2165);
            _1992 *= ((_2147 * _2147) * (3.0 - (2.0 * _2147)));
        }
        else
        {
            if ((_1994 == 1u) || (_1994 == 4u))
            {
                float _2186 = _1913.z;
                float _2190 = _44(_2186);
                float _2193 = 1.0 - _44(_2190);
                float _2195 = _10(_2193);
                float _2200 = _44(_2195) / (9.9999999392252902907785028219223e-09 + _2129);
                float _2185 = _10(_2200);
                _1992 *= _2185;
            }
        }
        float _2205 = _1992.x;
        float _2208 = _1992.y;
        float _2211 = _1992.z;
        if (_27(_2205, _2208, _2211) <= _1873)
        {
            continue;
        }
        float _2220 = 1.0;
        if ((_1874 & 8u) != 0u)
        {
            float _2227 = 0.00999999977648258209228515625;
            vec3 _2229 = _761._m15 + (_761._m6 * _2227);
            uint _2237 = 0u;
            if ((_1874 & 7u) == 0u)
            {
                vec3 _2243 = _2229 - _1750._m2;
                float _2248 = _2243.x;
                float _2251 = _2243.y;
                float _2254 = _2243.z;
                _2237 = _38(_2248, _2251, _2254);
            }
            else
            {
                if ((_1874 & 7u) == 2u)
                {
                    float _2264 = 0.0;
                    uint _2265 = uint((_555._m14.w > 0.0) ? 3 : 4);
                    for (; _2237 < _2265; _2237++)
                    {
                        int _2279 = 5;
                        _2282._m0 = _2287._m0[(uint(_2279) * ((_1874 >> uint(22)) + _2237)) + 0u];
                        _2282._m1 = _2287._m0[(uint(_2279) * ((_1874 >> uint(22)) + _2237)) + 1u];
                        _2282._m2 = _2287._m0[(uint(_2279) * ((_1874 >> uint(22)) + _2237)) + 2u];
                        _2282._m3 = _2287._m0[(uint(_2279) * ((_1874 >> uint(22)) + _2237)) + 3u];
                        _2282._m4 = _2287._m0[(uint(_2279) * ((_1874 >> uint(22)) + _2237)) + 4u];
                        vec2 _2343 = vec2(dot(_2229, _2282._m0.xyz) + _2282._m0.w, dot(_2229, _2282._m1.xyz) + _2282._m1.w);
                        _2343 = abs((_2343 * 2.0) - vec2(1.0));
                        bool _2369 = _2343.x < 0.9900000095367431640625;
                        bool _2375;
                        if (_2369)
                        {
                            _2375 = _2343.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _2375 = _2369;
                        }
                        if (_2375)
                        {
                            _2264 = (1.0 - max(_2343.x, _2343.y)) * _555._m15.w;
                            break;
                        }
                    }
                    _761._m36 = int(_2237);
                    _2237 = min((_2265 - 1u), _2237);
                    if (_555._m14.w > 0.0)
                    {
                        uint _2402 = uint(_761._m17.x) ^ (uint(_761._m17.y) << uint(1));
                        _2402 ^= uint(_555._m16.x);
                        _2237 += uint(int(((float(_2402 & 3u) * 0.25) + 0.125) > _2264));
                    }
                }
            }
            int _2428 = 5;
            _2429._m0 = _2287._m0[(uint(_2428) * ((_1874 >> uint(22)) + _2237)) + 0u];
            _2429._m1 = _2287._m0[(uint(_2428) * ((_1874 >> uint(22)) + _2237)) + 1u];
            _2429._m2 = _2287._m0[(uint(_2428) * ((_1874 >> uint(22)) + _2237)) + 2u];
            _2429._m3 = _2287._m0[(uint(_2428) * ((_1874 >> uint(22)) + _2237)) + 3u];
            _2429._m4 = _2287._m0[(uint(_2428) * ((_1874 >> uint(22)) + _2237)) + 4u];
            vec4 _2485 = vec4((_2229.x * _2429._m0.x) + ((_2229.y * _2429._m0.y) + ((_2229.z * _2429._m0.z) + _2429._m0.w)), (_2229.x * _2429._m1.x) + ((_2229.y * _2429._m1.y) + ((_2229.z * _2429._m1.z) + _2429._m1.w)), (_2229.x * _2429._m2.x) + ((_2229.y * _2429._m2.y) + ((_2229.z * _2429._m2.z) + _2429._m2.w)), (_2229.x * _2429._m3.x) + ((_2229.y * _2429._m3.y) + ((_2229.z * _2429._m3.z) + _2429._m3.w)));
            vec3 _2572 = _2485.xyz / vec3(_2485.w);
            _2485 = vec4(_2572.x, _2572.y, _2572.z, _2485.w);
            bool _2580 = min(_2485.x, _2485.y) > 0.0;
            bool _2589;
            if (_2580)
            {
                _2589 = max(_2485.x, _2485.y) < 1.0;
            }
            else
            {
                _2589 = _2580;
            }
            if (_2589)
            {
                vec2 _2601 = (_2485.xy * _2429._m4.xy) + _2429._m4.zw;
                _2485 = vec4(_2601.x, _2601.y, _2485.z, _2485.w);
                if (false)
                {
                    _2220 = textureLod(sampler2DShadow(_2608, _2610), vec3(_2485.xyz.xy, _2485.xyz.z), 0.0);
                }
                else
                {
                    vec2 _2619 = (_2485.xy * _555._m17.xy) + vec2(0.5);
                    vec2 _2628 = floor(_2619);
                    vec2 _2631 = _2619 - _2628;
                    _2628 -= vec2(0.5);
                    vec2 _2638 = vec2(4.0) - (_2631 * 3.0);
                    vec2 _2644 = vec2(7.0);
                    vec2 _2647 = vec2(1.0) + (_2631 * 3.0);
                    vec2 _2652 = (_2628 + (((vec2(3.0) - (_2631 * 2.0)) / _2638) - vec2(2.0))) * _555._m17.zw;
                    vec2 _2667 = (_2628 + ((vec2(3.0) + _2631) / _2644)) * _555._m17.zw;
                    vec2 _2679 = (_2628 + ((_2631 / _2647) + vec2(2.0))) * _555._m17.zw;
                    vec3 _2705 = vec3(_2652.x, _2652.y, _2485.z);
                    _2220 = (_2638.x * _2638.y) * textureLod(sampler2DShadow(_2608, _2610), vec3(_2705.xy, _2705.z), 0.0);
                    vec3 _2723 = vec3(_2667.x, _2652.y, _2485.z);
                    _2220 += ((_2644.x * _2638.y) * textureLod(sampler2DShadow(_2608, _2610), vec3(_2723.xy, _2723.z), 0.0));
                    vec3 _2743 = vec3(_2679.x, _2652.y, _2485.z);
                    _2220 += ((_2647.x * _2638.y) * textureLod(sampler2DShadow(_2608, _2610), vec3(_2743.xy, _2743.z), 0.0));
                    vec3 _2763 = vec3(_2652.x, _2667.y, _2485.z);
                    _2220 += ((_2638.x * _2644.y) * textureLod(sampler2DShadow(_2608, _2610), vec3(_2763.xy, _2763.z), 0.0));
                    vec3 _2783 = vec3(_2667.x, _2667.y, _2485.z);
                    _2220 += ((_2644.x * _2644.y) * textureLod(sampler2DShadow(_2608, _2610), vec3(_2783.xy, _2783.z), 0.0));
                    vec3 _2803 = vec3(_2679.x, _2667.y, _2485.z);
                    _2220 += ((_2647.x * _2644.y) * textureLod(sampler2DShadow(_2608, _2610), vec3(_2803.xy, _2803.z), 0.0));
                    vec3 _2823 = vec3(_2652.x, _2679.y, _2485.z);
                    _2220 += ((_2638.x * _2647.y) * textureLod(sampler2DShadow(_2608, _2610), vec3(_2823.xy, _2823.z), 0.0));
                    vec3 _2843 = vec3(_2667.x, _2679.y, _2485.z);
                    _2220 += ((_2644.x * _2647.y) * textureLod(sampler2DShadow(_2608, _2610), vec3(_2843.xy, _2843.z), 0.0));
                    vec3 _2863 = vec3(_2679.x, _2679.y, _2485.z);
                    _2220 += ((_2647.x * _2647.y) * textureLod(sampler2DShadow(_2608, _2610), vec3(_2863.xy, _2863.z), 0.0));
                    _2220 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _2220 = float((_1874 & 7u) == 2u);
                if ((_1874 & 7u) == 2u)
                {
                    _761._m36 = -1;
                }
            }
            float _2883 = float((_1874 >> uint(16)) & 63u) / 63.0;
            float _2897 = ((_2220 * _2883) + 1.0) - _2883;
            _2220 = _10(_2897);
            if ((_555._m58 > 0.0) && (_2220 > 0.0))
            {
                vec4 _2908 = vec4(_761._m17.xy * _555._m8.xy, _761._m17.z, 1.0);
                float _2921 = _2908.z;
                bool _2924 = false;
                float _2925 = _100(_2921, _2924);
                _2908.z = _2925;
                vec3 _2963 = _761._m15 + (_1882 * 0.0500000007450580596923828125);
                mat4 _2964 = mat4(vec4(_555._m18), vec4(_555._m19), vec4(_555._m20), vec4(_555._m21));
                vec4 _2927 = _52(_2963, _2964);
                vec3 _2971 = _2927.xyz / vec3(_2927.w);
                _2927 = vec4(_2971.x, _2971.y, _2971.z, _2927.w);
                float _2974 = _2927.z;
                bool _2977 = false;
                float _2978 = _100(_2974, _2977);
                _2927.z = _2978;
                int _2980 = 4;
                vec3 _2981 = vec3(_2927.xyz - _2908.xyz) / vec3(float(_2980));
                float _2995 = 0.100000001490116119384765625;
                float _2997 = 0.001000000047497451305389404296875 * _2908.z;
                uvec2 _3010 = uvec2(_761._m17.xy);
                uint _3011 = uint(_555._m22.w);
                float _3002 = _128(_3010, _3011) - 0.5;
                vec3 _3014 = _2908.xyz + (_2981 * _3002);
                for (int _3021 = 0; _3021 < _2980; _3021++)
                {
                    _3014 += _2981;
                    float _3033 = 1.0 - textureLod(sampler2D(_3034, _3036), vec4(_3014.xy, 0.0, 0.0).xy, vec4(_3014.xy, 0.0, 0.0).w).x;
                    float _3055 = _3033;
                    bool _3057 = false;
                    float _3058 = _100(_3055, _3057);
                    float _3054 = _3058 + _2997;
                    bool _3065 = (_3014.z - _3054) > 0.001000000047497451305389404296875;
                    bool _3074;
                    if (_3065)
                    {
                        _3074 = (_3014.z - _3054) <= _2995;
                    }
                    else
                    {
                        _3074 = _3065;
                    }
                    if (_3074)
                    {
                        //_2220 = 0.0;
                        break;
                    }
                }
            }
        }
        if (_2220 <= _1873)
        {
            continue;
        }
        vec3 _3086 = (_1750._m12 * _2220) * _1992;
        float _3093 = _1750._m13;
        vec3 _3096 = _3086;
        vec3 _3098 = _761._m18[0];
        vec3 _3101 = _761._m18[1];
        vec3 _3104 = _761._m14;
        vec3 _3107 = _761._m6;
        vec3 _3110 = _1882;
        float _3112 = dot(_3107, _3110);
        float _3124 = 1.0 + _893._m15;
        float _3127 = (_3112 + _893._m15) / _44(_3124);
        float _3116 = _10(_3127);
        vec3 _3129 = normalize(_3104 + _3110);
        float _3134 = dot(_3107, _3129);
        vec3 _3138 = vec3(0.0);
        float _3139 = 1.0 - _893._m16;
        float _3143 = _3139 * _3139;
        float _3147 = 1.0;
        float _3148 = _3147 * _3147;
        float _3152 = dot(normalize(_3098 + ((_3107 * _893._m17) * _760)), _3129);
        float _3164 = dot(normalize(_3101 + ((_3107 * _893._m17) * _760)), _3129);
        float _3176 = (((_3152 * _3152) / _3148) + ((_3164 * _3164) / _3143)) + (_3134 * _3134);
        _3138 = vec3(1.0 / (_3176 * _3176)) / vec3(_3148 * _3143);
        float _3206 = dot(_3107, _3104);
        float _3202 = (_10(_3206) * (1.0 - _3139)) + _3139;
        float _3217 = dot(_3107, _3110);
        float _3213 = (_10(_3217) * (1.0 - _3139)) + _3139;
        _3138 /= vec3(((4.0 * _3202) * _3213) + 9.9999999392252902907785028219223e-09);
        vec3 _3232 = vec3(0.0);
        float _3233 = 1.0 - _893._m18;
        float _3237 = _3233 * _3233;
        float _3241 = 1.0;
        float _3242 = _3241 * _3241;
        float _3246 = dot(normalize(_3098 + ((_3107 * _893._m19) * _760)), _3129);
        float _3258 = dot(normalize(_3101 + ((_3107 * _893._m19) * _760)), _3129);
        float _3270 = (((_3246 * _3246) / _3242) + ((_3258 * _3258) / _3237)) + (_3134 * _3134);
        _3232 = vec3(1.0 / (_3270 * _3270)) / vec3((_3242 * _3237) + 9.9999999392252902907785028219223e-09);
        float _3301 = dot(_3107, _3104);
        float _3297 = (_10(_3301) * (1.0 - _3233)) + _3233;
        float _3312 = dot(_3107, _3110);
        float _3308 = (_10(_3312) * (1.0 - _3233)) + _3233;
        _3232 /= vec3(((4.0 * _3297) * _3308) + 9.9999999392252902907785028219223e-09);
        vec3 _3334 = _761._m2;
        float _3337 = dot(_3110, _3129);
        vec3 _3327 = (_3138 + _3232) * _78(_3334, _3337);
        float _3346 = _3112;
        vec3 _3340 = ((_3327 * _3093) * _3096) * _10(_3346);
        float _3356 = _3112;
        vec3 _3350 = ((_3327 * _3093) * _3096) * _10(_3356);
        _761._m21 += ((((_3096 * _3116) + _3350) * _761._m0) + _3340);
    }
    _761._m21 *= _761._m11;
    _3381 = vec4(_761._m21, 0.0);
    if (((_555._m59 & 1u) != 0u) == true)
    {
        vec3 _3397 = _761._m6;
        bool _3400 = false;
        vec2 _3401 = _136(_3397, _3400);
        _3396 = vec4(_3401, 0.0, 0.0);
        float _3411 = dot(_761._m14, _761._m6);
        float _3405 = _10(_3411);
        float _3414 = _3405;
        float _3416 = _761._m3;
        vec3 _3419 = _761._m2;
        vec3 _3413 = _84(_3414, _3416, _3419);
        float _3424 = _3413.x;
        float _3428 = _3413.y;
        float _3432 = _3413.z;
        float _3436 = _761._m3;
        _3423 = vec4(_70(_3424), _70(_3428), _70(_3432), _139(_3436));
    }
}

