// SHADOW FIX 2
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

struct _103
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _2034
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _2565
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _665_667
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    float _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    uint _m58;
    float _m59[3];
} _667;

layout(set = 2, binding = 0, std140) uniform _1068_1070
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    float _m22;
    uint _m23;
    uint _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    uint _m29;
    float _m30;
    uint _m31;
    uint _m32;
    float _m33;
    uint _m34;
    uint _m35;
    uint _m36;
    uint _m37;
    uint _m38;
    float _m39;
    uint _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    uint _m61;
    uint _m62;
    uint _m63;
    int _m64;
    uint _m65;
    float _m66[3];
} _1070;

layout(set = 1, binding = 0, std140) uniform _1259_1261
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    uint _m42;
    uint _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    int _m63;
    float _m64;
    float _m65;
    float _m66;
    float _m67;
    uint _m68;
} _1261;

layout(set = 0, binding = 15, std430) restrict readonly buffer _1969_1971
{
    uint _m0[];
} _1971;

layout(set = 0, binding = 16, std140) uniform _2039_2041
{
    vec4 _m0[4096];
} _2041;

layout(set = 0, binding = 17, std140) uniform _2115_2117
{
    vec4 _m0[4096];
} _2117;

layout(set = 0, binding = 19, std140) uniform _2570_2572
{
    vec4 _m0[4095];
} _2572;

layout(set = 0, binding = 1, std140) uniform _3611_3613
{
    vec4 _m0[64];
} _3613;

layout(push_constant, std430) uniform _3607_3609
{
    int _m0;
    int _m1;
} _3609;

layout(set = 3, binding = 0) uniform texture2D _1066[34816];
layout(set = 0, binding = 11) uniform sampler _1079;
layout(set = 0, binding = 12) uniform sampler _1201;
layout(set = 0, binding = 13) uniform texture2D _1644;
layout(set = 0, binding = 14) uniform sampler _1646;
layout(set = 0, binding = 18) uniform sampler _2395;
layout(set = 0, binding = 20) uniform texture2D _2893;
layout(set = 0, binding = 21) uniform samplerShadow _2895;
layout(set = 0, binding = 22) uniform texture2D _3318;
layout(set = 0, binding = 23) uniform sampler _3320;
layout(set = 0, binding = 24) uniform texture2D _3552;
layout(set = 0, binding = 25) uniform texture2D _3570;
layout(set = 0, binding = 7) uniform texture3D _3616;
layout(set = 0, binding = 8) uniform sampler _3617;
layout(set = 0, binding = 9) uniform texture3D _3618;
layout(set = 0, binding = 10) uniform sampler _3619;

layout(location = 17, component = 3) in float _878;
layout(location = 18, component = 0) in float _880;
layout(location = 18, component = 1) in float _885;
layout(location = 18, component = 2) in float _887;
layout(location = 18, component = 3) in float _889;
layout(location = 19, component = 0) in float _917;
layout(location = 19, component = 1) in float _919;
layout(location = 19, component = 2) in float _921;
layout(location = 19, component = 3) in float _925;
layout(location = 20, component = 0) in float _927;
layout(location = 20, component = 1) in float _929;
layout(location = 20, component = 2) in float _941;
layout(location = 10, component = 0) in vec4 _966;
layout(location = 11, component = 0) in vec4 _969;
layout(location = 12, component = 0) in vec4 _972;
layout(location = 0, component = 0) out vec4 _3464;
layout(location = 1, component = 0) out vec4 _3479;
layout(location = 2, component = 0) out vec4 _3506;
uint _154;
uint _156;
uint _158;
uint _160;
uint _162;
uint _164;
uint _166;
uint _167;
uint _169;
uint _170;
uint _172;
uint _174;
uint _176;
uint _178;
uint _180;
uint _182;
uint _184;
uint _186;
uint _188;

_103 _105()
{
    _103 _557;
    _557._m0 = vec3(0.0);
    _557._m2 = vec3(0.0);
    _557._m3 = 0.0;
    _557._m4 = 0u;
    _557._m5 = 0.0;
    _557._m6 = vec3(0.0);
    _557._m7 = vec3(0.0, 0.0, 1.0);
    _557._m8 = vec3(0.0, 0.0, 1.0);
    _557._m1 = vec3(0.0);
    _557._m9 = 1.0;
    _557._m10 = 1.0;
    _557._m14 = vec3(0.0);
    _557._m15 = vec3(0.0);
    _557._m16 = vec4(0.0);
    _557._m17 = vec4(0.0);
    _557._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _557._m19 = vec3(0.0);
    _557._m20 = vec3(0.0);
    _557._m21 = vec3(0.0);
    _557._m22 = vec3(0.0);
    _557._m23 = vec3(0.0);
    _557._m24 = vec3(0.0);
    _557._m25 = 1.0;
    _557._m26 = uvec4(0u);
    _557._m27 = uvec4(0u);
    _557._m28 = uvec4(0u);
    _557._m29 = vec4(0.0);
    _557._m30 = vec4(0.0);
    _557._m31 = vec4(0.0);
    _557._m32 = vec4(0.0);
    _557._m33 = uvec2(0u);
    _557._m34 = vec2(0.0);
    _557._m35 = 0.0;
    _557._m36 = -1;
    _557._m37 = 0;
    _557._m38 = vec2(0.0);
    _557._m39 = 1.0;
    _557._m41 = -1;
    _557._m45 = 1.0;
    _557._m11 = 1.0;
    _557._m12 = 0u;
    _557._m13 = uvec3(0u);
    _557._m40 = vec3(0.0);
    _557._m46 = 0.0;
    _557._m47 = 1.0;
    return _557;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _77(vec3 _76)
{
    return dot(_76, vec3(0.2125999927520751953125, 0.715200006961822509765625, 0.072200000286102294921875));
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec2 _117(vec2 _116)
{
    return ((_116 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _122(inout vec2 _120, bool _121)
{
    vec2 _699 = _120;
    _120 = _117(_699);
    float _719 = (1.0 - (_120.x * _120.x)) - (_120.y * _120.y);
    vec3 _702 = vec3(_120.x, _120.y, sqrt(_10(_719)));
    if (_121 == false)
    {
        _702.z = -_702.z;
    }
    return _702;
}

vec3 _59(mat3 _57, vec3 _58)
{
    return _57 * _58;
}

vec3 _127(vec3 _125, mat3 _126)
{
    mat3 _735 = _126;
    vec3 _737 = _125;
    return normalize(_59(_735, _737));
}

vec3 _133(vec2 _130, mat3 _131, bool _132)
{
    vec2 _744 = _130;
    bool _746 = _132;
    vec3 _748 = _122(_744, _746);
    vec3 _743 = _748;
    vec3 _749 = _743;
    mat3 _751 = _131;
    return _127(_749, _751);
}

float _112(inout float _110, bool _111)
{
    if (_111)
    {
        _110 += (float(_110 < _667._m22) * _667._m23);
    }
    float _680 = _110;
    return _667._m0.w / (_10(_680) + _667._m0.z);
}

uint _21(float _20)
{
    return floatBitsToUint(_20);
}

float _32(float _29, float _30, float _31)
{
    return min(_29, min(_30, _31));
}

float _27(float _24, float _25, float _26)
{
    return max(_24, max(_25, _26));
}

float _44(float _43)
{
    return _43 * _43;
}

vec3 _41(vec3 _40)
{
    return _40 * _40;
}

uint _38(float _35, float _36, float _37)
{
    bool _224 = abs(_37) >= abs(_35);
    bool _232;
    if (_224)
    {
        _232 = abs(_37) >= abs(_36);
    }
    else
    {
        _232 = _224;
    }
    if (_232)
    {
        return uint((_37 < 0.0) ? 5 : 4);
    }
    if (abs(_36) >= abs(_35))
    {
        return uint((_36 < 0.0) ? 3 : 2);
    }
    return uint(int(_35 < 0.0));
}

vec4 _52(vec3 _50, mat4 _51)
{
    return vec4((_50.x * _51[0].x) + ((_50.y * _51[0].y) + ((_50.z * _51[0].z) + _51[0].w)), (_50.x * _51[1].x) + ((_50.y * _51[1].y) + ((_50.z * _51[1].z) + _51[1].w)), (_50.x * _51[2].x) + ((_50.y * _51[2].y) + ((_50.z * _51[2].z) + _51[2].w)), (_50.x * _51[3].x) + ((_50.y * _51[3].y) + ((_50.z * _51[3].z) + _51[3].w)));
}

float _140(uvec2 _138, uint _139)
{
    uvec2 _756 = _138 & uvec2(3u);
    return float(((((2068378560u * (1u - (_756.x >> uint(1)))) + (1500172770u * (_756.x >> uint(1)))) >> ((_756.y + ((_756.x & 1u) << uint(2))) << uint(2))) + _139) & 15u) / 16.0;
}

float _67(float _65, float _66)
{
    return pow(_65, _66);
}

vec3 _82(vec3 _80, float _81)
{
    float _395 = dot(_80, vec3(16.666500091552734375));
    float _390 = _10(_395);
    float _404 = 1.0 - _81;
    float _407 = _10(_404);
    float _408 = 5.0;
    vec3 _412 = _80 + ((vec3(_390) - _80) * _67(_407, _408));
    return _16(_412);
}

vec3 _90(vec3 _85, vec3 _86, vec3 _87, vec3 _88, float _89)
{
    float _420 = dot(_85, _86);
    float _416 = _10(_420);
    vec3 _422 = normalize(_86 + _87);
    float _431 = dot(_85, _422);
    float _427 = _10(_431);
    float _437 = dot(_87, _422);
    float _433 = _10(_437);
    vec3 _440 = _88;
    float _442 = _433;
    vec3 _439 = _82(_440, _442);
    float _449 = dot(_85, _87);
    float _445 = _10(_449);
    float _451 = 1.0 - (_89 * 0.800000011920928955078125);
    _451 *= _451;
    _451 *= _451;
    float _462 = _451 * _451;
    float _466 = ((_427 * _427) * (_462 - 1.0)) + 1.0;
    _466 = _462 / ((_466 * _466) + 9.9999999392252902907785028219223e-09);
    float _481 = (_416 * (1.0 - _451)) + _451;
    float _488 = (_445 * (1.0 - _451)) + _451;
    _466 /= (((4.0 * _481) * _488) + 9.9999999392252902907785028219223e-09);
    return _439 * _466;
}

vec2 _143(vec2 _142)
{
    return (vec2(1.0) - abs(_142.yx)) * vec2((_142.x >= 0.0) ? 1.0 : (-1.0), (_142.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _148(inout vec3 _146, bool _147)
{
    _146 /= vec3((abs(_146.x) + abs(_146.y)) + abs(_146.z));
    vec2 _825;
    if (_146.z >= 0.0)
    {
        _825 = _146.xy;
    }
    else
    {
        vec2 _831 = _146.xy;
        _825 = _143(_831);
    }
    _146 = vec3(_825.x, _825.y, _146.z);
    if (_147)
    {
        vec2 _846 = (_146.xy * 0.5) + vec2(0.5);
        _146 = vec3(_846.x, _846.y, _146.z);
    }
    return _146.xy;
}

float _62(float _61)
{
    return exp2(_61);
}

vec3 _96(float _93, float _94, vec3 _95)
{
    float _508 = 0.0949999988079071044921875 + (_94 * (0.60000002384185791015625 + (4.190000057220458984375 * _94)));
    float _518 = _93 + 0.02500000037252902984619140625;
    float _522 = (9.5 * _94) * _93;
    float _536 = 1.0 - (14.0 * _93);
    float _528 = (_508 * _518) * _62(_536);
    float _543 = -_522;
    float _539 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _62(_543)));
    return mix(vec3(_528), vec3(_539), _95);
}

float _70(float _69)
{
    return sqrt(_69);
}

float _73(float _72)
{
    return sqrt(_72);
}

float _151(float _150)
{
    float _856 = abs(_150);
    float _853 = _73(_856);
    float _860;
    if (_150 > 0.0)
    {
        _860 = _853;
    }
    else
    {
        _860 = -_853;
    }
    return (_860 * 0.5) + 0.5;
}

void main()
{
    _154 = 2147483648u;
    _156 = 1073741824u;
    _158 = 0u;
    _160 = 268435456u;
    _162 = 536870912u;
    _164 = 805306368u;
    _166 = 1073741824u;
    _167 = 1342177280u;
    _169 = 0u;
    _170 = 16777216u;
    _172 = 33554432u;
    _174 = 50331648u;
    _176 = 67108864u;
    _178 = 83886080u;
    _180 = 100663296u;
    _182 = 117440512u;
    _184 = 134217728u;
    _186 = 150994944u;
    _188 = 167772160u;
    float _872 = 0.0;
    _103 _873 = _105();
    _103 _875 = _105();
    _875._m16 = vec4(0.0, 0.0, _878, _880);
    vec3 _884 = vec3(_885, _887, _889);
    _875._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _875._m15 = vec3(_667._m33, _667._m34, _667._m35) + _884;
    vec3 _915 = vec3(0.0);
    vec3 _916 = vec3(0.0);
    _915 = normalize(vec3(_917, _919, _921));
    _916 = normalize(vec3(_925, _927, _929));
    vec3 _933 = _915;
    vec3 _935 = _916;
    vec3 _937 = normalize(cross(_933, _935) * _941);
    _875._m18 = mat3(vec3(_935), vec3(_937), vec3(_933));
    _875._m14 = normalize(-_884);
    _875._m29 = _966;
    _875._m30 = _969;
    _875._m31 = _972;
    uint _975 = 0u;
    vec4 _976 = vec4(0.0);
    vec4 _977 = vec4(0.0);
    vec4 _978 = vec4(0.0);
    vec4 _979 = vec4(0.0);
    vec4 _980 = vec4(0.0);
    float _981 = 0.0;
    uvec2 _982 = uvec2(0u, 65535u);
    _875._m0 = _976.xyz;
    _875._m2 = _977.xyz;
    _875._m1 = _980.xyz;
    _875._m3 = _979.w;
    _875._m6 = _978.xyz;
    vec2 _1000 = _875._m16.zw;
    _875._m10 = 0.0;
    float _1005 = 0.800000011920928955078125;
    vec3 _1006 = normalize(refract(normalize(_875._m18[2]), -_875._m14, _1005));
    vec3 _1016 = normalize(vec3(dot(_1006, _875._m18[0]), dot(_1006, _875._m18[1]), dot(_1006, _875._m18[2])));
    int _1031 = 4;
    vec3 _1032 = vec3(-vec2(_1016.x, -_1016.y), 1.0) / vec3(float(_1031));
    vec3 _1047 = vec3(_1000, 0.0);
    vec2 _1052 = _1047.xy;
    vec2 _1055 = dFdx(_1000);
    vec2 _1058 = dFdy(_1000);
    float _1061 = texture(sampler2D(_1066[_1070._m29], _1079), _1047.xy).w * _1070._m33;
    float _1090 = _1061;
    int _1092 = 0;
    for (;;)
    {
        bool _1100 = _1092 < _1031;
        bool _1107;
        if (_1100)
        {
            _1107 = _1047.z < _1061;
        }
        else
        {
            _1107 = _1100;
        }
        if (_1107)
        {
            _1052 = _1047.xy;
            _1090 = _1061;
            _1047 += _1032;
            _1061 = textureGrad(sampler2D(_1066[_1070._m29], _1079), _1047.xy, _1055, _1058).w * _1070._m33;
            _1092++;
            continue;
        }
        else
        {
            break;
        }
    }
    float _1131 = _1061 - _1047.z;
    float _1136 = (_1090 - _1047.z) + _1032.z;
    float _1150 = _1131 / (_1131 - _1136);
    float _1144 = _10(_1150);
    vec2 _1152 = (_1052 * _1144) + (_1047.xy * (1.0 - _1144));
    vec4 _1162 = texture(sampler2D(_1066[_1070._m29], _1079), _1152);
    vec3 _1171 = texture(sampler2D(_1066[_1070._m36], _1079), _1152).xyz;
    vec3 _1181 = vec3(vec2(1.0) - texture(sampler2D(_1066[_1070._m34], _1079), _1000).xy, 0.0);
    float _1196 = texture(sampler2D(_1066[_1070._m35], _1201), _1000).x;
    vec3 _1207 = texture(sampler2D(_1066[_1070._m34], _1079), _1152).xyz;
    float _1217 = texture(sampler2D(_1066[_1070._m32], _1079), _1152).x;
    vec3 _1227 = texture(sampler2D(_1066[_1070._m31], _1079), _1152).xyz;
    vec3 _1239 = _1162.xyz;
    vec3 _1255 = (_1162.www * _1070._m2.w) * 8.0;
    _875._m0 = mix(mix(_1162.xyz, _1070._m2.xyz * _77(_1239), _16(_1255)), vec3(0.60000002384185791015625), vec3(_1261._m45));
    vec3 _1276 = (_1162.www * _1070._m2.w) * 8.0;
    _875._m2 = mix(_1171, vec3(0.039999999105930328369140625), _16(_1276));
    _875._m6 = _1181;
    _875._m3 = _1196;
    _873._m2 = _1171;
    _873._m3 = _1217;
    _873._m6 = _1207;
    vec2 _1291 = _873._m6.xy;
    mat3 _1295 = _875._m18;
    bool _1298 = true;
    _873._m6 = _133(_1291, _1295, _1298);
    vec3 _1301 = (_1227 * vec3(_1070._m47, _1070._m48, _1070._m49)) * vec3(_1261._m46, _1261._m47, _1261._m48);
    float _1325;
    if (_1261._m49 > 0.0)
    {
        _1325 = _1261._m49;
    }
    else
    {
        _1325 = _1070._m50;
    }
    float _1321 = _1325;
    _875._m22 = _1301 * _1321;
    uint _1339 = 0u;
    bool _1340 = true;
    vec2 _1341 = _875._m6.xy;
    bool _1345 = _1340;
    vec3 _1347 = _122(_1341, _1345);
    _875._m7 = _1347;
    vec2 _1349 = _875._m6.xy;
    mat3 _1353 = _875._m18;
    bool _1356 = _1340;
    _875._m6 = _133(_1349, _1353, _1356);
    uvec2 _1360 = uvec2(_875._m17.xy);
    uint _1365 = _1360.x / 256u;
    uint _1370 = _1360.y / 256u;
    float _1375 = _875._m17.z;
    bool _1378 = false;
    float _1379 = _112(_1375, _1378);
    float _1374 = _1379;
    float _1380 = log2(max(1.0, _1374 / _667._m6.z)) * _667._m6.w;
    uint _1390 = min(23u, uint(_1380));
    float _1397 = _667._m51;
    float _1403 = _667._m52;
    uint _1395 = (_21(_1397) + ((_1365 + (_21(_1403) * _1370)) * 24u)) + _1390;
    uvec2 _1415 = uvec2(_875._m17.xy);
    uint _1420 = _1415.x / 32u;
    uint _1425 = _1415.y / 32u;
    float _1433 = _667._m53;
    uint _1429 = _1420 + (_1425 * _21(_1433));
    float _1440 = _1261._m53;
    uint _1439 = _21(_1440);
    _875._m21 = _875._m22;
    _875._m25 = 1.0;
    float _1448 = _667._m7.w;
    bool _1451 = _1448 < 0.0;
    _1448 = abs(_1448);
    vec3 _1456 = _875._m15;
    float _1475 = (1.0 - (length(_1456 - vec3(_667._m33, _667._m34, _667._m35)) / _1448)) / 0.25;
    float _1459 = _10(_1475);
    if ((!_1451) && (_1459 > 0.0))
    {
        vec3 _1484 = _667._m7.xyz;
        vec3 _1488 = _667._m8.xyz;
        float _1492 = _1456.z - _1488.z;
        float _1498 = _667._m9.w;
        float _1501 = _667._m10.w;
        float _1504 = float(_1501 < 0.0);
        _1501 = abs(_1501) - 1.0;
        bool _1511 = _1492 <= 0.0;
        float _1514 = 3.5 * float(!(_1501 == 0.0));
        float _1523;
        if (!(_1498 == 0.0))
        {
            _1523 = _1484.z;
        }
        else
        {
            _1523 = _1488.z;
        }
        float _1520 = _1523;
        float _1532 = min(_1511 ? 2.0 : 1000.0, abs(_1492));
        float _1540 = max(_1484.x - _1456.x, _1456.x - _1488.x);
        float _1552 = max(_1484.y - _1456.y, _1456.y - _1488.y);
        float _1564 = max(_1540, _1552) - _1532;
        _1564 = max(_1564, _1520 - _1456.z);
        _1564 = max(_1564, _1492 - _1514);
        if (_1564 <= 0.0)
        {
            float _1585 = _1511 ? _1498 : _1501;
            vec2 _1590 = _875._m18[2].xy;
            float _1594 = length(_1590);
            vec3 _1597 = vec3(_1590, (-1.73205077648162841796875) * _1594);
            _1597 /= vec3(2.0 * _1594);
            vec3 _1610 = _667._m10.xyz;
            vec3 _1614 = mix(_1597, _1610, bvec3(_1511));
            vec2 _1621 = _1456.xy - (_1614.xy * (_1492 / _1614.z));
            float _1632 = (_667._m54 / 100.0) * 16.0;
            vec2 _1639 = _1621 * _1632;
            float _1643 = textureLod(sampler2D(_1644, _1646), vec4(_1639, 0.0, 0.0).xy, vec4(_1639, 0.0, 0.0).w).x;
            float _1661 = min(8.0, _1488.z - _1484.z);
            float _1673 = (-_1492) / _1661;
            float _1668 = _10(_1673);
            float _1680 = dot(_875._m6, _1614);
            float _1675 = _10(_1680);
            float _1686 = _1540 / _1532;
            float _1682 = 1.0 - _10(_1686);
            float _1692 = _1552 / _1532;
            _1682 *= (1.0 - _10(_1692));
            _1682 *= _1682;
            float _1708 = min(_1492 / 1.0, 1.0 - (_1492 / _1514));
            float _1700 = _10(_1708);
            _1682 *= max(_1700, _1668);
            _1682 *= _1682;
            _1682 *= _1459;
            float _1721 = _1643 - 1.0;
            float _1724 = float(_1511) * _1504;
            float _1729 = max(0.0, _1643 - 0.85000002384185791015625);
            float _1734 = _1511 ? _1721 : _1729;
            float _1739 = (((1.0 - _1724) * _1675) * _1682) * _1585;
            vec3 _1748 = _875._m0 + (_875._m2 * (vec3(1.0) - _875._m0));
            _875._m21 += ((_1748 * (_1734 * _1739)) * _667._m9.xyz);
            float _1772 = _1724 * _1682;
            _875._m25 = 1.0 + (_1772 * (_1643 - 1.0));
        }
    }
    else
    {
        if (_1459 > 0.0)
        {
            _1459 *= _667._m55;
            float _1792 = float(_667._m10.w < 0.0);
            vec3 _1797 = _667._m10.xyz;
            float _1806 = dot(_875._m6, _1797);
            float _1801 = _10(_1806);
            vec2 _1808 = _1456.xy - (_1797.xy * (_1456.z / _1797.z));
            float _1820 = (_667._m54 / 100.0) * 16.0;
            vec2 _1825 = _1808 * _1820;
            float _1829 = textureLod(sampler2D(_1644, _1646), vec4(_1825, 0.0, 0.0).xy, vec4(_1825, 0.0, 0.0).w).x;
            vec4 _1845 = _667._m9;
            _875._m21 += (_1845.xyz * (((((1.0 - _1792) * (_1829 - 1.0)) * _1801) * _1459) * _1845.w));
            _875._m25 = 1.0 + ((_1792 * (_1829 - 1.0)) * _1459);
        }
    }
    _875._m14 = normalize(vec3(_667._m33, _667._m34, _667._m35) - _875._m15);
    vec3 _1887 = vec3(0.0);
    vec3 _1888 = vec3(0.0);
    vec3 _1889 = vec3(0.0);
    vec3 _1890 = vec3(0.0);
    vec3 _1891 = vec3(0.0);
    vec4 _1892 = _875._m29;
    vec4 _1895 = _875._m30;
    vec4 _1898 = _875._m31;
    _1888 = vec3(_1892.x, _1892.y, _1892.z);
    _1889 = vec3(_1892.w, _1895.x, _1895.y);
    _1890 = vec3(_1895.z, _1895.w, _1898.x);
    _1891 = vec3(_1898.y, _1898.z, _1898.w);
    vec3 _1929 = ((_1888 - (_1889 * _875._m6.y)) + (_1890 * _875._m6.z)) - (_1891 * _875._m6.x);
    float _1953 = _1261._m50 * _667._m56;
    _1887 += (max(vec3(0.0), _1929 * _10(_1953)) * _875._m0);
    _875._m21 += _1887;
    uint _1967 = _1971._m0[_1395 * 64u];
    uint _1978 = _1967 & 255u;
    uint _1982 = _1971._m0[_1429 * 64u];
    uint _1987 = _1982 & 255u;
    uint _1995;
    uint _1997;
    uint _1999;
    if (_1978 < _1987)
    {
        _1995 = _1978;
        _1997 = _1967;
        _1999 = _1395;
    }
    else
    {
        _1995 = _1987;
        _1997 = _1982;
        _1999 = _1429;
    }
    uint _2005 = 1u;
    _2034 _2036;
    vec3 _2173;
    float _2295;
    vec2 _2365;
    _2565 _2567;
    _2565 _2714;
    while (_2005 <= _1995)
    {
        uint _2014 = (_1999 * 64u) + _2005;
        uint _2019 = _1971._m0[_2014];
        uint _2023 = _2019;
        if (_2023 >= _2019)
        {
            _2005++;
        }
        int _2032 = 4;
        int _2033 = 4;
        _2036._m0 = _2041._m0[(uint(_2032) * _2023) + 0u].xyz;
        float _2056 = _2041._m0[(uint(_2032) * _2023) + 0u].w;
        _2036._m1 = _21(_2056);
        _2036._m2 = _2041._m0[(uint(_2032) * _2023) + 1u].xyz;
        _2036._m3 = _2041._m0[(uint(_2032) * _2023) + 1u].w;
        _2036._m4 = _2041._m0[(uint(_2032) * _2023) + 2u];
        float _2091 = _2041._m0[(uint(_2032) * _2023) + 3u].x;
        _2036._m8 = _21(_2091);
        float _2101 = _2041._m0[(uint(_2032) * _2023) + 3u].y;
        _2036._m9 = _21(_2101);
        _2036._m10 = _2041._m0[(uint(_2032) * _2023) + 3u].z;
        _2036._m5 = _2117._m0[(uint(_2033) * _2023) + 0u];
        _2036._m6 = _2117._m0[(uint(_2033) * _2023) + 1u];
        _2036._m7 = _2117._m0[(uint(_2033) * _2023) + 2u];
        _2036._m12 = _2117._m0[(uint(_2033) * _2023) + 3u].xyz;
        _2036._m13 = _2117._m0[(uint(_2033) * _2023) + 3u].w;
        float _2159 = 0.0;
        uint _2160 = _2036._m1;
        vec3 _2163 = _2036._m0;
        vec3 _2166 = _2163;
        if ((_2160 & 7u) == 2u)
        {
            _2173 = _2166;
        }
        else
        {
            _2173 = normalize(_2163 - _875._m15);
        }
        vec3 _2168 = _2173;
        uint _2184 = uint(((_1439 & 3u) != 0u) ? 16 : 0);
        _2184 |= 32u;
        if ((_2160 & _2184) != 0u)
        {
            continue;
        }
        vec3 _2199 = vec3(dot(_875._m15, _2036._m5.xyz) + _2036._m5.w, dot(_875._m15, _2036._m6.xyz) + _2036._m6.w, dot(_875._m15, _2036._m7.xyz) + _2036._m7.w);
        vec2 _2233 = _2199.xy / vec2(_2199.z);
        _2199 = vec3(_2233.x, _2233.y, _2199.z);
        _2199.z = dot(_875._m15, _2036._m4.xyz) + _2036._m4.w;
        float _2246 = _2199.x;
        float _2249 = _2199.y;
        float _2252 = _2199.z;
        bool _2257 = _32(_2246, _2249, _2252) <= _2159;
        bool _2274;
        if (!_2257)
        {
            float _2261 = _2199.x;
            float _2264 = _2199.y;
            float _2267 = _2199.z;
            _2274 = _27(_2261, _2264, _2267) >= (1.0 - _2159);
        }
        else
        {
            _2274 = _2257;
        }
        if (_2274)
        {
            continue;
        }
        vec3 _2278 = vec3(1.0);
        uint _2280 = _2160 & 7u;
        vec3 _2283 = _2036._m0 - _875._m15;
        float _2289 = dot(_2283, _2283);
        if (_2280 != 2u)
        {
            _2295 = 1.0 / (1.0 + _2289);
        }
        else
        {
            _2295 = _875._m25;
        }
        _2278 = vec3(_2295);
        if (_2280 == 0u)
        {
            float _2315 = _2289 * _2036._m3;
            float _2318 = 1.0 - _44(_2315);
            float _2320 = _10(_2318);
            float _2310 = _44(_2320);
            _2278 *= _2310;
        }
        else
        {
            if (_2280 == 4u)
            {
                float _2338 = length((_2199.xy - vec2(0.5)) * 2.0);
                float _2331 = _10(_2338);
                float _2340 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_2331 * 7.80000019073486328125))));
                _2278 *= _2340;
            }
            else
            {
                if ((_2280 == 1u) || (_2280 == 2u))
                {
                    if (_2280 == 2u)
                    {
                        _2365 = fract((_2199.xy * _667._m11.xy) + _667._m11.zw);
                    }
                    else
                    {
                        _2365 = _2199.xy;
                    }
                    vec2 _2362 = _2365;
                    vec3 _2383 = vec3(0.0);
                    uint _2384 = bitfieldExtract(_2036._m8, 0, 20);
                    uint _2388 = _2384;
                    uint _2392 = _2388 + 0u;
                    vec3 _2409 = textureLod(sampler2D(_1066[nonuniformEXT(_2392)], _2395), vec4(_2362, 0.0, 0.0).xy, vec4(_2362, 0.0, 0.0).w).xyz;
                    _2383 = _41(_2409);
                    _2278 *= _2383;
                }
            }
        }
        float _2415 = float((_2160 >> uint(8)) & 255u) / 255.0;
        if ((_2280 == 0u) || (_2280 == 2u))
        {
            vec3 _2428 = abs((_2199 * 2.0) - vec3(1.0));
            float _2434 = _2428.x;
            float _2437 = _2428.y;
            float _2440 = _2428.z;
            float _2445 = 1.0 - _27(_2434, _2437, _2440);
            float _2450 = _10(_2445) / (9.9999999392252902907785028219223e-09 + _2415);
            float _2433 = _10(_2450);
            _2278 *= ((_2433 * _2433) * (3.0 - (2.0 * _2433)));
        }
        else
        {
            if ((_2280 == 1u) || (_2280 == 4u))
            {
                float _2471 = _2199.z;
                float _2475 = _44(_2471);
                float _2478 = 1.0 - _44(_2475);
                float _2480 = _10(_2478);
                float _2485 = _44(_2480) / (9.9999999392252902907785028219223e-09 + _2415);
                float _2470 = _10(_2485);
                _2278 *= _2470;
            }
        }
        float _2490 = _2278.x;
        float _2493 = _2278.y;
        float _2496 = _2278.z;
        if (_27(_2490, _2493, _2496) <= _2159)
        {
            continue;
        }
        float _2505 = 1.0;
        if ((_2160 & 8u) != 0u)
        {
            float _2512 = 0.00999999977648258209228515625;
            vec3 _2514 = _875._m15 + (_875._m6 * _2512);
            uint _2522 = 0u;
            if ((_2160 & 7u) == 0u)
            {
                vec3 _2528 = _2514 - _2036._m2;
                float _2533 = _2528.x;
                float _2536 = _2528.y;
                float _2539 = _2528.z;
                _2522 = _38(_2533, _2536, _2539);
            }
            else
            {
                if ((_2160 & 7u) == 2u)
                {
                    float _2549 = 0.0;
                    uint _2550 = uint((_667._m12.w > 0.0) ? 3 : 4);
                    for (; _2522 < _2550; _2522++)
                    {
                        int _2564 = 5;
                        _2567._m0 = _2572._m0[(uint(_2564) * ((_2160 >> uint(22)) + _2522)) + 0u];
                        _2567._m1 = _2572._m0[(uint(_2564) * ((_2160 >> uint(22)) + _2522)) + 1u];
                        _2567._m2 = _2572._m0[(uint(_2564) * ((_2160 >> uint(22)) + _2522)) + 2u];
                        _2567._m3 = _2572._m0[(uint(_2564) * ((_2160 >> uint(22)) + _2522)) + 3u];
                        _2567._m4 = _2572._m0[(uint(_2564) * ((_2160 >> uint(22)) + _2522)) + 4u];
                        vec2 _2628 = vec2(dot(_2514, _2567._m0.xyz) + _2567._m0.w, dot(_2514, _2567._m1.xyz) + _2567._m1.w);
                        _2628 = abs((_2628 * 2.0) - vec2(1.0));
                        bool _2654 = _2628.x < 0.9900000095367431640625;
                        bool _2660;
                        if (_2654)
                        {
                            _2660 = _2628.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _2660 = _2654;
                        }
                        if (_2660)
                        {
                            _2549 = (1.0 - max(_2628.x, _2628.y)) * _667._m13.w;
                            break;
                        }
                    }
                    _875._m36 = int(_2522);
                    _2522 = min((_2550 - 1u), _2522);
                    if (_667._m12.w > 0.0)
                    {
                        uint _2687 = uint(_875._m17.x) ^ (uint(_875._m17.y) << uint(1));
                        _2687 ^= uint(_667._m14.x);
                        _2522 += uint(int(((float(_2687 & 3u) * 0.25) + 0.125) > _2549));
                    }
                }
            }
            int _2713 = 5;
            _2714._m0 = _2572._m0[(uint(_2713) * ((_2160 >> uint(22)) + _2522)) + 0u];
            _2714._m1 = _2572._m0[(uint(_2713) * ((_2160 >> uint(22)) + _2522)) + 1u];
            _2714._m2 = _2572._m0[(uint(_2713) * ((_2160 >> uint(22)) + _2522)) + 2u];
            _2714._m3 = _2572._m0[(uint(_2713) * ((_2160 >> uint(22)) + _2522)) + 3u];
            _2714._m4 = _2572._m0[(uint(_2713) * ((_2160 >> uint(22)) + _2522)) + 4u];
            vec4 _2770 = vec4((_2514.x * _2714._m0.x) + ((_2514.y * _2714._m0.y) + ((_2514.z * _2714._m0.z) + _2714._m0.w)), (_2514.x * _2714._m1.x) + ((_2514.y * _2714._m1.y) + ((_2514.z * _2714._m1.z) + _2714._m1.w)), (_2514.x * _2714._m2.x) + ((_2514.y * _2714._m2.y) + ((_2514.z * _2714._m2.z) + _2714._m2.w)), (_2514.x * _2714._m3.x) + ((_2514.y * _2714._m3.y) + ((_2514.z * _2714._m3.z) + _2714._m3.w)));
            vec3 _2857 = _2770.xyz / vec3(_2770.w);
            _2770 = vec4(_2857.x, _2857.y, _2857.z, _2770.w);
            bool _2865 = min(_2770.x, _2770.y) > 0.0;
            bool _2874;
            if (_2865)
            {
                _2874 = max(_2770.x, _2770.y) < 1.0;
            }
            else
            {
                _2874 = _2865;
            }
            if (_2874)
            {
                vec2 _2886 = (_2770.xy * _2714._m4.xy) + _2714._m4.zw;
                _2770 = vec4(_2886.x, _2886.y, _2770.z, _2770.w);
                if (false)
                {
                    _2505 = textureLod(sampler2DShadow(_2893, _2895), vec3(_2770.xyz.xy, _2770.xyz.z), 0.0);
                }
                else
                {
                    vec2 _2904 = (_2770.xy * _667._m15.xy) + vec2(0.5);
                    vec2 _2913 = floor(_2904);
                    vec2 _2916 = _2904 - _2913;
                    _2913 -= vec2(0.5);
                    vec2 _2923 = vec2(4.0) - (_2916 * 3.0);
                    vec2 _2928 = vec2(7.0);
                    vec2 _2931 = vec2(1.0) + (_2916 * 3.0);
                    vec2 _2936 = (_2913 + (((vec2(3.0) - (_2916 * 2.0)) / _2923) - vec2(2.0))) * _667._m15.zw;
                    vec2 _2951 = (_2913 + ((vec2(3.0) + _2916) / _2928)) * _667._m15.zw;
                    vec2 _2963 = (_2913 + ((_2916 / _2931) + vec2(2.0))) * _667._m15.zw;
                    vec3 _2989 = vec3(_2936.x, _2936.y, _2770.z);
                    _2505 = (_2923.x * _2923.y) * textureLod(sampler2DShadow(_2893, _2895), vec3(_2989.xy, _2989.z), 0.0);
                    vec3 _3007 = vec3(_2951.x, _2936.y, _2770.z);
                    _2505 += ((_2928.x * _2923.y) * textureLod(sampler2DShadow(_2893, _2895), vec3(_3007.xy, _3007.z), 0.0));
                    vec3 _3027 = vec3(_2963.x, _2936.y, _2770.z);
                    _2505 += ((_2931.x * _2923.y) * textureLod(sampler2DShadow(_2893, _2895), vec3(_3027.xy, _3027.z), 0.0));
                    vec3 _3047 = vec3(_2936.x, _2951.y, _2770.z);
                    _2505 += ((_2923.x * _2928.y) * textureLod(sampler2DShadow(_2893, _2895), vec3(_3047.xy, _3047.z), 0.0));
                    vec3 _3067 = vec3(_2951.x, _2951.y, _2770.z);
                    _2505 += ((_2928.x * _2928.y) * textureLod(sampler2DShadow(_2893, _2895), vec3(_3067.xy, _3067.z), 0.0));
                    vec3 _3087 = vec3(_2963.x, _2951.y, _2770.z);
                    _2505 += ((_2931.x * _2928.y) * textureLod(sampler2DShadow(_2893, _2895), vec3(_3087.xy, _3087.z), 0.0));
                    vec3 _3107 = vec3(_2936.x, _2963.y, _2770.z);
                    _2505 += ((_2923.x * _2931.y) * textureLod(sampler2DShadow(_2893, _2895), vec3(_3107.xy, _3107.z), 0.0));
                    vec3 _3127 = vec3(_2951.x, _2963.y, _2770.z);
                    _2505 += ((_2928.x * _2931.y) * textureLod(sampler2DShadow(_2893, _2895), vec3(_3127.xy, _3127.z), 0.0));
                    vec3 _3147 = vec3(_2963.x, _2963.y, _2770.z);
                    _2505 += ((_2931.x * _2931.y) * textureLod(sampler2DShadow(_2893, _2895), vec3(_3147.xy, _3147.z), 0.0));
                    _2505 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _2505 = float((_2160 & 7u) == 2u);
                if ((_2160 & 7u) == 2u)
                {
                    _875._m36 = -1;
                }
            }
            float _3167 = float((_2160 >> uint(16)) & 63u) / 63.0;
            float _3181 = ((_2505 * _3167) + 1.0) - _3167;
            _2505 = _10(_3181);
            if ((_667._m57 > 0.0) && (_2505 > 0.0))
            {
                vec4 _3192 = vec4(_875._m17.xy * _667._m16.xy, _875._m17.z, 1.0);
                float _3205 = _3192.z;
                bool _3208 = false;
                float _3209 = _112(_3205, _3208);
                _3192.z = _3209;
                vec3 _3247 = _875._m15 + (_2168 * 0.0500000007450580596923828125);
                mat4 _3248 = mat4(vec4(_667._m17), vec4(_667._m18), vec4(_667._m19), vec4(_667._m20));
                vec4 _3211 = _52(_3247, _3248);
                vec3 _3255 = _3211.xyz / vec3(_3211.w);
                _3211 = vec4(_3255.x, _3255.y, _3255.z, _3211.w);
                float _3258 = _3211.z;
                bool _3261 = false;
                float _3262 = _112(_3258, _3261);
                _3211.z = _3262;
                int _3264 = 4;
                vec3 _3265 = vec3(_3211.xyz - _3192.xyz) / vec3(float(_3264));
                float _3279 = 0.100000001490116119384765625;
                float _3281 = 0.001000000047497451305389404296875 * _3192.z;
                uvec2 _3294 = uvec2(_875._m17.xy);
                uint _3295 = uint(_667._m21.w);
                float _3286 = _140(_3294, _3295) - 0.5;
                vec3 _3298 = _3192.xyz + (_3265 * _3286);
                for (int _3305 = 0; _3305 < _3264; _3305++)
                {
                    _3298 += _3265;
                    float _3317 = 1.0 - textureLod(sampler2D(_3318, _3320), vec4(_3298.xy, 0.0, 0.0).xy, vec4(_3298.xy, 0.0, 0.0).w).x;
                    float _3339 = _3317;
                    bool _3341 = false;
                    float _3342 = _112(_3339, _3341);
                    float _3338 = _3342 + _3281;
                    bool _3349 = (_3298.z - _3338) > 0.001000000047497451305389404296875;
                    bool _3358;
                    if (_3349)
                    {
                        _3358 = (_3298.z - _3338) <= _3279;
                    }
                    else
                    {
                        _3358 = _3349;
                    }
                    if (_3358)
                    {
		    //FIX
                        //_2505 = 0.0;
                        break;
                    }
                }
            }
        }
        if (_2505 <= _2159)
        {
            continue;
        }
        vec3 _3370 = (_2036._m12 * _2505) * _2278;
        float _3377 = _2036._m13;
        vec3 _3380 = _3370;
        float _3387 = dot(_875._m6, _2168);
        float _3382 = _10(_3387);
        vec3 _3390 = _875._m6;
        vec3 _3393 = _875._m14;
        vec3 _3396 = _2168;
        vec3 _3398 = _875._m2;
        float _3401 = _875._m3;
        vec3 _3389 = _90(_3390, _3393, _3396, _3398, _3401);
        vec3 _3405 = _873._m6;
        vec3 _3408 = _875._m14;
        vec3 _3411 = _2168;
        vec3 _3413 = _873._m2;
        float _3416 = _873._m3;
        _3389 += _90(_3405, _3408, _3411, _3413, _3416);
        _3389 *= (_3380 * (_3382 * _3377));
        float _3436 = 1.25;
        float _3439 = (dot(_873._m6, _2168) + 0.25) / _44(_3436);
        float _3429 = _10(_3439);
        vec3 _3441 = _3380 * _3429;
        _875._m21 += ((_3441 * _875._m0) + _3389);
    }
    _875._m21 *= _875._m11;
    _872 = _875._m6.x;
    _3464 = vec4(_875._m21, 0.0);
    if (((_667._m58 & 1u) != 0u) == true)
    {
        vec3 _3480 = _875._m6;
        bool _3483 = false;
        vec2 _3484 = _148(_3480, _3483);
        _3479 = vec4(_3484, 0.0, 0.0);
        float _3494 = dot(_875._m14, _875._m6);
        float _3488 = _10(_3494);
        float _3497 = _3488;
        float _3499 = _875._m3;
        vec3 _3502 = _875._m2;
        vec3 _3496 = _96(_3497, _3499, _3502);
        float _3507 = _3496.x;
        float _3511 = _3496.y;
        float _3515 = _3496.z;
        float _3519 = _875._m3;
        _3506 = vec4(_70(_3507), _70(_3511), _70(_3515), _151(_3519));
    }
    float _3524 = _1261._m52;
    if (_3524 > 0.0)
    {
        vec2 _3531 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _667._m16.xy;
        vec2 _3547 = vec2(_878, _880);
        float _3551 = (texture(sampler2D(_3552, _1201), _3547 * _1070._m14.xy).x * 0.5) - 0.100000001490116119384765625;
        if (_3524 > _3551)
        {
            vec3 _3593 = textureLod(sampler2D(_3570, _1201), vec4(_3531 + vec2(_872 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).xy, vec4(_3531 + vec2(_872 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).w).xyz;
            _3464 = vec4(_3593.x, _3593.y, _3593.z, _3464.w);
        }
        else
        {
            if (_3524 > (_3551 - 0.02500000037252902984619140625))
            {
                _3464 = vec4(vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).x, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).y, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).z, _3464.w);
            }
        }
    }
}

