// More GLASS FIX
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

layout(set = 0, binding = 0, std140) uniform _211_213
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    uint _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    float _m64;
    uint _m65;
    uint _m66;
    float _m67;
    float _m68;
    float _m69[3];
} _213;

layout(set = 2, binding = 0, std140) uniform _335_337
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19[3];
} _337;

layout(set = 0, binding = 1, std140) uniform _1040_1042
{
    vec4 _m0[64];
} _1042;

layout(set = 1, binding = 0, std140) uniform _1044_1046
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    int _m5;
    uint _m6;
    float _m7[2];
} _1046;

layout(push_constant, std430) uniform _1035_1037
{
    int _m0;
} _1037;

layout(set = 2, binding = 1) uniform TEXTURE_2D _362;
layout(set = 0, binding = 6) uniform sampler _366;
layout(set = 0, binding = 7) uniform texture3D _816;
layout(set = 0, binding = 8) uniform sampler _818;
layout(set = 0, binding = 9) uniform texture3D _837;
layout(set = 0, binding = 10) uniform texture3D _937;
layout(set = 0, binding = 11) uniform sampler _939;
layout(set = 0, binding = 12) uniform TEXTURE_2D _1004;
layout(set = 0, binding = 13) uniform sampler _1006;

layout(location = 2, component = 0) in vec4 _371;
layout(location = 7, component = 0) in vec4 _401;
layout(location = 8, component = 0) in vec4 _409;
layout(location = 3, component = 0) in vec4 _607;
layout(location = 4, component = 0) in vec4 _636;
layout(location = 5, component = 0) in vec4 _691;
layout(location = 6, component = 0) in vec4 _695;
layout(location = 0, component = 0) out vec4 _711;
layout(location = 1, component = 0) out vec4 _973;
layout(location = 2, component = 0) out vec4 _974;
uint _50;
uint _52;
uint _54;
uint _56;
uint _58;
uint _60;
uint _62;
uint _63;
uint _65;
uint _66;
uint _68;
uint _70;
uint _72;
uint _74;
uint _76;
uint _78;
uint _80;
uint _82;
uint _84;

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec2 _16(vec2 _15)
{
    return clamp(_15, vec2(0.0), vec2(1.0));
}

float _42(inout float _40, bool _41)
{
    if (_41)
    {
        _40 += (float(_40 < _213._m24) * _213._m25);
    }
    float _230 = _40;
    return _213._m0.w / (_10(_230) + _213._m0.z);
}

uint _21(float _20)
{
    return floatBitsToUint(_20);
}

vec3 _47(vec2 _46)
{
    return (vec3(_213._m26, _213._m27, _213._m28) + (vec3(_213._m29, _213._m30, _213._m31) * _46.x)) + (vec3(_213._m32, _213._m33, _213._m34) * _46.y);
}

float _24(float _23)
{
    float _102 = (((-0.15658299624919891357421875) * abs(_23)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_23));
    float _116;
    if (_23 >= 0.0)
    {
        _116 = _102;
    }
    else
    {
        _116 = 3.1415927410125732421875 - _102;
    }
    return _116;
}

float _27(float _26)
{
    float _130;
    if (_26 < 1.0)
    {
        _130 = _26;
    }
    else
    {
        _130 = 1.0 / _26;
    }
    float _127 = _130;
    float _138 = _127 * _127;
    float _142 = 0.087292902171611785888671875;
    _142 = (-0.3018949925899505615234375) + (_142 * _138);
    _142 = 1.0 + (_142 * _138);
    _142 *= _127;
    float _158;
    if (_26 < 1.0)
    {
        _158 = _142;
    }
    else
    {
        _158 = 1.57079637050628662109375 - _142;
    }
    return _158;
}

float _30(float _29)
{
    float _171 = abs(_29);
    float _168 = _27(_171);
    float _175;
    if (_29 < 0.0)
    {
        _175 = -_168;
    }
    else
    {
        _175 = _168;
    }
    return _175;
}

float _35(float _33, float _34)
{
    float _189 = _33 / _34;
    float _185 = _30(_189);
    if (_34 < 0.0)
    {
        _185 += ((_33 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _185;
}

void main()
{
    _50 = 2147483648u;
    _52 = 1073741824u;
    _54 = 0u;
    _56 = 268435456u;
    _58 = 536870912u;
    _60 = 805306368u;
    _62 = 1073741824u;
    _63 = 1342177280u;
    _65 = 0u;
    _66 = 16777216u;
    _68 = 33554432u;
    _70 = 50331648u;
    _72 = 67108864u;
    _74 = 83886080u;
    _76 = 100663296u;
    _78 = 117440512u;
    _80 = 134217728u;
    _82 = 150994944u;
    _84 = 167772160u;
    int _280 = 6;
    float _282 = 1.0 / float(_280);
    int _286 = 1;
    float _288 = 1.0 / float(_286);
    if (_213._m65 == 1u)
    {
        _280 = 6;
        _282 = 1.0 / float(_280);
        _286 = 6;
        _288 = 1.0 / float(_286);
    }
    else
    {
        if (_213._m65 == 2u)
        {
            _280 = 8;
            _282 = 1.0 / float(_280);
            _286 = 8;
            _288 = 1.0 / float(_286);
        }
        else
        {
            if (_213._m65 == 3u)
            {
                _280 = 16;
                _282 = 1.0 / float(_280);
                _286 = 8;
                _288 = 1.0 / float(_286);
            }
        }
    }
    float _331 = 100.0;
    float _333 = _337._m13 * _331;
    float _343 = 1.0;
    float _344 = 1.0;
    float _345 = 0.0;
    if (_213._m66 > 0u)
    {
    }
    float _352 = 0.100000001490116119384765625 * _337._m14;
    vec4 _359 = SAMPLE_TEXTURE(SAMPLER_2D(_362, _366), (_371.xy * _337._m2.xy) + ((_337._m2.zw * vec2(_213._m67)) * _344));
    if (_359.w < 0.0039215688593685626983642578125)
    {
        _359.w = 0.0;
    }
    else
    {
        vec2 _400 = normalize(_401.xyz).xy * _352;
        vec2 _408 = normalize(_409.xyz).xy * _352;
        vec2 _420;
        if (_409.z < 0.0)
        {
            _420 = -_408;
        }
        else
        {
            _420 = _408;
        }
        _408 = _420;
        float _437 = (_409.z * _337._m15) + 0.5;
        float _428 = _10(_437);
        float _439 = 1.0;
        for (int _440 = 0; _440 < _280; _440++)
        {
            float _449 = _282 * (float(_440) + _345);
            vec2 _456 = _371.xy + (_400 * (1.0 - _449));
            vec2 _468 = _456;
            float _464 = SAMPLE_TEXTURE(SAMPLER_2D(_362, _366), (_16(_468) * _337._m2.xy) + ((_337._m2.zw * vec2(_213._m67)) * _344)).x;
            float _487 = max(0.001000000047497451305389404296875, _464 - _449);
            _439 *= exp(((-_487) * _333) * _282);
            float _502 = 1.0;
            for (int _503 = 0; _503 < _286; _503++)
            {
                float _512 = _288 * float(_503);
                vec2 _527 = _456 - (_408 * (1.0 - _512));
                float _517 = SAMPLE_TEXTURE(SAMPLER_2D(_362, _366), (_16(_527) * _337._m2.xy) + ((_337._m2.zw * vec2(_213._m67)) * _344)).x;
                float _545 = max(0.001000000047497451305389404296875, (_517 - _512) - _449);
                _502 *= exp(((-_545) * _333) * _288);
            }
            _502 = mix(_502, 1.0 - _502, _428);
            _343 = mix(_343, _502, _487);
        }
        _359.w *= (1.0 - _439);
    }
    _359.w *= SAMPLE_TEXTURE(SAMPLER_2D(_362, _366), (_371.xy * _337._m3.xy) + _337._m3.zw).z;
    float _600 = 1.0;
    float _601 = 0.0;
    _343 *= _600;
    vec3 _606 = normalize(_607.xyz);
    vec3 _611 = vec3(_213._m53, _213._m54, _213._m55);
    float _622 = dot(_611, _606);
    float _626 = max((_622 * 0.5) + 0.5, (_622 * (-0.5)) + 0.5);
    vec3 _635 = normalize(_636.xyz);
    float _640 = 0.079577468335628509521484375;
    vec2 _642 = vec2(_337._m16, -_337._m17);
    float _650 = dot(_635, _611);
    vec2 _654 = _642 * _642;
    vec2 _658 = vec2(1.0) - _654;
    vec2 _662 = (vec2(1.0) + _654) - ((vec2(2.0) * _642) * _650);
    vec2 _672 = (_658 * _640) / (_662 * sqrt(_662));
    float _681 = mix(_672.y, _672.x, (_650 * 0.5) + 0.5);
    vec3 _690 = _691.xyz;
    vec3 _694 = _695.xyz * _343;
    float _700 = (1.0 - _359.y) * (_337._m18 * 10.0);
    vec3 _732 = (_690 * _337._m4.xyz) + (_694 * ((vec3(_626) + (_337._m5.xyz * _700)) + vec3(_681)));
    _711 = vec4(_732.x, _732.y, _732.z, _711.w);
    float _741 = (_359.w * _600) - _601;
    _711.w = _10(_741);
    vec2 _745 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _213._m19.xy;
    float _775 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).z;
    bool _777 = false;
    float _778 = _42(_775, _777);
    float _763 = _778;
    vec2 _779 = _745 + vec2(0.0);
    float _783 = 0.119999997317790985107421875;
    float _785 = _213._m20.y;
    float _789 = _213._m21.z + 1.0;
    float _794 = pow(max(0.0, _763 - _783) / (_785 - _783), 0.5);
    float _804 = (0.5 / _789) + (_794 * (1.0 - (1.0 / _789)));
    
    // FIX
    _779.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec3 _813 = textureLod(sampler3D(_816, _818), vec4(_779, _804, 0.0).xyz, vec4(_779, _804, 0.0).w).xyz;
    vec2 _836 = textureLod(sampler3D(_837, _818), vec4(_779, _804, 0.0).xyz, vec4(_779, _804, 0.0).w).xy;
    float _855 = _836.x;
    float _858 = _836.y;
    float _864 = _213._m68;
    uint _862 = _21(_864);
    bool _868 = (_862 & 2u) != 0u;
    _813 *= float(_868);
    _855 = _868 ? _855 : 1.0;
    vec3 _879 = vec3(0.0);
    if ((_862 & 1u) != 0u)
    {
        vec3 _886 = vec3(_213._m35, _213._m36, _213._m37);
        vec3 _897 = _47(_745);
        vec4 _900 = vec4(0.0);
        vec3 _902 = normalize(_897);
        float _905 = _902.z;
        _900.x = clamp(_24(_905) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _914 = _902.y;
        float _917 = _902.x;
        _900.y = _35(_914, _917) / 6.283185482025146484375;
        _900.z = sqrt(_763 * _213._m22.w);
        _900.z = clamp(_900.z, 0.015625, 0.984375);
        _879 = textureLod(sampler3D(_937, _939), _900.xyz, _900.w).xyz;
        _879 *= _858;
    }
    vec3 _958 = ((_711.xyz + _879) * _855) + _813;
    _711 = vec4(_958.x, _958.y, _958.z, _711.w);
    float _961 = _711.w;
    _711.w = _10(_961);
    vec3 _970 = _711.xyz * _711.w;
    _711 = vec4(_970.x, _970.y, _970.z, _711.w);
    _973 = vec4(0.0);
    _974 = vec4(0.0);
    float _975 = _213._m23.w;
    if (!(_975 == 0.0))
    {
        vec2 _983 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _213._m19.xy;
        bool _999 = ((1.0 - gl_FragCoord.z) - 0.0) < (1.0 - TEXTURE_LOD(SAMPLER_2D(_1004, _1006), vec4(_983, 0.0, 0.0).xy, vec4(_983, 0.0, 0.0).w).x);
        _973 = _711 * float(!_999);
        _711 *= float(_999);
        _974 = vec4(_711.w);
    }
}


