// Another SSR shader!
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_KHR_shader_subgroup_quad : require
#extension GL_KHR_shader_subgroup_basic : require
#extension GL_KHR_shader_subgroup_ballot : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 50, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

struct _115
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    float _m5;
};

struct _123
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _2646
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
};

struct _4607
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _5561
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _778_780
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    uint _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    float _m64;
    float _m65;
    uint _m66;
    float _m67[2];
} _780;

layout(set = 2, binding = 0, std140) uniform _1157_1159
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    float _m16;
    float _m17;
    float _m18;
    uint _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    uint _m24;
    uint _m25;
    uint _m26;
    uint _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    uint _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    uint _m57;
    float _m58[2];
} _1159;

layout(set = 1, binding = 0, std140) uniform _1170_1172
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    int _m31;
    uint _m32;
    float _m33[3];
} _1172;

layout(set = 3, binding = 0, std140) uniform _1609_1611
{
    vec4 _m0[5];
    vec4 _m1[5];
    vec4 _m2[5];
    vec4 _m3[5];
} _1611;

layout(set = 0, binding = 21, std430) restrict readonly buffer _2193_2195
{
    vec4 _m0[];
} _2195;

layout(set = 0, binding = 22, std430) restrict readonly buffer _2558_2560
{
    uint _m0[];
} _2560;

layout(set = 0, binding = 23, std140) uniform _2651_2653
{
    vec4 _m0[4096];
} _2653;

layout(set = 0, binding = 24, std140) uniform _2671_2673
{
    vec4 _m0[4096];
} _2673;

layout(set = 0, binding = 25, std140) uniform _2724_2726
{
    vec4 _m0[2048];
} _2726;

layout(set = 0, binding = 33, std430) restrict readonly buffer _3964_3966
{
    uint _m0[];
} _3966;

layout(set = 0, binding = 37, std140) uniform _4611_4613
{
    vec4 _m0[4096];
} _4613;

layout(set = 0, binding = 38, std140) uniform _4687_4689
{
    vec4 _m0[4096];
} _4689;

layout(set = 0, binding = 40, std430) restrict readonly buffer _4968_4970
{
    uint _m0[];
} _4970;

layout(set = 0, binding = 41, std140) uniform _5566_5568
{
    vec4 _m0[4095];
} _5568;

layout(set = 0, binding = 1, std140) uniform _6314_6316
{
    vec4 _m0[64];
} _6316;

layout(push_constant, std430) uniform _2179_2181
{
    int _m0;
    int _m1;
    int _m2;
    int _m3;
} _2181;

layout(set = 3, binding = 8) uniform texture2D _1353[5];
layout(set = 0, binding = 12) uniform sampler _1361;
layout(set = 3, binding = 1) uniform texture2D _1650[5];
layout(set = 0, binding = 13) uniform sampler _1655;
layout(set = 3, binding = 3) uniform texture2D _1672[5];
layout(set = 0, binding = 14) uniform sampler _1677;
layout(set = 3, binding = 2) uniform texture2D _1684[5];
layout(set = 0, binding = 15) uniform sampler _1689;
layout(set = 3, binding = 4) uniform texture2D _1706[5];
layout(set = 0, binding = 16) uniform sampler _1711;
layout(set = 3, binding = 5) uniform texture2D _1718[5];
layout(set = 0, binding = 17) uniform sampler _1723;
layout(set = 3, binding = 7) uniform texture2D _1730[5];
layout(set = 0, binding = 18) uniform sampler _1735;
layout(set = 0, binding = 19) uniform TEXTURE_2D _2151;
layout(set = 0, binding = 20) uniform sampler _2153;
layout(set = 4, binding = 0) uniform texture2D _2290[34816];
layout(set = 0, binding = 26) uniform TEXTURE_2D _2920;
layout(set = 0, binding = 27) uniform sampler _2922;
layout(set = 0, binding = 28) uniform TEXTURE_2D _2972;
layout(set = 0, binding = 29) uniform TEXTURE_2D _3385;
layout(set = 0, binding = 30) uniform sampler _3387;
layout(set = 0, binding = 31) uniform TEXTURE_2D _3625;
layout(set = 0, binding = 32) uniform sampler _3627;
layout(set = 0, binding = 34) uniform TEXTURE_2D _4217;
layout(set = 0, binding = 35) uniform sampler _4219;
layout(set = 0, binding = 36) uniform texture2D _4514;
layout(set = 0, binding = 39) uniform textureCubeArray _4941;
layout(set = 0, binding = 11) uniform sampler _4943;
layout(set = 0, binding = 42) uniform texture2D _5889;
layout(set = 0, binding = 43) uniform samplerShadow _5891;
layout(set = 3, binding = 6) uniform texture2D _6312[5];
layout(set = 0, binding = 8) uniform texture3D _6319;
layout(set = 0, binding = 9) uniform sampler _6320;
layout(set = 0, binding = 10) uniform texture3D _6321;

layout(location = 17, component = 3) in float _1037;
layout(location = 18, component = 0) in float _1039;
layout(location = 18, component = 1) in float _1044;
layout(location = 18, component = 2) in float _1046;
layout(location = 18, component = 3) in float _1048;
layout(location = 19, component = 0) in float _1077;
layout(location = 19, component = 1) in float _1079;
layout(location = 19, component = 2) in float _1081;
layout(location = 19, component = 3) in float _1085;
layout(location = 20, component = 0) in float _1087;
layout(location = 20, component = 1) in float _1089;
layout(location = 20, component = 2) in float _1101;
layout(location = 10, component = 0) in vec4 _1126;
layout(location = 11, component = 0) in vec4 _1129;
layout(location = 12, component = 0) in vec4 _1132;
layout(location = 15, component = 0) in vec4 _1191;
layout(location = 0, component = 0) out vec4 _6253;
layout(location = 1, component = 0) out vec4 _6267;
layout(location = 2, component = 0) out vec4 _6294;
uint _188;
uint _190;
uint _192;
uint _194;
uint _196;
uint _198;
uint _200;
uint _201;
uint _203;
uint _204;
uint _206;
uint _208;
uint _210;
uint _212;
uint _214;
uint _216;
uint _218;
uint _220;
uint _222;

_123 _125()
{
    _123 _670;
    _670._m0 = vec3(0.0);
    _670._m2 = vec3(0.0);
    _670._m3 = 0.0;
    _670._m4 = 0u;
    _670._m5 = 0.0;
    _670._m6 = vec3(0.0);
    _670._m7 = vec3(0.0, 0.0, 1.0);
    _670._m8 = vec3(0.0, 0.0, 1.0);
    _670._m1 = vec3(0.0);
    _670._m9 = 1.0;
    _670._m10 = 1.0;
    _670._m14 = vec3(0.0);
    _670._m15 = vec3(0.0);
    _670._m16 = vec4(0.0);
    _670._m17 = vec4(0.0);
    _670._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _670._m19 = vec3(0.0);
    _670._m20 = vec3(0.0);
    _670._m21 = vec3(0.0);
    _670._m22 = vec3(0.0);
    _670._m23 = vec3(0.0);
    _670._m24 = vec3(0.0);
    _670._m25 = 1.0;
    _670._m26 = uvec4(0u);
    _670._m27 = uvec4(0u);
    _670._m28 = uvec4(0u);
    _670._m29 = vec4(0.0);
    _670._m30 = vec4(0.0);
    _670._m31 = vec4(0.0);
    _670._m32 = vec4(0.0);
    _670._m33 = uvec2(0u);
    _670._m34 = vec2(0.0);
    _670._m35 = 0.0;
    _670._m36 = -1;
    _670._m37 = 0;
    _670._m38 = vec2(0.0);
    _670._m39 = 1.0;
    _670._m41 = -1;
    _670._m45 = 1.0;
    _670._m11 = 1.0;
    _670._m12 = 0u;
    _670._m13 = uvec3(0u);
    _670._m40 = vec3(0.0);
    _670._m46 = 0.0;
    _670._m47 = 1.0;
    return _670;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

_115 _117()
{
    _115 _658;
    _658._m0 = vec4(0.0);
    _658._m1 = vec4(0.0);
    _658._m2 = vec4(0.0);
    _658._m3 = vec4(0.0);
    _658._m4 = vec4(0.0);
    _658._m5 = 0.0;
    return _658;
}

vec2 _141(vec2 _140)
{
    return ((_140 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _146(inout vec2 _144, bool _145)
{
    vec2 _812 = _144;
    _144 = _141(_812);
    float _832 = (1.0 - (_144.x * _144.x)) - (_144.y * _144.y);
    vec3 _815 = vec3(_144.x, _144.y, sqrt(_10(_832)));
    if (_145 == false)
    {
        _815.z = -_815.z;
    }
    return _815;
}

vec3 _67(mat3 _65, vec3 _66)
{
    return _65 * _66;
}

vec3 _151(vec3 _149, mat3 _150)
{
    mat3 _848 = _150;
    vec3 _850 = _149;
    return normalize(_67(_848, _850));
}

vec3 _157(vec2 _154, mat3 _155, bool _156)
{
    vec2 _857 = _154;
    bool _859 = _156;
    vec3 _861 = _146(_857, _859);
    vec3 _856 = _861;
    vec3 _862 = _856;
    mat3 _864 = _155;
    return _151(_862, _864);
}

uint _21(float _20)
{
    return floatBitsToUint(_20);
}

float _78(float _77)
{
    return sqrt(_77);
}

float _113(vec3 _110, float _111, float _112)
{
    float _613 = length(_110) * _112;
    if (_613 < 1.0)
    {
        float _622 = 1.0 - _111;
        float _625 = _613 * _613;
        float _629 = ((3.0 * _613) - (_613 * _625)) / (1.0 - _625);
        float _640 = 1.0 / (2.0 * _629);
        float _650 = (_622 * _622) + _640;
        return 1.0 - _78(_650);
    }
    return _111;
}

float _137(inout float _135, bool _136)
{
    if (_136)
    {
        _135 += (float(_135 < _780._m29) * _780._m30);
    }
    float _793 = _135;
    return _780._m0.w / (_10(_793) + _780._m0.z);
}

float _32(float _29, float _30, float _31)
{
    return min(_29, min(_30, _31));
}

float _27(float _24, float _25, float _26)
{
    return max(_24, max(_25, _26));
}

float _130(vec2 _129)
{
    return dot(_129, _129);
}

vec4 _88(uint _87)
{
    return vec4(float((_87 >> uint(24)) & 255u), float((_87 >> uint(16)) & 255u), float((_87 >> uint(8)) & 255u), float(_87 & 255u));
}

vec4 _85(uint _84)
{
    return unpackUnorm4x8(_84).wzyx;
}

float _70(float _69)
{
    return exp2(_69);
}

vec3 _107(float _104, float _105, vec3 _106)
{
    float _565 = 0.0949999988079071044921875 + (_105 * (0.60000002384185791015625 + (4.190000057220458984375 * _105)));
    float _575 = _104 + 0.02500000037252902984619140625;
    float _579 = (9.5 * _105) * _104;
    float _593 = 1.0 - (14.0 * _104);
    float _585 = (_565 * _575) * _70(_593);
    float _600 = -_579;
    float _596 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _70(_600)));
    return mix(vec3(_585), vec3(_596), _106);
}

float _174(uvec2 _172, uint _173)
{
    uvec2 _919 = _172 & uvec2(3u);
    return float(((((2068378560u * (1u - (_919.x >> uint(1)))) + (1500172770u * (_919.x >> uint(1)))) >> ((_919.y + ((_919.x & 1u) << uint(2))) << uint(2))) + _173) & 15u) / 16.0;
}

vec3 _168(vec3 _165, vec4 _166, vec4 _167)
{
    return vec3((_166.xy * _165.xy) + _166.zw, _167.z) / vec3((_167.x * _165.z) + _167.y);
}

vec3 _162(vec3 _160, vec4 _161)
{
    return vec3(vec2(0.5) + (_161.xy * (_160.xy / vec2(_160.z))), (_161.w / _160.z) + _161.z);
}

int _44(uint _43)
{
    return findLSB(_43);
}

vec4 _60(vec3 _55, vec4 _56, vec4 _57, vec4 _58, vec4 _59)
{
    return vec4((_55.x * _56.x) + ((_55.y * _56.y) + ((_55.z * _56.z) + _56.w)), (_55.x * _57.x) + ((_55.y * _57.y) + ((_55.z * _57.z) + _57.w)), (_55.x * _58.x) + ((_55.y * _58.y) + ((_55.z * _58.z) + _58.w)), (_55.x * _59.x) + ((_55.y * _59.y) + ((_55.z * _59.z) + _59.w)));
}

float _50(float _49)
{
    return _49 * _49;
}

vec3 _47(vec3 _46)
{
    return _46 * _46;
}

uint _38(float _35, float _36, float _37)
{
    bool _258 = abs(_37) >= abs(_35);
    bool _266;
    if (_258)
    {
        _266 = abs(_37) >= abs(_36);
    }
    else
    {
        _266 = _258;
    }
    if (_266)
    {
        return uint((_37 < 0.0) ? 5 : 4);
    }
    if (abs(_36) >= abs(_35))
    {
        return uint((_36 < 0.0) ? 3 : 2);
    }
    return uint(int(_35 < 0.0));
}

float _75(float _73, float _74)
{
    return pow(_73, _74);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _93(vec3 _91, float _92)
{
    float _452 = dot(_91, vec3(16.666500091552734375));
    float _447 = _10(_452);
    float _461 = 1.0 - _92;
    float _464 = _10(_461);
    float _465 = 5.0;
    vec3 _469 = _91 + ((vec3(_447) - _91) * _75(_464, _465));
    return _16(_469);
}

vec3 _101(vec3 _96, vec3 _97, vec3 _98, vec3 _99, float _100)
{
    float _477 = dot(_96, _97);
    float _473 = _10(_477);
    vec3 _479 = normalize(_97 + _98);
    float _488 = dot(_96, _479);
    float _484 = _10(_488);
    float _494 = dot(_98, _479);
    float _490 = _10(_494);
    vec3 _497 = _99;
    float _499 = _490;
    vec3 _496 = _93(_497, _499);
    float _506 = dot(_96, _98);
    float _502 = _10(_506);
    float _508 = 1.0 - (_100 * 0.800000011920928955078125);
    _508 *= _508;
    _508 *= _508;
    float _519 = _508 * _508;
    float _523 = ((_484 * _484) * (_519 - 1.0)) + 1.0;
    _523 = _519 / ((_523 * _523) + 9.9999999392252902907785028219223e-09);
    float _538 = (_473 * (1.0 - _508)) + _508;
    float _545 = (_502 * (1.0 - _508)) + _508;
    _523 /= (((4.0 * _538) * _545) + 9.9999999392252902907785028219223e-09);
    return _496 * _523;
}

vec2 _177(vec2 _176)
{
    return (vec2(1.0) - abs(_176.yx)) * vec2((_176.x >= 0.0) ? 1.0 : (-1.0), (_176.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _182(inout vec3 _180, bool _181)
{
    _180 /= vec3((abs(_180.x) + abs(_180.y)) + abs(_180.z));
    vec2 _988;
    if (_180.z >= 0.0)
    {
        _988 = _180.xy;
    }
    else
    {
        vec2 _994 = _180.xy;
        _988 = _177(_994);
    }
    _180 = vec3(_988.x, _988.y, _180.z);
    if (_181)
    {
        vec2 _1008 = (_180.xy * 0.5) + vec2(0.5);
        _180 = vec3(_1008.x, _1008.y, _180.z);
    }
    return _180.xy;
}

float _81(float _80)
{
    return sqrt(_80);
}

float _185(float _184)
{
    float _1018 = abs(_184);
    float _1015 = _81(_1018);
    float _1022;
    if (_184 > 0.0)
    {
        _1022 = _1015;
    }
    else
    {
        _1022 = -_1015;
    }
    return (_1022 * 0.5) + 0.5;
}

void main()
{
    _188 = 2147483648u;
    _190 = 1073741824u;
    _192 = 0u;
    _194 = 268435456u;
    _196 = 536870912u;
    _198 = 805306368u;
    _200 = 1073741824u;
    _201 = 1342177280u;
    _203 = 0u;
    _204 = 16777216u;
    _206 = 33554432u;
    _208 = 50331648u;
    _210 = 67108864u;
    _212 = 83886080u;
    _214 = 100663296u;
    _216 = 117440512u;
    _218 = 134217728u;
    _220 = 150994944u;
    _222 = 167772160u;
    _123 _1034 = _125();
    _1034._m16 = vec4(0.0, 0.0, _1037, _1039);
    vec3 _1043 = vec3(_1044, _1046, _1048);
    _1034._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _1034._m15 = vec3(_780._m40, _780._m41, _780._m42) + _1043;
    vec3 _1075 = vec3(0.0);
    vec3 _1076 = vec3(0.0);
    _1075 = normalize(vec3(_1077, _1079, _1081));
    _1076 = normalize(vec3(_1085, _1087, _1089));
    vec3 _1093 = _1075;
    vec3 _1095 = _1076;
    vec3 _1097 = normalize(cross(_1093, _1095) * _1101);
    _1034._m18 = mat3(vec3(_1095), vec3(_1097), vec3(_1093));
    _1034._m14 = normalize(-_1043);
    _1034._m29 = _1126;
    _1034._m30 = _1129;
    _1034._m31 = _1132;
    uint _1135 = 0u;
    vec4 _1136 = vec4(0.0);
    vec4 _1137 = vec4(0.0);
    vec4 _1138 = vec4(0.0);
    vec4 _1139 = vec4(0.0);
    vec4 _1140 = vec4(0.0);
    float _1141 = 0.0;
    uvec2 _1142 = uvec2(0u, 65535u);
    vec2 _1145 = _1034._m16.zw;
    vec2 _1149 = _1145;
    vec2 _1151 = _1145;
    float _1153 = 0.0009765625;
    vec3 _1166;
    if ((_1159._m57 & 1u) != 0u)
    {
        _1166 = vec3(_1172._m17, _1172._m18, _1172._m19);
    }
    else
    {
        _1166 = vec3(1.0);
    }
    vec3 _1155 = _1166;
    float _1183 = 1.0;
    float _1184 = 0.0;
    vec2 _1187[2] = vec2[](vec2(1.0), vec2(1.0));
    vec4 _1190 = vec4(0.0);
    _1190 = _1191;
    _1184 = 1.0;
    _1142.x = 65535u;
    _1142.y = 65535u;
    _1184 = 0.0;
    float _1195 = 0.0;
    float _1196 = 0.0;
    for (uint _1197 = 0u; _1197 < 4u; _1197++)
    {
        float _1206 = _1190[_1197];
        float _1210 = max(_1206, subgroupQuadSwapHorizontal(_1206));
        _1210 = max(_1210, subgroupQuadSwapVertical(_1210));
        if (_1210 > _1195)
        {
            _1142.y = _1142.x;
            _1142.x = _1197;
            _1196 = _1195;
            _1195 = _1210;
            _1184 = _1206;
        }
        else
        {
            if (_1210 > _1196)
            {
                _1142.y = _1197;
                _1196 = _1210;
            }
        }
    }
    if (_1142.x == 65535u)
    {
        _1142.x = 0u;
        _1184 = 1.0;
    }
    float _1249 = _1184;
    _1184 = _10(_1249);
    switch (_1142.x)
    {
        case 0u:
        {
            _1187[0] = _1159._m1.xx;
            break;
        }
        case 1u:
        {
            _1187[0] = _1159._m1.yy;
            break;
        }
        case 2u:
        {
            _1187[0] = _1159._m1.zz;
            break;
        }
        case 3u:
        {
            _1187[0] = _1159._m1.ww;
            break;
        }
        default:
        {
            _1187[0] = vec2(1.0);
            break;
        }
    }
    switch (_1142.y)
    {
        case 0u:
        {
            _1187[1] = _1159._m1.xx;
            break;
        }
        case 1u:
        {
            _1187[1] = _1159._m1.yy;
            break;
        }
        case 2u:
        {
            _1187[1] = _1159._m1.zz;
            break;
        }
        case 3u:
        {
            _1187[1] = _1159._m1.ww;
            break;
        }
        default:
        {
            _1187[1] = vec2(1.0);
            break;
        }
    }
    _1149 = _1145 * _1187[0];
    _1151 = _1145 * _1187[1];
    if (_1184 < _1153)
    {
        _1183 = 0.0;
    }
    else
    {
        if (_1184 > (1.0 - _1153))
        {
            _1183 = 1.0;
        }
        else
        {
            float _1336 = 0.0;
            float _1337 = 0.0;
            uint _1338 = _1142.x;
            uint _1341 = _1338 & 7u;
            uint _1345 = _1341;
            uint _1347 = _1345;
            uint _1355 = _1347;
            _1336 = texture(sampler2D(_1353[nonuniformEXT(_1355)], _1361), _1149).x;
            uint _1368 = _1142.y;
            uint _1371 = _1368 & 7u;
            uint _1374 = _1371;
            uint _1376 = _1374;
            uint _1379 = _1376;
            _1337 = texture(sampler2D(_1353[nonuniformEXT(_1379)], _1361), _1151).x;
            _1183 = 0.0;
            float _1395;
            switch (_1142.x)
            {
                case 0u:
                {
                    _1395 = _1159._m0.x;
                    break;
                }
                case 1u:
                {
                    _1395 = _1159._m0.y;
                    break;
                }
                case 2u:
                {
                    _1395 = _1159._m0.z;
                    break;
                }
                case 3u:
                {
                    _1395 = _1159._m0.w;
                    break;
                }
                default:
                {
                    _1395 = 0.0;
                    break;
                }
            }
            float _1418;
            switch (_1142.y)
            {
                case 0u:
                {
                    _1418 = _1159._m0.x;
                    break;
                }
                case 1u:
                {
                    _1418 = _1159._m0.y;
                    break;
                }
                case 2u:
                {
                    _1418 = _1159._m0.z;
                    break;
                }
                case 3u:
                {
                    _1418 = _1159._m0.w;
                    break;
                }
                default:
                {
                    _1418 = 0.0;
                    break;
                }
            }
            float _1433 = (((_1336 - 0.4980392158031463623046875) + 0.0) + _1184) * _1395;
            float _1442 = (((_1337 - 0.4980392158031463623046875) + 1.0) - _1184) * _1418;
            float _1450 = _1433 - _1442;
            float _1454 = (clamp(_1450 / _1159._m18, -1.0, 1.0) / 2.0) + 0.5;
            float _1462 = 0.100000001490116119384765625;
            float _1464 = abs(0.5 - _1184);
            float _1475 = (_1464 - (0.5 - _1462)) / _1462;
            float _1468 = _10(_1475);
            if ((_1184 < _1462) && (_1454 > _1184))
            {
                _1183 = mix(_1454, _1184, _1468);
            }
            else
            {
                if ((_1184 > (1.0 - _1462)) && (_1454 < _1184))
                {
                    _1183 = mix(_1454, _1184, _1468);
                }
                else
                {
                    _1183 = _1454;
                }
            }
            float _1507 = _1183;
            _1183 = _10(_1507);
        }
    }
    uint _1510 = gl_SubgroupInvocationID;
    uint _1514 = gl_SubgroupInvocationID & 4294967292u;
    uvec4 _1518 = subgroupBallot(_1183 < _1153);
    uvec4 _1523 = subgroupBallot(_1183 > (1.0 - _1153));
    int _1533;
    if (_1514 < 32u)
    {
        _1533 = 15 << int(_1514);
    }
    else
    {
        _1533 = 0;
    }
    uint _1529 = uint(_1533);
    int _1544;
    if (32u <= _1514)
    {
        _1544 = 15 << int(_1514 - 32u);
    }
    else
    {
        _1544 = 0;
    }
    uint _1541 = uint(_1544);
    uvec4 _1553 = uvec4(_1529, _1541, 0u, 0u);
    bool _1557 = all(equal((_1518 & _1553), _1553));
    bool _1565 = all(equal((_1523 & _1553), _1553));
    if (_1557)
    {
        _1183 = 1.0;
        _1149 = _1151;
        _1142.x = _1142.y;
        _1142.y = 65535u;
    }
    else
    {
        if (_1565)
        {
            _1183 = 1.0;
            _1142.y = 65535u;
        }
    }
    float _1585 = _1172._m20;
    bool _1588 = _1585 > 0.0;
    float _1591 = 1.0;
    uint _1592 = _1142.x;
    uint _1595 = _1592 & 7u;
    uint _1598 = _1595;
    uint _1600 = _1598;
    float _1602 = 0.0;
    vec2 _1603 = _1149;
    _1603.x *= _1611._m1[_1600].w;
    _1603.y *= _1611._m2[_1600].x;
    _1603.x += (_780._m58 * _1611._m2[_1600].y);
    _1603.y += (_780._m58 * _1611._m2[_1600].z);
    vec2 _1647 = _1603;
    uint _1652 = _1600;
    vec3 _1649 = (texture(sampler2D(_1650[nonuniformEXT(_1652)], _1655), _1647).xyz * vec3(_1611._m0[_1600].x)) + vec3(_1611._m0[_1600].y);
    uint _1674 = _1600;
    vec2 _1671 = texture(sampler2D(_1672[nonuniformEXT(_1674)], _1677), _1647).xy;
    uint _1686 = _1600;
    vec3 _1683 = (texture(sampler2D(_1684[nonuniformEXT(_1686)], _1689), _1647).xyz * vec3(_1611._m0[_1600].z)) + vec3(_1611._m0[_1600].w);
    uint _1708 = _1600;
    float _1705 = texture(sampler2D(_1706[nonuniformEXT(_1708)], _1711), _1647).x;
    uint _1720 = _1600;
    float _1717 = texture(sampler2D(_1718[nonuniformEXT(_1720)], _1723), _1647).x;
    uint _1732 = _1600;
    vec3 _1729 = texture(sampler2D(_1730[nonuniformEXT(_1732)], _1735), _1647).xyz;
    uint _1743 = _1600;
    float _1741 = texture(sampler2D(_1353[nonuniformEXT(_1743)], _1361), _1647).x;
    _1136 = vec4(_1649.x, _1649.y, _1649.z, _1136.w);
    _1136.w = 0.0;
    _1137 = vec4(_1683.x, _1683.y, _1683.z, _1137.w);
    _1137.w = _1717;
    _1138 = vec4(_1671.x, _1671.y, _1138.z, _1138.w);
    _1139.x = 0.0;
    _1139.y = _1602;
    _1139.z = _1717;
    _1139.w = _1705;
    _1141 = _1741;
    _1591 = _1611._m1[_1600].x;
    vec3 _1779 = _1729 * _1611._m3[_1600].xyz;
    _1140 = vec4(_1779.x, _1779.y, _1779.z, _1140.w);
    float _1782 = _1588 ? _1585 : _1591;
    vec3 _1791 = _1140.xyz * vec3(_1782);
    _1140 = vec4(_1791.x, _1791.y, _1791.z, _1140.w);
    vec2 _1794 = vec2(0.0);
    _115 _1795;
    _1795._m0 = _1136;
    _1795._m1 = _1137;
    _1795._m2 = _1139;
    _1795._m3 = _1138;
    _1795._m4 = _1140;
    _1795._m5 = _1141;
    _115 _1808 = _1795;
    if (_1142.y != 65535u)
    {
        float _1815 = 1.0 - _1183;
        _115 _1818 = _117();
        float _1820 = _1172._m20;
        bool _1823 = _1820 > 0.0;
        float _1826 = 1.0;
        uint _1827 = _1142.y;
        uint _1830 = _1827 & 7u;
        uint _1833 = _1830;
        uint _1835 = _1833;
        float _1837 = 0.0;
        vec2 _1838 = _1151;
        _1838.x *= _1611._m1[_1835].w;
        _1838.y *= _1611._m2[_1835].x;
        _1838.x += (_780._m58 * _1611._m2[_1835].y);
        _1838.y += (_780._m58 * _1611._m2[_1835].z);
        vec2 _1874 = _1838;
        uint _1878 = _1835;
        vec3 _1876 = (texture(sampler2D(_1650[nonuniformEXT(_1878)], _1655), _1874).xyz * vec3(_1611._m0[_1835].x)) + vec3(_1611._m0[_1835].y);
        uint _1898 = _1835;
        vec2 _1896 = texture(sampler2D(_1672[nonuniformEXT(_1898)], _1677), _1874).xy;
        uint _1908 = _1835;
        vec3 _1906 = (texture(sampler2D(_1684[nonuniformEXT(_1908)], _1689), _1874).xyz * vec3(_1611._m0[_1835].z)) + vec3(_1611._m0[_1835].w);
        uint _1928 = _1835;
        float _1926 = texture(sampler2D(_1706[nonuniformEXT(_1928)], _1711), _1874).x;
        uint _1938 = _1835;
        float _1936 = texture(sampler2D(_1718[nonuniformEXT(_1938)], _1723), _1874).x;
        uint _1948 = _1835;
        vec3 _1946 = texture(sampler2D(_1730[nonuniformEXT(_1948)], _1735), _1874).xyz;
        uint _1958 = _1835;
        float _1956 = texture(sampler2D(_1353[nonuniformEXT(_1958)], _1361), _1874).x;
        _1818._m0 = vec4(_1876.x, _1876.y, _1876.z, _1818._m0.w);
        _1818._m0.w = 0.0;
        _1818._m1 = vec4(_1906.x, _1906.y, _1906.z, _1818._m1.w);
        _1818._m1.w = _1936;
        _1818._m3 = vec4(_1896.x, _1896.y, _1818._m3.z, _1818._m3.w);
        _1818._m2.x = 0.0;
        _1818._m2.y = _1837;
        _1818._m2.z = _1936;
        _1818._m2.w = _1926;
        _1818._m5 = _1956;
        _1826 = _1611._m1[_1835].x;
        vec3 _1998 = _1946 * _1611._m3[_1835].xyz;
        _1818._m4 = vec4(_1998.x, _1998.y, _1998.z, _1818._m4.w);
        float _2002 = _1823 ? _1820 : _1826;
        vec3 _2012 = _1818._m4.xyz * vec3(_2002);
        _1818._m4 = vec4(_2012.x, _2012.y, _2012.z, _1818._m4.w);
        _1808._m0 = mix(_1808._m0, _1818._m0, vec4(_1815 * 1.0));
        _1808._m1 = mix(_1808._m1, _1818._m1, vec4(_1815 * 1.0));
        _1808._m2.w = mix(_1808._m2.w, _1818._m2.w, _1815 * 1.0);
        vec3 _2050 = mix(_1808._m2.xyz, _1818._m2.xyz, vec3(_1815));
        _1808._m2 = vec4(_2050.x, _2050.y, _2050.z, _1808._m2.w);
        _1808._m3 = mix(_1808._m3, _1818._m3, vec4(_1815 * 1.0));
        _1808._m4 = mix(_1808._m4, _1818._m4, vec4(_1815 * 1.0));
        _1808._m5 = mix(_1808._m5, _1818._m5, _1815);
    }
    _1136 = _1808._m0;
    _1137 = _1808._m1;
    _1139.w = _1808._m2.w;
    _1138 = _1808._m3;
    _1140 = _1808._m4;
    _1141 = _1808._m5;
    _1034._m22 = _1140.xyz * _1155;
    _1034._m0 = _1136.xyz;
    _1034._m2 = _1137.xyz;
    _1034._m1 = _1140.xyz;
    _1034._m3 = _1139.w;
    _1034._m6 = _1138.xyz;
    uint _2112 = 0u;
    bool _2113 = true;
    vec2 _2115 = _1034._m6.xy;
    bool _2119 = _2113;
    vec3 _2121 = _146(_2115, _2119);
    _1034._m7 = _2121;
    vec2 _2123 = _1034._m6.xy;
    mat3 _2127 = _1034._m18;
    bool _2130 = _2113;
    _1034._m6 = _157(_2123, _2127, _2130);
    vec3 _2134 = dFdx(_1034._m15);
    vec3 _2138 = dFdy(_1034._m15);
    vec2 _2142 = _1034._m17.xy * _780._m6.xy;
    uint _2150 = uint(int(TEXTURE_LOD(SAMPLER_2D(_2151, _2153), vec4(_2142, 0.0, 0.0).xy, vec4(_2142, 0.0, 0.0).w).x * 255.0));
    if ((_2150 > 0u) && (_2150 < 255u))
    {
        int _2178 = _2181._m3;
        if (_2178 > 0)
        {
            _2178--;
            vec4 _2191 = _2195._m0[((uint(_2178) + _2150) - 1u) * 2u];
            vec4 _2205 = _2195._m0[(((uint(_2178) + _2150) - 1u) * 2u) + 1u];
            vec2 _2215 = vec2((_1034._m15.x * _2191.x) + ((_1034._m15.y * _2191.y) + ((_1034._m15.z * _2191.z) + _2191.w)), (_1034._m15.x * _2205.x) + ((_1034._m15.y * _2205.y) + ((_1034._m15.z * _2205.z) + _2205.w)));
            vec2 _2257 = vec2(dot(_2134, _2191.xyz), dot(_2134, _2205.xyz));
            vec2 _2267 = vec2(dot(_2138, _2191.xyz), dot(_2138, _2205.xyz));
            int _2277 = int(_1172._m15);
            vec4 _2281 = vec4(0.0);
            vec4 _2282 = vec4(0.0);
            vec4 _2283 = vec4(0.0);
            uint _2284 = uint(_2277);
            uint _2293 = _2284 + 0u;
            _2281 = textureGrad(sampler2D(_2290[nonuniformEXT(_2293)], _1655), _2215, _2257, _2267);
            uint _2304 = _2284 + 1u;
            _2282 = textureGrad(sampler2D(_2290[nonuniformEXT(_2304)], _1677), _2215, _2257, _2267);
            uint _2315 = _2284 + 2u;
            _2283 = textureGrad(sampler2D(_2290[nonuniformEXT(_2315)], _1689), _2215, _2257, _2267);
            vec2 _2325 = _2282.xy;
            bool _2328 = true;
            vec3 _2329 = _146(_2325, _2328);
            vec3 _2324 = _2329;
            float _2330 = _2282.w;
            float _2333 = _2282.z;
            vec3 _2336 = _2281.xyz;
            float _2339 = _2281.w;
            vec4 _2342 = _2283;
            float _2345 = _1172._m16;
            if (_2150 > _21(_2345))
            {
                _2336 *= _1172._m3.xyz;
                _2333 *= _1172._m3.w;
            }
            _1034._m0 = mix(_1034._m0, _2336, vec3(_2330));
            _1034._m2 = mix(_1034._m2, _2342.xyz, vec3(_2330));
            _1034._m22 = mix(_1034._m22, _2336 * (_2339 * 16.0), vec3(_2339));
            vec3 _2386 = _1034._m18[2];
            float _2389 = sign(dot(cross(_2205.xyz, _2191.xyz), _2386));
            vec3 _2407 = normalize(_2191.xyz + (_2386 * dot(_2191.xyz, _2386)));
            _2191 = vec4(_2407.x, _2407.y, _2407.z, _2191.w);
            vec3 _2416 = normalize(cross(_2386, _2191.xyz)) * _2389;
            _2205 = vec4(_2416.x, _2416.y, _2416.z, _2205.w);
            _2324 = ((_2191.xyz * _2324.x) + (_2205.xyz * _2324.y)) + (_2386 * _2324.z);
            vec3 _2435 = _2324;
            float _2437 = dot(_2435, _2386);
            _2324 = (_1034._m6 * _2437) + ((_2435 - (_2386 * _2437)) * dot(_1034._m6, _2386));
            _1034._m6 = normalize(_2324);
            vec3 _2459 = _2324;
            float _2461 = _2342.w;
            float _2464 = 1.0;
            _1034._m3 = mix(_1034._m3, _2342.w, _2333);
        }
    }
    uvec2 _2473 = uvec2(_1034._m17.xy);
    uint _2478 = _2473.x / 256u;
    uint _2483 = _2473.y / 256u;
    float _2488 = _1034._m17.z;
    bool _2491 = false;
    float _2492 = _137(_2488, _2491);
    float _2487 = _2492;
    float _2493 = log2(max(1.0, _2487 / _780._m7.z)) * _780._m7.w;
    uint _2503 = min(23u, uint(_2493));
    float _2510 = _780._m59;
    float _2516 = _780._m60;
    uint _2508 = (_21(_2510) + ((_2478 + (_21(_2516) * _2483)) * 24u)) + _2503;
    uvec2 _2528 = uvec2(_1034._m17.xy);
    uint _2533 = _2528.x / 32u;
    uint _2537 = _2528.y / 32u;
    float _2545 = _780._m61;
    uint _2541 = _2533 + (_2537 * _21(_2545));
    float _2552 = _1172._m30;
    uint _2551 = _21(_2552);
    uint _2556 = _2560._m0[_2508 * 64u];
    uint _2567 = _2556 & 255u;
    uint _2570 = _2560._m0[_2541 * 64u];
    uint _2575 = _2570 & 255u;
    uint _2583;
    uint _2585;
    uint _2587;
    if (_2567 < _2575)
    {
        _2583 = _2567;
        _2585 = _2556;
        _2587 = _2508;
    }
    else
    {
        _2583 = _2575;
        _2585 = _2570;
        _2587 = _2541;
    }
    vec3 _2593 = dFdx(_1034._m15);
    vec3 _2597 = dFdy(_1034._m15);
    uint _2601 = _2551 & 3u;
    bool _2604 = (_2551 & 4u) != 0u;
    uint _2608 = ((_2601 == 0u) && (!_2604)) ? 0u : _2583;
    uint _2616 = 1u;
    _2646 _2648;
    vec3 _3068;
    while (_2616 <= _2608)
    {
        uint _2625 = (_2587 * 64u) + _2616;
        uint _2630 = _2560._m0[_2625];
        uint _2634 = _2630;
        if (_2634 >= _2630)
        {
            _2616++;
        }
        int _2643 = 2;
        int _2644 = 2;
        int _2645 = 1;
        _2648._m0 = _2653._m0[(uint(_2643) * _2634) + 0u];
        _2648._m1 = _2653._m0[(uint(_2643) * _2634) + 1u];
        _2648._m2 = _2673._m0[(uint(_2644) * _2634) + 0u];
        float _2687 = _2673._m0[(uint(_2644) * _2634) + 1u].x;
        _2648._m3 = _21(_2687);
        float _2697 = _2673._m0[(uint(_2644) * _2634) + 1u].y;
        _2648._m4 = _21(_2697);
        float _2707 = _2673._m0[(uint(_2644) * _2634) + 1u].z;
        _2648._m5 = _21(_2707);
        float _2717 = _2673._m0[(uint(_2644) * _2634) + 1u].w;
        _2648._m6 = _21(_2717);
        float _2732 = _2726._m0[(uint(_2645) * _2634) + 0u].x;
        _2648._m7 = _21(_2732);
        float _2742 = _2726._m0[(uint(_2645) * _2634) + 0u].y;
        _2648._m8 = _21(_2742);
        float _2752 = _2726._m0[(uint(_2645) * _2634) + 0u].z;
        _2648._m9 = _21(_2752);
        vec4 _2757 = _2648._m0;
        vec4 _2760 = _2648._m1;
        vec4 _2763 = _2648._m2;
        vec3 _2766 = vec3(dot(_1034._m15, _2757.xyz) + _2757.w, dot(_1034._m15, _2760.xyz) + _2760.w, dot(_1034._m15, _2763.xyz) + _2763.w);
        float _2792 = 0.0039215688593685626983642578125;
        float _2794 = _2766.x;
        float _2797 = _2766.y;
        float _2800 = _2766.z;
        bool _2805 = _32(_2794, _2797, _2800) <= _2792;
        bool _2822;
        if (!_2805)
        {
            float _2809 = _2766.x;
            float _2812 = _2766.y;
            float _2815 = _2766.z;
            _2822 = _27(_2809, _2812, _2815) >= (1.0 - _2792);
        }
        else
        {
            _2822 = _2805;
        }
        if (_2822)
        {
            continue;
        }
        uint _2826 = _2648._m5;
        uint _2829 = _2648._m9;
        uint _2832 = _2551 & 3u;
        bool _2841 = ((_2829 & 512u) != 0u) && (_2832 != 0u);
        bool _2852;
        if (!_2841)
        {
            _2852 = ((_2829 & 1024u) != 0u) && (_2832 != 1u);
        }
        else
        {
            _2852 = _2841;
        }
        bool _2860;
        if (!_2852)
        {
            _2860 = (_2829 & 16384u) != 0u;
        }
        else
        {
            _2860 = _2852;
        }
        if (_2860)
        {
            continue;
        }
        vec2 _2864 = vec2(dot(_2593, _2757.xyz), dot(_2593, _2760.xyz));
        vec2 _2874 = vec2(dot(_2597, _2757.xyz), dot(_2597, _2760.xyz));
        vec4 _2884 = vec4(0.0);
        vec4 _2885 = vec4(0.0);
        uint _2886 = _2648._m3;
        uint _2892 = _2886 + 1u;
        vec4 _2889 = textureGrad(sampler2D(_2290[nonuniformEXT(_2892)], _1677), _2766.xy, _2864 * vec2(1.0), _2874 * vec2(1.0));
        if ((_2829 & 32768u) != 0u)
        {
            vec2 _2910 = vec2(1.0 / length(_2757.xyz), 1.0 / length(_2760.xyz));
            vec2 _2942 = TEXTURE_LOD(SAMPLER_2D(_2920, _2922), vec4(_2766.xy * _2910, 0.0, 0.0).xy, vec4(_2766.xy * _2910, 0.0, 0.0).w).xy;
            _2889 = vec4(_2942.x, _2942.y, _2889.z, _2889.w);
            vec2 _2949 = _2889.xy - vec2(0.4980392158031463623046875);
            float _2952 = 1.0 - _130(_2949);
            _2889.z = sqrt(_10(_2952));
        }
        else
        {
            if ((_2829 & 65536u) != 0u)
            {
                vec2 _2963 = vec2(1.0, (1.0 / length(_2760.xyz)) / 2.5);
                vec2 _2971 = TEXTURE_GRAD(SAMPLER_2D(_2972, _2922), _2766.xy * _2963, _2864 * _2963, _2874 * _2963).xy;
                vec2 _2992 = _2889.xy + (_2971 - vec2(0.4980392158031463623046875));
                _2889 = vec4(_2992.x, _2992.y, _2889.z, _2889.w);
                vec2 _2998 = _2889.xy - vec2(0.4980392158031463623046875);
                float _3001 = 1.0 - _130(_2998);
                _2889.z = sqrt(_10(_3001));
            }
        }
        if ((_2826 & 1u) != 0u)
        {
            uint _3012 = _2886 + 0u;
            _2884 = textureGrad(sampler2D(_2290[nonuniformEXT(_3012)], _1655), _2766.xy, _2864 * vec2(1.0), _2874 * vec2(1.0));
        }
        if ((_2826 & 2u) != 0u)
        {
            uint _3031 = _2886 + 2u;
            _2885 = textureGrad(sampler2D(_2290[nonuniformEXT(_3031)], _1689), _2766.xy, _2864 * vec2(1.0), _2874 * vec2(1.0));
        }
        float _3043 = 1.0;
        vec3 _3044 = vec3(0.5, 0.5, 1.0);
        vec3 _3046 = vec3(0.0, 0.0, 1.0);
        vec4 _3047 = _2889;
        _3044 = _3047.xyz;
        _3043 = _3047.w;
        _3046 = (_3044 * 2.0) - vec3(1.0);
        if (_3043 <= (4.0 * _2792))
        {
            continue;
        }
        _3044 = _3046;
        if ((_2829 & 128u) != 0u)
        {
            _3068 = vec3(-_3044.x, -_3044.y, _3044.z);
        }
        else
        {
            _3068 = _3044;
        }
        _3044 = _3068;
        uint _3083 = _2648._m6;
        uint _3087 = _3083;
        float _3086 = 1.0 + (_88(_3087).w * 0.062745101749897003173828125);
        uint _3095 = _2826;
        float _3094 = _85(_3095).z;
        uint _3100 = _3083;
        vec3 _3099 = _85(_3100).xyz;
        float _3113 = _3086 - (_3086 * abs((_2766.z * 2.0) - 1.0));
        _3043 *= _10(_3113);
        float _3117 = _3043;
        if ((_2826 & 1u) != 0u)
        {
            _3099 *= _2884.xyz;
            _3117 *= _2884.w;
        }
        vec3 _3132 = _1034._m18[2];
        float _3141 = dot(_3132, normalize(_2763.xyz));
        float _3135 = _10(_3141);
        uint _3143 = _2648._m7;
        uint _3147 = _3143;
        vec4 _3146 = _85(_3147);
        _1034._m22 = mix(_1034._m22, ((_3146.xyz * ((_3117 * _3146.w) * 16.0)) * _3094) * _3135, vec3(_3117));
        uint _3168 = _2648._m8;
        uint _3172 = _3168;
        vec4 _3171 = _85(_3172);
        if ((_2826 & 2u) != 0u)
        {
            _3171 = _2885;
        }
        if ((_2826 & 32u) != 0u)
        {
            uint _3187 = _2826;
            float _3186 = _85(_3187).x;
            uint _3192 = _2826;
            float _3191 = _88(_3192).y;
            float _3212 = dot((_2766.xy + _3046.xy) - vec2(0.5), (_2766.xy + _3046.xy) - vec2(0.5));
            float _3196 = _10(_3212);
            float _3220 = _3191 * (_3186 - _3196);
            float _3222 = _10(_3220);
            float _3214 = _78(_3222);
            _3043 = min(_3043, _3214);
        }
        float _3227 = _3043 * _3135;
        uint _3231 = _2648._m4;
        uint _3235 = _3231;
        vec4 _3234 = _85(_3235) * _3227;
        _1034._m9 = max(_1034._m9, _3234.x);
        _1034._m0 = mix(_1034._m0, _3099, _3234.xxx);
        _1034._m2 = mix(_1034._m2, _3171.xyz, _3234.yyy);
        if (!(_3227 == 0.0))
        {
            float _3265 = 1.0;
            vec3 _3275 = normalize(_2757.xyz + (_3132 * dot(_2757.xyz, _3132)));
            _2757 = vec4(_3275.x, _3275.y, _3275.z, _2757.w);
            vec3 _3284 = normalize(cross(_3132, _2757.xyz)) * _3265;
            _2760 = vec4(_3284.x, _3284.y, _3284.z, _2760.w);
            _3044 = ((_2757.xyz * _3044.x) + (_2760.xyz * _3044.y)) + (_3132 * _3044.z);
            if ((_2829 & 256u) != 0u)
            {
                vec3 _3308 = mix(_3132, _3044, _3234.www);
                float _3314 = dot(_3308, _3132);
                _3044 = (_1034._m6 * _3314) + ((_3308 - (_3132 * _3314)) * dot(_1034._m6, _3132));
            }
            else
            {
                if ((_2829 & 64u) != 0u)
                {
                    _3044 = mix(mix(_1034._m6, _3132, vec3(_3227)), _3044, _3234.www);
                }
                else
                {
                    _3044 = mix(_1034._m6, _3044, _3234.www);
                }
            }
            _1034._m6 = normalize(_3044);
        }
        float _3359 = _3171.w;
        _1034._m3 = mix(_1034._m3, _3359, _3234.z);
    }
    float _3369 = _780._m8.x;
    if (_3369 > 0.0)
    {
        vec2 _3376 = _1034._m17.xy * _780._m6.xy;
        vec3 _3384 = (TEXTURE_LOD(SAMPLER_2D(_3385, _3387), vec4(_3376, 0.0, 0.0).xy, vec4(_3376, 0.0, 0.0).w).xyz * 2.0) - vec3(1.0);
        float _3409 = dot(_3384, _1034._m6);
        _1034._m11 = _10(_3409);
        float _3417 = 1.0 - pow(_1034._m11, 0.699999988079071044921875);
        _1034._m11 = _10(_3417);
        _1034._m11 *= _1034._m11;
    }
    _1034._m21 = _1034._m22;
    _1034._m25 = 1.0;
    float _3430 = _780._m9.w;
    bool _3433 = _3430 < 0.0;
    _3430 = abs(_3430);
    vec3 _3438 = _1034._m15;
    float _3457 = (1.0 - (length(_3438 - vec3(_780._m40, _780._m41, _780._m42)) / _3430)) / 0.25;
    float _3441 = _10(_3457);
    if ((!_3433) && (_3441 > 0.0))
    {
        vec3 _3466 = _780._m9.xyz;
        vec3 _3470 = _780._m10.xyz;
        float _3474 = _3438.z - _3470.z;
        float _3480 = _780._m11.w;
        float _3483 = _780._m12.w;
        float _3486 = float(_3483 < 0.0);
        _3483 = abs(_3483) - 1.0;
        bool _3493 = _3474 <= 0.0;
        float _3496 = 3.5 * float(!(_3483 == 0.0));
        float _3505;
        if (!(_3480 == 0.0))
        {
            _3505 = _3466.z;
        }
        else
        {
            _3505 = _3470.z;
        }
        float _3502 = _3505;
        float _3514 = min(_3493 ? 2.0 : 1000.0, abs(_3474));
        float _3521 = max(_3466.x - _3438.x, _3438.x - _3470.x);
        float _3533 = max(_3466.y - _3438.y, _3438.y - _3470.y);
        float _3545 = max(_3521, _3533) - _3514;
        _3545 = max(_3545, _3502 - _3438.z);
        _3545 = max(_3545, _3474 - _3496);
        if (_3545 <= 0.0)
        {
            float _3566 = _3493 ? _3480 : _3483;
            vec2 _3571 = _1034._m18[2].xy;
            float _3575 = length(_3571);
            vec3 _3578 = vec3(_3571, (-1.73205077648162841796875) * _3575);
            _3578 /= vec3(2.0 * _3575);
            vec3 _3591 = _780._m12.xyz;
            vec3 _3595 = mix(_3578, _3591, bvec3(_3493));
            vec2 _3602 = _3438.xy - (_3595.xy * (_3474 / _3595.z));
            float _3613 = (_780._m62 / 100.0) * 16.0;
            vec2 _3620 = _3602 * _3613;
            float _3624 = TEXTURE_LOD(SAMPLER_2D(_3625, _3627), vec4(_3620, 0.0, 0.0).xy, vec4(_3620, 0.0, 0.0).w).x;
            float _3642 = min(8.0, _3470.z - _3466.z);
            float _3655 = (-_3474) / _3642;
            float _3650 = _10(_3655);
            float _3662 = dot(_1034._m6, _3595);
            float _3657 = _10(_3662);
            float _3668 = _3521 / _3514;
            float _3664 = 1.0 - _10(_3668);
            float _3674 = _3533 / _3514;
            _3664 *= (1.0 - _10(_3674));
            _3664 *= _3664;
            float _3690 = min(_3474 / 1.0, 1.0 - (_3474 / _3496));
            float _3682 = _10(_3690);
            _3664 *= max(_3682, _3650);
            _3664 *= _3664;
            _3664 *= _3441;
            float _3703 = _3624 - 1.0;
            float _3706 = float(_3493) * _3486;
            float _3711 = max(0.0, _3624 - 0.85000002384185791015625);
            float _3716 = _3493 ? _3703 : _3711;
            float _3721 = (((1.0 - _3706) * _3657) * _3664) * _3566;
            vec3 _3730 = _1034._m0 + (_1034._m2 * (vec3(1.0) - _1034._m0));
            _1034._m21 += ((_3730 * (_3716 * _3721)) * _780._m11.xyz);
            float _3754 = _3706 * _3664;
            _1034._m25 = 1.0 + (_3754 * (_3624 - 1.0));
        }
    }
    else
    {
        if (_3441 > 0.0)
        {
            _3441 *= _780._m63;
            float _3774 = float(_780._m12.w < 0.0);
            vec3 _3779 = _780._m12.xyz;
            float _3788 = dot(_1034._m6, _3779);
            float _3783 = _10(_3788);
            vec2 _3790 = _3438.xy - (_3779.xy * (_3438.z / _3779.z));
            float _3802 = (_780._m62 / 100.0) * 16.0;
            vec2 _3807 = _3790 * _3802;
            float _3811 = TEXTURE_LOD(SAMPLER_2D(_3625, _3627), vec4(_3807, 0.0, 0.0).xy, vec4(_3807, 0.0, 0.0).w).x;
            vec4 _3827 = _780._m11;
            _1034._m21 += (_3827.xyz * (((((1.0 - _3774) * (_3811 - 1.0)) * _3783) * _3441) * _3827.w));
            _1034._m25 = 1.0 + ((_3774 * (_3811 - 1.0)) * _3441);
        }
    }
    _1034._m14 = normalize(vec3(_780._m40, _780._m41, _780._m42) - _1034._m15);
    vec3 _3869 = vec3(0.0);
    vec3 _3870 = vec3(0.0);
    vec3 _3871 = vec3(0.0);
    vec3 _3872 = vec3(0.0);
    vec3 _3873 = vec3(0.0);
    vec4 _3874 = _1034._m29;
    vec4 _3877 = _1034._m30;
    vec4 _3880 = _1034._m31;
    _3870 = vec3(_3874.x, _3874.y, _3874.z);
    _3871 = vec3(_3874.w, _3877.x, _3877.y);
    _3872 = vec3(_3877.z, _3877.w, _3880.x);
    _3873 = vec3(_3880.y, _3880.z, _3880.w);
    vec3 _3911 = ((_3870 - (_3871 * _1034._m6.y)) + (_3872 * _1034._m6.z)) - (_3873 * _1034._m6.x);
    float _3935 = _1172._m21 * _780._m64;
    _3869 += (max(vec3(0.0), _3911 * _10(_3935)) * _1034._m0);
    _1034._m21 += _3869;
    bool _3949 = true;
    _3949 = (((_780._m66 & 1u) != 0u) == true) ? false : true;
    if (true && (_3949 == true))
    {
        uint _3962 = _3966._m0[_2508 * 64u];
        uint _3971 = _3962 & 255u;
        uint _3974 = _3966._m0[_2541 * 64u];
        uint _3979 = _3974 & 255u;
        uint _3987;
        uint _3989;
        uint _3991;
        if (_3971 < _3979)
        {
            _3987 = _3971;
            _3989 = _3962;
            _3991 = _2508;
        }
        else
        {
            _3987 = _3979;
            _3989 = _3974;
            _3991 = _2541;
        }
        float _3997 = _1034._m47;
        float _4006 = dot(_1034._m14, _1034._m6);
        float _4000 = _10(_4006);
        float _4008 = _4000;
        float _4010 = _1034._m3;
        vec3 _4013 = _1034._m2;
        _1034._m24 = (_107(_4008, _4010, _4013) * _1034._m11) * _1034._m39;
        float _4024 = _780._m13.x;
        float _4027 = _780._m13.z;
        bool _4031 = _4024 > 0.0;
        bool _4038;
        if (_4031)
        {
            _4038 = _1034._m3 > _4027;
        }
        else
        {
            _4038 = _4031;
        }
        if (_4038)
        {
            float _4041 = 0.0;
            vec3 _4042 = normalize(reflect(-_1034._m14, _1034._m6));
            if (dot(_1034._m14, _4042) <= _4041)
            {
                vec2 _4058 = vec2(1.0);
                uvec2 _4071 = uvec2(_1034._m17.xy * (vec2(1.0) / _4058));
                uint _4072 = uint(_780._m13.w);
                float _4059 = _174(_4071, _4072);
                _4059 -= 1.0;
                vec2 _4076 = _1034._m17.xy * _780._m6.xy;
                vec3 _4091 = vec3(_4076, _1034._m17.z);
                vec4 _4092 = _780._m14;
                vec4 _4095 = _780._m15;
                vec3 _4084 = _168(_4091, _4092, _4095);
                mat3 _4099 = mat3(vec3(_780._m16.xyz), vec3(_780._m17.xyz), vec3(_780._m18.xyz));
                mat3 _4123 = _4099;
                vec3 _4125 = _4042;
                vec3 _4122 = normalize(_67(_4123, _4125));
                float _4129 = 1.0;
                uint _4130 = uint((_4024 == 1.0) ? 8 : 12);
                _4130 = (_4024 == 3.0) ? 16u : _4130;
                vec3 _4140 = _4084;
                float _4145 = _1034._m17.z;
                bool _4148 = true;
                float _4149 = _137(_4145, _4148);
                vec3 _4142 = _4140 + (_4122 * _4149);
                vec4 _4152 = vec4(0.0);
                vec3 _4154 = _4140;
                vec4 _4156 = _780._m19;
                vec3 _4153 = _162(_4154, _4156);
                vec3 _4161 = _4142;
                vec4 _4163 = _780._m19;
                vec3 _4160 = _162(_4161, _4163);
                vec3 _4167 = ((_4160 - _4153) * (_4129 / float(_4130))) / vec3(length(_4160.xy - _4153.xy));
                vec3 _4184 = _4153 + (_4167 * _4059);
                float _4190 = abs(_4167.z) * 1.0;
                uint _4195 = 0u;
                vec3 _4196 = _4184;
                float _4198 = _4153.z;
                float _4384;
                for (uint _4201 = 0u; _4201 < _4130; _4201 += 4u)
                {
                    vec4 _4210 = vec4(1.0, 2.0, 3.0, 4.0) + vec4(float(_4201));
                    vec4 _4216 = vec4(1.0) - vec4(TEXTURE_LOD(SAMPLER_2D(_4217, _4219), vec4(_4184.xy + (_4167.xy * _4210.x), 0.0, 0.0).xy, vec4(_4184.xy + (_4167.xy * _4210.x), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4217, _4219), vec4(_4184.xy + (_4167.xy * _4210.y), 0.0, 0.0).xy, vec4(_4184.xy + (_4167.xy * _4210.y), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4217, _4219), vec4(_4184.xy + (_4167.xy * _4210.z), 0.0, 0.0).xy, vec4(_4184.xy + (_4167.xy * _4210.z), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4217, _4219), vec4(_4184.xy + (_4167.xy * _4210.w), 0.0, 0.0).xy, vec4(_4184.xy + (_4167.xy * _4210.w), 0.0, 0.0).w).x);
                    uvec4 _4338 = mix(uvec4(0u), uvec4(1u), lessThan(abs(((_4184.zzzz + (_4167.zzzz * _4210)) - _4216) - vec4(_4190)), vec4(_4190)));
                    uint _4357 = (((_4338.x << uint(0)) | (_4338.y << uint(1))) | (_4338.z << uint(2))) | (_4338.w << uint(3));
                    if (_4357 > 0u)
                    {
                        uint _4378 = _4357;
                        uint _4377 = uint(_44(_4378));
                        if (_4377 > 0u)
                        {
                            _4384 = _4216[_4377 - 1u];
                        }
                        else
                        {
                            _4384 = _4198;
                        }
                        _4198 = _4384;
                        _4196 = _4184 + (_4167 * float((_4201 + _4377) + 1u));
                        float _4403 = _4216[_4377] - _4196.z;
                        float _4410 = (_4198 - _4196.z) + _4167.z;
                        float _4424 = _4403 / (_4403 - _4410);
                        float _4418 = _10(_4424);
                        vec3 _4426 = _4196 - _4167;
                        _4196 = (_4426 * _4418) + (_4196 * (1.0 - _4418));
                        _4195 = _4201 + _4377;
                        break;
                    }
                    _4198 = _4216.w;
                }
                if (_4195 > 0u)
                {
                    vec3 _4451 = _4196;
                    vec4 _4453 = _780._m20;
                    vec4 _4456 = _780._m21;
                    vec4 _4459 = _780._m22;
                    vec4 _4462 = _780._m23;
                    vec3 _4450 = _60(_4451, _4453, _4456, _4459, _4462).xyw;
                    vec2 _4472 = _4450.xy / vec2(_4450.z);
                    _4450 = vec3(_4472.x, _4472.y, _4450.z);
                    vec2 _4475 = (_4450.xy * 2.0) - vec2(1.0);
                    float _4489 = (1.0 - (float(_4195) / float(_4130))) * 4.0;
                    float _4481 = _10(_4489);
                    if (false)
                    {
                        float _4493 = _4475.y;
                        float _4498 = 1.0 - _50(_4493);
                        _4481 *= smoothstep(0.0, 0.25, _10(_4498));
                    }
                    else
                    {
                        float _4508 = 1.0 - dot(_4475, _4475);
                        _4481 *= smoothstep(0.0, 0.5, _10(_4508));
                    }
                    // SSR IS HERE!
                    vec3 _4513 = textureLod(sampler2D(_4514, _3387), vec4(_4450.xy, 0.0, 0.0).xy, vec4(_4450.xy, 0.0, 0.0).w).xyz;
                    _4152 = vec4(_4513, _4481);
                }
                float _4546 = 1.0 - ((1.0 - _1034._m3) / (1.0 - _4027));
                float _4538 = _10(_4546);
                float _4548 = (_4152.w * _4538) * _780._m65;
                _1034._m21 += ((_4152.xyz * _4548) * _1034._m24);
                _3997 = 1.0 - _4548;
            }
        }
        uint _4570 = 1u;
        _4607 _4609;
        while (_4570 <= _3987)
        {
            uint _4579 = (_3991 * 64u) + _4570;
            uint _4584 = _3966._m0[_4579];
            uint _4588 = _4584;
            if (_4588 >= _4584)
            {
                _4570++;
            }
            float _4597 = 0.0039215688593685626983642578125;
            if (_3997 <= (_4597 * 4.0))
            {
                break;
            }
            int _4605 = 4;
            int _4606 = 4;
            _4609._m0 = _4613._m0[(uint(_4605) * _4588) + 0u].xyz;
            float _4628 = _4613._m0[(uint(_4605) * _4588) + 0u].w;
            _4609._m1 = _21(_4628);
            _4609._m2 = _4613._m0[(uint(_4605) * _4588) + 1u].xyz;
            _4609._m3 = _4613._m0[(uint(_4605) * _4588) + 1u].w;
            _4609._m4 = _4613._m0[(uint(_4605) * _4588) + 2u];
            float _4663 = _4613._m0[(uint(_4605) * _4588) + 3u].x;
            _4609._m8 = _21(_4663);
            float _4673 = _4613._m0[(uint(_4605) * _4588) + 3u].y;
            _4609._m9 = _21(_4673);
            _4609._m10 = _4613._m0[(uint(_4605) * _4588) + 3u].z;
            _4609._m5 = _4689._m0[(uint(_4606) * _4588) + 0u];
            _4609._m6 = _4689._m0[(uint(_4606) * _4588) + 1u];
            _4609._m7 = _4689._m0[(uint(_4606) * _4588) + 2u];
            _4609._m12 = _4689._m0[(uint(_4606) * _4588) + 3u].xyz;
            _4609._m13 = _4689._m0[(uint(_4606) * _4588) + 3u].w;
            vec3 _4731 = vec3(dot(_1034._m15, _4609._m5.xyz) + _4609._m5.w, dot(_1034._m15, _4609._m6.xyz) + _4609._m6.w, dot(_1034._m15, _4609._m4.xyz) + _4609._m4.w);
            float _4760 = _4731.x;
            float _4763 = _4731.y;
            float _4766 = _4731.z;
            bool _4771 = _32(_4760, _4763, _4766) <= _4597;
            bool _4788;
            if (!_4771)
            {
                float _4775 = _4731.x;
                float _4778 = _4731.y;
                float _4781 = _4731.z;
                _4788 = _27(_4775, _4778, _4781) >= (1.0 - _4597);
            }
            else
            {
                _4788 = _4771;
            }
            if (_4788)
            {
                continue;
            }
            uint _4792 = _4609._m1;
            vec3 _4795 = _4609._m0;
            float _4798 = float(bitfieldExtract(_4609._m8, 20, 12));
            float _4803 = 0.800000011920928955078125;
            vec3 _4804 = (_4731 * 2.0) - vec3(1.0);
            vec3 _4809 = _4804;
            vec3 _4808 = _47(_4809);
            vec3 _4812 = _4804 * sqrt(((vec3(1.0) - (_4808.yzx * 0.5)) - (_4808.zxy * 0.5)) + ((_4808.yzx * _4808.zxy) / vec3(3.0)));
            float _4843 = 1.0 - ((length(_4812) - _4803) / ((1.0 - _4803) + 9.9999999747524270787835121154785e-07));
            float _4832 = _10(_4843);
            _4832 *= _4832;
            _4832 *= _3997;
            float _4851 = _4609._m7.w;
            _4832 *= _4851;
            _3997 *= (1.0 - _4832);
            vec3 _4861 = _4609._m12;
            float _4864 = _4609._m13;
            float _4869 = _4832;
            vec3 _4867 = _4861 * (_10(_4869) * _4864);
            vec3 _4875 = _4609._m2;
            vec3 _4878 = _4609._m7.xyz;
            vec3 _4882 = vec3(0.0);
            vec3 _4883 = reflect(-_1034._m14, _1034._m6);
            vec3 _4890 = (_4878 - _1034._m15) / _4883;
            vec3 _4897 = (_4875 - _1034._m15) / _4883;
            vec3 _4904 = max(_4890, _4897);
            float _4909 = _4904.x;
            float _4912 = _4904.y;
            float _4915 = _4904.z;
            float _4908 = _32(_4909, _4912, _4915);
            vec3 _4919 = _1034._m15 + (_4883 * _4908);
            vec3 _4926 = _4919 - _4795;
            float _4930 = 6.0;
            float _4932 = _4930 - (_4930 * _1034._m3);
            _4882 = textureLod(samplerCubeArray(_4941, _4943), vec4(_4926, _4798), _4932).xyz;
            _1034._m21 += ((_4882 * _4867) * _1034._m24);
        }
    }
    uint _4966 = _4970._m0[_2508 * 64u];
    uint _4975 = _4966 & 255u;
    uint _4978 = _4970._m0[_2541 * 64u];
    uint _4983 = _4978 & 255u;
    uint _4991;
    uint _4993;
    uint _4995;
    if (_4975 < _4983)
    {
        _4991 = _4975;
        _4993 = _4966;
        _4995 = _2508;
    }
    else
    {
        _4991 = _4983;
        _4993 = _4978;
        _4995 = _2541;
    }
    uint _5001 = 1u;
    _4607 _5030;
    vec3 _5157;
    float _5295;
    vec2 _5363;
    _5561 _5563;
    _5561 _5710;
    while (_5001 <= _4991)
    {
        uint _5010 = (_4995 * 64u) + _5001;
        uint _5015 = _4970._m0[_5010];
        uint _5019 = _5015;
        if (_5019 >= _5015)
        {
            _5001++;
        }
        int _5028 = 4;
        int _5029 = 4;
        _5030._m0 = _4613._m0[(uint(_5028) * _5019) + 0u].xyz;
        float _5045 = _4613._m0[(uint(_5028) * _5019) + 0u].w;
        _5030._m1 = _21(_5045);
        _5030._m2 = _4613._m0[(uint(_5028) * _5019) + 1u].xyz;
        _5030._m3 = _4613._m0[(uint(_5028) * _5019) + 1u].w;
        _5030._m4 = _4613._m0[(uint(_5028) * _5019) + 2u];
        float _5080 = _4613._m0[(uint(_5028) * _5019) + 3u].x;
        _5030._m8 = _21(_5080);
        float _5090 = _4613._m0[(uint(_5028) * _5019) + 3u].y;
        _5030._m9 = _21(_5090);
        _5030._m10 = _4613._m0[(uint(_5028) * _5019) + 3u].z;
        _5030._m5 = _4689._m0[(uint(_5029) * _5019) + 0u];
        _5030._m6 = _4689._m0[(uint(_5029) * _5019) + 1u];
        _5030._m7 = _4689._m0[(uint(_5029) * _5019) + 2u];
        _5030._m12 = _4689._m0[(uint(_5029) * _5019) + 3u].xyz;
        _5030._m13 = _4689._m0[(uint(_5029) * _5019) + 3u].w;
        float _5144 = 0.0;
        uint _5145 = _5030._m1;
        vec3 _5148 = _5030._m0;
        vec3 _5151 = _5148;
        if ((_5145 & 7u) == 2u)
        {
            _5157 = _5151;
        }
        else
        {
            _5157 = normalize(_5148 - _1034._m15);
        }
        vec3 _5153 = _5157;
        uint _5168 = uint(((_2551 & 3u) != 0u) ? 16 : 0);
        _5168 |= 32u;
        float _5181 = dot(_1034._m6, _5153);
        float _5176 = _10(_5181);
        bool _5183 = _5176 <= _5144;
        bool _5188 = _5183 == true;
        bool _5196;
        if (!_5188)
        {
            _5196 = (_5145 & _5168) != 0u;
        }
        else
        {
            _5196 = _5188;
        }
        if (_5196)
        {
            continue;
        }
        vec3 _5200 = vec3(dot(_1034._m15, _5030._m5.xyz) + _5030._m5.w, dot(_1034._m15, _5030._m6.xyz) + _5030._m6.w, dot(_1034._m15, _5030._m7.xyz) + _5030._m7.w);
        vec2 _5234 = _5200.xy / vec2(_5200.z);
        _5200 = vec3(_5234.x, _5234.y, _5200.z);
        _5200.z = dot(_1034._m15, _5030._m4.xyz) + _5030._m4.w;
        float _5247 = _5200.x;
        float _5250 = _5200.y;
        float _5253 = _5200.z;
        bool _5258 = _32(_5247, _5250, _5253) <= _5144;
        bool _5275;
        if (!_5258)
        {
            float _5262 = _5200.x;
            float _5265 = _5200.y;
            float _5268 = _5200.z;
            _5275 = _27(_5262, _5265, _5268) >= (1.0 - _5144);
        }
        else
        {
            _5275 = _5258;
        }
        if (_5275)
        {
            continue;
        }
        vec3 _5279 = vec3(1.0);
        uint _5280 = _5145 & 7u;
        vec3 _5283 = _5030._m0 - _1034._m15;
        float _5289 = dot(_5283, _5283);
        if (_5280 != 2u)
        {
            _5295 = 1.0 / (1.0 + _5289);
        }
        else
        {
            _5295 = _1034._m25;
        }
        _5279 = vec3(_5295);
        if (_5280 == 0u)
        {
            float _5315 = _5289 * _5030._m3;
            float _5318 = 1.0 - _50(_5315);
            float _5320 = _10(_5318);
            float _5310 = _50(_5320);
            _5279 *= _5310;
        }
        else
        {
            if (_5280 == 4u)
            {
                float _5336 = length((_5200.xy - vec2(0.5)) * 2.0);
                float _5330 = _10(_5336);
                float _5338 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_5330 * 7.80000019073486328125))));
                _5279 *= _5338;
            }
            else
            {
                if ((_5280 == 1u) || (_5280 == 2u))
                {
                    if (_5280 == 2u)
                    {
                        _5363 = fract((_5200.xy * _780._m24.xy) + _780._m24.zw);
                    }
                    else
                    {
                        _5363 = _5200.xy;
                    }
                    vec2 _5360 = _5363;
                    vec3 _5381 = vec3(0.0);
                    uint _5382 = bitfieldExtract(_5030._m8, 0, 20);
                    uint _5386 = _5382;
                    uint _5390 = _5386 + 0u;
                    vec3 _5406 = textureLod(sampler2D(_2290[nonuniformEXT(_5390)], _1711), vec4(_5360, 0.0, 0.0).xy, vec4(_5360, 0.0, 0.0).w).xyz;
                    _5381 = _47(_5406);
                    _5279 *= _5381;
                }
            }
        }
        float _5412 = float((_5145 >> uint(8)) & 255u) / 255.0;
        if ((_5280 == 0u) || (_5280 == 2u))
        {
            vec3 _5425 = abs((_5200 * 2.0) - vec3(1.0));
            float _5431 = _5425.x;
            float _5434 = _5425.y;
            float _5437 = _5425.z;
            float _5442 = 1.0 - _27(_5431, _5434, _5437);
            float _5447 = _10(_5442) / (9.9999999392252902907785028219223e-09 + _5412);
            float _5430 = _10(_5447);
            _5279 *= ((_5430 * _5430) * (3.0 - (2.0 * _5430)));
        }
        else
        {
            if ((_5280 == 1u) || (_5280 == 4u))
            {
                float _5467 = _5200.z;
                float _5471 = _50(_5467);
                float _5474 = 1.0 - _50(_5471);
                float _5476 = _10(_5474);
                float _5481 = _50(_5476) / (9.9999999392252902907785028219223e-09 + _5412);
                float _5466 = _10(_5481);
                _5279 *= _5466;
            }
        }
        float _5486 = _5279.x;
        float _5489 = _5279.y;
        float _5492 = _5279.z;
        if (_27(_5486, _5489, _5492) <= _5144)
        {
            continue;
        }
        float _5501 = 1.0;
        if ((_5145 & 8u) != 0u)
        {
            float _5508 = 0.00999999977648258209228515625;
            vec3 _5510 = _1034._m15 + (_1034._m6 * _5508);
            uint _5518 = 0u;
            if ((_5145 & 7u) == 0u)
            {
                vec3 _5524 = _5510 - _5030._m2;
                float _5529 = _5524.x;
                float _5532 = _5524.y;
                float _5535 = _5524.z;
                _5518 = _38(_5529, _5532, _5535);
            }
            else
            {
                if ((_5145 & 7u) == 2u)
                {
                    float _5545 = 0.0;
                    uint _5546 = uint((_780._m25.w > 0.0) ? 3 : 4);
                    for (; _5518 < _5546; _5518++)
                    {
                        int _5560 = 5;
                        _5563._m0 = _5568._m0[(uint(_5560) * ((_5145 >> uint(22)) + _5518)) + 0u];
                        _5563._m1 = _5568._m0[(uint(_5560) * ((_5145 >> uint(22)) + _5518)) + 1u];
                        _5563._m2 = _5568._m0[(uint(_5560) * ((_5145 >> uint(22)) + _5518)) + 2u];
                        _5563._m3 = _5568._m0[(uint(_5560) * ((_5145 >> uint(22)) + _5518)) + 3u];
                        _5563._m4 = _5568._m0[(uint(_5560) * ((_5145 >> uint(22)) + _5518)) + 4u];
                        vec2 _5624 = vec2(dot(_5510, _5563._m0.xyz) + _5563._m0.w, dot(_5510, _5563._m1.xyz) + _5563._m1.w);
                        _5624 = abs((_5624 * 2.0) - vec2(1.0));
                        bool _5650 = _5624.x < 0.9900000095367431640625;
                        bool _5656;
                        if (_5650)
                        {
                            _5656 = _5624.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _5656 = _5650;
                        }
                        if (_5656)
                        {
                            _5545 = (1.0 - max(_5624.x, _5624.y)) * _780._m26.w;
                            break;
                        }
                    }
                    _1034._m36 = int(_5518);
                    _5518 = min((_5546 - 1u), _5518);
                    if (_780._m25.w > 0.0)
                    {
                        uint _5683 = uint(_1034._m17.x) ^ (uint(_1034._m17.y) << uint(1));
                        _5683 ^= uint(_780._m27.x);
                        _5518 += uint(int(((float(_5683 & 3u) * 0.25) + 0.125) > _5545));
                    }
                }
            }
            int _5709 = 5;
            _5710._m0 = _5568._m0[(uint(_5709) * ((_5145 >> uint(22)) + _5518)) + 0u];
            _5710._m1 = _5568._m0[(uint(_5709) * ((_5145 >> uint(22)) + _5518)) + 1u];
            _5710._m2 = _5568._m0[(uint(_5709) * ((_5145 >> uint(22)) + _5518)) + 2u];
            _5710._m3 = _5568._m0[(uint(_5709) * ((_5145 >> uint(22)) + _5518)) + 3u];
            _5710._m4 = _5568._m0[(uint(_5709) * ((_5145 >> uint(22)) + _5518)) + 4u];
            vec4 _5766 = vec4((_5510.x * _5710._m0.x) + ((_5510.y * _5710._m0.y) + ((_5510.z * _5710._m0.z) + _5710._m0.w)), (_5510.x * _5710._m1.x) + ((_5510.y * _5710._m1.y) + ((_5510.z * _5710._m1.z) + _5710._m1.w)), (_5510.x * _5710._m2.x) + ((_5510.y * _5710._m2.y) + ((_5510.z * _5710._m2.z) + _5710._m2.w)), (_5510.x * _5710._m3.x) + ((_5510.y * _5710._m3.y) + ((_5510.z * _5710._m3.z) + _5710._m3.w)));
            vec3 _5853 = _5766.xyz / vec3(_5766.w);
            _5766 = vec4(_5853.x, _5853.y, _5853.z, _5766.w);
            bool _5861 = min(_5766.x, _5766.y) > 0.0;
            bool _5870;
            if (_5861)
            {
                _5870 = max(_5766.x, _5766.y) < 1.0;
            }
            else
            {
                _5870 = _5861;
            }
            if (_5870)
            {
                vec2 _5882 = (_5766.xy * _5710._m4.xy) + _5710._m4.zw;
                _5766 = vec4(_5882.x, _5882.y, _5766.z, _5766.w);
                if (false)
                {
                    _5501 = textureLod(sampler2DShadow(_5889, _5891), vec3(_5766.xyz.xy, _5766.xyz.z), 0.0);
                }
                else
                {
                    vec2 _5900 = (_5766.xy * _780._m28.xy) + vec2(0.5);
                    vec2 _5909 = floor(_5900);
                    vec2 _5912 = _5900 - _5909;
                    _5909 -= vec2(0.5);
                    vec2 _5919 = vec2(4.0) - (_5912 * 3.0);
                    vec2 _5924 = vec2(7.0);
                    vec2 _5927 = vec2(1.0) + (_5912 * 3.0);
                    vec2 _5932 = (_5909 + (((vec2(3.0) - (_5912 * 2.0)) / _5919) - vec2(2.0))) * _780._m28.zw;
                    vec2 _5947 = (_5909 + ((vec2(3.0) + _5912) / _5924)) * _780._m28.zw;
                    vec2 _5959 = (_5909 + ((_5912 / _5927) + vec2(2.0))) * _780._m28.zw;
                    vec3 _5985 = vec3(_5932.x, _5932.y, _5766.z);
                    _5501 = (_5919.x * _5919.y) * textureLod(sampler2DShadow(_5889, _5891), vec3(_5985.xy, _5985.z), 0.0);
                    vec3 _6003 = vec3(_5947.x, _5932.y, _5766.z);
                    _5501 += ((_5924.x * _5919.y) * textureLod(sampler2DShadow(_5889, _5891), vec3(_6003.xy, _6003.z), 0.0));
                    vec3 _6023 = vec3(_5959.x, _5932.y, _5766.z);
                    _5501 += ((_5927.x * _5919.y) * textureLod(sampler2DShadow(_5889, _5891), vec3(_6023.xy, _6023.z), 0.0));
                    vec3 _6043 = vec3(_5932.x, _5947.y, _5766.z);
                    _5501 += ((_5919.x * _5924.y) * textureLod(sampler2DShadow(_5889, _5891), vec3(_6043.xy, _6043.z), 0.0));
                    vec3 _6063 = vec3(_5947.x, _5947.y, _5766.z);
                    _5501 += ((_5924.x * _5924.y) * textureLod(sampler2DShadow(_5889, _5891), vec3(_6063.xy, _6063.z), 0.0));
                    vec3 _6083 = vec3(_5959.x, _5947.y, _5766.z);
                    _5501 += ((_5927.x * _5924.y) * textureLod(sampler2DShadow(_5889, _5891), vec3(_6083.xy, _6083.z), 0.0));
                    vec3 _6103 = vec3(_5932.x, _5959.y, _5766.z);
                    _5501 += ((_5919.x * _5927.y) * textureLod(sampler2DShadow(_5889, _5891), vec3(_6103.xy, _6103.z), 0.0));
                    vec3 _6123 = vec3(_5947.x, _5959.y, _5766.z);
                    _5501 += ((_5924.x * _5927.y) * textureLod(sampler2DShadow(_5889, _5891), vec3(_6123.xy, _6123.z), 0.0));
                    vec3 _6143 = vec3(_5959.x, _5959.y, _5766.z);
                    _5501 += ((_5927.x * _5927.y) * textureLod(sampler2DShadow(_5889, _5891), vec3(_6143.xy, _6143.z), 0.0));
                    _5501 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _5501 = float((_5145 & 7u) == 2u);
                if ((_5145 & 7u) == 2u)
                {
                    _1034._m36 = -1;
                }
            }
            float _6163 = float((_5145 >> uint(16)) & 63u) / 63.0;
            float _6177 = ((_5501 * _6163) + 1.0) - _6163;
            _5501 = _10(_6177);
        }
        if (_5501 <= _5144)
        {
            continue;
        }
        vec3 _6185 = (_5030._m12 * _5501) * _5279;
        float _6192 = _5030._m13;
        vec3 _6195 = _6185;
        float _6202 = dot(_1034._m6, _5153);
        float _6197 = _10(_6202);
        float _6204 = 1.0;
        vec3 _6206 = _1034._m6;
        vec3 _6209 = _1034._m14;
        vec3 _6212 = _5153;
        vec3 _6214 = _1034._m2;
        float _6217 = _1034._m3;
        vec3 _6205 = _101(_6206, _6209, _6212, _6214, _6217);
        _1034._m21 += ((((_6205 * _6192) * _6195) * _6197) * _6204);
        vec3 _6234 = _6195;
        _1034._m21 += ((_6234 * _6197) * _1034._m0);
    }
    _1034._m21 *= _1034._m11;
    _6253 = vec4(_1034._m21, 0.0);
    if (((_780._m66 & 1u) != 0u) == true)
    {
        vec3 _6268 = _1034._m6;
        bool _6271 = false;
        vec2 _6272 = _182(_6268, _6271);
        _6267 = vec4(_6272, 0.0, 0.0);
        float _6282 = dot(_1034._m14, _1034._m6);
        float _6276 = _10(_6282);
        float _6285 = _6276;
        float _6287 = _1034._m3;
        vec3 _6290 = _1034._m2;
        vec3 _6284 = _107(_6285, _6287, _6290);
        float _6295 = _6284.x;
        float _6299 = _6284.y;
        float _6303 = _6284.z;
        float _6307 = _1034._m3;
        _6294 = vec4(_78(_6295), _78(_6299), _78(_6303), _185(_6307));
    }
}


